/* ALL RIGHTS RESERVED
 *
 * This file is provided for demonstration and educational uses only.
 * Permission to use, copy, modify and distribute this file for
 * any purpose and without fee is hereby granted, provided that the
 * above copyright notice and this permission notice appear in all
 * copies, and that the name of KL Group not be used in advertising
 * or publicity pertaining to this material without the specific,
 * prior written permission of an authorized representative of
 * KL Group.
 *
 * KL GROUP MAKES NO REPRESENTATIONS AND EXTENDS NO WARRANTIES, EX-
 * PRESS OR IMPLIED, WITH RESPECT TO THE SOFTWARE, INCLUDING, BUT
 * NOT LIMITED TO, THE IMPLIED WARRANTIES OF MERCHANTABILITY AND
 * FITNESS FOR ANY PARTICULAR PURPOSE, AND THE WARRANTY AGAINST IN-
 * FRINGEMENT OF PATENTS OR OTHER INTELLECTUAL PROPERTY RIGHTS.  THE
 * SOFTWARE IS PROVIDED "AS IS", AND IN NO EVENT SHALL KL GROUP OR
 * ANY OF ITS AFFILIATES BE LIABLE FOR ANY DAMAGES, INCLUDING ANY
 * LOST PROFITS OR OTHER INCIDENTAL OR CONSEQUENTIAL DAMAGES
 * RELATING TO THE USE OF THIS SOFTWARE.
 *
 *
 * XRT/3d widget UIM/X integration file
 *
 *  SCCSID -- @(#)Xrt3d_conf.c	1.5    95/09/27 KL Group Inc.
 */

/******************************************************************************
				Xrt3d_conf.c
******************************************************************************/

#include <Xm/Xrt3d.h>

#ifndef	UXREGFUNC
# ifdef __STDC__
#  define UXREGFUNC(func)	UxRegisterFunction( #func, func)
# else
#  define UXREGFUNC(func)	UxRegisterFunction( "func", func)
# endif
#endif

void
Xrt3d_register_functions()
{
	UXREGFUNC( XtCreateXrt3d );
	UXREGFUNC( XtCreateXrt3dText );
	UXREGFUNC( Xrt3dGetImage );
	UXREGFUNC( Xrt3dSetNthContourStyle  );
	UXREGFUNC( Xrt3dGetNthContourStyle );
	UXREGFUNC( Xrt3dDupContourStyles );
	UXREGFUNC( Xrt3dContourStylesFromFile );
	UXREGFUNC( Xrt3dMakeDataFromFile );
	UXREGFUNC( Xrt3dMakeGridData );
	UXREGFUNC( Xrt3dDataCopy );
	UXREGFUNC( Xrt3dDataShaded );
	UXREGFUNC( Xrt3dDataSmooth );
	UXREGFUNC( Xrt3dDataWindow );
	UXREGFUNC( Xrt3dGetDistnTable );
	UXREGFUNC( Xrt3dDupDistnTable );
	UXREGFUNC( Xrt3dDistnIndex );
	UXREGFUNC( Xrt3dDistnTableFromFile );
	UXREGFUNC( Xrt3dMap );
	UXREGFUNC( Xrt3dPick );
	UXREGFUNC( Xrt3dDupStrings );
	UXREGFUNC( Xrt3dDrawPS );
	UXREGFUNC( Xrt3dOutputPS );
	UXREGFUNC( Xrt3dOutputXwd );
	UXREGFUNC( Xrt3dSaveDataToFile );
	UXREGFUNC( Xrt3dFreeContourStyles );
	UXREGFUNC( Xrt3dDestroyData );
	UXREGFUNC( Xrt3dFreeDistnTable );
	UXREGFUNC( Xrt3dFreeStrings );
	UXREGFUNC( Xrt3dUnmap );
	UXREGFUNC( Xrt3dUnpick );
	UXREGFUNC( Xrt3dComputeZValue );
	UXREGFUNC( Xrt3dZInterpolate );
	UXREGFUNC( Xrt3dMakeIrGridData );
	UXREGFUNC( Xrt3dGetNthDataLabel );
	UXREGFUNC( Xrt3dGetValueLabel );
	UXREGFUNC( Xrt3dSetNthDataLabel );
	UXREGFUNC( Xrt3dSetValueLabel );
	UXREGFUNC( Xrt3dGetXYColor );
	UXREGFUNC( Xrt3dSetXYColor );
	UXREGFUNC( Xrt3dFreeValueLabels );
	UXREGFUNC( Xrt3dDupValueLabels );
	UXREGFUNC( Xrt3dFreeXYColors );
	UXREGFUNC( Xrt3dDupXYColors );
	UXREGFUNC( Xrt3dDoubleToArgVal );
	UXREGFUNC( Xrt3dArgValToDouble );
	UXREGFUNC( Xrt3dSetReverseConverters );
	UXREGFUNC( Xrt3dDrawCGM );
}

Xrt3d_config()
{
	/*
	 ** Calls to XtSetTypeConverter() go here
	 */

	XtInitializeWidgetClass(xtXrt3dWidgetClass);
	Xrt3dSetReverseConverters();

	Xrt3d_register_functions();

}
