/*------------------------------------------------------------------------------
 * $AstecId: uxgui.c,v 1.3 1998/02/04 02:10:30 yamato Exp $
 * $Source: /rcs/rcs2/build/uxgui.c,v $
 * $Date: 1997/09/30 00:08:04 $		$Revision: 2.44.65.6 $
 *------------------------------------------------------------------------------
 *		Copyright (c) 1992, Visual Edge Software Ltd.
 *
 * ALL  RIGHTS  RESERVED.  Permission  to  use,  copy,  modify,  and
 * distribute  this  software  and its documentation for any purpose
 * and  without  fee  is  hereby  granted,  provided  that the above
 * copyright  notice  appear  in  all  copies  and  that  both  that
 * copyright  notice and this permission notice appear in supporting
 * documentation,  and that  the name of Visual Edge Software not be
 * used  in advertising  or publicity  pertaining to distribution of
 * the software without specific, written prior permission. The year
 * included in the notice is the year of the creation of the work.
 *------------------------------------------------------------------------------
 * This file contains wrapper functions for functions which exist in
 * libuxgui.a. Users can block these functions from being called.
 *----------------------------------------------------------------------------*/

/*--- include files ---*/

#include <stdio.h>
#include "uxgui.h"
#include "vhandle.h"
#include <Xm/Xm.h>
#include "UxSb.h"
#ifdef ASTEC_EDITOR
#include "UxUe.h"
#endif /* ASTEC_EDITOR */

/*------------------------------------------------------------------------
 * NAME:	UxGUICDEDropRegisterIfaceArea
 * DESCRIPTION: Wrapper function for UxCDEDropRegister used to register
 *		Project Window Interface Area as a CDE Drop Site.
 * PARAMETERS:	Widget w [I]	widget to be drop site
 * RETURN:	void
 * LAST REV:	March 97	fix16627 Add IMD support for sgi platform.
 *------------------------------------------------------------------------*/
void	UxGUICDEDropRegisterIfaceArea( w )
	Widget w;
{
#if I_WANT_CDE_EXTENSIONS

#ifdef DTBUILDER
	UxCDEDropRegister( w );
#else
#ifdef DTSCRIPT
	/* Interface Area not shown so don't bother */
#else /* UIMX */
	UxCDEDropRegister( w );
#endif /* DTSCRIPT */
#endif /* DTBUILDER */

#endif

#if sgi
#ifdef DTBUILDER
	UxIMDDropRegister( w );
#else
#ifdef DTSCRIPT
	/* Interface Area not shown so don't bother */
#else /* UIMX */
	UxIMDDropRegister( w );
#endif /* DTSCRIPT */
#endif /* DTBUILDER */

#endif /* sgi */
}
 
/*------------------------------------------------------------------------
 * NAME:	UxGUICDEDropRegisterPalArea
 * DESCRIPTION: Wrapper function for UxCDEDropRegister used to register
 *		Project Window Palette Area as a CDE Drop Site.
 * PARAMETERS:	Widget w [I]	widget to be drop site
 * RETURN:	void
 * LAST REV:	March 97	fix16627 Add IMD support for sgi platform.
 *------------------------------------------------------------------------*/
void	UxGUICDEDropRegisterPalArea( w )
	Widget w;
{
#if I_WANT_CDE_EXTENSIONS

#ifdef DTBUILDER
	/* Palette Area not shown so don't bother */
#else
#ifdef DTSCRIPT
	/* Palette Area not shown so don't bother */
#else /* UIMX */
	UxCDEDropRegister( w );
#endif /* DTSCRIPT */
#endif /* DTBUILDER */

#endif

#ifdef sgi
#ifdef DTBUILDER
	/* Palette Area not shown so don't bother */
#else
#ifdef DTSCRIPT
	/* Palette Area not shown so don't bother */
#else /* UIMX */
	UxIMDDropRegister( w );
#endif /* DTSCRIPT */
#endif /* DTBUILDER */
#endif /* sgi */
}
 
/*------------------------------------------------------------------------
 * NAME:	UxGUICDEDropRegisterMsgArea
 * DESCRIPTION: Wrapper function for UxCDEDropRegister used to register
 *		Project Window Message Area as a CDE Drop Site.
 * PARAMETERS:	Widget w [I]	widget to be drop site
 * RETURN:	void
 * LAST REV:	March 97	fix16627 Add IMD support for sgi platform.
 *------------------------------------------------------------------------*/
void	UxGUICDEDropRegisterMsgArea( w )
	Widget w;
{
#if I_WANT_CDE_EXTENSIONS

#ifdef DTBUILDER
	/* Don't bother */
#else
#ifdef DTSCRIPT
	UxCDEDropRegister( w );
#else /* UIMX */
	/* Don't bother */
#endif /* DTSCRIPT */
#endif /* DTBUILDER */

#endif

#ifdef sgi
#ifdef DTBUILDER
	/* Don't bother */
#else
#ifdef DTSCRIPT
	UxIMDDropRegister( w );
#else /* UIMX */
	/* Don't bother */
#endif /* DTSCRIPT */
#endif /* DTBUILDER */
#endif /* sgi */
}

/*------------------------------------------------------------------------
 * NAME:	UxGUICDEDropUnRegisterIfaceArea
 * DESCRIPTION: Wrapper function for UxCDEDropRegister used to register
 *		Project Window Interface Area as a CDE Drop Site.
 * PARAMETERS:	Widget w [I]	widget to be drop site
 * RETURN:	void
 * LAST REV:	March 97	fix16627 Add IMD support for sgi platform.
 *------------------------------------------------------------------------*/
void	UxGUICDEDropUnRegisterIfaceArea( w )
	Widget w;
{
#if I_WANT_CDE_EXTENSIONS

#ifdef DTBUILDER
	UxCDEDropUnRegister( w );
#else
#ifdef DTSCRIPT
	/* Interface Area not shown so don't bother */
#else /* UIMX */
	UxCDEDropUnRegister( w );
#endif /* DTSCRIPT */
#endif /* DTBUILDER */
#endif

#ifdef sgi
#ifdef DTBUILDER
	UxIMDDropUnRegister( w );
#else
#ifdef DTSCRIPT
	/* Interface Area not shown so don't bother */
#else /* UIMX */
	UxIMDDropUnRegister( w );
#endif /* DTSCRIPT */
#endif /* DTBUILDER */
#endif /* sgi */
}
 
/*------------------------------------------------------------------------
 * NAME:	UxGUICDEDropUnRegisterPalArea
 * DESCRIPTION: Wrapper function for UxCDEDropRegister used to register
 *		Project Window Palette Area as a CDE Drop Site.
 * PARAMETERS:	Widget w [I]	widget to be drop site
 * RETURN:	void
 * LAST REV:	March 97	fix16627 Add IMD support for sgi platform.
 *------------------------------------------------------------------------*/
void	UxGUICDEDropUnRegisterPalArea( w )
	Widget w;
{
#if I_WANT_CDE_EXTENSIONS

#ifdef DTBUILDER
	/* Palette Area not shown so don't bother */
#else
#ifdef DTSCRIPT
	/* Palette Area not shown so don't bother */
#else /* UIMX */
	UxCDEDropUnRegister( w );
#endif /* DTSCRIPT */
#endif /* DTBUILDER */
#endif

#ifdef sgi
#ifdef DTBUILDER
	/* Palette Area not shown so don't bother */
#else
#ifdef DTSCRIPT
	/* Palette Area not shown so don't bother */
#else /* UIMX */
	UxIMDDropUnRegister( w );
#endif /* DTSCRIPT */
#endif /* DTBUILDER */
#endif /* sgi */
}
 
/*------------------------------------------------------------------------
 * NAME:	UxGUICDEDropUnRegisterMsgArea
 * DESCRIPTION: Wrapper function for UxCDEDropRegister used to register
 *		Project Window Message Area as a CDE Drop Site.
 * PARAMETERS:	Widget w [I]	widget to be drop site
 * RETURN:	void
 * LAST REV:	March 97	fix16627 Add IMD support for sgi platform.
 *------------------------------------------------------------------------*/
void	UxGUICDEDropUnRegisterMsgArea( w )
	Widget w;
{
#if I_WANT_CDE_EXTENSIONS

#ifdef DTBUILDER
	/* Don't bother */
#else
#ifdef DTSCRIPT
	UxCDEDropUnRegister( w );
#else /* UIMX */
	/* Don't bother */
#endif /* DTSCRIPT */
#endif /* DTBUILDER */
#endif

#ifdef sgi
#ifdef DTBUILDER
	/* Don't bother */
#else
#ifdef DTSCRIPT
	UxIMDDropUnRegister( w );
#else /* UIMX */
	/* Don't bother */
#endif /* DTSCRIPT */
#endif /* DTBUILDER */
#endif /* sgi */
}
/*------------------------------------------------------------------------
 * NAME:	UxGUICDEWorkspaceSet
 * DESCRIPTION: Wrapper function for UxCDEWorkspaceSet used to set the
 *		Workspace a shell should appear in.
 * PARAMETERS:	Widget w [I]	widget to be placed.
 * RETURN:	void
 * LAST REV:	may 94 fix5435	Created.
 *------------------------------------------------------------------------*/
void	UxGUICDEWorkspaceSet( w )
	Widget w;
{
#if I_WANT_CDE_EXTENSIONS
	UxCDEWorkspaceSet( w );
#endif
}

/*------------------------------------------------------------------------
 * NAME:	UxGUICDESessionInitialize
 * DESCRIPTION: Wrapper function for UxCDESessionInitialize used to set up
 *		Session management on the passed in shell widget.
 * PARAMETERS:	Widget w [I]	widget to be setup
 * RETURN:	void
 * LAST REV:	may 94	Created.
 *------------------------------------------------------------------------*/
void	UxGUICDESessionInitialize( w )
	Widget w;
{
#if I_WANT_CDE_EXTENSIONS
	UxCDESessionInitialize( w );
#endif
}
 
/*------------------------------------------------------------------------
 * NAME:	UxGUIPopupBrowserIfList()
 * DESCRIPTION: Wrapper function for UxPopupBrowserIfList(). Used to
 *		Pop up the Browser Interface List from within the Browser.
 *		By recompiling UIM/X with I_WANT_BRIFLST set to NO this
 *		functionality can be disabled.
 *		The Browser Interface List is only active when the browser
 *		is the startup interface.
 * PARAMETERS:	Widget		Uxw	[O]	The Browser Interface List
 *		XtPointer Uxclient_data	[I]	the browser
 *		XtPointer Uxcall_data	[I]	nothing
 * RETURN:	void
 * REVISIONS:	nov94 fix6155	Converted to XtPointer
 *------------------------------------------------------------------------*/
void	UxGUIPopupBrowserIfList( Uxw, Uxclient_data, Uxcall_data )
	Widget		Uxw;
	XtPointer	Uxclient_data;
	XtPointer	Uxcall_data;
{
#if I_WANT_BRIFLST
	UxPopupBrowserIfList( Uxw, Uxclient_data, Uxcall_data );
#endif
}
 
/*------------------------------------------------------------------------
 * NAME:	UxGUICreateInterp()
 * DESCRIPTION: Wrapper function for UxCreateInterp(). Used to create
 *		the UIM/X Interpreter Interface. By recompiling with
 *		I_WANT_INTERP set to NO this functionality can be disabled.
 * PARAMETERS:	none
 * RETURN:	swidget		The interpreter interface.
 * LAST REV:	oct 92	Created.
 *------------------------------------------------------------------------*/
swidget	UxGUICreateInterp()
{
	swidget	Uxrtrn = NULL;

#if I_WANT_INTERP
	Uxrtrn = UxCreateInterp();
#endif
	return ( Uxrtrn );
}

/*------------------------------------------------------------------------
 * NAME:	UxGUIGetInterpInterface()
 * DESCRIPTION: Wrapper function for UxGetInterpInterface(). Used to
 *		find the Interpreter Interface if it exists. Not used
 *		if I_WANT_INTERP set to NO.
 * PARAMETERS:	none
 * RETURN:	swidget		The interpreter interface.
 * LAST REV:	oct 92	Created.
 *------------------------------------------------------------------------*/
swidget	UxGUIGetInterpInterface()
{
#if I_WANT_INTERP
	return UxGetInterpInterface();
#else
	return (swidget) NULL;
#endif
}

/*------------------------------------------------------------------------
 * NAME:	UxGUIPopupBrowserOptions
 * DESCRIPTION: Wrapper function for UxPopupBrowserOptions(). Used to
 *		bring up the Browser Options Interface. If you don't
 *		want the options being changed you can recompile with
 *		I_WANT_BROWSER_OPTIONS set to NO which will remove access to it.
 * PARAMETERS:	swidget* UxHolder [I/O] current Browser Option Settings
 * RETURN:	swidget		The Browser Options interface.
 * LAST REV:	nov 92	Created.
 *------------------------------------------------------------------------*/
swidget	UxGUIPopupBrowserOptions( UxHolder )
	swidget	*UxHolder;
{
#if I_WANT_BROWSER_OPTIONS
	return UxPopupBrowserOptions( UxHolder );
#else
	return (swidget) NULL;
#endif
}

/*------------------------------------------------------------------------
 * NAME:	UxGUIPopupCgenOptions
 * DESCRIPTION: Wrapper function for UxPopupCgenOptions(). 
 *		Used to bring up the Code Generation Options Interface. 
 *		If you don't want the options being changed you can 
 *		recompile with I_WANT_CGEN_OPTIONS set to NO which will remove
 *		access to it.
 * PARAMETERS:	swidget* UxHolder [I/O] current Code Generation Option swidget
 * RETURN:	swidget			The Code Generation Options interface.
 * LAST REV:	dec 92	Created.
 *------------------------------------------------------------------------*/
swidget UxGUIPopupCgenOptions( UxHolder )
	swidget *UxHolder;
{
#if I_WANT_CGEN_OPTIONS
	return UxPopupCgenOptions( UxHolder );
#else
	return (swidget) NULL;
#endif
}

/*------------------------------------------------------------------------------
 * NAME:	UxGUIPopupColorView()
 * DESCRIPTION: Wrapper function for UxPopupColorView(). Used to bring
 *		up the Color Viewer. If you don't to use the Color
 *		Viewer for selecting colors from the Property Editor,
 *		access can be removed by recompiling with 
 *		I_WANT_COLOR_VIEWER set to NO.
 * PARAMETERS:	swidget	UxParent	[I] The parent calling the Color Viewer
 *		char	*UxResName	[I] The resource that is being set.
 *		char	*UxPrintName	[I] Color to set at start.
 *		swidget	*UxEdList     [I/O] List of open viewers
 *		int	UxEdCount	    number of open viewers
 * RETURN:	swidget			 The Color View interface.
 * LAST REV:	Aug 97 fix17371 Adjust to BE API.
 *----------------------------------------------------------------------------*/
swidget	UxGUIPopupColorView(UxParent, UxResName, UxPrintName, UxEdList, UxEdCount)
	swidget UxParent;
	char	*UxResName;
	char	*UxPrintName;
	swidget *UxEdList;
	int	UxEdCount;
{
#if I_WANT_COLOR_VIEWER
	return UxPopupColorView( UxParent, UxResName, UxPrintName, UxEdList, UxEdCount, NULL, NULL, NULL, NULL);
#else
	return (swidget) NULL;
#endif
}

/*------------------------------------------------------------------------------
 * NAME:	UxGUIPopupBEColorView()
 * DESCRIPTION: Wrapper function for UxPopupColorView(). Used to bring
 *		up the Color Viewer for Builder Engine Reasons. If holder
 *		is non NULL the passed in functions will be uased rather
 *		than the default Property Editor ones.
 * PARAMETERS:	swidget	UxParent	[I] The parent calling the Color Viewer
 *		char	*UxResName	[I] Not used.
 *		char	*UxPrintName	[I] Not used.
 *		swidget	*UxEdList     [I/O] Not used.
 *		int	UxEdCount	    Not used.
 *		Widget	holder		{I} BE widget to hold color.
 *		reserveFun		{I} Called to do special initialization
 *					    and return initial value.
 *		releaseFun		{I} Called upon closing.
 *		depositFun		{I} Called when deposting value.
 * RETURN:	swidget			 The Color View interface.
 * LAST REV:	Aug 97 fix17371 Created.
 *----------------------------------------------------------------------------*/
swidget	UxGUIPopupBEColorView(UxParent, UxResName, UxPrintName, UxEdList, UxEdCount, holder, reserveFun, releaseFun, depositFun)
	swidget UxParent;
	char	*UxResName;
	char	*UxPrintName;
	swidget *UxEdList;
	int	UxEdCount;
	Widget	holder;
	char*	(* reserveFun)();
	void	(* releaseFun)();
	void	(* depositFun)();
{
#if I_WANT_COLOR_VIEWER
	return UxPopupColorView( UxParent, UxResName, UxPrintName, UxEdList, UxEdCount, holder, reserveFun, releaseFun, depositFun);
#else
	return (swidget) NULL;
#endif
}

/*------------------------------------------------------------------------------
 * NAME:	UxGUIPopupDirSelBox()
 * DESCRIPTION: Wrapper function for UxPopupDirSelBox(). Used to bring
 *		up the directory selection box when writing C code. Access
 *		to it can be removed by recompiling with I_WANT_DIR_SEL
 *		set to NO.
 * PARAMETERS:	char *UxInitPath	The initial directory.
 *		char **UxPath		The chosen directory
 * RETURN:	int			true on success else false
 * LAST REV:	nov 92	Created.
 *----------------------------------------------------------------------------*/
int	UxGUIPopupDirSelBox( Uxinpath, Uxpath )
	char	*Uxinpath;
	char	**Uxpath;
{
#if I_WANT_DIR_SEL
	return UxPopupDirSelBox( Uxinpath, Uxpath ); 
#else
	return (int) NULL;
#endif
}

/*------------------------------------------------------------------------------
 * NAME:	UxGUIPopupCurrentDirectory()
 * DESCRIPTION: Wrapper function for UxPopupCurrentDirectory(). Used to
 *		bring up the interface for selecting the current 
 *		directory. To keep a user from changing it you could
 *		deny access to this function by recompiling with 
 *		I_WANT_CUR_DIR set to NO.
 * PARAMETERS:	char*	UxTitle		[I] the title of the interface
 *		char*  UxPutFunction	[I] function used in the OK callback
 *		swidget*    UxHolder	[I/O] contains current settings
 *		char* (*)() UxExtraFunction [I] function used if put
 *						function fails.
 * RETURN:	swidget		The Current Directory Selection interface.
 * LAST REV:	nov 92	Created.
 *------------------------------------------------------------------------*/
swidget	UxGUIPopupCurrentDirectory( UxTitle, UxPutFunction, UxHolder, UxExtraFunction )
	char	*UxTitle;
	char	*(*UxPutFunction)();
	swidget	*UxHolder;
	char	*(*UxExtraFunction)();
{
#if I_WANT_CUR_DIR
	return UxPopupCurrentDirectory( UxTitle, UxPutFunction, UxHolder, UxExtraFunction ); 
#else
	return (swidget) NULL;
#endif
}

/*------------------------------------------------------------------------
 * NAME:	UxGUIPopupMethodEditor()
 * DESCRIPTION: Wrapper function for UxPopupMethodEditor(). Used to
 *		bring up the Method Editor. Acccess to it can be denied
 *		by recompiling with I_WANT_METHOD_EDITOR set to NO.
 * PARAMETERS:	swidget sw   [I] Interface whose methods are to be edited.
 *		char*   name [I] title to be used.
 * RETURN:	swidget		 The Method Editor interface.
 * LAST REV:	nov 92	Created.
 *------------------------------------------------------------------------*/
swidget	UxGUIPopupMethodEditor(sw, name)
	swidget	sw;
	char*	name;
{
#if I_WANT_METHOD_EDITOR
	return UxPopupMethodEditor(sw, name);
#else
	return (swidget) NULL;
#endif
}

/*------------------------------------------------------------------------
 * NAME:	UxGUIPopupTextGeometryOptions()
 * DESCRIPTION: Wrapper function for UxPopupTextGeometryOptions(). Used
 *		to bring up interface for selecting Text Editor options.
 *		If you want to deny access to these options, recompile
 *		with I_WANT_TEXT_EDTOPT set to NO.
 * PARAMETERS:	swidget* UxHolder [I/O]  The cuurent text editor options.
 * RETURN:	swidget			 The Text Editor Options interface.
 * LAST REV:	nov 92	Created.
 *------------------------------------------------------------------------*/
swidget	UxGUIPopupTextGeometryOptions( UxHolder )
	swidget *UxHolder;
{
#if I_WANT_TEXT_EDTOPT
	return UxPopupTextGeometryOptions( UxHolder );
#else
	return (swidget) NULL;
#endif
}

/*------------------------------------------------------------------------
 * NAME:	UxGUIPopupWriteCCode()
 * DESCRIPTION: Wrapper function for UxPopupWriteCCode (). Used to bring
 *		up the Write C Code Interface which allows users to
 *		make certain decisions before actually writing C code.
 *		Access to it can denied by recompiling with 
 *		I_WANT_WRITE_C_CODE set to NO.
 * PARAMETERS:	swidget UxParent [I]	Parent swidget calling it.
 * RETURN:	int			Make status (1 if started else 0)
 * LAST REV:	nov 92	Created.
 *------------------------------------------------------------------------*/
int	UxGUIPopupWriteCCode( Uxparent )
	swidget Uxparent;
{
#if I_WANT_WRITE_C_CODE
	return UxPopupWriteCCode( Uxparent );
#else
	return (int) NULL;
#endif
}

/*------------------------------------------------------------------------
 * NAME:	UxGUIPopupCallbackEditor()
 * DESCRIPTION: Wrapper function for UxPopupCallbackEditor(). Used to
 *		bring up the Callback Editor from the property editor.
 *		If don't want users changing callbacks you might as well
 *		deny access to it by recompiling with I_WANT_CB_EDITOR
 *		set to NO.
 * PARAMETERS:	swidget UxSwParent  [I]   The parent swidget calling it.
 *		char*   UxResName   [I]   The resource we are changing.
 *		char*   UxPrintName [I]   Name to give editor.
 *		swidget* UxEdList   [I/O] List of Widgets in the Editors.
 *		int	UxEdCount   [I/O] Number of Widgets in the Editors
 * RETURN:	swidget			  The Callback Editor interface.
 * REVISIONS:	nov 95 fix6155	Updated comment
 *------------------------------------------------------------------------*/
swidget	UxGUIPopupCallbackEditor( UxSwParent, UxResName, UxPrintName, UxEdList,UxEdCount )
	swidget UxSwParent;
	char	*UxResName;
	char	*UxPrintName;
	swidget *UxEdList;
	int	UxEdCount;
{
#if I_WANT_CB_EDITOR
	return UxPopupCallbackEditor( UxSwParent, UxResName, UxPrintName, UxEdList, UxEdCount ); 
#else
#ifdef DTSCRIPT
	UxPopupPEditTextEditor
		(UxSwParent,
		 UxResName,
		 UxPrintName,
		 UxEdList,
		 UxEdCount
		);
#else /* UIMX */
	return (swidget) NULL;
#endif /* DTSCRIPT */
#endif
}

/*------------------------------------------------------------------------
 * NAME:	UxGUIUpdateCallbackEditorWidgets()
 * DESCRIPTION: The property editor received a new widget list and 
 *		we need to tell the callback editor so it knows which
 *		widgets it's now dealing with
 * PARAMETERS:	swidget	 Editor	    [I/O] Editor to update
 *		swidget* UxEdList   [I/O] New widgets list
 *		int	 UxEdCount  [I]   Number of widgets in the list
 * REVISION:	nov94 fix6155	Created
 *------------------------------------------------------------------------*/
 void UxGUIUpdateCallbackEditorWidgets( Editor, UxEdList, UxEdCount)
	swidget Editor;
	swidget	*UxEdList;
	int	UxEdCount;
{
#if I_WANT_CB_EDITOR
	UxUpdateCallbackEditorWidgets(Editor, UxEdList, UxEdCount);
#endif
}

/*------------------------------------------------------------------------
 * NAME:	UxGUIResetCBTed()
 * DESCRIPTION: Wrapper function for UxResetCBTed(). 
 *		If don't want users changing callbacks you might as well
 *		deny access to it by recompiling with I_WANT_CB_EDITOR
 *		set to NO.
 * PARAMETERS:	swidget sw 	[I]	The Callback Editor.
 * RETURN:	int			Success
 * LAST REV:	oct 93 fix4543	Created.
 *------------------------------------------------------------------------*/
int UxGUIResetCBTed(sw)
	swidget *sw;
{
#if I_WANT_CB_EDITOR
	return UxResetCBTed(sw);
#else
	return (int) NULL;
#endif
}

/*------------------------------------------------------------------------
 * NAME:	UxGUIPopupFontView()
 * DESCRIPTION: Wrapper function for UxPopupFontView(). Used to bring
 *		up the Font Viewer from the Property Editor. To deny
 *		access recompile with I_WANT_FONT_VIEWER set to NO.
 * PARAMETERS:	swidget UxdlogParent [I] parent calling the viewer.
 *		char*   UxResName    [I] resource we are editing.
 *		char*   UxPrintName  [I] name to use on viewer.
 * RETURN:	swidget			 The Font Viewer interface.
 * LAST REV:	Aug 97 fix17371	Adjust to BE API
 *------------------------------------------------------------------------*/
swidget	UxGUIPopupFontView( UxdlogParent, UxResName, UxPrintName )
	swidget UxdlogParent;
	char	*UxResName;
	char	*UxPrintName;
{
#if I_WANT_FONT_VIEWER
	return UxPopupFontView( UxdlogParent, UxResName, UxPrintName,
				NULL, NULL, NULL, NULL );
#else
	return (swidget) NULL;
#endif
}

/*------------------------------------------------------------------------------
 * NAME:	UxGUIPopupBEFontView()
 * DESCRIPTION: Wrapper function for UxPopupFontView(). Used to bring
 *		up the Font Viewer for Builder Engine Reasons. If holder
 *		is non NULL the passed in functions will be uased rather
 *		than the default Property Editor ones.
 * PARAMETERS:	swidget	UxParent	[I] The parent calling the Font Viewer
 *		char	*UxResName	[I] Not used
 *		char	*UxPrintName	[I] Not used
 *		Widget	holder		{I} BE widget to hold Font.
 *		reserveFun		{I} Called to do special initialization
 *					    and return initial value.
 *		releaseFun		{I} Called upon closing.
 *		depositFun		{I} Called when deposting value.
 * RETURN:	swidget			 The Font View interface.
 * LAST REV:	Aug 97 fix17371 Created.
 *----------------------------------------------------------------------------*/
swidget	UxGUIPopupBEFontView( UxdlogParent, UxResName, UxPrintName, holder, reserveFun, releaseFun, depositFun )
	swidget UxdlogParent;
	char	*UxResName;
	char	*UxPrintName;
        Widget  holder;
        char*   (* reserveFun)();
        void    (* releaseFun)();
        void    (* depositFun)();
{
#if I_WANT_FONT_VIEWER
	return UxPopupFontView( UxdlogParent, UxResName, UxPrintName,
				holder, reserveFun, releaseFun, depositFun );
#else
	return (swidget) NULL;
#endif
}

/*------------------------------------------------------------------------
 * NAME:	UxGUIPopupPixView()
 * DESCRIPTION: Wrapper function for UxPopupPixView(). Used to bring up
 *		The Pixmap Viewer from the Property Editor. To deny
 *		access recompile with I_WANT_PIXMAP_VIEWER set to NO.
 * PARAMETERS:	swidget UxEditParent [I] parent calling the viewer.
 *		char	*UxResName   [I] resource we are editing.
 *		char	*UxPrintName [I] name to use on viewer.
 * RETURN:	swidget			 The Pixmap Viewer interface.
 * LAST REV:	Aug 97 fix17371	Adjust to BE API
 *------------------------------------------------------------------------*/
swidget	UxGUIPopupPixView( UxEditParent, UxResName, UxPrintName )
	swidget UxEditParent;
	char	*UxResName;
	char	*UxPrintName;
{
#if I_WANT_PIXMAP_VIEWER
	return UxPopupPixView( UxEditParent, UxResName, UxPrintName,
		       Uxcreate_view_Motif_pixmap, NULL, NULL, NULL, NULL );
#else
	return (swidget) NULL;
#endif
}

/*------------------------------------------------------------------------------
 * NAME:	UxGUIPopupBEPixView()
 * DESCRIPTION: Wrapper function for UxPopupPixView(). Used to bring
 *		up the Pixmap Viewer for Builder Engine Reasons. If holder
 *		is non NULL the passed in functions will be uased rather
 *		than the default Property Editor ones.
 * PARAMETERS:	swidget	UxParent	[I] The parent calling the Pixmap Viewer
 *		char	*UxResName	[I] Not used.
 *		char	*UxPrintName	[I] Not used.
 *		Widget	holder		{I} BE widget to hold pixmap.
 *		reserveFun		{I} Called to do special initialization
 *					    and return initial value.
 *		releaseFun		{I} Called upon closing.
 *		depositFun		{I} Called when deposting value.
 * RETURN:	swidget			 The PixView interface.
 * LAST REV:	Aug 97 fix17371 Created.
 *----------------------------------------------------------------------------*/
swidget	UxGUIPopupBEPixView( UxEditParent, UxResName, UxPrintName, holder, reserveFun, releaseFun, depositFun )
	swidget UxEditParent;
	char	*UxResName;
	char	*UxPrintName;
        Widget  holder;
        char*   (* reserveFun)();
        void    (* releaseFun)();
        void    (* depositFun)();
{
#if I_WANT_PIXMAP_VIEWER
	return UxPopupPixView( UxEditParent, UxResName, UxPrintName,
				Uxcreate_view_Motif_pixmap, 
				holder, reserveFun, releaseFun, depositFun );
#else
	return (swidget) NULL;
#endif
}

/*------------------------------------------------------------------------
 * NAME:	UxGUIDestroyTextTool()
 * DESCRIPTION: Wrapper function for UxDestroyTextTool(). Used to
 *		destroy a text editor. Does nothing if I_WANT_TEXT_EDITOR
 *		set to NO.
 * PARAMETERS:	swidget tt [I]		The Text Editor to destroy.
 * RETURN:	void
 * LAST REV:	nov 92	Created.
 *------------------------------------------------------------------------*/
void	UxGUIDestroyTextTool (tt)
	swidget tt;
{
#if I_WANT_TEXT_EDITOR
#ifdef ASTEC_EDITOR
	if(UxUeIsEditToolUp(tt))
		UxUeStop(tt);
	else
#endif /* ASTEC_EDITOR */
	 UxDestroyTextTool (tt);
#endif
}

/*------------------------------------------------------------------------
 * NAME:	UxGUICreateTextTool
 * DESCRIPTION: Wrapper function for UxCreateTextTool(). Used to create
 *		a copy of one of our Text Editors. To deny access
 *		recompile with I_WANT_TEXT_EDITOR set to NO.
 * PARAMETERS:	swidget UxDialogParent	[I]	parent who called editor.
 *		char*   UxLeftTitle	[I]	the left title.
 *		char*   UxRightTitle	[I]	the right title.
 *		void (*)() UxOkFunction	[I]	function to use within
 *						the OK callback.
 *		char*	UxOkArg		[I]	argument passed to Okfunction.
 *		void (*)() UxApplyFunction [I]	function to use within
 *						the Apply callback.
 *		char*	UxOkArg		[I]	argument passed to 
 *						Applyfunction.
 *		void (*)() UxCancelFunction [I]	function to use within
 *						the Cancel callback.
 *		char*	UxOkArg		[I]	argument passed to 
 *						Cancelfunction.
 *		void (*)() UxDestFunction [I]	function to use within
 *						the Destroy callback.
 *		char*	UxOkArg		[I]	argument passed to 
 *						Destfunction.
 *		char*	initstring	[I]	initial string
 *		void*	txtw		[I]	text widget
 *
 * NOTE:	The function pointers are used because the way in which the
 *		text which is being edited is handled depends on who has
 *		asked for the text editor. Therefore these functions differ
 *		depending on wether the Property Editor, Declarations Editor,
 *		or Pragram Layout Editor has done the calling.
 *
 *		The function pointers all point to functions of the form,
 *		function ( (swidget) TextShell, (char *) passedArg, 
 *		(char *) Text ) where TextShell is the top level shell
 *		of the text editor, passedArg is for example the UxOkArg,
 *		and Text is the actual Text being handled.
 *
 * RETURN:	swidget		The Text Editor
 *				if using SB, returns NULL
 * LAST REV:	sep 93 fix3768	Added SB functionality
 *------------------------------------------------------------------------*/
swidget UxGUICreateTextTool( UxDialogParent, UxLeftTitle, UxRightTitle, UxOKFunction, UxOKArg, UxApplyFunction, UxApplyArg, UxCancelFunction, UxCancelArg, UxDestFunction, UxDestArg, initstring, txtw)
	swidget UxDialogParent;
	char	*UxLeftTitle;
	char	*UxRightTitle;
	void	(*UxOKFunction)();
	char	*UxOKArg;
	void	(*UxApplyFunction)();
	char	*UxApplyArg;
	void	(*UxCancelFunction)();
	char	*UxCancelArg;
	void	(*UxDestFunction)();
	char	*UxDestArg;
	char	*initstring;
	void	*txtw;
{
#if I_WANT_TEXT_EDITOR
	if (UxUsingSb())
	{
	   UxSbEdit(txtw, initstring, UxApplyFunction, UxApplyArg,
		    UxDestFunction, UxDestArg, UxDialogParent, UxLeftTitle,
		    UxRightTitle, (char *) NULL);
	   return((swidget) NULL);
	}
#ifdef ASTEC_EDITOR
	else if (UxUsingUe()) {
		return UxCreateUe(txtw, UxApplyFunction, UxApplyArg,
				UxDestFunction, UxDestArg, initstring,
				UxLeftTitle, UxRightTitle,
				(void *)UxDialogParent);
	}
#endif /* ASTEC_EDITOR */
	else
	{
	   return(UxCreateTextTool(UxDialogParent, UxLeftTitle, UxRightTitle,
				   UxOKFunction, UxOKArg, UxApplyFunction,
				   UxApplyArg, UxCancelFunction, UxCancelArg,
				   UxDestFunction, UxDestArg));
	}
#else
	return((swidget) NULL);
#endif
}

/*------------------------------------------------------------------------
 * NAME:	UxGUIPopupTextTool()
 * DESCRIPTION: Wrapper function for UxPopupTextTool(). Used to bring up
 *		a text editor that has been created. To remove this
 *		ability recompile with I_WANT_TEXT_EDITOR set to NO.
 * PARAMETERS:	swidget tt	[O]	the text editor
 *		char	*str	[I]	text to load editor with.
 * RETURN:	void
 * LAST REV:	nov 92	Created.
 *------------------------------------------------------------------------*/
void	UxGUIPopupTextTool (tt, str)
	swidget tt;
	char	*str;
{
#if I_WANT_TEXT_EDITOR
	UxPopupTextTool (tt, str);
#endif
}

/*------------------------------------------------------------------------
 * NAME:	UxGUIUpdateTextToolLabelLeft()
 * DESCRIPTION: Wrapper function for UxUpdateTextToolLabelLeft((). Used
 *		to change the Left Title of an existing text editor.
 * PARAMETERS:	vhandle tt	the text editor
 *		char	*str	the new title
 * RETURN:	void
 * LAST REV:	nov 92	Created.
 *------------------------------------------------------------------------*/
void	UxGUIUpdateTextToolLabelLeft (tt, str)
	vhandle tt;
	char	*str;
{
#if I_WANT_TEXT_EDITOR
	UxUpdateTextToolLabelLeft (tt, str);
#endif
}

/*------------------------------------------------------------------------
 * NAME:	UxGUIPopupPLed()
 * DESCRIPTION: Wrapper function for UxPopupPLed(). Used to bring up the
 *		program layout editor. To deny access recompile with
 *		I_WANT_PL_EDITOR set to NO.
 * PARAMETERS:	none
 * RETURN:	swidget		The Program Layout Editor.
 * LAST REV:	nov 92	Created.
 *------------------------------------------------------------------------*/
swidget	UxGUIPopupPLed()
{
#if I_WANT_PL_EDITOR
	return UxPopupPLed();
#else
	return (swidget) NULL;
#endif
}

/*------------------------------------------------------------------------
 * NAME:	UxGUIAboutUimx()
 * DESCRIPTION: Wrapper function for UxAboutUimx(). Brings up the About
 *		box. To remove recompile with I_WANT_HELP set to NO.
 *
 *		UxGUIAboutUimx() is now obsolete but remains
 *		for backwards compatibility. It may be removed
 *		in a future release.
 * PARAMETERS:	none
 * RETURN:	void
 * LAST REV:	mar 96 fix11905 Replaced HELP_ON_PROD_MENU by
 *				HELP_ON_ABOUT_PROD
 *------------------------------------------------------------------------*/
void	UxGUIAboutUimx()
{
#if I_WANT_HELP
	UxGUIPopupHelpBox(HELP_ON_ABOUT_PROD);
#endif
}

/*------------------------------------------------------------------------
 * NAME:	UxGUIGettingStarted()
 * DESCRIPTION: Wrapper function for UxGettingStarted(). Brings up the
 *		Getting Started box. To remove recompile with
 *		I_WANT_HELP set to NO.
 *
 *		UxGUIGettingStarted() is now obsolete but remains
 *		for backwards compatibility. It may be removed
 *		in a future release.
 * PARAMETERS:	none
 * RETURN:	void
 * LAST REV:	mar 96 fix11905	Replaced HELP_ON_INTRO by HELP_ON_OVERVIEW
 *------------------------------------------------------------------------*/
void	UxGUIGettingStarted()
{
#if I_WANT_HELP
	UxGUIPopupHelpBox(HELP_ON_OVERVIEW);
#endif
}

/*------------------------------------------------------------------------------
 * NAME:	UxGUIHelpVolumeName
 * DESCRIPTION: Wrapper that returns a pointer to a static string containing
 *		the name of the help volume. 
 * PARAMETERS:	none
 * RETURN:	char *volumename
 * LAST REV:	Sep 97 fix17583 - name change of Dtuimx to Xpress
 *----------------------------------------------------------------------------*/
char *UxGUIHelpVolumeName()
{
#if I_WANT_HELP
#ifdef DTSCRIPT
	return "DtScript";
#else
#ifdef DTBUILDER
	return "Xpress";
#else
#ifdef PLAT
	if (UxNoviceModeSet())
	{
		return "XkNovice";
	}
	else
	{
		return "Xk";
	}
#else /* UIMX */
	if (UxNoviceModeSet())
	{
		return "UxNovice";
	}
	else
	{
		return "Ux";
	}
#endif /* PLAT */
#endif /* DTBUILDER */
#endif /* DTSCRIPT */
#else 
	return NULL;
#endif /* I_WANT_HELP */
}

/*------------------------------------------------------------------------
 * NAME:	UxGUICoseVolumeName()
 * DESCRIPTION: Wrapper that returns a pointer to a static string containing
 *		the name of the COSE help volume.
 * PARAMETERS:	none
 * RETURN:	char* volumename
 * CREATION:	May 18th, 1994 - fix5371
 *------------------------------------------------------------------------*/
char *UxGUICoseVolumeName()
{
#if I_WANT_HELP
	return "Help4Help";
#else 
	return NULL;
#endif /* I_WANT_HELP */
}

/*------------------------------------------------------------------------
 * NAME:	UxGUIPopupHelpBox()
 * DESCRIPTION: Wrapper function for UxPopupDTHelpBox() and
 *		UxPopupNormalHelpBox(). Brings up the Main Help box.
 *		To remove recompile with I_WANT_HELP set to NO.
 * PARAMETERS:	int helpItem	-- item help being requested for.
 * RETURN:	void
 * LAST REV:	mar 97 fix16679 Call UxPopupIMDHelpBox if
 *				I_WANT_IMD_EXTENSIONS is YES.
 *------------------------------------------------------------------------*/
void	UxGUIPopupHelpBox( helpItem )
	int	helpItem;
{
#if I_WANT_HELP

#if I_WANT_CDE_EXTENSIONS
	UxPopupDTHelpBox( helpItem );
#else
#if I_WANT_IMD_EXTENSIONS
	UxPopupIMDHelpBox( helpItem );
#else
	UxPopupNormalHelpBox( helpItem );
#endif /* I_WANT_IMD_EXTENSIONS */
#endif /* I_WANT_CDE_EXTENSIONS */

#endif /* I_WANT_HELP */
}

/*------------------------------------------------------------------------
 * NAME:	UxGUIPopupActionEditor()
 * DESCRIPTION: Wrapper function for UxPopupActionEditor(). Brings up
 *		the Action Editor. To remove access recompile with
 *		I_WANT_ACTION_EDITOR set to NO.
 * PARAMETERS:	vhandle table_vh [I/O]  the action table.
 * RETURN:	swidget			the action table editor.
 * LAST REV:	nov 92	Created.
 *------------------------------------------------------------------------*/
swidget	UxGUIPopupActionEditor (table_vh)
	vhandle table_vh;
{
#if I_WANT_ACTION_EDITOR
	return UxPopupActionEditor (table_vh);
#else
	return (swidget) NULL;
#endif
}

/*------------------------------------------------------------------------
 * NAME:	UxGUIPopupEventEditor()
 * DESCRIPTION: Wrapper function for UxPopupEventEditor(). Brings up
 *		the Event Editor. To remove access recompile with
 *		I_WANT_EVENT_EDITOR set to NO.
 * PARAMETERS:	char*   Uxttab_editor_context	[I/O] info about existing
 *						      events passed from the
 *						      translation table
 *		char*   Uxtrans_table_name	[I/O] name of translation table
 *		vhandle Uxtable_vh		[I/O] the translation table
 * RETURN:	swidget				      the Event Editor
 * LAST REV:	nov 92	Created.
 *------------------------------------------------------------------------*/
swidget	UxGUIPopupEventEditor (Uxttab_editor_context, Uxtrans_table_name, Uxtable_vh)
	char	*Uxttab_editor_context; 
	char	*Uxtrans_table_name;
	vhandle Uxtable_vh;
{
#if I_WANT_EVENT_EDITOR
	return UxPopupEventEditor (Uxttab_editor_context, Uxtrans_table_name, Uxtable_vh);
#else
	return (swidget) NULL;
#endif
}

/*------------------------------------------------------------------------
 * NAME:	UxGUIPopupDeclEditor()
 * DESCRIPTION: Wrapper function for UxPopupDeclEditor(). Brings up the
 *		Declarations Editor. If not using it recompile with
 *		I_WANT_DECL_EDITOR set to NO.
 * OLD NAME:	Uxde_popup()
 * PARAMETERS:	swidget V_ed	[I/O]	The source associated with the
 *					declarations editor.
 * RETURN:	swidget			The Declarations Editor.
 * LAST REV:	nov 25th, 92	Created.
 *------------------------------------------------------------------------*/
swidget	UxGUIPopupDeclEditor(V_ed)
	swidget	V_ed;
{
#if I_WANT_DECL_EDITOR
	return UxPopupDeclEditor(V_ed);
#else
	return (swidget) NULL;
#endif
}

/*------------------------------------------------------------------------
 * NAME:	UxGUIUpdateDeclEditor()
 * DESCRIPTION: Wrapper function for UxUpdateDeclEditor(). Used to update 
 *		the contents of the declarations editor. If the editor
 *		isn't being used this can be removed by recompiling with
 *		I_WANT_DECL_EDITOR set to NO.
 * OLD NAME:	Uxde_update()
 * PARAMETERS:	vhandle rsvh		The declarations editor
 *		vhandle obsvh		The observer making the update.
 *		int	update type	The observer update type.
 * RETURN:	int	success
 * LAST REV:	nov 92	Created.
 *------------------------------------------------------------------------*/
int	UxGUIUpdateDeclEditor(rsvh, obsvh, update_type)
	vhandle	rsvh; 
	vhandle	obsvh;
	int	update_type;
{
#if I_WANT_DECL_EDITOR
	return UxUpdateDeclEditor(rsvh, obsvh, update_type);
#else
	return (int) NULL;
#endif
}

/*------------------------------------------------------------------------------
 * NAME:	UxGUIPopupArrange
 * DESCRIPTION:	Wrapper function for UxPopupArrange(). Use to bring up the
 *		arrange options interface. To keep them unchanged you can
 *		deny access to this interface by recompiling with
 *		I_WANT_ARRANGE_OPTIONS set to NO.
 * PARAMETERS:	swidget* UxHolder	[I/O]	the current grid options
 * RETURN:	swidget				the grid options interface
 * LAST REV:	mar 96 fix13008	Created.
 *----------------------------------------------------------------------------*/
swidget UxGUIPopupArrange( UxHolder )
	swidget *UxHolder;
{
#if I_WANT_ARRANGE_OPTIONS
	return UxPopupArrange( UxHolder );
#else
	return (swidget) NULL;
#endif
}

/*------------------------------------------------------------------------------
 * NAME:	UxGUIPopupGrid()
 * DESCRIPTION: Wrapper function for UxPopupGrid(). Use to bring up the
 *		grid options interface. To keep them unchanged you can deny
 *		access to this interface by recompiling with 
 *		I_WANT_GRID_OPTIONS set to NO. 
 * PARAMETERS:	swidget* UxHolder	[I/O]	the current grid options
 * RETURN:	swidget				the grid options interface
 * LAST REV:	nov 92	Created.
 *----------------------------------------------------------------------------*/
swidget	UxGUIPopupGrid( UxHolder )
	swidget *UxHolder;
{
#if I_WANT_GRID_OPTIONS
	return UxPopupGrid( UxHolder );
#else
	return (swidget) NULL;
#endif
}

/*------------------------------------------------------------------------------
 * NAME:	UxGUIPopupBubbleHelp()
 * DESCRIPTION: Wrapper function for UxPopupBubbleHelp(). Use to bring up the
 *		bubble help options interface. To keep them unchanged you
 *		can deny access to this interface by recompiling with 
 *		I_WANT_BHELP_OPTIONS set to NO. 
 * PARAMETERS:	swidget* UxHolder	the current bubble help options
 * RETURN:	swidget			the bubble help options interface
 * LAST REV:	july 96 fix14795 Created.
 *----------------------------------------------------------------------------*/
swidget	UxGUIPopupBubbleHelp( UxHolder )
	swidget *UxHolder;
{
#if I_WANT_BHELP_OPTIONS
	return UxPopupBubbleHelp( UxHolder );
#else
	return (swidget) NULL;
#endif
}

/*------------------------------------------------------------------------
 * NAME:	UxGUITransTableEditorObsUpdate()
 * DESCRIPTION: Wrapper function for UxTransTableEditorObsUpdate(). 
 * 	 	This function is for updates on the WIDGET, not the 
 *		translation table. Two 'observer list' managers exist 
 *		in UIMX, and they are handled differently.
 * PARAMETERS:	vhandle -interface toplevel swidget,
 *		vhandle -observer data object, 
 *		int -type of update
 * RETURN:	int
 * LAST REV:	dec 92	Created.
 *------------------------------------------------------------------------*/
int	UxGUITransTableEditorObsUpdate (rsvh, obsvh, type)
	vhandle rsvh;
	vhandle obsvh;
	int	type;
{
#if I_WANT_TTAB_EDITOR
	return UxTransTableEditorObsUpdate (rsvh, obsvh, type); 
#else
	return 0;
#endif
}

/*------------------------------------------------------------------------
 * NAME:	UxGUIPopupTranslationTableEditor()
 * DESCRIPTION: Wrapper function for UxPopupTranslationTableEditor(). 
 * PARAMETERS:	vhandle,vhandle
 * RETURN:	swidget
 * LAST REV:	dec 92	Created.
 *------------------------------------------------------------------------*/
swidget	UxGUIPopupTranslationTableEditor(Uxtable_vh, Uxinterface)
	vhandle Uxtable_vh;
	vhandle Uxinterface;
{
#if I_WANT_TTAB_EDITOR
	return UxPopupTranslationTableEditor(Uxtable_vh, Uxinterface);
#else
	return (swidget) NULL;
#endif
}

/*------------------------------------------------------------------------
 * NAME:	UxGUITransTableApplyFromEventEditor()
 * DESCRIPTION: Wrapper function for UxTransTableApplyFromEventEditor(). 
 *		Applies the new event string created with the event editor to
 *		the currently selected entry in the translation table editor.
 *		If there are no entries, an error message is displayed.
 * PARAMETERS:	char* pointer to editor context, char* new event string
 * RETURN:	void
 * LAST REV:	dec 92	Created.
 *------------------------------------------------------------------------*/
void	UxGUITransTableApplyFromEventEditor (ttab_editor_context, event_string)
	char	*ttab_editor_context;
	char	*event_string;
{
#if I_WANT_TTAB_EDITOR
	UxTransTableApplyFromEventEditor (ttab_editor_context, event_string);
#endif
}

/*------------------------------------------------------------------------
 * NAME:	UxGUITransTableListObsUpdate()
 * DESCRIPTION: Wrapper function for UxTransTableListObsUpdate(). 
 *	 	This function is for updates on the WIDGET, not the 
 *		translation table. Two 'observer list' managers exist 
 *		in UIMX, and they are handled differently.
 * PARAMETERS:	vhandle -interface toplevel swidget ,
 *		vhandle -observer data object,
 *		int -type of update
 * RETURN:	int ERROR/NO_ERROR
 * LAST REV:	dec 92	Created.
 *----------------------------------------------------------------------*/
int	UxGUITransTableListObsUpdate (rsvh, obsvh, type)
	vhandle rsvh;
	vhandle obsvh;
	int	type;
{
#if I_WANT_TTAB_LIST
	return UxTransTableListObsUpdate (rsvh, obsvh, type);
#else
	return 0;
#endif
}
/*------------------------------------------------------------------------
 * NAME:	UxGUIPopupTransTableList()
 * DESCRIPTION: Wrapper function for UxPopupTransTableList().
 * PARAMETERS: 	vhandle, vhandle,int 
 * RETURN:	swidget
 * LAST REV:	dec 92	Created.
 *------------------------------------------------------------------------*/
swidget	UxGUIPopupTransTableList (Uxinterface, Uxtable_list, raise)
	vhandle Uxinterface;
	vhandle Uxtable_list;
	int raise;
{
#if I_WANT_TTAB_LIST
	return UxPopupTransTableList (Uxinterface, Uxtable_list, raise);
#else
	return (swidget) NULL;
#endif
}

/*------------------------------------------------------------------------
 * NAME:	UxGUISetSelectStateOfTransTableIcon()
 * DESCRIPTION: Wrapper function for UxSetSelectStateOfTransTableIcon().
 * PARAMETERS: 	swidget	
 * RETURN:	void
 * LAST REV:	dec 92	Created.
 *------------------------------------------------------------------------*/
void	UxGUISetSelectStateOfTransTableIcon( item )
	swidget item;
{
#if I_WANT_TTAB_LIST
	UxSetSelectStateOfTransTableIcon( item );
#endif
}

/*------------------------------------------------------------------------
 * NAME:	UxGUIMeObsUpdateMenu()
 * DESCRIPTION: Wrapper function for UxMeObsUpdateMenu().
 *		Updates the menu editor when the menu is modified 
 *		elsewhere.
 * OLD:		Uxme_obs_update_menu
 * PARAMETERS: 	vhandle - edited widget, vhandle -observer form,
 *		int -type of update required	
 * RETURN:	int
 * LAST REV:	dec 92	Created.
 *------------------------------------------------------------------------*/
int	UxGUIMeObsUpdateMenu (rsvh, obsvh, update_type)
	vhandle	rsvh;
	vhandle	obsvh;
	int	update_type;
{
#if I_WANT_MENU_EDITOR
	return UxMeObsUpdateMenu (rsvh, obsvh, update_type);
#else
	return 0;
#endif
}

/*------------------------------------------------------------------------
 * NAME:	UxGUIMeObsUpdateButt()
 * DESCRIPTION: Wrapper function for UxMeObsUpdateButt().
 *	 	Updates a button in the menu editor when properties
 *		of the button are changed elsewhere.
 * OLD:		Uxme_obs_update_butt
 * PARAMETERS: 	vhandle -edited widget, vhandle -observer form,
 *		int -type of update required
 * RETURN:	int
 * LAST REV:	dec 92	Created.
 *------------------------------------------------------------------------*/
int	UxGUIMeObsUpdateButt (rsvh, obsvh, update_type)
	vhandle	rsvh;
	vhandle	obsvh;
	int	update_type;
{
#if I_WANT_MENU_EDITOR
	return UxMeObsUpdateButt (rsvh, obsvh, update_type);
#else
	return 0;
#endif
}

/*------------------------------------------------------------------------
 * NAME:	UxGUIMeObsUpdateSep()
 * DESCRIPTION: Wrapper function for UxMeObsUpdateSep().
 * OLD:		Uxme_obs_update_sep()
 * PARAMETERS: 	vhandle -edited widget, vhandle -observer form,
 *		int -type of update required
 * RETURN:	int
 * LAST REV:	dec 92	Created.
 *------------------------------------------------------------------------*/
int	UxGUIMeObsUpdateSep (rsvh, obsvh, update_type)
	vhandle	rsvh;
	vhandle	obsvh;
	int	update_type;
{
#if I_WANT_MENU_EDITOR
	return UxMeObsUpdateSep (rsvh, obsvh, update_type);
#else
	return 0;
#endif
} 

/*------------------------------------------------------------------------
 * NAME:	UxGUIMeObsUpdateMenuEd()
 * DESCRIPTION: Wrapper function for UxMeObsUpdateMenuEd().
 *		Updates the menu editor when the parent to which the
 *		menu is attached is modified elsewhere.
 * OLD:		Uxme_obs_update_menu_ed()
 * PARAMETERS: 	vhandle -edited widget, vhandle -observer form,
 *		int -type of update required
 * RETURN:	int
 * LAST REV:	dec 92	Created.
 *------------------------------------------------------------------------*/
int	UxGUIMeObsUpdateMenuEd (rsvh, obsvh, update_type)
	vhandle	rsvh;
	vhandle	obsvh;
	int	update_type;
{
#if I_WANT_MENU_EDITOR
	return UxMeObsUpdateMenuEd (rsvh, obsvh, update_type);
#else
	return 0;
#endif
}

/*------------------------------------------------------------------------------
 * NAME:	UxGUIMeObsUpdatePane()
 * DESCRIPTION:	Wrapper function for UxMeObsUpdatePane().
 *		Updates a pane in the menu editor when the properties
 *		of the pane are changed elsewhere.
 * OLD:		Uxme_obs_update_pane()
 * PARAMETERS:	vhandle -edited widget, vhandle -observer form,
 *		int -type of update required
 * RETURN:	int
 * LAST REV:	dec 92	Created.
 *----------------------------------------------------------------------------*/
int	UxGUIMeObsUpdatePane (rsvh, obsvh, update_type)
	vhandle	rsvh;
	vhandle	obsvh;
	int	update_type;
{
#if I_WANT_MENU_EDITOR
	return UxMeObsUpdatePane (rsvh, obsvh, update_type);
#else
	return 0;
#endif
}

/*------------------------------------------------------------------------------
 * NAME:	UxGUINoviceMePopup
 * DESCRIPTION:	Opens a menu editor.
 * PARAMETERS:	swidget sw	- ApplicationShell in Xpress and Novice Mode.
 * RETURN:	swidget of new menu editor
 * LAST REV:	nov 94 fix6446	Created.
 *----------------------------------------------------------------------------*/
swidget UxGUINoviceMePopup(sw)
	swidget sw;
{
#if I_WANT_MENU_EDITOR
	return UxNoviceMePopup(sw);
#else
	return (swidget) NULL;
#endif
}

/*------------------------------------------------------------------------------
 * NAME:	UxGUIMePopup()
 * DESCRIPTION: Wrapper function for UxMePopup().
 *		Opens a menu editor.
 *		If an existing menu is passed, or disallow_multiple is true,
 *		checks for an existing menu editor of that sort and raises it
 *		(after a dialog, if the existing session is on an 
 *		un-applied menu).
 * OLD:		Uxme_popup()
 * PARAMETERS:	swidget	parent - widget to which we are adding a menu
 *		swidget	menu
 *		int	menu_type
 *		int	disallow_multiple
 * RETURN:	swidget of new menu editor
 * LAST REV:	dec 92	Created.
 *----------------------------------------------------------------------------*/
swidget	UxGUIMePopup (parent, menu, menu_type, disallow_multiple)
	swidget parent;
	swidget menu;
	int	menu_type;
	int	disallow_multiple;
{
#if I_WANT_MENU_EDITOR
	return UxMePopup (parent, menu, menu_type, disallow_multiple);
#else
	return (swidget) NULL;
#endif
}

/*------------------------------------------------------------------------
 * NAME:	UxGUIMeEditedMenu()
 * DESCRIPTION: Wrapper function for UxMeEditedMenu().
 * OLD:		Uxme_edited_menu()
 * PARAMETERS: 	vhandle	editor_vh	- vhandle of menu editor
 *		vhandle	*men_vh		- vhandle of menu
 *		int	*type		- type of menu edited
 * RETURN:	int
 * LAST REV:	dec 92	Created.
 *------------------------------------------------------------------------*/
int	UxGUIMeEditedMenu (editor_vh, men_vh, type)
	vhandle	editor_vh;
	vhandle	*men_vh;
	int	*type;
{
#if I_WANT_MENU_EDITOR
	return UxMeEditedMenu (editor_vh, men_vh, type);
#else
	return 0;
#endif
}

/*------------------------------------------------------------------------
 * NAME:	UxGUIMeBlocksAddUpdate()
 * DESCRIPTION: Wrapper function for UxMeBlocksAddUpdate().
 *		Called by the UxAddBrowserComponent() to check if the
 *		menuEditor is blocking the udpate from UxOBS_ADD since
 *		the swidget added is not in its proper creationOrder yet.
 * OLD:		UxMEBlocksAddUpdate() 
 * PARAMETERS: 	none	
 * RETURN:	Boolean
 * LAST REV:	dec 92	Created.
 *------------------------------------------------------------------------*/
Boolean	UxGUIMeBlocksAddUpdate()
{
#if I_WANT_MENU_EDITOR
	return UxMeBlocksAddUpdate();
#else
	return False;
#endif
}

/*------------------------------------------------------------------------
 * NAME:	UxGUIMwePopup()
 * DESCRIPTION: Wrapper function for UxMwePopup().
 * OLD:		Uxmwe_popup()
 * PARAMETERS: 	swidget
 * RETURN:	swidget
 * LAST REV:	feb 93	One parameter only.
 *------------------------------------------------------------------------*/
swidget UxGUIMwePopup(rs)
	swidget	rs;
{
#if I_WANT_MAINWIN_EDITOR
	return UxMwePopup(rs);
#else
	return (swidget) NULL;
#endif
}

/*------------------------------------------------------------------------
 * NAME:	UxGUIMweObsUpdate()
 * DESCRIPTION: Wrapper function for UxMweObsUpdate().
 * OLD:		UxmweObsUpdate()
 * PARAMETERS: 	vhandle, vhandle,int	
 * RETURN:	int
 * LAST REV:	dec 92	Created.
 *------------------------------------------------------------------------*/
int	UxGUIMweObsUpdate(rsvh, obsvh, update_type)
	vhandle	rsvh;
	vhandle	obsvh;
	int	update_type;
{
#if I_WANT_MAINWIN_EDITOR
	return UxMweObsUpdate(rsvh, obsvh, update_type);
#else
	return 0;
#endif
}

/*------------------------------------------------------------------------
 * NAME:	UxGUIPopupConsEditor()
 * DESCRIPTION: Wrapper function for UxPopupConsEditor().
 * PARAMETERS: 	swidget
 * RETURN:	swidget
 * LAST REV:	aug 95	Created.
 *------------------------------------------------------------------------*/
swidget UxGUIPopupConsEditor(rs)
	swidget	rs;
{
#if I_WANT_CONSTRAINT_EDITOR
	return UxPopupConsEditor(rs);
#else
	return (swidget) NULL;
#endif
}

/*------------------------------------------------------------------------
 * NAME:	UxGUIDialog()
 * DESCRIPTION: Wrapper function for UxDialog().
 * PARAMETERS:	char * msg_str	- explanation of filename
 *		char * default_str - default filename
 *		char **result	- set to file name when user chose Ok	
 * RETURN:	int		- 1 if use chose Ok, 0 if user choose cancel.
 * LAST REV:	dec 92	Created.
 *------------------------------------------------------------------------*/
int	UxGUIDialog (msg_str, default_str, result)
	char	*msg_str;
	char	*default_str;
	char	**result;
{
#if I_WANT_FILE_BOX
	return UxDialog (msg_str, default_str, result);
#else
	return 0;
#endif
}

/*------------------------------------------------------------------------
 * NAME:	UxGUIDialogValidated()
 * DESCRIPTION: Wrapper function for UxDialogValidated().
 * PARAMETERS: 	char *msg		- explanation of filename
 *		char *default_str	- default filename
 *		char **result;		- set to file name when user chose Ok.
 *		char *(*Validator)();	- Validation Routine.	
 * RETURN:	int - 1 if use chose Ok, 0 if user choose cancel.
 * LAST REV:	dec 92	Created.
 *------------------------------------------------------------------------*/
int	UxGUIDialogValidated (msg_str, default_str, result, Validator)
	char	*msg_str;
	char	*default_str;
	char	**result;
	char	*(*Validator)();
{
#if I_WANT_FILE_BOX
	return UxDialogValidated (msg_str, default_str, result, Validator);
#else
	return 0;
#endif
}

#ifdef _IBMR2
/*------------------------------------------------------------------------
 * NAME:	UxGUICodeDialog()
 * DESCRIPTION: Wrapper function for UxCodeDialog().
 *	 	Similar to UxDialog except it builds an FSB with an 
 *		extra toggle button. Used for loading in object code 
 *		files on AIX
 * PARAMETERS:	char	*msg_str	- string to label input area in FSB
 *		char	*default_str	- default filename in FSB
 *		char	**result	- set to file name when user chooses OK
 *		int	*toggle		- stores value of toggle button if
 *					  user chose OK
 * RETURN:	int	- 1 if user chose OK, 0 otherwise 
 * LAST REV:	dec 92	Created.
 *------------------------------------------------------------------------*/
int	UxGUICodeDialog (msg_str, default_str, result, toggle)
	char	*msg_str;
	char	*default_str;
	char	**result;
	int	*toggle;
{
#if I_WANT_FILE_BOX
	return UxCodeDialog (msg_str, default_str, result, toggle);
#else
	return 0;
#endif
}
#endif /* _IBMR2 */

/*------------------------------------------------------------------------
 * NAME:	UxGUIPeRelease()
 * DESCRIPTION: Wrapper function for UxPeRelease().
 * PARAMETERS: 	swidget, swidget	
 * RETURN:	void
 * LAST REV:	dec 92	Created.
 *------------------------------------------------------------------------*/
void	UxGUIPeRelease (parent, dialog)
	swidget	parent;
	swidget	dialog;
{
#if I_WANT_PROPERTY_EDITOR
	UxPeRelease (parent, dialog);
#endif
}

/*------------------------------------------------------------------------
 * NAME:	UxGUIPeReserve()
 * DESCRIPTION: Wrapper function for UxPeReserve().
 *		This is the function the editor uses to take control of a 
 *		resource. It will usually be called on the resource that 
 *		triggered the editor.
 * 		All resources the editor reserves will be insensitive until 
 *		the it calls UxPeRelease.
 * PARAMETERS: 	swidget	-As passed to popup function
 *		char* 	-XtName of resource
 *		swidget -The editor interface	
 *		char** 	- Uimx sends back the value...
 *		PeSlot_t**	- ... and a handle
 * RETURN:	Boolean
 * LAST REV:	dec 92	Created.
 *------------------------------------------------------------------------*/
Boolean	UxGUIPeReserve (parent, resname, editor, out_val, out_slot)
	swidget		parent; 
	char		*resname;
	swidget		editor; 
	char		**out_val;
	PeSlot_t	**out_slot;
{
#if I_WANT_PROPERTY_EDITOR
	return UxPeReserve (parent, resname, editor, out_val, out_slot);
#else
	return (Boolean) NULL;
#endif
}

/*------------------------------------------------------------------------
 * NAME:	UxGUIPeDepositValue()
 * DESCRIPTION: Wrapper function for UxPeDepositValue().
 *		This is the function the editor uses to return its results
 * 		to Uimx. 'slot' identifies the resource, as obtained 
 *		from UxPeReserve ()
 * 		The value string should be a C code form initial 
 *		value expression.
 * PARAMETERS: 	swidget, PeSlot_t*, char*	
 * RETURN:	void
 * LAST REV:	dec 92	Created.
 *------------------------------------------------------------------------*/
void	UxGUIPeDepositValue (parent, slot, value)
	swidget		parent;
	PeSlot_t	*slot;
	char		*value;
{
#if I_WANT_PROPERTY_EDITOR
	UxPeDepositValue (parent, slot, value);
#endif
}

/*------------------------------------------------------------------------
 * NAME:	UxGUIPeDepositSource()
 * DESCRIPTION: Wrapper function for UxPeDepositSource().
 *		This is the function the editor uses to return a new 
 *		SourceFlag to Uimx. The 'slot' identifies the resource/row, 
 *		as obtained for UxPeReserve.
 * PARAMETERS: 	swidget, PeSlot_t*, int.	
 * RETURN:	void
 * LAST REV:	dec 92	Created.
 *------------------------------------------------------------------------*/
void	UxGUIPeDepositSource (parent, slot, src)
	swidget		parent;
	PeSlot_t	*slot;
	int		src;
{
#if I_WANT_PROPERTY_EDITOR
	UxPeDepositSource (parent, slot, src);
#endif
}

/*------------------------------------------------------------------------
 * NAME:	UxGUIPopupPropertyEditor()
 * DESCRIPTION: Wrapper function for UxPopupPropertyEditor().
 * PARAMETERS: 	object*	 - swidget OR PList of swidgets .	
 * RETURN:	swidget	 -the new editor popped up, or NULL
 * LAST REV:	dec 92	Created.
 *------------------------------------------------------------------------*/
swidget	UxGUIPopupPropertyEditor (sw_or_list)
	object*	sw_or_list;
{
#if I_WANT_PROPERTY_EDITOR
	return UxPopupPropertyEditor (sw_or_list);
#else
	return (swidget) NULL;
#endif
}

/*------------------------------------------------------------------------
 * NAME:	UxGUIStartupPropertyEditor()
 * DESCRIPTION: Wrapper function for UxStartupPropertyEditor().
 * PARAMETERS: 	object*	 - swidget OR PList of swidgets .	
 * RETURN:	swidget	 -the new editor popped up, or NULL
 * LAST REV:	dec 92	Created.
 *------------------------------------------------------------------------*/
swidget	UxGUIStartupPropertyEditor (sw_or_list)
	object*	sw_or_list;
{
#if I_WANT_PROPERTY_EDITOR
	return UxStartupPropertyEditor (sw_or_list);
#else
	return (swidget) NULL;
#endif
}

/*------------------------------------------------------------------------
 * NAME:	UxGUIPopupConnectionEditor()
 * DESCRIPTION: Wrapper function for UxPopupConnectionEditor().
 * PARAMETERS:	srcsw	- source swidget (may be NULL)
 *		dstsw	- destination swidget (may be NULL)
 * RETURN:	swidget	- the new editor popped up, or NULL
 * LAST REV:	jan 94	Created.
 *------------------------------------------------------------------------*/
swidget UxGUIPopupConnectionEditor (srcsw, dstsw)
	swidget	srcsw;
	swidget dstsw;
{
#if I_WANT_CONNECTION_EDITOR
	return UxPopupConnectionEditor (srcsw,dstsw);
#else
	return (swidget) NULL;
#endif
}

/*------------------------------------------------------------------------
 * NAME:	UxGUIUsingConnectionEditor()
 * DESCRIPTION: Used to indicate wether Connection Editor is present.
 * PARAMETERS:	none
 * RETURN:	int - YES or NO
 * LAST REV:	jan 94	Created.
 *------------------------------------------------------------------------*/
int UxGUIUsingConnectionEditor ()
{
	return (int) I_WANT_CONNECTION_EDITOR;
}


/*------------------------------------------------------------------------
 * NAME:	UxGUIPtObsUpdate()
 * DESCRIPTION: Wrapper function for UxPtObsUpdate().
 *		Updates the property table when values are changed
 * OLD:		UxptObsUpdate()
 * PARAMETERS: 		
 *		vhandle rsvh;		- edited widget
 *		vhandle obsvh;		- observer form
 *		int	update_type;	- type of update required
 * RETURN:	int
 * LAST REV:	dec 92	Created.
 *------------------------------------------------------------------------*/
int	UxGUIPtObsUpdate (rsvh, obsvh, update_type)
	vhandle	rsvh;
	vhandle	obsvh;
	int	update_type;
{
#if I_WANT_PROPERTY_EDITOR
	return UxPtObsUpdate (rsvh, obsvh, update_type);
#else
	return (int) NULL;
#endif
}

/*------------------------------------------------------------------------
 * NAME:	UxGUICopyright()
 * DESCRIPTION: Wrapper function for UxCopyright().
 *		Puts up working dialog box with no buttons. The text 
 *		displayed is the copyright message text, with the 
 *		Initializing message.
 * PARAMETERS: 	none	
 * RETURN:	void
 * LAST REV:	dec 92	Created.
 *------------------------------------------------------------------------*/
void	UxGUICopyright()
{
#if I_WANT_CPWRT_BOX
	UxCopyright();
#endif
}

/*------------------------------------------------------------------------
 * NAME:	UxGUIWarning()
 * DESCRIPTION: Wrapper function for UxWarning().
 *		Invokes warning dialog. To Disable recompile with
 *		I_WANT_MSG_BOX set to NO. When disabled the return
 *		value is always 1.
 * PARAMETERS: 	swidget	
 * RETURN:	int (ok=1 or cancel=0)
 * LAST REV:	dec 92	Created.
 *------------------------------------------------------------------------*/
int	UxGUIWarning (str)
	char	*str;
{
#if I_WANT_MSG_BOX
	return UxWarning (str);
#else
	return (int) 1;
#endif
}

/*------------------------------------------------------------------------
 * NAME:	UxGUIStatus()
 * DESCRIPTION: Wrapper function for UxStatus().
 *		Invokes status dialog. To Disable recompile with
 *		I_WANT_MSG_BOX set to NO. When disabled the return
 * PARAMETERS: 	char* -status message	
 * RETURN:	int (ok=1 or cancel=0)
 * LAST REV:	dec 92	Created.
 *------------------------------------------------------------------------*/
int	UxGUIStatus (str)
	char	*str;
{
#if I_WANT_MSG_BOX
	return UxStatus (str);
#else
	return (int) 1;
#endif
}

/*------------------------------------------------------------------------
 * NAME:	UxGUIError()
 * DESCRIPTION: Wrapper function for UxError().
 *		Invokes error dialog. To Disable recompile with
 *		I_WANT_MSG_BOX set to NO. When disabled the return
 *		value is always 1.
 * PARAMETERS: 	char*	- error message	
 * RETURN:	int (ok=1 or cancel=0)
 * LAST REV:	dec 92	Created.
 *------------------------------------------------------------------------*/
int	UxGUIError (str)
	char	*str;
{
#if I_WANT_MSG_BOX
	return UxError (str);
#else
	return (int) 1L;
#endif
}

/*------------------------------------------------------------------------
 * NAME:	UxGUIFatalError()
 * DESCRIPTION: Wrapper function for UxFatalError().
 *		Used in the course of handling a crash to present a
 *		final error dialog. Sets FatalError flag that disables
 *		such things as cursor changes, so this should only be
 *		used in last resort. To Disable recompile with
 *		I_WANT_MSG_BOX set to NO. When disabled the return
 *		value is always 1.
 * PARAMETERS: 	char* - error message	
 * RETURN:	int (ok=1 or cancel=0)
 * LAST REV:	dec 92	Created.
 *-------------------------------------------------------------------------*/
int	UxGUIFatalError (str)
	char*	str;
{
#if I_WANT_MSG_BOX
	return UxFatalError (str);
#else
	return (int) 1;
#endif
}

/*------------------------------------------------------------------------
 * NAME:	UxGUIWarningGeneric()
 * DESCRIPTION: Wrapper function for UxWarningGeneric().
 *		Invokes generic warning dialog. To Disable recompile with
 *		I_WANT_MSG_BOX set to NO. When disabled the return
 *		value is always 1.
 * PARAMETERS: 	char*	{I} message string
 *		char*	{I} OK button Label
 *		char*	{I} Cancel button Label	
 *		char*	{I} middle button Label	
 * RETURN:	int (ok=1 or cancel=0)
 * LAST REV:	dec 92	Created.
 *------------------------------------------------------------------------*/
int	UxGUIWarningGeneric (str, okLabel, cancelLabel, middleLabel)
	char	*str;
	char	*okLabel;
	char	*cancelLabel;
	char	*middleLabel;
{
#if I_WANT_MSG_BOX
	return UxWarningGeneric (str, okLabel, cancelLabel, middleLabel);
#else
	return (int) 1;
#endif
}

/*------------------------------------------------------------------------
 * NAME:	UxGUILoadBrowserCB()
 * DESCRIPTION: Wrapper function for UxLoadBrowserCB().
 *		Callback function that loads a given swidget into the Browser
 *		Checks first is the required widget is not the one already 
 *		loaded in which case, it clears the browser, clears the 
 *		select list, sets the browser's title and populates the 
 *		browser.
 * PARAMETERS:	Widget, XtPointer, XmToggleButtonCallbackStruct*	
 * RETURN:	void
 * REVISIONS:	nov94 convertion to XtPointer
 *------------------------------------------------------------------------*/
void	UxGUILoadBrowserCB(wid, client_data, call_data)
	Widget				wid;
	XtPointer			client_data;
	XmToggleButtonCallbackStruct	*call_data;
{
#if I_WANT_BROWSER
	UxLoadBrowserCB(wid, client_data, call_data);
#endif
}


/*------------------------------------------------------------------------
 * NAME:	UxGUIObsBrowser()
 * DESCRIPTION: Wrapper function for UxObsBrowser().
 *		Updates the browser when it is updated internally or from
 *		another editor.
 * PARAMETERS:	vhandle - edited widget
 *		vhandle - observer form
 *		int	- type of update required	
 * RETURN:	int
 * LAST REV:	dec 92	Created.
 *------------------------------------------------------------------------*/
int	UxGUIObsBrowser (swVh, obsVh, updateType)
	vhandle	swVh;
	vhandle	obsVh;
	int	updateType;
{
#if I_WANT_BROWSER
	return UxObsBrowser (swVh, obsVh, updateType);
#else
	return (int) NULL;
#endif
}

/*------------------------------------------------------------------------
 * NAME:	UxGUISetBrowserReorderFlag()
 * DESCRIPTION: Wrapper function for UxSetBrowserReorderFlag().
 *		Sets a flag so that UxOBS_REORDER update type may be 
 *		ignored or honored
 * PARAMETERS: 	Boolean	
 * RETURN:	void
 * LAST REV:	dec 92	Created.
 *------------------------------------------------------------------------*/
void	UxGUISetBrowserReorderFlag( honor )
	Boolean	honor;
{
#if I_WANT_BROWSER
	UxSetBrowserReorderFlag( honor );
#endif
}

/*------------------------------------------------------------------------
 * NAME:	UxGUIUpdateBrowserStartup()
 * DESCRIPTION: Wrapper function for UxUpdateBrowserStartup().
 * PARAMETERS: 	swidget	
 * RETURN:	void
 * LAST REV:	dec 92	Created.
 *------------------------------------------------------------------------*/
void	UxGUIUpdateBrowserStartup( reparentedSwidget )
	swidget	reparentedSwidget;
{
#if I_WANT_BROWSER
	UxUpdateBrowserStartup( reparentedSwidget );
#endif
}

/*------------------------------------------------------------------------
 * NAME:	UxGUIGetIfBrowser()
 * DESCRIPTION: Wrapper function for UxGetIfBrowser().
 * PARAMETERS: 	swidget	
 * RETURN:	ifBrowser*
 * LAST REV:	dec 92	Created.
 *------------------------------------------------------------------------*/
ifBrowser*	UxGUIGetIfBrowser( container )
	swidget	container;
{
#if I_WANT_BROWSER
	return UxGetIfBrowser( container );
#else
	return ( ifBrowser* ) NULL;
#endif
}

/*------------------------------------------------------------------------
 * NAME:	UxGUIPopupIfBrowser()
 * DESCRIPTION: Wrapper function for UxPopupIfBrowser().
 *		It is the 'Interface function' which is the
 *		external entry point for creating this interface.
 *		This function should be called from your application or from
 *		a callback function.
 * PARAMETERS: 	vhandle	
 * RETURN:	swidget
 * LAST REV:	dec 92	Created.
 *------------------------------------------------------------------------*/
swidget	UxGUIPopupIfBrowser( Uxinterface )
	vhandle	Uxinterface;
{
#if I_WANT_BROWSER
	return UxPopupIfBrowser( Uxinterface );
#else
	return (swidget) NULL;
#endif
}

/*------------------------------------------------------------------------
 * NAME:	UxGUICreateIfBrowser()
 * DESCRIPTION: Wrapper function for UxCreateIfBrowser().
 *		It is the 'Interface function' which is the
 *		external entry point for creating this interface.
 *		This function should be called from your application or from
 *		a callback function.
 * PARAMETERS: 	vhandle	
 * RETURN:	swidget
 * LAST REV:	jan 93	Created.
 *------------------------------------------------------------------------*/
swidget	UxGUICreateIfBrowser( Uxinterface )
	vhandle	Uxinterface;
{
#if I_WANT_BROWSER
	return UxCreateIfBrowser( Uxinterface );
#else
	return (swidget) NULL;
#endif
}

/*------------------------------------------------------------------------
 * NAME:	UxGUISelectedSwidgetsInThisBrowser()
 * DESCRIPTION: Wrapper function for UxSelectedSwidgetsInThisBrowser().
 *		Returns the first item in the selectList owned by an 
 *		ifBrowser class.
 * PARAMETERS: 	ifBrowser*	
 * RETURN:	swidget
 * LAST REV:	dec 92	Created.
 *------------------------------------------------------------------------*/
swidget	UxGUISelectedSwidgetsInThisBrowser( if_browser )
	ifBrowser*	if_browser;
{
#if I_WANT_BROWSER
	return UxSelectedSwidgetsInThisBrowser( if_browser );
#else
	return (swidget) NULL;
#endif
}

/*------------------------------------------------------------------------
 * NAME:	UxGUIBrowserTextAppend()
 * DESCRIPTION: Wrapper function for UxBrowserTextAppend().
 * PARAMETERS: 	char*	
 * RETURN:	void
 * LAST REV:	dec 92	Created.
 *------------------------------------------------------------------------*/
void	UxGUIBrowserTextAppend(msg)
	char*	msg;
{
#if I_WANT_BROWSER
	UxBrowserTextAppend(msg);
#endif
}

/*------------------------------------------------------------------------
 * NAME:	UxGUIDealWithBrowserAsStartup()
 * DESCRIPTION: Wrapper function for UxDealWithBrowserAsStartup().
 *		Selects sw which causes UxSelListObs() to kick in
 * PARAMETERS: 	swidget	
 * RETURN:	void
 * LAST REV:	dec 92	Created.
 *------------------------------------------------------------------------*/
void	UxGUIDealWithBrowserAsStartup (sw)
	swidget	sw;
{
#if I_WANT_BROWSER
	UxDealWithBrowserAsStartup (sw);
#endif
}

/*------------------------------------------------------------------------
 * NAME:	UxGUIAddBrowserComponent()
 * DESCRIPTION: Wrapper function for UxAddBrowserComponent().
 * PARAMETERS: 	ifBrowser*, swidget, swidget	
 * RETURN:	void
 * LAST REV:	dec 92	Created.
 *------------------------------------------------------------------------*/
void	UxGUIAddBrowserComponent( if_browser, userNew, userParent )
	ifBrowser*	if_browser;
	swidget		userNew;
	swidget		userParent;
{
#if I_WANT_BROWSER
	UxAddBrowserComponent( if_browser, userNew, userParent );
#endif
}

/*------------------------------------------------------------------------
 * NAME:	UxGUIRepopulateBrowserComponent()
 * DESCRIPTION: Wrapper function for UxRepopulateBrowser().
 * PARAMETERS: 	ifBrowser*
 * RETURN:	void
 * LAST REV:	sep 96	Created.
 *------------------------------------------------------------------------*/
void	UxGUIRepopulateBrowser( if_browser )
	ifBrowser*	if_browser;
{
#if I_WANT_BROWSER
	UxRepopulateBrowser( if_browser );
#endif
}

/*------------------------------------------------------------------------
 * NAME:	UxGUISelListObs()
 * DESCRIPTION: Wrapper function for UxSelListObs().
 * PARAMETERS: 	swidget	
 * RETURN:	void
 * LAST REV:	dec 92	Created.
 *------------------------------------------------------------------------*/
void	UxGUISelListObs(ifBrow)
	swidget	ifBrow;
{
#if I_WANT_BROWSER
	UxSelListObs(ifBrow);
#endif
}

#ifdef PLAT
/*------------------------------------------------------------------------------
 * NAME:	XkGUIPopupColorView()
 * DESCRIPTION: Wrapper function for XkPopupColorView(). Used to bring
 *		up the Color Viewer. If you don't to use the Color
 *		Viewer for selecting colors from the Property Editor,
 *		access can be removed by recompiling with 
 *		I_WANT_XK_COLOR_VIEWER set to NO.
 * PARAMETERS:	swidget	UxParent	[I] The parent calling the Color Viewer
 *		char	*UxResName	[I] The resource that is being set
 *		char	*UxPrintName	[I] Color to set at start
 *		swidget	*UxEdList     [I/O] List of open viewers
 *		int	UxEdCount	    number of open viewers
 * RETURN:	swidget			    the Color View interface.
 * REVISIONS:	Sep 95 fix10266	Created
 *----------------------------------------------------------------------------*/
swidget	XkGUIPopupColorView( UxParent, UxResName, UxPrintName, UxEdList, UxEdCount )
	swidget UxParent;
	char	*UxResName;
	char	*UxPrintName;
	swidget *UxEdList;
	int	UxEdCount;
{
#if I_WANT_XK_COLOR_VIEWER
	return XkPopupColorView( UxParent, UxResName, UxPrintName, UxEdList, UxEdCount );
#else
	return (swidget) NULL;
#endif
}

/*------------------------------------------------------------------------------
 * NAME:	XkGUIPopupFontView()
 * DESCRIPTION: Wrapper function for XkPopupFontView(). Used to bring
 *		up the Font Viewer from the Property Editor. To deny
 *		access recompile with I_WANT_XK_FONT_VIEWER set to NO.
 * PARAMETERS:	swidget UxdlogParent [I] parent calling the viewer.
 *		char	*UxResName   [I] resource we are editing.
 *		char	*UxPrintName [I] name to use on viewer.
 * RETURN:	swidget			 The Font Viewer interface.
 * REVISIONS:	Sep 95 fix10266	Created
 *----------------------------------------------------------------------------*/
swidget	XkGUIPopupFontView( UxdlogParent, UxResName, UxPrintName )
	swidget UxdlogParent;
	char	*UxResName;
	char	*UxPrintName;
{
#if I_WANT_XK_FONT_VIEWER
	return XkPopupFontView( UxdlogParent, UxResName, UxPrintName );
#else
	return (swidget) NULL;
#endif
}

/*------------------------------------------------------------------------------
 * NAME:	XkGUIPopupTipFontView()
 * DESCRIPTION: Wrapper function for XkPopupTipFontView(). Used to bring
 *		up the Tip Font Viewer from the Property Editor. To deny
 *		access recompile with I_WANT_XK_TIPFONT_VIEWER set to NO.
 * PARAMETERS:	swidget UxdlogParent [I] parent calling the viewer.
 *		char	*UxResName   [I] resource we are editing.
 *		char	*UxPrintName [I] name to use on viewer.
 * RETURN:	swidget			 The Font Viewer interface.
 * REVISIONS:	Feb 97 fix16496 Created
 *----------------------------------------------------------------------------*/
swidget	XkGUIPopupTipFontView( UxdlogParent, UxResName, UxPrintName )
	swidget UxdlogParent;
	char	*UxResName;
	char	*UxPrintName;
{
#if I_WANT_XK_TIPFONT_VIEWER
	return XkPopupTipFontView( UxdlogParent, UxResName, UxPrintName );
#else
	return (swidget) NULL;
#endif
}

/*------------------------------------------------------------------------------
 * NAME:	XkGUIPopupPixView()
 * DESCRIPTION: Wrapper function for UxPopupPixView(). Used to bring up
 *		The Pixmap Viewer from the Property Editor for CPT
 *		components. To deny access recompile with
 *		I_WANT_XK_PIXMAP_VIEWER set to NO.
 * PARAMETERS:	swidget	UxEditParent	[I]	parent calling the viewer
 *		char	*UxResName	[I]	resource we are editing
 *		char	*UxPrintName	[I]	name to use on viewer
 * RETURN:	swidget				The Pixmap Viewer interface
 * LAST REV:	Aug 97 fix17371	Adjust to BE API
 *----------------------------------------------------------------------------*/
swidget	XkGUIPopupPixView( UxEditParent, UxResName, UxPrintName )
	swidget UxEditParent;
	char	*UxResName;
	char	*UxPrintName;
{
#if I_WANT_XK_PIXMAP_VIEWER
	return UxPopupPixView( UxEditParent, UxResName, UxPrintName,
				Uxcreate_view_pixmap, NULL, NULL, NULL, NULL );
#else
	return (swidget) NULL;
#endif
}
#endif	/* PLAT */
