/*******************************************************************************
	$AstecId: xrtpopup.c,v 1.4 1998/03/06 05:19:46 yamato Exp $
       UxXrtPopup.c
       (Generated from interface file UxXrtPopup.i)
       Associated Header file: UxXrtPopup.h
*******************************************************************************/

#include <stdio.h>
#include "UxLib.h"
#include "UxFsBox.h"
#include "UxDialSh.h"

/*******************************************************************************
       Includes, Defines, and Global variables from the Declarations Editor:
*******************************************************************************/

/* 
 *  SCCSID -- @(#)UxXrtPopup.i	1.1    95/06/15 Tangent Computing Ltd.
 *
 *  A file browser for resources which can be converted from a file name.
 */ 

#include <Xm/SelectioB.h>
#include <pedit-pop.h>
#include <util.h>
#ifdef	HASXRTTABLE
#include <Xm/XrtTable.h>
#endif /* HASXRTTABLE */
#include "cat_macros.h"


static	int _UxIfClassId;
/*******************************************************************************
       The following header file defines the context structure.
*******************************************************************************/

#ifndef XKLOADDS
#define XKLOADDS
#endif /* XKLOADDS */

#define CONTEXT_MACRO_ACCESS 1
#include "xrtpopup.h"
#undef CONTEXT_MACRO_ACCESS

swidget	xrtFileSelectionBoxDialog;
swidget	xrtFileSelectionBox;

/*******************************************************************************
Auxiliary code from the Declarations Editor:
*******************************************************************************/

#ifdef	HASXRTTABLE
extern void seDepositSeriesValue();
#endif

/*
 ****************************************************************
 *  Generic XRT file browser
 ****************************************************************
 */
static void
popupXrtFileBrowser( pedit, resname, printname, homedir, pattern)
    swidget  pedit;
    char     *resname;
    char     *printname;
    char     *homedir;
    char     *pattern;
{
    char *value, *raw_value;
    swidget tmpsw;

    /*
     *  Create the interface and save context information
     */
    tmpsw = create_xrtFileSelectionBoxDialog( pattern, False);
    XrtFSB = tmpsw;
    XrtHomeDir = homedir;
    XrtPedit = pedit;

    /*
     *  Reserve this PE slot while we are choosing a file 
     */
    UxGUIPeReserve( XrtPedit, resname, XrtFSB, &value, &XrtFSBSlot);

    /*
     *  If the slot has a value grunge it back into the file browser
     */
    raw_value = UxUnquoteWrap( value);
    if( raw_value && *raw_value) {
        int i;
        for( i = strlen(raw_value) - 1; i; i--) {
            if( raw_value[i] == '/') {
                char *dir = UxCopyString( raw_value);
                dir[i+1] = '\0';
                UxPutDirectory( xrtFileSelectionBox, dir);
                UxFree( dir);
                break;
            }
        }
        UxPutTextString( xrtFileSelectionBox, raw_value);           
    }

    /*
     * Display the browser in all its glory!
     */
    UxPopupInterface( XrtFSB, no_grab);
}

void
UxXrtReleaseSlot()
{
    /*
     * Release the current slot and destroy the interface
     */
    UxGUIPeRelease( XrtPedit, XrtFSB);
    UxDestroyInterface( XrtFSB);
}

void
UxXrtDepositValue( filename)
    char* filename;
{
    /*
     *  Deposit a new quoted string in the current slot
     */
    UxGUIPeDepositValue( XrtPedit, XrtFSBSlot, UxQuoteWrap(filename));
}


/*
 ****************************************************************
 *  Widget specific file browser popups
 ****************************************************************
 */

#ifdef	HASXRTGRAPH
void
UxPopupXrtData( pedit, resname, printname, swidgets, nswidgets)
    swidget  pedit;
    char     *resname;
    char     *printname;
    swidget  *swidgets;
    int      nswidgets;
{
    popupXrtFileBrowser( pedit, resname, printname,
                         "$XRTHOME/src/graph/data", "*.dat");
}
#endif	/* HASXRTGRAPH */

#ifdef	HASXRT3D
void
UxPopupXrt3dSurfaceData( pedit, resname, printname, swidgets, nswidgets)
    swidget  pedit;
    char     *resname;
    char     *printname;
    swidget  *swidgets;
    int      nswidgets;
{
    popupXrtFileBrowser( pedit, resname, printname,
                         "$XRTHOME/src/3d/data", "*.dat");
}

void
UxPopupXrt3dZoneData( pedit, resname, printname, swidgets, nswidgets)
    swidget  pedit;
    char     *resname;
    char     *printname;
    swidget  *swidgets;
    int      nswidgets;
{
    popupXrtFileBrowser( pedit, resname, printname,
                         "$XRTHOME/src/3d/data", "*.dat");
}

void
UxPopupXrt3dDistnTable( pedit, resname, printname, swidgets, nswidgets)
    swidget  pedit;
    char     *resname;
    char     *printname;
    swidget  *swidgets;
    int      nswidgets;
{
    popupXrtFileBrowser( pedit, resname, printname,
                         "$XRTHOME/src/3d/samples", "*.distn");
}

void
UxPopupXrt3dContourStyles( pedit, resname, printname, swidgets, nswidgets)
    swidget  pedit;
    char     *resname;
    char     *printname;
    swidget  *swidgets;
    int      nswidgets;
{
    popupXrtFileBrowser( pedit, resname, printname,
                         "$XRTHOME/src/3d/samples", "*.col");
}
#endif	/* HASXRT3D */

#ifdef	HASXRTTABLE
void
UxPopupXrtTblCellValues( pedit, resname, printname, swidgets, nswidgets)
    swidget  pedit;
    char     *resname;
    char     *printname;
    swidget  *swidgets;
    int      nswidgets;
{
    popupXrtFileBrowser( pedit, resname, printname,
                         "$XRTHOME/src/table/data", "*.ascii");
}
#endif	/* HASXRTTABLE */

/*******************************************************************************
       The following are callback functions.
*******************************************************************************/

static void  cancelCB_xrtFileSelectionBox( UxWidget, UxClientData, UxCallbackArg )
	Widget		UxWidget;
	XtPointer	UxClientData, UxCallbackArg;

{
	_UxCxrtFileSelectionBoxDialog *UxSaveCtx, *UxContext;
	swidget			UxThisWidget;

	UxThisWidget = UxWidgetToSwidget( UxWidget );
	UxSaveCtx = UxXrtFileSelectionBoxDialogContext;
	UxXrtFileSelectionBoxDialogContext = UxContext =
		(_UxCxrtFileSelectionBoxDialog *) UxGetContext( UxThisWidget );
	{
		/* Release reserved slot before throwing away interface */
		UxXrtReleaseSlot();
	}
	UxXrtFileSelectionBoxDialogContext = UxSaveCtx;
}

static void  okCallback_xrtFileSelectionBox( UxWidget, UxClientData, UxCallbackArg )
	Widget		UxWidget;
	XtPointer	UxClientData, UxCallbackArg;

{
	_UxCxrtFileSelectionBoxDialog *UxSaveCtx, *UxContext;
	swidget			UxThisWidget;

	UxThisWidget = UxWidgetToSwidget( UxWidget );
	UxSaveCtx = UxXrtFileSelectionBoxDialogContext;
	UxXrtFileSelectionBoxDialogContext = UxContext =
		(_UxCxrtFileSelectionBoxDialog *) UxGetContext( UxThisWidget );
	{
		/*
		 *  Update the current slot with the new file value
		 *  then release the slot and blow away the interface
		 */
		UxXrtDepositValue( UxGetDirSpec(xrtFileSelectionBox) );
		UxXrtReleaseSlot();
	}
	UxXrtFileSelectionBoxDialogContext = UxSaveCtx;
}

static void  helpCB_xrtFileSelectionBox( UxWidget, UxClientData, UxCallbackArg )
	Widget		UxWidget;
	XtPointer	UxClientData, UxCallbackArg;

{
	_UxCxrtFileSelectionBoxDialog *UxSaveCtx, *UxContext;
	swidget			UxThisWidget;

	UxThisWidget = UxWidgetToSwidget( UxWidget );
	UxSaveCtx = UxXrtFileSelectionBoxDialogContext;
	UxXrtFileSelectionBoxDialogContext = UxContext =
		(_UxCxrtFileSelectionBoxDialog *) UxGetContext( UxThisWidget );
	{
		/* Warp to the XRT sample directories */
		UxPutDirectory(UxThisWidget,UxExpandEnv(XrtHomeDir));
	}
	UxXrtFileSelectionBoxDialogContext = UxSaveCtx;
}

/*******************************************************************************
       The 'build_' function creates all the swidgets and X widgets,
       and sets their properties to the values specified in the
       Property Editor.
*******************************************************************************/

static swidget	_Uxbuild_xrtFileSelectionBoxDialog()
{
	/* Create the swidgets */


	/* Creation of xrtFileSelectionBoxDialog */
	xrtFileSelectionBoxDialog = UxCreateDialogShell( "xrtFileSelectionBoxDialog", NO_PARENT );
	UxPutContext( xrtFileSelectionBoxDialog, UxXrtFileSelectionBoxDialogContext );
	UxPutClassCode( xrtFileSelectionBoxDialog, _UxIfClassId );

	UxPutTitle( xrtFileSelectionBoxDialog, "Xrt File Browser" ),
	UxCreateWidget( xrtFileSelectionBoxDialog );


	/* Creation of xrtFileSelectionBox */
	xrtFileSelectionBox = UxCreateFileSelectionBox( "xrtFileSelectionBox", xrtFileSelectionBoxDialog );
	UxPutDialogStyle( xrtFileSelectionBox, "dialog_primary_application_modal" ),
	UxPutHelpLabelString( xrtFileSelectionBox, CGETS_KL(XRTHOME) ),
	UxPutX( xrtFileSelectionBox, -20 ),
	UxPutY( xrtFileSelectionBox, 120 ),
	UxCreateWidget( xrtFileSelectionBox );

	UxAddCallback( xrtFileSelectionBox, XmNcancelCallback,
		(XtCallbackProc) cancelCB_xrtFileSelectionBox,
		(XtPointer) UxXrtFileSelectionBoxDialogContext );
	UxAddCallback( xrtFileSelectionBox, XmNokCallback,
		(XtCallbackProc) okCallback_xrtFileSelectionBox,
		(XtPointer) UxXrtFileSelectionBoxDialogContext );
	UxAddCallback( xrtFileSelectionBox, XmNhelpCallback,
		(XtCallbackProc) helpCB_xrtFileSelectionBox,
		(XtPointer) UxXrtFileSelectionBoxDialogContext );

	UxAddCallback( xrtFileSelectionBoxDialog, XmNdestroyCallback,
		(XtCallbackProc) UxDestroyContextCB,
		(XtPointer) UxXrtFileSelectionBoxDialogContext);



	/* UxRealizeInterface creates the X windows for the widgets above. */

	UxRealizeInterface( xrtFileSelectionBoxDialog );

	return ( xrtFileSelectionBoxDialog );
}

/*******************************************************************************
       The following is the 'Interface function' which is the
       external entry point for creating this interface.
       This function should be called from your application or from
       a callback function.
*******************************************************************************/

swidget	create_xrtFileSelectionBoxDialog( _Uxsearch_pattern)
	char	*_Uxsearch_pattern;
{
	swidget                 rtrn;
	_UxCxrtFileSelectionBoxDialog *UxContext;
	static int		_Uxinit = 0;

	UxXrtFileSelectionBoxDialogContext = UxContext =
		(_UxCxrtFileSelectionBoxDialog *) UxNewContext( sizeof(_UxCxrtFileSelectionBoxDialog), False );

	search_pattern = _Uxsearch_pattern;

	if ( ! _Uxinit )
	{
		_UxIfClassId = UxNewInterfaceClassId();
		_Uxinit = 1;
	}

	rtrn = _Uxbuild_xrtFileSelectionBoxDialog();

	/*
	 * set the search pattern for the file selection box
	 */
	UxPutPattern( xrtFileSelectionBox, search_pattern);
	
	return(rtrn);
}

/*******************************************************************************
       END OF FILE
*******************************************************************************/

static void putInitialValue( parent, value )
swidget parent;
char *value;
{
	_UxCxrtFileSelectionBoxDialog     *UxSaveCtx, *UxContext;

	UxSaveCtx = UxXrtFileSelectionBoxDialogContext;
	UxXrtFileSelectionBoxDialogContext = UxContext =
			(_UxCxrtFileSelectionBoxDialog *) UxGetContext(parent);
	{
	  if( value && *value) {
        int i;
        for( i = strlen(value) - 1; i; i--) {
		  if( value[i] == '/') {
			char *dir = UxCopyString( value);
			dir[i+1] = '\0';
			UxPutDirectory( xrtFileSelectionBox, dir);
			UxFree( dir);
			break;
		  }
        }
        UxPutTextString( xrtFileSelectionBox, value);
	  }
	}  
	UxXrtFileSelectionBoxDialogContext = UxSaveCtx;
}

