/*
 * (c) Copyright 1996, KL GROUP INC.  
 * ALL RIGHTS RESERVED 
 *
 * This file is provided for demonstration and educational uses only.
 * Permission to use, copy, modify and distribute this file for
 * any purpose and without fee is hereby granted, provided that the
 * above copyright notice and this permission notice appear in all
 * copies, and that the name of KL Group not be used in advertising
 * or publicity pertaining to this material without the specific,
 * prior written permission of an authorized representative of
 * KL Group.
 *
 * KL GROUP MAKES NO REPRESENTATIONS AND EXTENDS NO WARRANTIES, EX-
 * PRESS OR IMPLIED, WITH RESPECT TO THE SOFTWARE, INCLUDING, BUT
 * NOT LIMITED TO, THE IMPLIED WARRANTIES OF MERCHANTABILITY AND
 * FITNESS FOR ANY PARTICULAR PURPOSE, AND THE WARRANTY AGAINST IN-
 * FRINGEMENT OF PATENTS OR OTHER INTELLECTUAL PROPERTY RIGHTS.  THE
 * SOFTWARE IS PROVIDED "AS IS", AND IN NO EVENT SHALL KL GROUP OR
 * ANY OF ITS AFFILIATES BE LIABLE FOR ANY DAMAGES, INCLUDING ANY
 * LOST PROFITS OR OTHER INCIDENTAL OR CONSEQUENTIAL DAMAGES 
 * RELATING TO THE USE OF THIS SOFTWARE.
 */

#include <stdio.h>
#include <stdlib.h>
#include <Xm/Xm.h>
#include <Mrm/MrmPublic.h>
#include <Xm/XrtGearAll.h>


/* XrtProgress CBs */

static XtIntervalId interval_id = 0;

static void 
#ifndef _NO_PROTO
work_proc(XtPointer client_data, XtIntervalId *timer)
#else
work_proc(client_data, timer)
XtPointer client_data;
XtIntervalId *timer;
#endif
{
	Widget progress = (Widget) client_data;
	int value, maximum;

	XtVaGetValues(progress,
				  XmNvalue, &value,
				  XmNmaximum, &maximum,
				  NULL);

	if (value + 1 <= maximum) {
		XtVaSetValues(progress,
					  XmNvalue, value + 1,
					  NULL);

		interval_id = XtAppAddTimeOut(XtWidgetToApplicationContext(progress),
									  20, work_proc, (XtPointer) progress);
	}
	else {
		interval_id = 0;
	}
}

static void
#ifndef _NO_PROTO
startCB(Widget w, XtPointer client_data, XtPointer call_data)
#else
startCB(w, client_data, call_data)
Widget w;
XtPointer client_data;
XtPointer call_data;
#endif
{
	Widget progress = (Widget) client_data;

	if (interval_id != 0) {
		XtRemoveTimeOut(interval_id);
	}

	interval_id = XtAppAddTimeOut(XtWidgetToApplicationContext(w),
						20, work_proc, (XtPointer) progress);
}

static void
#ifndef _NO_PROTO
stopCB(Widget w, XtPointer client_data, XtPointer call_data)
#else
stopCB(w, client_data, call_data)
Widget w;
XtPointer client_data;
XtPointer call_data;
#endif
{
	if (interval_id != 0) {
		XtRemoveTimeOut(interval_id);
		interval_id = 0;
	}
}

static void
#ifndef _NO_PROTO
resetCB(Widget w, XtPointer client_data, XtPointer call_data)
#else
resetCB(w, client_data, call_data)
Widget w;
XtPointer client_data;
XtPointer call_data;
#endif
{
    Widget progress = (Widget) client_data;
  
	XtVaSetValues(progress,
				  XmNvalue, 0,
				  NULL);
}

