/* ALL RIGHTS RESERVED
 *
 * This file is provided for demonstration and educational uses only.
 * Permission to use, copy, modify and distribute this file for
 * any purpose and without fee is hereby granted, provided that the
 * above copyright notice and this permission notice appear in all
 * copies, and that the name of KL Group not be used in advertising
 * or publicity pertaining to this material without the specific,
 * prior written permission of an authorized representative of
 * KL Group.
 *
 * KL GROUP MAKES NO REPRESENTATIONS AND EXTENDS NO WARRANTIES, EX-
 * PRESS OR IMPLIED, WITH RESPECT TO THE SOFTWARE, INCLUDING, BUT
 * NOT LIMITED TO, THE IMPLIED WARRANTIES OF MERCHANTABILITY AND
 * FITNESS FOR ANY PARTICULAR PURPOSE, AND THE WARRANTY AGAINST IN-
 * FRINGEMENT OF PATENTS OR OTHER INTELLECTUAL PROPERTY RIGHTS.  THE
 * SOFTWARE IS PROVIDED "AS IS", AND IN NO EVENT SHALL KL GROUP OR
 * ANY OF ITS AFFILIATES BE LIABLE FOR ANY DAMAGES, INCLUDING ANY
 * LOST PROFITS OR OTHER INCIDENTAL OR CONSEQUENTIAL DAMAGES
 * RELATING TO THE USE OF THIS SOFTWARE.
 *
 *
 * XRT/gear widget UIM/X integration file
 *
 * $AstecId: UxXrtAligner.hxx,v 1.3 1998/10/12 02:25:26 yamato Exp $
 *
 *  SCCSID -- @(#)UxXrtAligner.hxx	1.5    97/02/26 KL Group Inc.
 */

#if defined(__cplusplus) && !defined(XT_CODE) && !defined(NO_UXBINDINGS)  && !defined(UIMX2_9)

class UxXrtAligner : public UxXrtManager
{
    public:

	// Constructors
	UXINLINE UxXrtAligner(void);
	UXINLINE UxXrtAligner(const char*, swidget);

	// Initialisation
	UXINLINE swidget CreateSwidget (const char*, swidget);

	// Resource accessor functions
	UXINLINE short GetXrtGearColumnSpacing_Alnr () const;
	UXINLINE void SetXrtGearColumnSpacing_Alnr	(short);

	UXINLINE short GetXrtGearMarginHeight_Alnr () const;
	UXINLINE void SetXrtGearMarginHeight_Alnr	(short);

	UXINLINE short GetXrtGearMarginWidth_Alnr () const;
	UXINLINE void SetXrtGearMarginWidth_Alnr	(short);

	UXINLINE char * GetXrtGearOrientation_Alnr () const;
	UXINLINE void SetXrtGearOrientation_Alnr (const char *);

	UXINLINE short GetXrtGearRowSpacing_Alnr () const;
	UXINLINE void SetXrtGearRowSpacing_Alnr	(short);

};
	
	
#ifdef DESIGN_TIME

#define XRTGEAR_ALNR_TABLE(x)	xrtAlnr_res_table[x].prpty, xrtAlnr_res_table[x].name

extern Class_t UxC_XrtAligner;

#else  /* (not DESIGN_TIME) */

// Constructors
inline UxXrtAligner::UxXrtAligner(void){}
inline UxXrtAligner::UxXrtAligner(const char* name, swidget uXParent)
{
	CreateSwidget(name,uXParent);
}

// Initialisation
inline swidget UxXrtAligner::CreateSwidget (const char* name, swidget parent)
{
	if (UxThis == NULL)
		UxThis = UxCreateSwidget( (char *) name,
					  xmXrtAlignerWidgetClass, parent);
	return UxThis;
}

inline short UxXrtAligner::GetXrtGearColumnSpacing_Alnr (void) const
	{ return (short ) ShortGetProp(XmNxrtGearColumnSpacing);}
inline void UxXrtAligner::SetXrtGearColumnSpacing_Alnr	(short val)
	{ SetProp(XmNxrtGearColumnSpacing, ((XtArgVal)(val)));}
	
inline short UxXrtAligner::GetXrtGearMarginHeight_Alnr (void) const
	{ return (short ) ShortGetProp(XmNxrtGearMarginHeight);}
inline void UxXrtAligner::SetXrtGearMarginHeight_Alnr	(short val)
	{ SetProp(XmNxrtGearMarginHeight, ((XtArgVal)(val)));}

inline short UxXrtAligner::GetXrtGearMarginWidth_Alnr (void) const
	{ return (short ) ShortGetProp(XmNxrtGearMarginWidth);}
inline void UxXrtAligner::SetXrtGearMarginWidth_Alnr	(short val)
	{ SetProp(XmNxrtGearMarginWidth, ((XtArgVal)(val)));}

inline char * UxXrtAligner::GetXrtGearOrientation_Alnr (void) const
	{ return (char * ) DDGetProp(XmNxrtGearOrientation);}
inline void UxXrtAligner::SetXrtGearOrientation_Alnr (const char * val)
	{ DDSetProp(XmNxrtGearOrientation, ((XtArgVal)(val)));}
	
inline short UxXrtAligner::GetXrtGearRowSpacing_Alnr (void) const
	{ return (short ) ShortGetProp(XmNxrtGearRowSpacing);}
inline void UxXrtAligner::SetXrtGearRowSpacing_Alnr	(short val)
	{ SetProp(XmNxrtGearRowSpacing, ((XtArgVal)(val)));}
	

#endif /* DESIGN_TIME */
#endif /* __cplusplus */



