/* ALL RIGHTS RESERVED
 *
 * This file is provided for demonstration and educational uses only.
 * Permission to use, copy, modify and distribute this file for
 * any purpose and without fee is hereby granted, provided that the
 * above copyright notice and this permission notice appear in all
 * copies, and that the name of KL Group not be used in advertising
 * or publicity pertaining to this material without the specific,
 * prior written permission of an authorized representative of
 * KL Group.
 *
 * KL GROUP MAKES NO REPRESENTATIONS AND EXTENDS NO WARRANTIES, EX-
 * PRESS OR IMPLIED, WITH RESPECT TO THE SOFTWARE, INCLUDING, BUT
 * NOT LIMITED TO, THE IMPLIED WARRANTIES OF MERCHANTABILITY AND
 * FITNESS FOR ANY PARTICULAR PURPOSE, AND THE WARRANTY AGAINST IN-
 * FRINGEMENT OF PATENTS OR OTHER INTELLECTUAL PROPERTY RIGHTS.  THE
 * SOFTWARE IS PROVIDED "AS IS", AND IN NO EVENT SHALL KL GROUP OR
 * ANY OF ITS AFFILIATES BE LIABLE FOR ANY DAMAGES, INCLUDING ANY
 * LOST PROFITS OR OTHER INCIDENTAL OR CONSEQUENTIAL DAMAGES
 * RELATING TO THE USE OF THIS SOFTWARE.
 *
 *
 * XRT/gear widget UIM/X integration file
 *
 *  SCCSID -- @(#)UxXrtGLabel.h	1.6    97/02/10 KL Group Inc.
 */

/******************************************************************************
				UxXrtGLabel.h
******************************************************************************/

#ifndef UXXRTGLABEL_INCLUDED
#define UXXRTGLABEL_INCLUDED

#include <Xm/XrtGLabel.h>	/* Widget class public header file */
#include "Xrt_restable.h"
#include "UxLabel.h"
#include "UxXrtGLabel.hxx"  /* Include C++ header file (New in UIM/X 3.0)*/

#ifdef DESIGN_TIME

#define XRTGEAR_GLBL_TABLE(x)	xrtGLbl_res_table[x].prpty, xrtGLbl_res_table[x].name

/* Design-Time UxGet and UxPut macros for xrtGLblBorderType */
#ifndef UxGetXrtGearBorderType_GLbl
#define UxGetXrtGearBorderType_GLbl(sw) \
	UxGET_string(sw, XRTGEAR_GLBL_TABLE(xrtGLblResNumBorderType))
#endif
#ifndef UxPutXrtGearBorderType_GLbl
#define UxPutXrtGearBorderType_GLbl(sw, val) \
	UxPUT_string(sw, XRTGEAR_GLBL_TABLE(xrtGLblResNumBorderType), val)
#endif

/* Design-Time UxGet and UxPut macros for xrtGLblLabelPixmap */
#ifndef UxGetXrtGearLabelPixmap_GLbl
#define UxGetXrtGearLabelPixmap_GLbl(sw) \
	UxGET_string(sw, XRTGEAR_GLBL_TABLE(xrtGLblResNumLabelPixmap))
#endif
#ifndef UxPutXrtGearLabelPixmap_GLbl
#define UxPutXrtGearLabelPixmap_GLbl(sw, val) \
	UxPUT_string(sw, XRTGEAR_GLBL_TABLE(xrtGLblResNumLabelPixmap), val)
#endif

/* Design-Time UxGet and UxPut macros for xrtGLblLabelType */
#ifndef UxGetXrtGearLabelType_GLbl
#define UxGetXrtGearLabelType_GLbl(sw) \
	UxGET_string(sw, XRTGEAR_GLBL_TABLE(xrtGLblResNumLabelType))
#endif
#ifndef UxPutXrtGearLabelType_GLbl
#define UxPutXrtGearLabelType_GLbl(sw, val) \
	UxPUT_string(sw, XRTGEAR_GLBL_TABLE(xrtGLblResNumLabelType), val)
#endif

/* Design-Time UxGet and UxPut macros for xrtGLblLayoutSpacing */
#ifndef UxGetXrtGearLayoutSpacing_GLbl
#define UxGetXrtGearLayoutSpacing_GLbl(sw) \
	UxGET_short(sw, XRTGEAR_GLBL_TABLE(xrtGLblResNumLayoutSpacing))
#endif
#ifndef UxPutXrtGearLayoutSpacing_GLbl
#define UxPutXrtGearLayoutSpacing_GLbl(sw, val) \
	UxPUT_short(sw, XRTGEAR_GLBL_TABLE(xrtGLblResNumLayoutSpacing), val)
#endif

/* Design-Time UxGet and UxPut macros for xrtGLblMask */
#ifndef UxGetXrtGearMask_GLbl
#define UxGetXrtGearMask_GLbl(sw) \
	UxGET_string(sw, XRTGEAR_GLBL_TABLE(xrtGLblResNumMask))
#endif
#ifndef UxPutXrtGearMask_GLbl
#define UxPutXrtGearMask_GLbl(sw, val) \
	UxPUT_string(sw, XRTGEAR_GLBL_TABLE(xrtGLblResNumMask), val)
#endif

/* Design-Time UxGet and UxPut macros for xrtGLblPixmapRotation */
#ifndef UxGetXrtGearPixmapRotation_GLbl
#define UxGetXrtGearPixmapRotation_GLbl(sw) \
	UxGET_string(sw, XRTGEAR_GLBL_TABLE(xrtGLblResNumPixmapRotation))
#endif
#ifndef UxPutXrtGearPixmapRotation_GLbl
#define UxPutXrtGearPixmapRotation_GLbl(sw, val) \
	UxPUT_string(sw, XRTGEAR_GLBL_TABLE(xrtGLblResNumPixmapRotation), val)
#endif

/* Design-Time UxGet and UxPut macros for xrtGLblStringLayout */
#ifndef UxGetXrtGearStringLayout_GLbl
#define UxGetXrtGearStringLayout_GLbl(sw) \
	UxGET_string(sw, XRTGEAR_GLBL_TABLE(xrtGLblResNumStringLayout))
#endif
#ifndef UxPutXrtGearStringLayout_GLbl
#define UxPutXrtGearStringLayout_GLbl(sw, val) \
	UxPUT_string(sw, XRTGEAR_GLBL_TABLE(xrtGLblResNumStringLayout), val)
#endif

/* Design-Time UxGet and UxPut macros for xrtGLblStringRotation */
#ifndef UxGetXrtGearStringRotation_GLbl
#define UxGetXrtGearStringRotation_GLbl(sw) \
	UxGET_string(sw, XRTGEAR_GLBL_TABLE(xrtGLblResNumStringRotation))
#endif
#ifndef UxPutXrtGearStringRotation_GLbl
#define UxPutXrtGearStringRotation_GLbl(sw, val) \
	UxPUT_string(sw, XRTGEAR_GLBL_TABLE(xrtGLblResNumStringRotation), val)
#endif

extern Class_t	UxC_XrtGLabel;
/* Design-time create macro */
#ifndef UxCreateXrtGLabel
#define UxCreateXrtGLabel(name, parent) \
	UxCreateSwidget(UxC_XrtGLabel, name, parent)
#endif

#else /* RUN_TIME */

#ifndef UxGetXrtGearBorderType_GLbl
#define UxGetXrtGearBorderType_GLbl(sw) \
	(char *) UxDDGetProp(sw, XmNxrtGearBorderType)
#endif
#ifndef UxPutXrtGearBorderType_GLbl
#define UxPutXrtGearBorderType_GLbl(sw, val) \
	UxDDPutProp(sw, XmNxrtGearBorderType, (XtArgVal)(val))
#endif

#ifndef UxGetXrtGearLabelPixmap_GLbl
#define UxGetXrtGearLabelPixmap_GLbl(sw) \
	(char *) UxDDGetProp(sw, XmNxrtGearLabelPixmap)
#endif
#ifndef UxPutXrtGearLabelPixmap_GLbl
#define UxPutXrtGearLabelPixmap_GLbl(sw, val) \
	UxDDPutProp(sw, XmNxrtGearLabelPixmap, (XtArgVal)(val))
#endif

#ifndef UxGetXrtGearLabelType_GLbl
#define UxGetXrtGearLabelType_GLbl(sw) \
	(char *) UxDDGetProp(sw, XmNxrtGearLabelType)
#endif
#ifndef UxPutXrtGearLabelType_GLbl
#define UxPutXrtGearLabelType_GLbl(sw, val) \
	UxDDPutProp(sw, XmNxrtGearLabelType, (XtArgVal)(val))
#endif

#ifndef UxGetXrtGearLayoutSpacing_GLbl
#define UxGetXrtGearLayoutSpacing_GLbl(sw) \
	(short)UxShortGetProp(sw, XmNxrtGearLayoutSpacing)
#endif
#ifndef UxPutXrtGearLayoutSpacing_GLbl
#define UxPutXrtGearLayoutSpacing_GLbl(sw, val) \
	UxPutProp(sw, XmNxrtGearLayoutSpacing, (XtArgVal)(val))
#endif

#ifndef UxGetXrtGearMask_GLbl
#define UxGetXrtGearMask_GLbl(sw) \
	(char *) UxDDGetProp(sw, XmNxrtGearMask)
#endif
#ifndef UxPutXrtGearMask_GLbl
#define UxPutXrtGearMask_GLbl(sw, val) \
	UxDDPutProp(sw, XmNxrtGearMask, (XtArgVal)(val))
#endif

#ifndef UxGetXrtGearPixmapRotation_GLbl
#define UxGetXrtGearPixmapRotation_GLbl(sw) \
	(char *) UxDDGetProp(sw, XmNxrtGearPixmapRotation)
#endif
#ifndef UxPutXrtGearPixmapRotation_GLbl
#define UxPutXrtGearPixmapRotation_GLbl(sw, val) \
	UxDDPutProp(sw, XmNxrtGearPixmapRotation, (XtArgVal)(val))
#endif

#ifndef UxGetXrtGearStringLayout_GLbl
#define UxGetXrtGearStringLayout_GLbl(sw) \
	(char *) UxDDGetProp(sw, XmNxrtGearStringLayout)
#endif
#ifndef UxPutXrtGearStringLayout_GLbl
#define UxPutXrtGearStringLayout_GLbl(sw, val) \
	UxDDPutProp(sw, XmNxrtGearStringLayout, (XtArgVal)(val))
#endif

#ifndef UxGetXrtGearStringRotation_GLbl
#define UxGetXrtGearStringRotation_GLbl(sw) \
	(char *) UxDDGetProp(sw, XmNxrtGearStringRotation)
#endif
#ifndef UxPutXrtGearStringRotation_GLbl
#define UxPutXrtGearStringRotation_GLbl(sw, val) \
	UxDDPutProp(sw, XmNxrtGearStringRotation, (XtArgVal)(val))
#endif


/* Runtime create macro */
#ifndef UxCreateXrtGLabel
#define UxCreateXrtGLabel(name, parent) \
	UxCreateSwidget(name, xmXrtGLabelWidgetClass, parent)
#endif

#endif /* DESIGN_TIME */

#endif /* UXXRTGLABELINCLUDED */

/***END*OF*FILE***************************************************************/
