/* ALL RIGHTS RESERVED
 *
 * This file is provided for demonstration and educational uses only.
 * Permission to use, copy, modify and distribute this file for
 * any purpose and without fee is hereby granted, provided that the
 * above copyright notice and this permission notice appear in all
 * copies, and that the name of KL Group not be used in advertising
 * or publicity pertaining to this material without the specific,
 * prior written permission of an authorized representative of
 * KL Group.
 *
 * KL GROUP MAKES NO REPRESENTATIONS AND EXTENDS NO WARRANTIES, EX-
 * PRESS OR IMPLIED, WITH RESPECT TO THE SOFTWARE, INCLUDING, BUT
 * NOT LIMITED TO, THE IMPLIED WARRANTIES OF MERCHANTABILITY AND
 * FITNESS FOR ANY PARTICULAR PURPOSE, AND THE WARRANTY AGAINST IN-
 * FRINGEMENT OF PATENTS OR OTHER INTELLECTUAL PROPERTY RIGHTS.  THE
 * SOFTWARE IS PROVIDED "AS IS", AND IN NO EVENT SHALL KL GROUP OR
 * ANY OF ITS AFFILIATES BE LIABLE FOR ANY DAMAGES, INCLUDING ANY
 * LOST PROFITS OR OTHER INCIDENTAL OR CONSEQUENTIAL DAMAGES
 * RELATING TO THE USE OF THIS SOFTWARE.
 *
 *
 * XRT/gear widget UIM/X integration file
 *
 *  SCCSID -- @(#)UxXrtGaCenter.h	1.3    99/12/13 KL Group Inc.
 */

/******************************************************************************
				UxXrtGaCenter.h
******************************************************************************/

#ifndef UxXrtGaCenter_h
#define UxXrtGaCenter_h

#include <Xm/XrtGaCenter.h>	/* Widget class public header file */
#include "Xrt_restable.h"
#include "UxGadget.h"
#include "UxXrtGaCenter.hxx"  /* Include C++ header file (New in UIM/X 3.0)*/

#ifdef DESIGN_TIME
#ifndef NO_UX_MACROS

#define XrtGaCenter_prpty_name(x)	XrtGaCenter_res_table[x].prpty, XrtGaCenter_res_table[x].name

#ifdef hp700v9
#define XrtGaDoubleToArgVal(d) UxXrtGaDoubleToArgVal(0,d)
#endif /* hp700v9 */

#ifndef UxGetBackground
#define UxGetBackground(sw) \
	UxGET_int(sw, XrtGaCenter_prpty_name(XrtGaCenter_background))
#endif
#ifndef UxPutBackground
#define UxPutBackground(sw, val) \
	UxPUT_int(sw, XrtGaCenter_prpty_name(XrtGaCenter_background), val)
#endif

#ifndef UxGetXrtGaCircularScale
#define UxGetXrtGaCircularScale(sw) \
	UxGET_string(sw, XrtGaCenter_prpty_name(XrtGaCenter_CircularScale))
#endif
#ifndef UxPutXrtGaCircularScale
#define UxPutXrtGaCircularScale(sw, val) \
	UxPUT_string(sw, XrtGaCenter_prpty_name(XrtGaCenter_CircularScale), val)
#endif

#ifndef UxGetXrtGaDebug
#define UxGetXrtGaDebug(sw) \
	UxGET_string(sw, XrtGaCenter_prpty_name(XrtGaCenter_Debug))
#endif
#ifndef UxPutXrtGaDebug
#define UxPutXrtGaDebug(sw, val) \
	UxPUT_string(sw, XrtGaCenter_prpty_name(XrtGaCenter_Debug), val)
#endif

#ifndef UxGetXrtGaImage
#define UxGetXrtGaImage(sw) \
	UxGET_string(sw, XrtGaCenter_prpty_name(XrtGaCenter_Image))
#endif
#ifndef UxPutXrtGaImage
#define UxPutXrtGaImage(sw, val) \
	UxPUT_string(sw, XrtGaCenter_prpty_name(XrtGaCenter_Image), val)
#endif

#ifndef UxGetXrtGaImage
#define UxGetXrtGaImage(sw) \
	UxGET_string(sw, XrtGaCenter_prpty_name(XrtGaCenter_Image))
#endif
#ifndef UxPutXrtGaImage
#define UxPutXrtGaImage(sw, val) \
	UxPUT_string(sw, XrtGaCenter_prpty_name(XrtGaCenter_Image), val)
#endif

#ifndef UxGetXrtGaIsShowing
#define UxGetXrtGaIsShowing(sw) \
	UxGET_string(sw, XrtGaCenter_prpty_name(XrtGaCenter_IsShowing))
#endif
#ifndef UxPutXrtGaIsShowing
#define UxPutXrtGaIsShowing(sw, val) \
	UxPUT_string(sw, XrtGaCenter_prpty_name(XrtGaCenter_IsShowing),val)
#endif

#ifndef UxGetXrtGaRadius
#define UxGetXrtGaRadius(sw) \
	UxGET_float(sw, XrtGaCenter_prpty_name(XrtGaCenter_Radius))
#endif
#ifndef UxPutXrtGaRadius
#define UxPutXrtGaRadius(sw, val) \
	UxPUT_float(sw, XrtGaCenter_prpty_name(XrtGaCenter_Radius), val)
#endif

#endif /* NO_UX_MACROS */

extern Class_t	UxC_XrtGaCenter;

/* Design-time create macro */
#ifndef UxCreateXrtGaCenter
#define UxCreateXrtGaCenter(name, parent) \
	UxCreateSwidget(UxC_XrtGaCenter, name, parent)
#endif

#else /* RUN-TIME */

extern int	XrtGaGetDoubleProp();
extern double	XrtGaArgValToDouble();

#define RT_GA_GET_DOUBLE(sw,res) \
	XrtGaArgValToDouble(UxGetXrtGaDoubleProp(sw,res))

#define RT_GA_PUT_DOUBLE(sw,res,val) \
	UxPutProp(sw,res,(XtArgVal)XrtGaDoubleToArgVal((double)val))

#ifndef UxGetBackground
#define UxGetBackground(sw) \
	(int) UxDDGetProp(sw, XmNbackground)
#endif
#ifndef UxPutBackground
#define UxPutBackground(sw, val) \
	UxDDPutProp(sw, XmNbackground, ((XtArgVal)(val)))
#endif

#ifndef UxGetXrtGaCircularScale
#define UxGetXrtGaCircularScale(sw) \
	(char *) UxDDGetProp(sw, XmNxrtGaCircularScale)
#endif
#ifndef UxPutXrtGaCircularScale
#define UxPutXrtGaCircularScale(sw, val) \
	UxDDPutProp(sw, XmNxrtGaCircularScale, ((XtArgVal)(val)))
#endif

#ifndef UxGetXrtGaDebug
#define UxGetXrtGaDebug(sw) \
	(char *) UxDDGetProp(sw, XmNxrtGaDebug)
#endif
#ifndef UxPutXrtGaDebug
#define UxPutXrtGaDebug(sw, val) \
	UxDDPutProp(sw, XmNxrtGaDebug, ((XtArgVal)(val)))
#endif

#ifndef UxGetXrtGaImage
#define UxGetXrtGaImage(sw) \
	(char *) UxDDGetProp(sw, XmNxrtGaImage)
#endif
#ifndef UxPutXrtGaImage
#define UxPutXrtGaImage(sw, val) \
	UxDDPutProp(sw, XmNxrtGaImage, ((XtArgVal)(val)))
#endif

#ifndef UxGetXrtGaImage
#define UxGetXrtGaImage(sw) \
	(char *) UxDDGetProp(sw, XmNxrtGaImage)
#endif
#ifndef UxPutXrtGaImage
#define UxPutXrtGaImage(sw, val) \
	UxDDPutProp(sw, XmNxrtGaImage, ((XtArgVal)(val)))
#endif

#ifndef UxGetXrtGaIsShowing
#define UxGetXrtGaIsShowing(sw) \
	(char *) UxDDGetProp(sw, XmNxrtGaIsShowing)
#endif
#ifndef UxPutXrtGaIsShowing
#define UxPutXrtGaIsShowing(sw, val) \
	UxDDPutProp(sw, XmNxrtGaIsShowing, ((XtArgVal)(val)))
#endif

#ifndef UxGetXrtGaRadius
#define UxGetXrtGaRadius(sw) \
	(double) RT_GA_GET_DOUBLE(sw, XmNxrtGaRadius)
#endif
#ifndef UxPutXrtGaRadius
#define UxPutXrtGaRadius(sw, val) \
	RT_GA_PUT_DOUBLE(sw, XmNxrtGaRadius, (val))
#endif


/* Runtime create macro */
#ifndef UxCreateXrtGaCenter
#define UxCreateXrtGaCenter(name, parent) \
	UxCreateSwidget(name, xmXrtGaCenterObjectClass, parent)
#endif

#endif /* DESIGN_TIME */

#endif

