/* ALL RIGHTS RESERVED
 *
 * This file is provided for demonstration and educational uses only.
 * Permission to use, copy, modify and distribute this file for
 * any purpose and without fee is hereby granted, provided that the
 * above copyright notice and this permission notice appear in all
 * copies, and that the name of KL Group not be used in advertising
 * or publicity pertaining to this material without the specific,
 * prior written permission of an authorized representative of
 * KL Group.
 *
 * KL GROUP MAKES NO REPRESENTATIONS AND EXTENDS NO WARRANTIES, EX-
 * PRESS OR IMPLIED, WITH RESPECT TO THE SOFTWARE, INCLUDING, BUT
 * NOT LIMITED TO, THE IMPLIED WARRANTIES OF MERCHANTABILITY AND
 * FITNESS FOR ANY PARTICULAR PURPOSE, AND THE WARRANTY AGAINST IN-
 * FRINGEMENT OF PATENTS OR OTHER INTELLECTUAL PROPERTY RIGHTS.  THE
 * SOFTWARE IS PROVIDED "AS IS", AND IN NO EVENT SHALL KL GROUP OR
 * ANY OF ITS AFFILIATES BE LIABLE FOR ANY DAMAGES, INCLUDING ANY
 * LOST PROFITS OR OTHER INCIDENTAL OR CONSEQUENTIAL DAMAGES
 * RELATING TO THE USE OF THIS SOFTWARE.
 *
 *
 * XRT/gauge widget UIM/X integration file
 *
 * $AstecId: UxXrtGaCounter.h,v 1.3 2003/02/14 02:25:57 kosaka Exp $
 *
 *  SCCSID -- @(#)UxXrtGaCounter.h	1.3    99/12/13 KL Group Inc.
 */

/******************************************************************************
				UxXrtGaCounter.h
******************************************************************************/

#ifndef UxXrtGaCounter_h
#define UxXrtGaCounter_h

#include <Xm/XrtGaCounter.h>	/* Widget class public header file */
#include "Xrt_restable.h"
#include "UxGadget.h"
#include "UxXrtGaCounter.hxx"  /* Include C++ header file (New in UIM/X 3.0)*/

#ifdef DESIGN_TIME
#ifndef NO_UX_MACROS

#define XrtGaCounter_prpty_name(x)	XrtGaCounter_res_table[x].prpty, XrtGaCounter_res_table[x].name

#ifdef hp700v9
#define XrtGaDoubleToArgVal(d) UxXrtGaDoubleToArgVal(0,d)
#endif /* hp700v9 */

#ifndef UxGetBackground
#define UxGetBackground(sw) \
	UxGET_string(sw, XrtGaCounter_prpty_name(XrtGaCounter_background))
#endif
#ifndef UxPutBackground
#define UxPutBackground(sw, val) \
	UxPUT_string(sw, XrtGaCounter_prpty_name(XrtGaCounter_background),val)
#endif

#ifndef UxGetFontList
#define UxGetFontList(sw) \
	UxGET_string(sw, XrtGaCounter_prpty_name(XrtGaCounter_fontList))
#endif
#ifndef UxPutFontList
#define UxPutFontList(sw, val) \
	UxPUT_string(sw, XrtGaCounter_prpty_name(XrtGaCounter_fontList),val)
#endif

#ifndef UxGetHeight
#define UxGetHeight(sw) \
	UxGET_int(sw, XrtGaCounter_prpty_name(XrtGaCounter_height))
#endif
#ifndef UxPutHeight
#define UxPutHeight(sw, val) \
	UxPUT_int(sw, XrtGaCounter_prpty_name(XrtGaCounter_height), val)
#endif

#ifndef UxGetWidth
#define UxGetWidth(sw) \
	UxGET_int(sw, XrtGaCounter_prpty_name(XrtGaCounter_width))
#endif
#ifndef UxPutWidth
#define UxPutWidth(sw, val) \
	UxPUT_int(sw, XrtGaCounter_prpty_name(XrtGaCounter_width), val)
#endif

#ifndef UxGetX
#define UxGetX(sw) \
	UxGET_int(sw, XrtGaCounter_prpty_name(XrtGaCounter_x))
#endif
#ifndef UxPutX
#define UxPutX(sw, val) \
	UxPUT_int(sw, XrtGaCounter_prpty_name(XrtGaCounter_x), val)
#endif

#ifndef UxGetY
#define UxGetY(sw) \
	UxGET_int(sw, XrtGaCounter_prpty_name(XrtGaCounter_y))
#endif
#ifndef UxPutY
#define UxPutY(sw, val) \
	UxPUT_int(sw, XrtGaCounter_prpty_name(XrtGaCounter_y), val)
#endif

#ifndef UxGetXrtGaBorder
#define UxGetXrtGaBorder(sw) \
	UxGET_string(sw, XrtGaCounter_prpty_name(XrtGaCounter_Border))
#endif
#ifndef UxPutXrtGaBorder
#define UxPutXrtGaBorder(sw, val) \
	UxPUT_string(sw, XrtGaCounter_prpty_name(XrtGaCounter_Border),val)
#endif

#ifndef UxGetXrtGaBorderWidth
#define UxGetXrtGaBorderWidth(sw) \
	UxGET_int(sw, XrtGaCounter_prpty_name(XrtGaCounter_BorderWidth))
#endif
#ifndef UxPutXrtGaBorderWidth
#define UxPutXrtGaBorderWidth(sw, val) \
	UxPUT_int(sw, XrtGaCounter_prpty_name(XrtGaCounter_BorderWidth),val)
#endif

#ifndef UxGetXrtGaDebug
#define UxGetXrtGaDebug(sw) \
	UxGET_string(sw, XrtGaCounter_prpty_name(XrtGaCounter_Debug))
#endif
#ifndef UxPutXrtGaDebug
#define UxPutXrtGaDebug(sw, val) \
	UxPUT_string(sw, XrtGaCounter_prpty_name(XrtGaCounter_Debug), val)
#endif

#ifndef UxGetXrtGaDecimalPlaces
#define UxGetXrtGaDecimalPlaces(sw) \
	UxGET_int(sw, XrtGaCounter_prpty_name(XrtGaCounter_DecimalPlaces))
#endif
#ifndef UxPutXrtGaDecimalPlaces
#define UxPutXrtGaDecimalPlaces(sw, val) \
	UxPUT_int(sw, XrtGaCounter_prpty_name(XrtGaCounter_DecimalPlaces),val)
#endif

#ifndef UxGetXrtGaDigitBackgroundColor
#define UxGetXrtGaDigitBackgroundColor(sw) \
	UxGET_string(sw,XrtGaCounter_prpty_name(XrtGaCounter_DigitBackgroundColor))
#endif
#ifndef UxPutXrtGaDigitBackgroundColor
#define UxPutXrtGaDigitBackgroundColor(sw, val) \
	UxPUT_string(sw,XrtGaCounter_prpty_name(XrtGaCounter_DigitBackgroundColor), val)
#endif

#ifndef UxGetXrtGaDigitForegroundColor
#define UxGetXrtGaDigitForegroundColor(sw) \
	UxGET_string(sw,XrtGaCounter_prpty_name(XrtGaCounter_DigitForegroundColor))
#endif
#ifndef UxPutXrtGaDigitForegroundColor
#define UxPutXrtGaDigitForegroundColor(sw, val) \
	UxPUT_string(sw,XrtGaCounter_prpty_name(XrtGaCounter_DigitForegroundColor), val)
#endif

#ifndef UxGetXrtGaImage
#define UxGetXrtGaImage(sw) \
	UxGET_string(sw, XrtGaCounter_prpty_name(XrtGaCounter_Image))
#endif
#ifndef UxPutXrtGaImage
#define UxPutXrtGaImage(sw, val) \
	UxPUT_string(sw, XrtGaCounter_prpty_name(XrtGaCounter_Image), val)
#endif

#ifndef UxGetXrtGaImageLayout
#define UxGetXrtGaImageLayout(sw) \
	UxGET_string(sw,XrtGaCounter_prpty_name(XrtGaCounter_ImageLayout))
#endif
#ifndef UxPutXrtGaImageLayout
#define UxPutXrtGaImageLayout(sw, val) \
	UxPUT_string(sw,XrtGaCounter_prpty_name(XrtGaCounter_ImageLayout), val)
#endif

#ifndef UxGetXrtGaIsShowing
#define UxGetXrtGaIsShowing(sw) \
	UxGET_string(sw, XrtGaCounter_prpty_name(XrtGaCounter_IsShowing))
#endif
#ifndef UxPutXrtGaIsShowing
#define UxPutXrtGaIsShowing(sw, val) \
	UxPUT_string(sw, XrtGaCounter_prpty_name(XrtGaCounter_IsShowing),val)
#endif

#ifndef UxGetXrtGaNumDigits
#define UxGetXrtGaNumDigits(sw) \
	UxGET_int(sw, XrtGaCounter_prpty_name(XrtGaCounter_NumDigits))
#endif
#ifndef UxPutXrtGaNumDigits
#define UxPutXrtGaNumDigits(sw, val) \
	UxPUT_int(sw, XrtGaCounter_prpty_name(XrtGaCounter_NumDigits),val)
#endif

#ifndef UxGetXrtGaResetAlignment
#define UxGetXrtGaResetAlignment(sw) \
	UxGET_string(sw,XrtGaCounter_prpty_name(XrtGaCounter_ResetAlignment))
#endif
#ifndef UxPutXrtGaResetAlignment
#define UxPutXrtGaResetAlignment(sw, val) \
	UxPUT_string(sw,XrtGaCounter_prpty_name(XrtGaCounter_ResetAlignment), val)
#endif

#ifndef UxGetXrtGaResetBackgroundColor
#define UxGetXrtGaResetBackgroundColor(sw) \
	UxGET_string(sw,XrtGaCounter_prpty_name(XrtGaCounter_ResetBackgroundColor))
#endif
#ifndef UxPutXrtGaResetBackgroundColor
#define UxPutXrtGaResetBackgroundColor(sw, val) \
	UxPUT_string(sw,XrtGaCounter_prpty_name(XrtGaCounter_ResetBackgroundColor), val)
#endif

#ifndef UxGetResetHeight
#define UxGetResetHeight(sw) \
	UxGET_int(sw, XrtGaCounter_prpty_name(XrtGaCounter_ResetHeight))
#endif
#ifndef UxPutResetHeight
#define UxPutResetHeight(sw, val) \
	UxPUT_int(sw, XrtGaCounter_prpty_name(XrtGaCounter_ResetHeight),val)
#endif

#ifndef UxGetResetXrtGaImage
#define UxGetResetXrtGaImage(sw) \
	UxGET_string(sw, XrtGaCounter_prpty_name(XrtGaCounter_ResetImage))
#endif
#ifndef UxPutResetXrtGaImage
#define UxPutResetXrtGaImage(sw, val) \
	UxPUT_string(sw, XrtGaCounter_prpty_name(XrtGaCounter_ResetImage),val)
#endif

#ifndef UxGetXrtGaResetOffset
#define UxGetXrtGaResetOffset(sw) \
	UxGET_int(sw, XrtGaCounter_prpty_name(XrtGaCounter_ResetOffset))
#endif
#ifndef UxPutXrtGaResetOffset
#define UxPutXrtGaResetOffset(sw, val) \
	UxPUT_int(sw, XrtGaCounter_prpty_name(XrtGaCounter_ResetOffset),val)
#endif

#ifndef UxGetXrtGaResetShape
#define UxGetXrtGaResetShape(sw) \
	UxGET_string(sw, XrtGaCounter_prpty_name(XrtGaCounter_ResetShape))
#endif
#ifndef UxPutXrtGaResetShape
#define UxPutXrtGaResetShape(sw, val) \
	UxPUT_string(sw, XrtGaCounter_prpty_name(XrtGaCounter_ResetShape),val)
#endif

#ifndef UxGetXrtGaResetShow
#define UxGetXrtGaResetShow(sw) \
	UxGET_string(sw, XrtGaCounter_prpty_name(XrtGaCounter_ResetShow))
#endif
#ifndef UxPutXrtGaResetShow
#define UxPutXrtGaResetShow(sw, val) \
	UxPUT_string(sw, XrtGaCounter_prpty_name(XrtGaCounter_ResetShow),val)
#endif

#ifndef UxGetXrtGaResetWidth
#define UxGetXrtGaResetWidth(sw) \
	UxGET_int(sw, XrtGaCounter_prpty_name(XrtGaCounter_ResetWidth))
#endif
#ifndef UxPutXrtGaResetWidth
#define UxPutXrtGaResetWidth(sw, val) \
	UxPUT_int(sw, XrtGaCounter_prpty_name(XrtGaCounter_ResetWidth),val)
#endif

#ifndef UxGetXrtGaSpacingHorizontal
#define UxGetXrtGaSpacingHorizontal(sw) \
	UxGET_int(sw,XrtGaCounter_prpty_name(XrtGaCounter_SpacingHorizontal))
#endif
#ifndef UxPutXrtGaSpacingHorizontal
#define UxPutXrtGaSpacingHorizontal(sw, val) \
	UxPUT_int(sw,XrtGaCounter_prpty_name(XrtGaCounter_SpacingHorizontal), val)
#endif

#ifndef UxGetXrtGaSpacingVertical
#define UxGetXrtGaSpacingVertical(sw) \
	UxGET_int(sw,XrtGaCounter_prpty_name(XrtGaCounter_SpacingVertical))
#endif
#ifndef UxPutXrtGaSpacingVertical
#define UxPutXrtGaSpacingVertical(sw, val) \
	UxPUT_int(sw,XrtGaCounter_prpty_name(XrtGaCounter_SpacingVertical), val)
#endif

#ifndef UxGetXrtGaTransitionRate
#define UxGetXrtGaTransitionRate(sw) \
	UxGET_int(sw,XrtGaCounter_prpty_name(XrtGaCounter_TransitionRate))
#endif
#ifndef UxPutXrtGaTransitionRate
#define UxPutXrtGaTransitionRate(sw, val) \
	UxPUT_int(sw,XrtGaCounter_prpty_name(XrtGaCounter_TransitionRate), val)
#endif

#ifndef UxGetXrtGaTransitionSteps
#define UxGetXrtGaTransitionSteps(sw) \
	UxGET_int(sw,XrtGaCounter_prpty_name(XrtGaCounter_TransitionSteps))
#endif
#ifndef UxPutXrtGaTransitionSteps
#define UxPutXrtGaTransitionSteps(sw, val) \
	UxPUT_int(sw,XrtGaCounter_prpty_name(XrtGaCounter_TransitionSteps), val)
#endif

#ifndef UxGetXrtGaUseTransition
#define UxGetXrtGaUseTransition(sw) \
	UxGET_string(sw,XrtGaCounter_prpty_name(XrtGaCounter_UseTransition))
#endif
#ifndef UxPutXrtGaUseTransition
#define UxPutXrtGaUseTransition(sw, val) \
	UxPUT_string(sw,XrtGaCounter_prpty_name(XrtGaCounter_UseTransition), val)
#endif

#ifndef UxGetXrtGaValue
#define UxGetXrtGaValue(sw) \
	UxGET_float(sw, XrtGaCounter_prpty_name(XrtGaCounter_Value))
#endif
#ifndef UxPutXrtGaValue
#define UxPutXrtGaValue(sw, val) \
	UxPUT_float(sw, XrtGaCounter_prpty_name(XrtGaCounter_Value), val)
#endif


#endif /* NO_UX_MACROS */

extern Class_t	UxC_XrtGaCounter;

/* Design-time create macro */
#ifndef UxCreateXrtGaCounter
#define UxCreateXrtGaCounter(name, parent) \
	UxCreateSwidget(UxC_XrtGaCounter, name, parent)
#endif

#else /* RUN-TIME */

extern int	XrtGaGetDoubleProp();
extern double	XrtGaArgValToDouble();

#define RT_GA_GET_DOUBLE(sw,res) \
	XrtGaArgValToDouble(UxGetXrtGaDoubleProp(sw,res))

#define RT_GA_PUT_DOUBLE(sw,res,val) \
	UxPutProp(sw,res,(XtArgVal)XrtGaDoubleToArgVal((double)val))

#ifndef UxGetBackground
#define UxGetBackground(sw) \
	(char *) UxDDGetProp(sw, XmNbackground)
#endif
#ifndef UxPutBackground
#define UxPutBackground(sw, val) \
	UxDDPutProp(sw, XmNbackground, ((XtArgVal)(val)))
#endif

#ifndef UxGetFontList
#define UxGetFontList(sw) \
	(char *) UxDDGetProp(sw, XmNfontList)
#endif
#ifndef UxPutFontList
#define UxPutFontList(sw, val) \
	UxDDPutProp(sw, XmNfontList, ((XtArgVal)(val)))
#endif

#ifndef UxGetHeight
#define UxGetHeight(sw) \
	(int) UxGetProp(sw, XmNheight)
#endif
#ifndef UxPutHeight
#define UxPutHeight(sw, val) \
	UxPutProp(sw, XmNheight, ((XtArgVal)(val)))
#endif

#ifndef UxGetWidth
#define UxGetWidth(sw) \
	(int) UxGetProp(sw, XmNwidth)
#endif
#ifndef UxPutWidth
#define UxPutWidth(sw, val) \
	UxPutProp(sw, XmNwidth, ((XtArgVal)(val)))
#endif

#ifndef UxGetX
#define UxGetX(sw) \
	(int) UxGetProp(sw, XmNx)
#endif
#ifndef UxPutX
#define UxPutX(sw, val) \
	UxPutProp(sw, XmNx, ((XtArgVal)(val)))
#endif

#ifndef UxGetY
#define UxGetY(sw) \
	(int) UxGetProp(sw, XmNy)
#endif
#ifndef UxPutY
#define UxPutY(sw, val) \
	UxPutProp(sw, XmNy, ((XtArgVal)(val)))
#endif

#ifndef UxGetXrtGaBorder
#define UxGetXrtGaBorder(sw) \
	(char *) UxDDGetProp(sw, XmNxrtGaBorder)
#endif
#ifndef UxPutXrtGaBorder
#define UxPutXrtGaBorder(sw, val) \
	UxDDPutProp(sw, XmNxrtGaBorder, ((XtArgVal)(val)))
#endif

#ifndef UxGetXrtGaBorderWidth
#define UxGetXrtGaBorderWidth(sw) \
	(int) UxGetProp(sw, XmNxrtGaBorderWidth)
#endif
#ifndef UxPutXrtGaBorderWidth
#define UxPutXrtGaBorderWidth(sw, val) \
	UxPutProp(sw, XmNxrtGaBorderWidth, ((XtArgVal)(val)))
#endif

#ifndef UxGetXrtGaDebug
#define UxGetXrtGaDebug(sw) \
	(char *) UxDDGetProp(sw, XmNxrtGaDebug)
#endif
#ifndef UxPutXrtGaDebug
#define UxPutXrtGaDebug(sw, val) \
	UxDDPutProp(sw, XmNxrtGaDebug, ((XtArgVal)(val)))
#endif

#ifndef UxGetXrtGaDecimalPlaces
#define UxGetXrtGaDecimalPlaces(sw) \
	(int) UxGetProp(sw, XmNxrtGaDecimalPlaces)
#endif
#ifndef UxPutXrtGaDecimalPlaces
#define UxPutXrtGaDecimalPlaces(sw, val) \
	UxPutProp(sw, XmNxrtGaDecimalPlaces, ((XtArgVal)(val)))
#endif

#ifndef UxGetXrtGaDigitBackgroundColor
#define UxGetXrtGaDigitBackgroundColor(sw) \
	(char *) UxDDGetProp(sw, XmNxrtGaDigitBackgroundColor)
#endif
#ifndef UxPutXrtGaDigitBackgroundColor
#define UxPutXrtGaDigitBackgroundColor(sw, val) \
	UxDDPutProp(sw, XmNxrtGaDigitBackgroundColor, ((XtArgVal)(val)))
#endif

#ifndef UxGetXrtGaDigitForegroundColor
#define UxGetXrtGaDigitForegroundColor(sw) \
	(char *) UxDDGetProp(sw, XmNxrtGaDigitForegroundColor)
#endif
#ifndef UxPutXrtGaDigitForegroundColor
#define UxPutXrtGaDigitForegroundColor(sw, val) \
	UxDDPutProp(sw, XmNxrtGaDigitForegroundColor, ((XtArgVal)(val)))
#endif

#ifndef UxGetXrtGaImage
#define UxGetXrtGaImage(sw) \
	(char *) UxDDGetProp(sw, XmNxrtGaImage)
#endif
#ifndef UxPutXrtGaImage
#define UxPutXrtGaImage(sw, val) \
	UxDDPutProp(sw, XmNxrtGaImage, ((XtArgVal)(val)))
#endif

#ifndef UxGetXrtGaImageLayout
#define UxGetXrtGaImageLayout(sw) \
	(char *) UxDDGetProp(sw, XmNxrtGaImageLayout)
#endif
#ifndef UxPutXrtGaImageLayout
#define UxPutXrtGaImageLayout(sw, val) \
	UxDDPutProp(sw, XmNxrtGaImageLayout, ((XtArgVal)(val)))
#endif

#ifndef UxGetXrtGaIsShowing
#define UxGetXrtGaIsShowing(sw) \
	(char *) UxDDGetProp(sw, XmNxrtGaIsShowing)
#endif
#ifndef UxPutXrtGaIsShowing
#define UxPutXrtGaIsShowing(sw, val) \
	UxDDPutProp(sw, XmNxrtGaIsShowing, ((XtArgVal)(val)))
#endif

#ifndef UxGetXrtGaNumDigits
#define UxGetXrtGaNumDigits(sw) \
	(int) UxGetProp(sw, XmNxrtGaNumDigits)
#endif
#ifndef UxPutXrtGaNumDigits
#define UxPutXrtGaNumDigits(sw, val) \
	UxPutProp(sw, XmNxrtGaNumDigits, ((XtArgVal)(val)))
#endif

#ifndef UxGetXrtGaResetAlignment
#define UxGetXrtGaResetAlignment(sw) \
	(char *) UxDDGetProp(sw, XmNxrtGaResetAlignment)
#endif
#ifndef UxPutXrtGaResetAlignment
#define UxPutXrtGaResetAlignment(sw, val) \
	UxDDPutProp(sw, XmNxrtGaResetAlignment, ((XtArgVal)(val)))
#endif

#ifndef UxGetXrtGaResetBackgroundColor
#define UxGetXrtGaResetBackgroundColor(sw) \
	(char *) UxDDGetProp(sw, XmNxrtGaResetBackgroundColor)
#endif
#ifndef UxPutXrtGaResetBackgroundColor
#define UxPutXrtGaResetBackgroundColor(sw, val) \
	UxDDPutProp(sw, XmNxrtGaResetBackgroundColor, ((XtArgVal)(val)))
#endif

#ifndef UxGetResetHeight
#define UxGetResetHeight(sw) \
	(int) UxGetProp(sw, XmNxrtGaResetHeight)
#endif
#ifndef UxPutResetHeight
#define UxPutResetHeight(sw, val) \
	UxPutProp(sw, XmNxrtGaResetHeight, ((XtArgVal)(val)))
#endif

#ifndef UxGetResetXrtGaImage
#define UxGetResetXrtGaImage(sw) \
	(char *) UxDDGetProp(sw, XmNxrtGaResetImage)
#endif
#ifndef UxPutResetXrtGaImage
#define UxPutResetXrtGaImage(sw, val) \
	UxDDPutProp(sw, XmNxrtGaResetImage, ((XtArgVal)(val)))
#endif

#ifndef UxGetXrtGaResetOffset
#define UxGetXrtGaResetOffset(sw) \
	(int) UxGetProp(sw, XmNxrtGaResetOffset)
#endif
#ifndef UxPutXrtGaResetOffset
#define UxPutXrtGaResetOffset(sw, val) \
	UxPutProp(sw, XmNxrtGaResetOffset, ((XtArgVal)(val)))
#endif

#ifndef UxGetXrtGaResetShape
#define UxGetXrtGaResetShape(sw) \
	(char *) UxDDGetProp(sw, XmNxrtGaResetShape)
#endif
#ifndef UxPutXrtGaResetShape
#define UxPutXrtGaResetShape(sw, val) \
	UxDDPutProp(sw, XmNxrtGaResetShape, ((XtArgVal)(val)))
#endif

#ifndef UxGetXrtGaResetShow
#define UxGetXrtGaResetShow(sw) \
	(char *) UxDDGetProp(sw, XmNxrtGaResetShow)
#endif
#ifndef UxPutXrtGaResetShow
#define UxPutXrtGaResetShow(sw, val) \
	UxDDPutProp(sw, XmNxrtGaResetShow, ((XtArgVal)(val)))
#endif

#ifndef UxGetXrtGaResetWidth
#define UxGetXrtGaResetWidth(sw) \
	(int) UxGetProp(sw, XmNxrtGaResetWidth)
#endif
#ifndef UxPutXrtGaResetWidth
#define UxPutXrtGaResetWidth(sw, val) \
	UxPutProp(sw, XmNxrtGaResetWidth, ((XtArgVal)(val)))
#endif

#ifndef UxGetXrtGaSpacingHorizontal
#define UxGetXrtGaSpacingHorizontal(sw) \
	(int) UxGetProp(sw, XmNxrtGaSpacingHorizontal)
#endif
#ifndef UxPutXrtGaSpacingHorizontal
#define UxPutXrtGaSpacingHorizontal(sw, val) \
	UxPutProp(sw, XmNxrtGaSpacingHorizontal, ((XtArgVal)(val)))
#endif

#ifndef UxGetXrtGaSpacingVertical
#define UxGetXrtGaSpacingVertical(sw) \
	(int) UxGetProp(sw, XmNxrtGaSpacingVertical)
#endif
#ifndef UxPutXrtGaSpacingVertical
#define UxPutXrtGaSpacingVertical(sw, val) \
	UxPutProp(sw, XmNxrtGaSpacingVertical, ((XtArgVal)(val)))
#endif

#ifndef UxGetXrtGaTransitionRate
#define UxGetXrtGaTransitionRate(sw) \
	(int) UxGetProp(sw, XmNxrtGaTransitionRate)
#endif
#ifndef UxPutXrtGaTransitionRate
#define UxPutXrtGaTransitionRate(sw, val) \
	UxPutProp(sw, XmNxrtGaTransitionRate, ((XtArgVal)(val)))
#endif

#ifndef UxGetXrtGaTransitionSteps
#define UxGetXrtGaTransitionSteps(sw) \
	(int) UxGetProp(sw, XmNxrtGaTransitionSteps)
#endif
#ifndef UxPutXrtGaTransitionSteps
#define UxPutXrtGaTransitionSteps(sw, val) \
	UxPutProp(sw, XmNxrtGaTransitionSteps, ((XtArgVal)(val)))
#endif

#ifndef UxGetXrtGaUseTransition
#define UxGetXrtGaUseTransition(sw) \
	(char *) UxDDGetProp(sw, XmNxrtGaUseTransition)
#endif
#ifndef UxPutXrtGaUseTransition
#define UxPutXrtGaUseTransition(sw, val) \
	UxDDPutProp(sw, XmNxrtGaUseTransition, ((XtArgVal)(val)))
#endif

#ifndef UxGetXrtGaValue
#define UxGetXrtGaValue(sw) \
	(double) RT_GA_GET_DOUBLE(sw, XmNxrtGaValue)
#endif
#ifndef UxPutXrtGaValue
#define UxPutXrtGaValue(sw, val) \
	RT_GA_PUT_DOUBLE(sw, XmNxrtGaValue, (val))
#endif


/* Runtime create macro */
#ifndef UxCreateXrtGaCounter
#define UxCreateXrtGaCounter(name, parent) \
	UxCreateSwidget(name, xmXrtGaCounterObjectClass, parent)
#endif

#endif /* DESIGN_TIME */

#endif

