/* ALL RIGHTS RESERVED
 *
 * This file is provided for demonstration and educational uses only.
 * Permission to use, copy, modify and distribute this file for
 * any purpose and without fee is hereby granted, provided that the
 * above copyright notice and this permission notice appear in all
 * copies, and that the name of KL Group not be used in advertising
 * or publicity pertaining to this material without the specific,
 * prior written permission of an authorized representative of
 * KL Group.
 *
 * KL GROUP MAKES NO REPRESENTATIONS AND EXTENDS NO WARRANTIES, EX-
 * PRESS OR IMPLIED, WITH RESPECT TO THE SOFTWARE, INCLUDING, BUT
 * NOT LIMITED TO, THE IMPLIED WARRANTIES OF MERCHANTABILITY AND
 * FITNESS FOR ANY PARTICULAR PURPOSE, AND THE WARRANTY AGAINST IN-
 * FRINGEMENT OF PATENTS OR OTHER INTELLECTUAL PROPERTY RIGHTS.  THE
 * SOFTWARE IS PROVIDED "AS IS", AND IN NO EVENT SHALL KL GROUP OR
 * ANY OF ITS AFFILIATES BE LIABLE FOR ANY DAMAGES, INCLUDING ANY
 * LOST PROFITS OR OTHER INCIDENTAL OR CONSEQUENTIAL DAMAGES
 * RELATING TO THE USE OF THIS SOFTWARE.
 *
 *
 * XRT/gear widget UIM/X integration file
 *
 *  SCCSID -- @(#)UxXrtGaLEDIcon.h	1.3    99/12/13 KL Group Inc.
 */

/******************************************************************************
				UxXrtGaLEDIcon.h
******************************************************************************/

#ifndef UxXrtGaLEDIcon_h
#define UxXrtGaLEDIcon_h

#include <Xm/XrtGaLEDIcon.h>	/* Widget class public header file */
#include "Xrt_restable.h"
#include "UxPrim.h"

#include "UxXrtGaLEDIcon.hxx"  /* Include C++ header file (New in UIM/X 3.0)*/

#ifdef DESIGN_TIME
#ifndef NO_UX_MACROS

#define XrtGaLEDIcon_prpty_name(x)	XrtGaLEDIcon_res_table[x].prpty, XrtGaLEDIcon_res_table[x].name

#ifndef UxGetXrtGaBorder
#define UxGetXrtGaBorder(sw) \
	UxGET_string(sw, XrtGaLEDIcon_prpty_name(XrtGaLEDIcon_Border))
#endif
#ifndef UxPutXrtGaBorder
#define UxPutXrtGaBorder(sw, val) \
	UxPUT_string(sw, XrtGaLEDIcon_prpty_name(XrtGaLEDIcon_Border),val)
#endif

#ifndef UxGetXrtGaDebug
#define UxGetXrtGaDebug(sw) \
	UxGET_string(sw, XrtGaLEDIcon_prpty_name(XrtGaLEDIcon_Debug))
#endif
#ifndef UxPutXrtGaDebug
#define UxPutXrtGaDebug(sw, val) \
	UxPUT_string(sw, XrtGaLEDIcon_prpty_name(XrtGaLEDIcon_Debug), val)
#endif

#ifndef UxGetXrtGaDecayRate
#define UxGetXrtGaDecayRate(sw) \
	UxGET_int(sw, XrtGaLEDIcon_prpty_name(XrtGaLEDIcon_DecayRate))
#endif
#ifndef UxPutXrtGaDecayRate
#define UxPutXrtGaDecayRate(sw, val) \
	UxPUT_int(sw, XrtGaLEDIcon_prpty_name(XrtGaLEDIcon_DecayRate),val)
#endif

#ifndef UxGetXrtGaDisplayMode
#define UxGetXrtGaDisplayMode(sw) \
	UxGET_string(sw, XrtGaLEDIcon_prpty_name(XrtGaLEDIcon_DisplayMode))
#endif
#ifndef UxPutXrtGaDisplayMode
#define UxPutXrtGaDisplayMode(sw, val) \
	UxPUT_string(sw, XrtGaLEDIcon_prpty_name(XrtGaLEDIcon_DisplayMode), val)
#endif

#ifndef UxGetXrtGaDirection
#define UxGetXrtGaDirection(sw) \
	UxGET_string(sw, XrtGaLEDIcon_prpty_name(XrtGaLEDIcon_Direction))
#endif
#ifndef UxPutXrtGaDirection
#define UxPutXrtGaDirection(sw, val) \
	UxPUT_string(sw, XrtGaLEDIcon_prpty_name(XrtGaLEDIcon_Direction),val)
#endif

#ifndef UxGetXrtGaDoubleBuffer
#define UxGetXrtGaDoubleBuffer(sw) \
	UxGET_string(sw, XrtGaLEDIcon_prpty_name(XrtGaLEDIcon_DoubleBuffer))
#endif
#ifndef UxPutXrtGaDoubleBuffer
#define UxPutXrtGaDoubleBuffer(sw, val) \
	UxPUT_string(sw, XrtGaLEDIcon_prpty_name(XrtGaLEDIcon_DoubleBuffer), val)
#endif

#ifndef UxGetXrtGaIconHeight
#define UxGetXrtGaIconHeight(sw) \
	UxGET_int(sw, XrtGaLEDIcon_prpty_name(XrtGaLEDIcon_IconHeight))
#endif
#ifndef UxPutXrtGaIconHeight
#define UxPutXrtGaIconHeight(sw, val) \
	UxPUT_int(sw, XrtGaLEDIcon_prpty_name(XrtGaLEDIcon_IconHeight),val)
#endif

#ifndef UxGetXrtGaIconList
#define UxGetXrtGaIconList(sw) \
	UxGET_string(sw, XrtGaLEDIcon_prpty_name(XrtGaLEDIcon_IconList))
#endif
#ifndef UxPutXrtGaIconList
#define UxPutXrtGaIconList(sw, val) \
	UxPUT_string(sw, XrtGaLEDIcon_prpty_name(XrtGaLEDIcon_IconList),val)
#endif

#ifndef UxGetXrtGaIconSpacing
#define UxGetXrtGaIconSpacing(sw) \
	UxGET_int(sw, XrtGaLEDIcon_prpty_name(XrtGaLEDIcon_IconSpacing))
#endif
#ifndef UxPutXrtGaIconSpacing
#define UxPutXrtGaIconSpacing(sw, val) \
	UxPUT_int(sw, XrtGaLEDIcon_prpty_name(XrtGaLEDIcon_IconSpacing),val)
#endif

#ifndef UxGetXrtGaIconWidth
#define UxGetXrtGaIconWidth(sw) \
	UxGET_int(sw, XrtGaLEDIcon_prpty_name(XrtGaLEDIcon_IconWidth))
#endif
#ifndef UxPutXrtGaIconWidth
#define UxPutXrtGaIconWidth(sw, val) \
	UxPUT_int(sw, XrtGaLEDIcon_prpty_name(XrtGaLEDIcon_IconWidth),val)
#endif
		
#ifndef UxGetXrtGaImage
#define UxGetXrtGaImage(sw) \
	UxGET_string(sw, XrtGaLEDIcon_prpty_name(XrtGaLEDIcon_Image))
#endif
#ifndef UxPutXrtGaImage
#define UxPutXrtGaImage(sw, val) \
	UxPUT_string(sw, XrtGaLEDIcon_prpty_name(XrtGaLEDIcon_Image), val)
#endif

#ifndef UxGetXrtGaImageLayout
#define UxGetXrtGaImageLayout(sw) \
	UxGET_string(sw, XrtGaLEDIcon_prpty_name(XrtGaLEDIcon_ImageLayout))
#endif
#ifndef UxPutXrtGaImageLayout
#define UxPutXrtGaImageLayout(sw, val) \
	UxPUT_string(sw, XrtGaLEDIcon_prpty_name(XrtGaLEDIcon_ImageLayout), val)
#endif

#ifndef UxGetXrtGaLEDStartValue
#define UxGetXrtGaLEDStartValue(sw) \
	UxGET_int(sw, XrtGaLEDIcon_prpty_name(XrtGaLEDIcon_LEDStartValue))
#endif
#ifndef UxPutXrtGaLEDStartValue
#define UxPutXrtGaLEDStartValue(sw, val) \
	UxPUT_int(sw, XrtGaLEDIcon_prpty_name(XrtGaLEDIcon_LEDStartValue),val)
#endif

#ifndef UxGetXrtGaLEDValue
#define UxGetXrtGaLEDValue(sw) \
	UxGET_int(sw, XrtGaLEDIcon_prpty_name(XrtGaLEDIcon_LEDValue))
#endif
#ifndef UxPutXrtGaLEDValue
#define UxPutXrtGaLEDValue(sw, val) \
	UxPUT_int(sw, XrtGaLEDIcon_prpty_name(XrtGaLEDIcon_LEDValue), val)
#endif

#ifndef UxGetXrtGaMaxIcon
#define UxGetXrtGaMaxIcon(sw) \
	UxGET_string(sw, XrtGaLEDIcon_prpty_name(XrtGaLEDIcon_MaxIcon))
#endif
#ifndef UxPutXrtGaMaxIcon
#define UxPutXrtGaMaxIcon(sw, val) \
	UxPUT_string(sw, XrtGaLEDIcon_prpty_name(XrtGaLEDIcon_MaxIcon),val)
#endif

#ifndef UxGetXrtGaOrientation
#define UxGetXrtGaOrientation(sw) \
	UxGET_string(sw, XrtGaLEDIcon_prpty_name(XrtGaLEDIcon_Orientation))
#endif
#ifndef UxPutXrtGaOrientation
#define UxPutXrtGaOrientation(sw, val) \
	UxPUT_string(sw, XrtGaLEDIcon_prpty_name(XrtGaLEDIcon_Orientation), val)
#endif

#ifndef UxGetXrtGaRepaint
#define UxGetXrtGaRepaint(sw) \
	UxGET_string(sw, XrtGaLEDIcon_prpty_name(XrtGaLEDIcon_Repaint))
#endif
#ifndef UxPutXrtGaRepaint
#define UxPutXrtGaRepaint(sw, val) \
	UxPUT_string(sw, XrtGaLEDIcon_prpty_name(XrtGaLEDIcon_Repaint),val)
#endif

#ifndef UxGetXrtGaSizingPolicy
#define UxGetXrtGaSizingPolicy(sw) \
	UxGET_string(sw,XrtGaLEDIcon_prpty_name(XrtGaLEDIcon_SizingPolicy))
#endif
#ifndef UxPutXrtGaSizingPolicy
#define UxPutXrtGaSizingPolicy(sw, val) \
	UxPUT_string(sw,XrtGaLEDIcon_prpty_name(XrtGaLEDIcon_SizingPolicy), val)
#endif

#ifndef UxGetXrtGaSpacingHorizontal
#define UxGetXrtGaSpacingHorizontal(sw) \
	UxGET_int(sw,XrtGaLEDIcon_prpty_name(XrtGaLEDIcon_SpacingHorizontal))
#endif
#ifndef UxPutXrtGaSpacingHorizontal
#define UxPutXrtGaSpacingHorizontal(sw, val) \
	UxPUT_int(sw,XrtGaLEDIcon_prpty_name(XrtGaLEDIcon_SpacingHorizontal), val)
#endif

#ifndef UxGetXrtGaSpacingVertical
#define UxGetXrtGaSpacingVertical(sw) \
	UxGET_int(sw,XrtGaLEDIcon_prpty_name(XrtGaLEDIcon_SpacingVertical))
#endif
#ifndef UxPutXrtGaSpacingVertical
#define UxPutXrtGaSpacingVertical(sw, val) \
	UxPUT_int(sw,XrtGaLEDIcon_prpty_name(XrtGaLEDIcon_SpacingVertical), val)
#endif

#ifndef UxGetXrtGaXOrigin
#define UxGetXrtGaXOrigin(sw) \
	UxGET_int(sw, XrtGaLEDIcon_prpty_name(XrtGaLEDIcon_XOrigin))
#endif
#ifndef UxPutXrtGaXOrigin
#define UxPutXrtGaXOrigin(sw, val) \
	UxPUT_int(sw, XrtGaLEDIcon_prpty_name(XrtGaLEDIcon_XOrigin), val)
#endif

#ifndef UxGetXrtGaYOrigin
#define UxGetXrtGaYOrigin(sw) \
	UxGET_int(sw, XrtGaLEDIcon_prpty_name(XrtGaLEDIcon_YOrigin))
#endif
#ifndef UxPutXrtGaYOrigin
#define UxPutXrtGaYOrigin(sw, val) \
	UxPUT_int(sw, XrtGaLEDIcon_prpty_name(XrtGaLEDIcon_YOrigin), val)
#endif


#endif /* NO_UX_MACROS */

extern Class_t	UxC_XrtGaLEDIcon;

/* Design-time create macro */
#ifndef UxCreateXrtGaLEDIcon
#define UxCreateXrtGaLEDIcon(name, parent) \
	UxCreateSwidget(UxC_XrtGaLEDIcon, name, parent)
#endif

#else /* RUN-TIME */

#ifndef UxGetXrtGaBorder
#define UxGetXrtGaBorder(sw) \
	(char *) UxDDGetProp(sw, XmNxrtGaBorder)
#endif
#ifndef UxPutXrtGaBorder
#define UxPutXrtGaBorder(sw, val) \
	UxDDPutProp(sw, XmNxrtGaBorder, ((XtArgVal)(val)))
#endif

#ifndef UxGetXrtGaDebug
#define UxGetXrtGaDebug(sw) \
	(char *) UxDDGetProp(sw, XmNxrtGaDebug)
#endif
#ifndef UxPutXrtGaDebug
#define UxPutXrtGaDebug(sw, val) \
	UxDDPutProp(sw, XmNxrtGaDebug, ((XtArgVal)(val)))
#endif

#ifndef UxGetXrtGaDecayRate
#define UxGetXrtGaDecayRate(sw) \
	(int) UxGetProp(sw, XmNxrtGaDecayRate)
#endif
#ifndef UxPutXrtGaDecayRate
#define UxPutXrtGaDecayRate(sw, val) \
	UxPutProp(sw, XmNxrtGaDecayRate, ((XtArgVal)(val)))
#endif

#ifndef UxGetXrtGaDisplayMode
#define UxGetXrtGaDisplayMode(sw) \
	(char *) UxDDGetProp(sw, XmNxrtGaDisplayMode)
#endif
#ifndef UxPutXrtGaDisplayMode
#define UxPutXrtGaDisplayMode(sw, val) \
	UxDDPutProp(sw, XmNxrtGaDisplayMode, ((XtArgVal)(val)))
#endif

#ifndef UxGetXrtGaDirection
#define UxGetXrtGaDirection(sw) \
	(char *) UxDDGetProp(sw, XmNxrtGaDirection)
#endif
#ifndef UxPutXrtGaDirection
#define UxPutXrtGaDirection(sw, val) \
	UxDDPutProp(sw, XmNxrtGaDirection, ((XtArgVal)(val)))
#endif

#ifndef UxGetXrtGaDoubleBuffer
#define UxGetXrtGaDoubleBuffer(sw) \
	(char *) UxDDGetProp(sw, XmNxrtGaDoubleBuffer)
#endif
#ifndef UxPutXrtGaDoubleBuffer
#define UxPutXrtGaDoubleBuffer(sw, val) \
	UxDDPutProp(sw, XmNxrtGaDoubleBuffer, ((XtArgVal)(val)))
#endif

#ifndef UxGetXrtGaIconHeight
#define UxGetXrtGaIconHeight(sw) \
	(int) UxGetProp(sw, XmNxrtGaIconHeight)
#endif
#ifndef UxPutXrtGaIconHeight
#define UxPutXrtGaIconHeight(sw, val) \
	UxPutProp(sw, XmNxrtGaIconHeight, ((XtArgVal)(val)))
#endif

#ifndef UxGetXrtGaIconList
#define UxGetXrtGaIconList(sw) \
	(char *) UxDDGetProp(sw, XmNxrtGaIconList)
#endif
#ifndef UxPutXrtGaIconList
#define UxPutXrtGaIconList(sw, val) \
	UxDDPutProp(sw, XmNxrtGaIconList, ((XtArgVal)(val)))
#endif

#ifndef UxGetXrtGaIconSpacing
#define UxGetXrtGaIconSpacing(sw) \
	(int) UxGetProp(sw, XmNxrtGaIconSpacing)
#endif
#ifndef UxPutXrtGaIconSpacing
#define UxPutXrtGaIconSpacing(sw, val) \
	UxPutProp(sw, XmNxrtGaIconSpacing, ((XtArgVal)(val)))
#endif

#ifndef UxGetXrtGaIconWidth
#define UxGetXrtGaIconWidth(sw) \
	(int) UxGetProp(sw, XmNxrtGaIconWidth)
#endif
#ifndef UxPutXrtGaIconWidth
#define UxPutXrtGaIconWidth(sw, val) \
	UxPutProp(sw, XmNxrtGaIconWidth, ((XtArgVal)(val)))
#endif
		
#ifndef UxGetXrtGaImage
#define UxGetXrtGaImage(sw) \
	(char *) UxDDGetProp(sw, XmNxrtGaImage)
#endif
#ifndef UxPutXrtGaImage
#define UxPutXrtGaImage(sw, val) \
	UxDDPutProp(sw, XmNxrtGaImage, ((XtArgVal)(val)))
#endif

#ifndef UxGetXrtGaImageLayout
#define UxGetXrtGaImageLayout(sw) \
	(char *) UxDDGetProp(sw, XmNxrtGaImageLayout)
#endif
#ifndef UxPutXrtGaImageLayout
#define UxPutXrtGaImageLayout(sw, val) \
	UxDDPutProp(sw, XmNxrtGaImageLayout, ((XtArgVal)(val)))
#endif

#ifndef UxGetXrtGaLEDStartValue
#define UxGetXrtGaLEDStartValue(sw) \
	(int) UxGetProp(sw, XmNxrtGaLEDStartValue)
#endif
#ifndef UxPutXrtGaLEDStartValue
#define UxPutXrtGaLEDStartValue(sw, val) \
	UxPutProp(sw, XmNxrtGaLEDStartValue, ((XtArgVal)(val)))
#endif

#ifndef UxGetXrtGaLEDValue
#define UxGetXrtGaLEDValue(sw) \
	(int) UxGetProp(sw, XmNxrtGaLEDValue)
#endif
#ifndef UxPutXrtGaLEDValue
#define UxPutXrtGaLEDValue(sw, val) \
	UxPutProp(sw, XmNxrtGaLEDValue, ((XtArgVal)(val)))
#endif

#ifndef UxGetXrtGaMaxIcon
#define UxGetXrtGaMaxIcon(sw) \
	(char *) UxDDGetProp(sw, XmNxrtGaMaxIcon)
#endif
#ifndef UxPutXrtGaMaxIcon
#define UxPutXrtGaMaxIcon(sw, val) \
	UxDDPutProp(sw, XmNxrtGaMaxIcon, ((XtArgVal)(val)))
#endif

#ifndef UxGetXrtGaOrientation
#define UxGetXrtGaOrientation(sw) \
	(char *) UxDDGetProp(sw, XmNxrtGaOrientation)
#endif
#ifndef UxPutXrtGaOrientation
#define UxPutXrtGaOrientation(sw, val) \
	UxDDPutProp(sw, XmNxrtGaOrientation, ((XtArgVal)(val)))
#endif

#ifndef UxGetXrtGaRepaint
#define UxGetXrtGaRepaint(sw) \
	(char *) UxDDGetProp(sw, XmNxrtGaRepaint)
#endif
#ifndef UxPutXrtGaRepaint
#define UxPutXrtGaRepaint(sw, val) \
	UxDDPutProp(sw, XmNxrtGaRepaint, ((XtArgVal)(val)))
#endif

#ifndef UxGetXrtGaSizingPolicy
#define UxGetXrtGaSizingPolicy(sw) \
	(char *) UxDDGetProp(sw, XmNxrtGaSizingPolicy)
#endif
#ifndef UxPutXrtGaSizingPolicy
#define UxPutXrtGaSizingPolicy(sw, val) \
	UxDDPutProp(sw, XmNxrtGaSizingPolicy, ((XtArgVal)(val)))
#endif

#ifndef UxGetXrtGaSpacingHorizontal
#define UxGetXrtGaSpacingHorizontal(sw) \
	(int) UxGetProp(sw, XmNxrtGaSpacingHorizontal)
#endif
#ifndef UxPutXrtGaSpacingHorizontal
#define UxPutXrtGaSpacingHorizontal(sw, val) \
	UxPutProp(sw, XmNxrtGaSpacingHorizontal, ((XtArgVal)(val)))
#endif

#ifndef UxGetXrtGaSpacingVertical
#define UxGetXrtGaSpacingVertical(sw) \
	(int) UxGetProp(sw, XmNxrtGaSpacingVertical)
#endif
#ifndef UxPutXrtGaSpacingVertical
#define UxPutXrtGaSpacingVertical(sw, val) \
	UxPutProp(sw, XmNxrtGaSpacingVertical, ((XtArgVal)(val)))
#endif

#ifndef UxGetXrtGaXOrigin
#define UxGetXrtGaXOrigin(sw) \
	(int) UxGetProp(sw, XmNxrtGaXOrigin)
#endif
#ifndef UxPutXrtGaXOrigin
#define UxPutXrtGaXOrigin(sw, val) \
	UxPutProp(sw, XmNxrtGaXOrigin, ((XtArgVal)(val)))
#endif

#ifndef UxGetXrtGaYOrigin
#define UxGetXrtGaYOrigin(sw) \
	(int) UxGetProp(sw, XmNxrtGaYOrigin)
#endif
#ifndef UxPutXrtGaYOrigin
#define UxPutXrtGaYOrigin(sw, val) \
	UxPutProp(sw, XmNxrtGaYOrigin, ((XtArgVal)(val)))
#endif


/* Runtime create macro */
#ifndef UxCreateXrtGaLEDIcon
#define UxCreateXrtGaLEDIcon(name, parent) \
	UxCreateSwidget(name, xmXrtGaLEDIconWidgetClass, parent)
#endif

#endif /* DESIGN_TIME */

#endif

