/* ALL RIGHTS RESERVED
 *
 * This file is provided for demonstration and educational uses only.
 * Permission to use, copy, modify and distribute this file for
 * any purpose and without fee is hereby granted, provided that the
 * above copyright notice and this permission notice appear in all
 * copies, and that the name of KL Group not be used in advertising
 * or publicity pertaining to this material without the specific,
 * prior written permission of an authorized representative of
 * KL Group.
 *
 * KL GROUP MAKES NO REPRESENTATIONS AND EXTENDS NO WARRANTIES, EX-
 * PRESS OR IMPLIED, WITH RESPECT TO THE SOFTWARE, INCLUDING, BUT
 * NOT LIMITED TO, THE IMPLIED WARRANTIES OF MERCHANTABILITY AND
 * FITNESS FOR ANY PARTICULAR PURPOSE, AND THE WARRANTY AGAINST IN-
 * FRINGEMENT OF PATENTS OR OTHER INTELLECTUAL PROPERTY RIGHTS.  THE
 * SOFTWARE IS PROVIDED "AS IS", AND IN NO EVENT SHALL KL GROUP OR
 * ANY OF ITS AFFILIATES BE LIABLE FOR ANY DAMAGES, INCLUDING ANY
 * LOST PROFITS OR OTHER INCIDENTAL OR CONSEQUENTIAL DAMAGES
 * RELATING TO THE USE OF THIS SOFTWARE.
 *
 *
 * XRT/gear widget UIM/X integration file
 *
 *  SCCSID -- @(#)UxXrtGaLinearScale.h	1.3    99/12/13 KL Group Inc.
 */

/******************************************************************************
				UxXrtGaLinearScale.h
******************************************************************************/

#ifndef UxXrtGaLinearScale_h
#define UxXrtGaLinearScale_h

#include <Xm/XrtGaLinearScale.h>	/* Widget class public header file */
#include "Xrt_restable.h"
#include "UxGadget.h"
#include "UxXrtGaLinearScale.hxx"  /* Include C++ header file (New in UIM/X 3.0)*/

#ifdef DESIGN_TIME
#ifndef NO_UX_MACROS

#define XrtGaLScale_prpty_name(x)	XrtGaLinearScale_res_table[x].prpty, XrtGaLinearScale_res_table[x].name

#ifdef hp700v9
#define XrtGaDoubleToArgVal(d) UxXrtGaDoubleToArgVal(0,d)
#endif /* hp700v9 */

#ifndef UxGetBackground
#define UxGetBackground(sw) \
	UxGET_string(sw, XrtGaLScale_prpty_name(XrtGaLScale_background))
#endif
#ifndef UxPutBackground
#define UxPutBackground(sw, val) \
	UxPUT_string(sw, XrtGaLScale_prpty_name(XrtGaLScale_background),val)
#endif

#ifndef UxGetHeight
#define UxGetHeight(sw) \
	UxGET_int(sw, XrtGaLScale_prpty_name(XrtGaLScale_height))
#endif
#ifndef UxPutHeight
#define UxPutHeight(sw, val) \
	UxPUT_int(sw, XrtGaLScale_prpty_name(XrtGaLScale_height), val)
#endif

#ifndef UxGetWidth
#define UxGetWidth(sw) \
	UxGET_int(sw, XrtGaLScale_prpty_name(XrtGaLScale_width))
#endif
#ifndef UxPutWidth
#define UxPutWidth(sw, val) \
	UxPUT_int(sw, XrtGaLScale_prpty_name(XrtGaLScale_width), val)
#endif

#ifndef UxGetX
#define UxGetX(sw) \
	UxGET_int(sw, XrtGaLScale_prpty_name(XrtGaLScale_x))
#endif
#ifndef UxPutX
#define UxPutX(sw, val) \
	UxPUT_int(sw, XrtGaLScale_prpty_name(XrtGaLScale_x), val)
#endif

#ifndef UxGetY
#define UxGetY(sw) \
	UxGET_int(sw, XrtGaLScale_prpty_name(XrtGaLScale_y))
#endif
#ifndef UxPutY
#define UxPutY(sw, val) \
	UxPUT_int(sw, XrtGaLScale_prpty_name(XrtGaLScale_y), val)
#endif

#ifndef UxGetXrtGaAllowTransform
#define UxGetXrtGaAllowTransform(sw) \
	UxGET_string(sw,XrtGaLScale_prpty_name(XrtGaLScale_AllowTransform))
#endif
#ifndef UxPutXrtGaAllowTransform
#define UxPutXrtGaAllowTransform(sw, val) \
	UxPUT_string(sw,XrtGaLScale_prpty_name(XrtGaLScale_AllowTransform), val)
#endif

#ifndef UxGetXrtGaDebug
#define UxGetXrtGaDebug(sw) \
	UxGET_string(sw, XrtGaLScale_prpty_name(XrtGaLScale_Debug))
#endif
#ifndef UxPutXrtGaDebug
#define UxPutXrtGaDebug(sw, val) \
	UxPUT_string(sw, XrtGaLScale_prpty_name(XrtGaLScale_Debug), val)
#endif

#ifndef UxGetXrtGaDirection
#define UxGetXrtGaDirection(sw) \
	UxGET_string(sw, XrtGaLScale_prpty_name(XrtGaLScale_Direction))
#endif
#ifndef UxPutXrtGaDirection
#define UxPutXrtGaDirection(sw, val) \
	UxPUT_string(sw, XrtGaLScale_prpty_name(XrtGaLScale_Direction),val)
#endif

#ifndef UxGetMax
#define UxGetMax(sw) \
	UxGET_float(sw, XrtGaLScale_prpty_name(XrtGaLScale_Max))
#endif
#ifndef UxPutMax
#define UxPutMax(sw, val) \
	UxPUT_float(sw, XrtGaLScale_prpty_name(XrtGaLScale_Max), val)
#endif

#ifndef UxGetXrtGaMin
#define UxGetXrtGaMin(sw) \
	UxGET_float(sw, XrtGaLScale_prpty_name(XrtGaLScale_Min))
#endif
#ifndef UxPutXrtGaMin
#define UxPutXrtGaMin(sw, val) \
	UxPUT_float(sw, XrtGaLScale_prpty_name(XrtGaLScale_Min), val)
#endif

#ifndef UxGetXrtGaOrientation
#define UxGetXrtGaOrientation(sw) \
	UxGET_string(sw, XrtGaLScale_prpty_name(XrtGaLScale_Orientation))
#endif
#ifndef UxPutXrtGaOrientation
#define UxPutXrtGaOrientation(sw, val) \
	UxPUT_string(sw, XrtGaLScale_prpty_name(XrtGaLScale_Orientation),val)
#endif


#endif /* NO_UX_MACROS */

extern Class_t	UxC_XrtGaLinearScale;

/* Design-time create macro */
#ifndef UxCreateXrtGaLinearScale
#define UxCreateXrtGaLinearScale(name, parent) \
	UxCreateSwidget(UxC_XrtGaLinearScale, name, parent)
#endif

#else /* RUN-TIME */

extern int	XrtGaGetDoubleProp();
extern double	XrtGaArgValToDouble();

#define RT_GA_GET_DOUBLE(sw,res) \
	XrtGaArgValToDouble(UxGetXrtGaDoubleProp(sw,res))

#define RT_GA_PUT_DOUBLE(sw,res,val) \
	UxPutProp(sw,res,(XtArgVal)XrtGaDoubleToArgVal((double)val))

#ifndef UxGetBackground
#define UxGetBackground(sw) \
	(char *) UxDDGetProp(sw, XmNbackground)
#endif
#ifndef UxPutBackground
#define UxPutBackground(sw, val) \
	UxDDPutProp(sw, XmNbackground, ((XtArgVal)(val)))
#endif

#ifndef UxGetHeight
#define UxGetHeight(sw) \
	(int) UxGetProp(sw, XmNheight)
#endif
#ifndef UxPutHeight
#define UxPutHeight(sw, val) \
	UxPutProp(sw, XmNheight, ((XtArgVal)(val)))
#endif

#ifndef UxGetWidth
#define UxGetWidth(sw) \
	(int) UxGetProp(sw, XmNwidth)
#endif
#ifndef UxPutWidth
#define UxPutWidth(sw, val) \
	UxPutProp(sw, XmNwidth, ((XtArgVal)(val)))
#endif

#ifndef UxGetX
#define UxGetX(sw) \
	(int) UxGetProp(sw, XmNx)
#endif
#ifndef UxPutX
#define UxPutX(sw, val) \
	UxPutProp(sw, XmNx, ((XtArgVal)(val)))
#endif

#ifndef UxGetY
#define UxGetY(sw) \
	(int) UxGetProp(sw, XmNy)
#endif
#ifndef UxPutY
#define UxPutY(sw, val) \
	UxPutProp(sw, XmNy, ((XtArgVal)(val)))
#endif

#ifndef UxGetXrtGaAllowTransform
#define UxGetXrtGaAllowTransform(sw) \
	(char *) UxDDGetProp(sw, XmNxrtGaAllowTransform)
#endif
#ifndef UxPutXrtGaAllowTransform
#define UxPutXrtGaAllowTransform(sw, val) \
	UxDDPutProp(sw, XmNxrtGaAllowTransform, ((XtArgVal)(val)))
#endif

#ifndef UxGetXrtGaDebug
#define UxGetXrtGaDebug(sw) \
	(char *) UxDDGetProp(sw, XmNxrtGaDebug)
#endif
#ifndef UxPutXrtGaDebug
#define UxPutXrtGaDebug(sw, val) \
	UxDDPutProp(sw, XmNxrtGaDebug, ((XtArgVal)(val)))
#endif

#ifndef UxGetXrtGaDirection
#define UxGetXrtGaDirection(sw) \
	(char *) UxDDGetProp(sw, XmNxrtGaDirection)
#endif
#ifndef UxPutXrtGaDirection
#define UxPutXrtGaDirection(sw, val) \
	UxDDPutProp(sw, XmNxrtGaDirection, ((XtArgVal)(val)))
#endif

#ifndef UxGetMax
#define UxGetMax(sw) \
	(double) RT_GA_GET_DOUBLE(sw, XmNxrtGaMax)
#endif
#ifndef UxPutMax
#define UxPutMax(sw, val) \
	RT_GA_PUT_DOUBLE(sw, XmNxrtGaMax, (val))
#endif

#ifndef UxGetXrtGaMin
#define UxGetXrtGaMin(sw) \
	(double) RT_GA_GET_DOUBLE(sw, XmNxrtGaMin)
#endif
#ifndef UxPutXrtGaMin
#define UxPutXrtGaMin(sw, val) \
	RT_GA_PUT_DOUBLE(sw, XmNxrtGaMin, (val))
#endif

#ifndef UxGetXrtGaOrientation
#define UxGetXrtGaOrientation(sw) \
	(char *) UxDDGetProp(sw, XmNxrtGaOrientation)
#endif
#ifndef UxPutXrtGaOrientation
#define UxPutXrtGaOrientation(sw, val) \
	UxDDPutProp(sw, XmNxrtGaOrientation, ((XtArgVal)(val)))
#endif


/* Runtime create macro */
#ifndef UxCreateXrtGaLinearScale
#define UxCreateXrtGaLinearScale(name, parent) \
	UxCreateSwidget(name, xmXrtGaLinearScaleObjectClass, parent)
#endif

#endif /* DESIGN_TIME */

#endif

