/* ALL RIGHTS RESERVED
 *
 * This file is provided for demonstration and educational uses only.
 * Permission to use, copy, modify and distribute this file for
 * any purpose and without fee is hereby granted, provided that the
 * above copyright notice and this permission notice appear in all
 * copies, and that the name of KL Group not be used in advertising
 * or publicity pertaining to this material without the specific,
 * prior written permission of an authorized representative of
 * KL Group.
 *
 * KL GROUP MAKES NO REPRESENTATIONS AND EXTENDS NO WARRANTIES, EX-
 * PRESS OR IMPLIED, WITH RESPECT TO THE SOFTWARE, INCLUDING, BUT
 * NOT LIMITED TO, THE IMPLIED WARRANTIES OF MERCHANTABILITY AND
 * FITNESS FOR ANY PARTICULAR PURPOSE, AND THE WARRANTY AGAINST IN-
 * FRINGEMENT OF PATENTS OR OTHER INTELLECTUAL PROPERTY RIGHTS.  THE
 * SOFTWARE IS PROVIDED "AS IS", AND IN NO EVENT SHALL KL GROUP OR
 * ANY OF ITS AFFILIATES BE LIABLE FOR ANY DAMAGES, INCLUDING ANY
 * LOST PROFITS OR OTHER INCIDENTAL OR CONSEQUENTIAL DAMAGES
 * RELATING TO THE USE OF THIS SOFTWARE.
 *
 *
 * XRT/gauge widget UIM/X integration file
 *
 * $AstecId: UxXrtGaSwitch.hxx,v 1.3 2003/02/14 02:24:57 kosaka Exp $
 *
 *  SCCSID -- @(#)UxXrtGaSwitch.hxx	1.3    00/01/05 KL Group Inc.
 */

#if defined(__cplusplus) && !defined(XT_CODE) && !defined(NO_UXBINDINGS)  && !defined(UIMX2_9)

class UxXrtGaSwitch : public UxGadget
{
    public:

	// Constructors
	UXINLINE UxXrtGaSwitch(void);
	UXINLINE UxXrtGaSwitch(const char*, swidget);

	// Initialisation
	UXINLINE swidget CreateSwidget(const char*, swidget);

	// Resource accessor functions

	UXINLINE char * GetBackground () const;
	UXINLINE void SetBackground (const char *);

	UXINLINE char * GetXrtGaCircularScale () const;
	UXINLINE void SetXrtGaCircularScale (const char *);

	UXINLINE char * GetXrtGaContinuous () const;
	UXINLINE void SetXrtGaContinuous (const char *);

	UXINLINE char * GetXrtGaDebug () const;
	UXINLINE void SetXrtGaDebug (const char *);

//	UXINLINE voidFunction GetXrtGaDrawFunc () const;
//	UXINLINE void SetXrtGaDrawFunc (voidFunction);

	UXINLINE char * GetXrtGaImage () const;
	UXINLINE void SetXrtGaImage (const char *);

	UXINLINE char * GetXrtGaImageRotate () const;
	UXINLINE void SetXrtGaImageRotate (const char *);

	UXINLINE double GetXrtGaIncrementValue () const;
	UXINLINE void SetXrtGaIncrementValue (double);

	UXINLINE char * GetXrtGaInteractionType () const;
	UXINLINE void SetXrtGaInteractionType (const char *);

	UXINLINE char * GetXrtGaIsShowing () const;
	UXINLINE void SetXrtGaIsShowing (const char *);

	UXINLINE char * GetXrtGaMultipleTurnEnabled () const;
	UXINLINE void SetXrtGaMultipleTurnEnabled (const char *);

	UXINLINE double GetXrtGaMultipleTurnValue () const;
	UXINLINE void SetXrtGaMultipleTurnValue (double);

	UXINLINE double GetXrtGaRadius () const;
	UXINLINE void SetXrtGaRadius (double);

	UXINLINE double GetXrtGaValue () const;
	UXINLINE void SetXrtGaValue (double);

	UXINLINE char * GetXrtGaSwitchType () const;
	UXINLINE void SetXrtGaSwitchType (const char *);


};

#ifdef DESIGN_TIME

#define XrtGaSwitch_prpty_name(x)	XrtGaSwitch_res_table[x].prpty, XrtGaSwitch_res_table[x].name

extern Class_t UxC_XrtGaSwitch;

#else /* (not DESIGN_TIME) */

#if defined(__alpha) && defined(__cplusplus)
#pragma message save
#pragma message disable narrowptr
#endif /* __alpha */

// define macro to access properties of type double

extern "C" {
	XtArgVal UxGetXrtGaDoubleProp(swidget sw, char *res);
	double   XrtGaArgValToDouble(XtArgVal val);
	XtArgVal XrtGaDoubleToArgVal(double val);
}

#define RT_GA_GET_DOUBLE(res) \
	XrtGaArgValToDouble(UxGetXrtGaDoubleProp(UxThis,res))
#define RT_GA_PUT_DOUBLE(res,val) \
	UxPutProp(UxThis,res,(XtArgVal)XrtGaDoubleToArgVal((double)val))

// Constructors
inline UxXrtGaSwitch::UxXrtGaSwitch(void){}
inline UxXrtGaSwitch::UxXrtGaSwitch(const char* name, swidget uXParent)
{
	CreateSwidget(name,uXParent);
}

// Initialisation
inline swidget
UxXrtGaSwitch::CreateSwidget (const char* name, swidget parent)
{
	if (UxThis == NULL)
		UxThis = UxCreateSwidget( (char *) name,
					  xmXrtGaSwitchWidgetClass, parent);
	return UxThis;
}

inline char *  UxXrtGaSwitch::GetBackground (void) const
        { return (char * ) DDGetProp(XmNbackground);}
inline void UxXrtGaSwitch::SetBackground (const char * val)
        { DDSetProp(XmNbackground, ((XtArgVal)(val)));}

inline char *  UxXrtGaSwitch::GetXrtGaCircularScale (void) const
        { return (char * ) DDGetProp(XmNxrtGaCircularScale);}
inline void UxXrtGaSwitch::SetXrtGaCircularScale (const char * val)
        { DDSetProp(XmNxrtGaCircularScale, ((XtArgVal)(val)));}

inline char *  UxXrtGaSwitch::GetXrtGaContinuous (void) const
        { return (char * ) DDGetProp(XmNxrtGaContinuous);}
inline void UxXrtGaSwitch::SetXrtGaContinuous (const char * val)
        { DDSetProp(XmNxrtGaContinuous, ((XtArgVal)(val)));}

inline char *  UxXrtGaSwitch::GetXrtGaDebug (void) const
        { return (char * ) DDGetProp(XmNxrtGaDebug);}
inline void UxXrtGaSwitch::SetXrtGaDebug (const char * val)
        { DDSetProp(XmNxrtGaDebug, ((XtArgVal)(val)));}

// inline voidFunction  UxXrtGaSwitch::GetXrtGaDrawFunc (void) const
//         { return (voidFunction) DDGetProp(XmNxrtGaDrawFunc);}
// inline void UxXrtGaSwitch::SetXrtGaDrawFunc (voidFunction val)
//         { DDSetProp(XmNxrtGaDrawFunc, ((XtArgVal)(val)));}

inline char *  UxXrtGaSwitch::GetXrtGaImage (void) const
        { return (char * ) DDGetProp(XmNxrtGaImage);}
inline void UxXrtGaSwitch::SetXrtGaImage (const char * val)
        { DDSetProp(XmNxrtGaImage, ((XtArgVal)(val)));}

inline char *  UxXrtGaSwitch::GetXrtGaImageRotate (void) const
        { return (char * ) DDGetProp(XmNxrtGaImageRotate);}
inline void UxXrtGaSwitch::SetXrtGaImageRotate (const char * val)
        { DDSetProp(XmNxrtGaImageRotate, ((XtArgVal)(val)));}

inline double UxXrtGaSwitch::GetXrtGaIncrementValue (void) const
	{ return RT_GA_GET_DOUBLE(XmNxrtGaIncrementValue);}
inline void UxXrtGaSwitch::SetXrtGaIncrementValue (double val)
	{ RT_GA_PUT_DOUBLE(XmNxrtGaIncrementValue,val);}

inline char *  UxXrtGaSwitch::GetXrtGaInteractionType (void) const
        { return (char * ) DDGetProp(XmNxrtGaInteractionType);}
inline void UxXrtGaSwitch::SetXrtGaInteractionType (const char * val)
        { DDSetProp(XmNxrtGaInteractionType, ((XtArgVal)(val)));}

inline char *  UxXrtGaSwitch::GetXrtGaIsShowing (void) const
        { return (char * ) DDGetProp(XmNxrtGaIsShowing);}
inline void UxXrtGaSwitch::SetXrtGaIsShowing (const char * val)
        { DDSetProp(XmNxrtGaIsShowing, ((XtArgVal)(val)));}

inline char *  UxXrtGaSwitch::GetXrtGaMultipleTurnEnabled (void) const
        { return (char * ) DDGetProp(XmNxrtGaMultipleTurnEnabled);}
inline void UxXrtGaSwitch::SetXrtGaMultipleTurnEnabled (const char * val)
        { DDSetProp(XmNxrtGaMultipleTurnEnabled, ((XtArgVal)(val)));}

inline double UxXrtGaSwitch::GetXrtGaMultipleTurnValue (void) const
	{ return RT_GA_GET_DOUBLE(XmNxrtGaMultipleTurnValue);}
inline void UxXrtGaSwitch::SetXrtGaMultipleTurnValue (double val)
	{ RT_GA_PUT_DOUBLE(XmNxrtGaMultipleTurnValue,val);}

inline double UxXrtGaSwitch::GetXrtGaRadius (void) const
	{ return RT_GA_GET_DOUBLE(XmNxrtGaRadius);}
inline void UxXrtGaSwitch::SetXrtGaRadius (double val)
	{ RT_GA_PUT_DOUBLE(XmNxrtGaRadius,val);}

inline double UxXrtGaSwitch::GetXrtGaValue (void) const
	{ return RT_GA_GET_DOUBLE(XmNxrtGaValue);}
inline void UxXrtGaSwitch::SetXrtGaValue (double val)
	{ RT_GA_PUT_DOUBLE(XmNxrtGaValue,val);}

inline char *  UxXrtGaSwitch::GetXrtGaSwitchType (void) const
        { return (char * ) DDGetProp(XmNxrtGaSwitchType);}
inline void UxXrtGaSwitch::SetXrtGaSwitchType (const char * val)
        { DDSetProp(XmNxrtGaSwitchType, ((XtArgVal)(val)));}


#undef RT_GA_GET_DOUBLE
#undef RT_GA_PUT_DOUBLE

#if defined(__alpha) && defined(__cplusplus)
#pragma message restore
#endif /* __alpha */

#endif /* DESIGN_TIME */
#endif /* __cplusplus */
