/* ALL RIGHTS RESERVED
 *
 * This file is provided for demonstration and educational uses only.
 * Permission to use, copy, modify and distribute this file for
 * any purpose and without fee is hereby granted, provided that the
 * above copyright notice and this permission notice appear in all
 * copies, and that the name of KL Group not be used in advertising
 * or publicity pertaining to this material without the specific,
 * prior written permission of an authorized representative of
 * KL Group.
 *
 * KL GROUP MAKES NO REPRESENTATIONS AND EXTENDS NO WARRANTIES, EX-
 * PRESS OR IMPLIED, WITH RESPECT TO THE SOFTWARE, INCLUDING, BUT
 * NOT LIMITED TO, THE IMPLIED WARRANTIES OF MERCHANTABILITY AND
 * FITNESS FOR ANY PARTICULAR PURPOSE, AND THE WARRANTY AGAINST IN-
 * FRINGEMENT OF PATENTS OR OTHER INTELLECTUAL PROPERTY RIGHTS.  THE
 * SOFTWARE IS PROVIDED "AS IS", AND IN NO EVENT SHALL KL GROUP OR
 * ANY OF ITS AFFILIATES BE LIABLE FOR ANY DAMAGES, INCLUDING ANY
 * LOST PROFITS OR OTHER INCIDENTAL OR CONSEQUENTIAL DAMAGES
 * RELATING TO THE USE OF THIS SOFTWARE.
 *
 *
 * XRT/field widget UIM/X integration file
 *
 *  SCCSID -- @(#)UxXrtIntField.h	1.8    97/02/10 KL Group Inc.
 */

/******************************************************************************
				UxXrtIntField.h
******************************************************************************/

#ifndef UXXRTINTFIELD_INCLUDED
#define UXXRTINTFIELD_INCLUDED

#include <Xm/XrtField.h>	/* Widget class public header file */
#include "Xrt_restable.h"
#include "UxXrtField.h"
#include "UxXrtIntField.hxx"  /* Include C++ header file (New in UIM/X 3.0)*/

#ifdef DESIGN_TIME
#ifndef NO_UX_MACROS

#define XRTINTFLD_NAME(x)	xrtfldint_res_table[x].name
#define XRTINTFLD_PRPTY(x)	xrtfldint_res_table[x].prpty
#define XRTINTFLD_TABLE(x)	XRTINTFLD_PRPTY(x), XRTINTFLD_NAME(x)

/* Design-Time UxGet and UxPut macros for xrtFldCounterIncrement */
#ifndef UxGetXrtIntFldCounterIncrement
#define UxGetXrtIntFldCounterIncrement(sw) \
	UxGET_long(sw, XRTINTFLD_TABLE(xrtIntFldResNumCounterIncrement))
#endif
#ifndef UxPutXrtIntFldCounterIncrement
#define UxPutXrtIntFldCounterIncrement(sw, val) \
	UxPUT_long(sw, XRTINTFLD_TABLE(xrtIntFldResNumCounterIncrement), val)
#endif

/* Design-Time UxGet and UxPut macros for xrtFldDefaultValue */
#ifndef UxGetXrtIntFldDefaultValue
#define UxGetXrtIntFldDefaultValue(sw) \
	UxGET_long(sw, XRTINTFLD_TABLE(xrtIntFldResNumDefaultValue))
#endif
#ifndef UxPutXrtIntFldDefaultValue
#define UxPutXrtIntFldDefaultValue(sw, val) \
	UxPUT_long(sw, XRTINTFLD_TABLE(xrtIntFldResNumDefaultValue), val)
#endif

/* Design-Time UxGet and UxPut macros for xrtFldDisplayFormatString */
#ifndef UxGetXrtIntFldDisplayFormatString
#define UxGetXrtIntFldDisplayFormatString(sw) \
	UxGET_string(sw, XRTINTFLD_TABLE(xrtIntFldResNumDisplayFormatString))
#endif
#ifndef UxPutXrtIntFldDisplayFormatString
#define UxPutXrtIntFldDisplayFormatString(sw, val) \
	UxPUT_string(sw, XRTINTFLD_TABLE(xrtIntFldResNumDisplayFormatString), val)
#endif

/* Design-Time UxGet and UxPut macros for xrtFldInternalValue */
#ifndef UxGetXrtIntFldInternalValue
#define UxGetXrtIntFldInternalValue(sw) \
	UxGET_long(sw, XRTINTFLD_TABLE(xrtIntFldResNumInternalValue))
#endif
#ifndef UxPutXrtIntFldInternalValue
#define UxPutXrtIntFldInternalValue(sw, val) \
	UxPUT_long(sw, XRTINTFLD_TABLE(xrtIntFldResNumInternalValue), val)
#endif

/* Design-Time UxGet and UxPut macros for xrtFldMax */
#ifndef UxGetXrtIntFldMax
#define UxGetXrtIntFldMax(sw) \
	UxGET_long(sw, XRTINTFLD_TABLE(xrtIntFldResNumMax))
#endif
#ifndef UxPutXrtIntFldMax
#define UxPutXrtIntFldMax(sw, val) \
	UxPUT_long(sw, XRTINTFLD_TABLE(xrtIntFldResNumMax), val)
#endif

/* Design-Time UxGet and UxPut macros for xrtFldMin */
#ifndef UxGetXrtIntFldMin
#define UxGetXrtIntFldMin(sw) \
	UxGET_long(sw, XRTINTFLD_TABLE(xrtIntFldResNumMin))
#endif
#ifndef UxPutXrtIntFldMin
#define UxPutXrtIntFldMin(sw, val) \
	UxPUT_long(sw, XRTINTFLD_TABLE(xrtIntFldResNumMin), val)
#endif

/* Design-Time UxGet and UxPut macros for xrtFldNegativeFormat */
#ifndef UxGetXrtIntFldNegativeFormat
#define UxGetXrtIntFldNegativeFormat(sw) \
	UxGET_string(sw, XRTINTFLD_TABLE(xrtIntFldResNumNegativeFormat))
#endif
#ifndef UxPutXrtIntFldNegativeFormat
#define UxPutXrtIntFldNegativeFormat(sw, val) \
	UxPUT_string(sw, XRTINTFLD_TABLE(xrtIntFldResNumNegativeFormat), val)
#endif

/* Design-Time UxGet and UxPut macros for xrtFldPickList */
#ifndef UxGetXrtIntFldPickList
#define UxGetXrtIntFldPickList(sw) \
	UxGET_string(sw, XRTINTFLD_TABLE(xrtIntFldResNumPickList))
#endif
#ifndef UxPutXrtIntFldPickList
#define UxPutXrtIntFldPickList(sw, val) \
	UxPUT_string(sw, XRTINTFLD_TABLE(xrtIntFldResNumPickList), val)
#endif

#endif /* NO_UX_MACROS */

extern Class_t	UxC_XrtIntField;
/* Design-time create macro */
#ifndef UxCreateXrtIntField
#define UxCreateXrtIntField(name, parent) \
	UxCreateSwidget(UxC_XrtIntField, name, parent)
#endif

#else /* Not DESIGN_TIME */

#ifndef UxGetXrtIntFldCounterIncrement
#define UxGetXrtIntFldCounterIncrement(sw) \
	(long)UxGetProp(sw, XmNxrtFldCounterIncrement)
#endif
#ifndef UxPutXrtIntFldCounterIncrement
#define UxPutXrtIntFldCounterIncrement(sw, val) \
	UxPutProp(sw, XmNxrtFldCounterIncrement, (XtArgVal)(val))
#endif

#ifndef UxGetXrtIntFldDefaultValue
#define UxGetXrtIntFldDefaultValue(sw) \
	(long)UxGetProp(sw, XmNxrtFldDefaultValue)
#endif
#ifndef UxPutXrtIntFldDefaultValue
#define UxPutXrtIntFldDefaultValue(sw, val) \
	UxPutProp(sw, XmNxrtFldDefaultValue, (XtArgVal)(val))
#endif

#ifndef UxGetXrtIntFldDisplayFormatString
#define UxGetXrtIntFldDisplayFormatString(sw) \
	(char *) UxGetProp(sw, XmNxrtFldDisplayFormatString)
#endif
#ifndef UxPutXrtIntFldDisplayFormatString
#define UxPutXrtIntFldDisplayFormatString(sw, val) \
	UxPutProp(sw, XmNxrtFldDisplayFormatString, (XtArgVal)(val))
#endif

#ifndef UxGetXrtIntFldInternalValue
#define UxGetXrtIntFldInternalValue(sw) \
	(long)UxGetProp(sw, XmNxrtFldInternalValue)
#endif
#ifndef UxPutXrtIntFldInternalValue
#define UxPutXrtIntFldInternalValue(sw, val) \
	UxPutProp(sw, XmNxrtFldInternalValue, (XtArgVal)(val))
#endif

#ifndef UxGetXrtIntFldMax
#define UxGetXrtIntFldMax(sw) \
	(long)UxGetProp(sw, XmNxrtFldMax)
#endif
#ifndef UxPutXrtIntFldMax
#define UxPutXrtIntFldMax(sw, val) \
	UxPutProp(sw, XmNxrtFldMax, (XtArgVal)(val))
#endif

#ifndef UxGetXrtIntFldMin
#define UxGetXrtIntFldMin(sw) \
	(long)UxGetProp(sw, XmNxrtFldMin)
#endif
#ifndef UxPutXrtIntFldMin
#define UxPutXrtIntFldMin(sw, val) \
	UxPutProp(sw, XmNxrtFldMin, (XtArgVal)(val))
#endif

#ifndef UxGetXrtIntFldNegativeFormat
#define UxGetXrtIntFldNegativeFormat(sw) \
	(char *) UxDDGetProp(sw, XmNxrtFldNegativeFormat)
#endif
#ifndef UxPutXrtIntFldNegativeFormat
#define UxPutXrtIntFldNegativeFormat(sw, val) \
	UxDDPutProp(sw, XmNxrtFldNegativeFormat, (XtArgVal)(val))
#endif

#ifndef UxGetXrtIntFldPickList
#define UxGetXrtIntFldPickList(sw) \
	(char *) UxDDGetProp(sw, XmNxrtFldPickList)
#endif
#ifndef UxPutXrtIntFldPickList
#define UxPutXrtIntFldPickList(sw, val) \
	UxDDPutProp(sw, XmNxrtFldPickList, (XtArgVal)(val))
#endif

/* Runtime create macro */
#ifndef UxCreateXrtIntField
#define UxCreateXrtIntField(name, parent) \
	UxCreateSwidget(name, xmXrtIntFieldWidgetClass, parent)
#endif

#endif /* DESIGN_TIME */

#endif /* UXXRTINTFIELD_INCLUDED */

/***END*OF*FILE***************************************************************/







