/* ALL RIGHTS RESERVED
 *
 * This file is provided for demonstration and educational uses only.
 * Permission to use, copy, modify and distribute this file for
 * any purpose and without fee is hereby granted, provided that the
 * above copyright notice and this permission notice appear in all
 * copies, and that the name of KL Group not be used in advertising
 * or publicity pertaining to this material without the specific,
 * prior written permission of an authorized representative of
 * KL Group.
 *
 * KL GROUP MAKES NO REPRESENTATIONS AND EXTENDS NO WARRANTIES, EX-
 * PRESS OR IMPLIED, WITH RESPECT TO THE SOFTWARE, INCLUDING, BUT
 * NOT LIMITED TO, THE IMPLIED WARRANTIES OF MERCHANTABILITY AND
 * FITNESS FOR ANY PARTICULAR PURPOSE, AND THE WARRANTY AGAINST IN-
 * FRINGEMENT OF PATENTS OR OTHER INTELLECTUAL PROPERTY RIGHTS.  THE
 * SOFTWARE IS PROVIDED "AS IS", AND IN NO EVENT SHALL KL GROUP OR
 * ANY OF ITS AFFILIATES BE LIABLE FOR ANY DAMAGES, INCLUDING ANY
 * LOST PROFITS OR OTHER INCIDENTAL OR CONSEQUENTIAL DAMAGES
 * RELATING TO THE USE OF THIS SOFTWARE.
 *
 *
 * XRT/gear widget UIM/X integration file
 *
 * $AstecId: UxXrtOutliner.hxx,v 1.6 2000/06/19 08:32:32 kosaka Exp $
 *
 *  SCCSID -- @(#)UxXrtOutliner.hxx	1.7    98/11/05 KL Group Inc.
 */

#if defined(__cplusplus) && !defined(XT_CODE) && !defined(NO_UXBINDINGS)  && !defined(UIMX2_9)

class UxXrtOutliner : public UxManager
{
    public:

	// Constructors
	UXINLINE UxXrtOutliner(void);
	UXINLINE UxXrtOutliner(const char*, swidget);

	// Initialisation
	UXINLINE swidget CreateSwidget (const char*, swidget);

	// Resource accessor functions
	UXINLINE char * GetFontList_Outliner () const;
	UXINLINE void SetFontList_Outliner (const char *);

	UXINLINE short GetHighlightThickness_Outliner () const;
	UXINLINE void SetHighlightThickness_Outliner (short);

	UXINLINE char * GetScrollBarPlacement_Outliner () const;
	UXINLINE void SetScrollBarPlacement_Outliner (const char *);

	UXINLINE char * GetXrtGearAutoSort_Outliner () const;
	UXINLINE void SetXrtGearAutoSort_Outliner (const char *);

	UXINLINE char * GetXrtGearBorderLocation_Outliner () const;
	UXINLINE void SetXrtGearBorderLocation_Outliner (const char *);

	UXINLINE char * GetXrtGearBorderType_Outliner () const;
	UXINLINE void SetXrtGearBorderType_Outliner (const char *);

	UXINLINE char * GetXrtGearColumnLabelsShow_Outliner () const;
	UXINLINE void SetXrtGearColumnLabelsShow_Outliner (const char *);

	UXINLINE char * GetXrtGearColumnMoveAllow_Outliner () const;
	UXINLINE void SetXrtGearColumnMoveAllow_Outliner (const char *);

	UXINLINE char * GetXrtGearColumnSelected_Outliner () const;
	UXINLINE void SetXrtGearColumnSelected_Outliner (const char *);

	UXINLINE char * GetXrtGearCursor_Outliner () const;
	UXINLINE void SetXrtGearCursor_Outliner (const char *);

	UXINLINE char * GetXrtGearCursorResizeWidth_Outliner () const;
	UXINLINE void SetXrtGearCursorResizeWidth_Outliner (const char *);

	UXINLINE char * GetXrtGearCursorTracking_Outliner () const;
	UXINLINE void SetXrtGearCursorTracking_Outliner (const char *);

	UXINLINE char * GetXrtGearDoubleBuffer_Outliner () const;
	UXINLINE void SetXrtGearDoubleBuffer_Outliner (const char *);

	UXINLINE char * GetXrtGearFolderStateMask_Outliner () const;
	UXINLINE void SetXrtGearFolderStateMask_Outliner (const char *);

	UXINLINE int GetXrtGearHeightPreferredCount_Outliner () const;
	UXINLINE void SetXrtGearHeightPreferredCount_Outliner(int);

	UXINLINE char * GetXrtGearHeightSizingPolicy_Outliner () const;
	UXINLINE void SetXrtGearHeightSizingPolicy_Outliner (const char *);

	UXINLINE char * GetXrtGearHeightResizePolicy_Outliner () const;
	UXINLINE void SetXrtGearHeightResizePolicy_Outliner (const char *);

	UXINLINE short GetXrtGearMarginHeight_Outliner () const;
	UXINLINE void SetXrtGearMarginHeight_Outliner (short);

	UXINLINE short GetXrtGearMarginWidth_Outliner () const;
	UXINLINE void SetXrtGearMarginWidth_Outliner (short);

//	UXINLINE (voidFunction) GetXrtGearNodeCompareProc_Outliner () const;
//	UXINLINE void SetXrtGearNodeCompareProc_Outliner (voidFunction val) /*???*/

	UXINLINE char * GetXrtGearNodeCurrent_Outliner () const;
	UXINLINE void SetXrtGearNodeCurrent_Outliner (const char *);

	UXINLINE short GetXrtGearNodeHeight_Outliner () const;
	UXINLINE void SetXrtGearNodeHeight_Outliner (short);

	UXINLINE int GetXrtGearNodeIndent_Outliner () const;
	UXINLINE void SetXrtGearNodeIndent_Outliner (int);

	UXINLINE char * GetXrtGearNodeIndentPolicy_Outliner () const;
	UXINLINE void SetXrtGearNodeIndentPolicy_Outliner (const char *);

	UXINLINE char * GetXrtGearNodeImportPolicy_Outliner () const;
	UXINLINE void SetXrtGearNodeImportPolicy_Outliner (const char *);

	UXINLINE char * GetXrtGearNodeMovePolicy_Outliner () const;
	UXINLINE void SetXrtGearNodeMovePolicy_Outliner (const char *);

	UXINLINE short GetXrtGearNodeSpacing_Outliner () const;
	UXINLINE void SetXrtGearNodeSpacing_Outliner (short);

	UXINLINE char * GetXrtGearNodeStyleDefault_Outliner () const;
	UXINLINE void SetXrtGearNodeStyleDefault_Outliner (const char *);

	UXINLINE char * GetXrtGearNodeTop_Outliner () const;
	UXINLINE void SetXrtGearNodeTop_Outliner (const char *);

	UXINLINE char * GetXrtGearPSFontMapList_Outliner () const;
	UXINLINE void SetXrtGearPSFontMapList_Outliner (const char *);

	UXINLINE char * GetXrtGearRepaint_Outliner () const;
	UXINLINE void SetXrtGearRepaint_Outliner (const char *);

	UXINLINE char * GetXrtGearScrollBarHoriz_Outliner () const;
	UXINLINE void SetXrtGearScrollBarHoriz_Outliner (const char *);

	UXINLINE char * GetXrtGearScrollBarHorizDisplayPolicy_Outliner () const;
	UXINLINE void SetXrtGearScrollBarHorizDisplayPolicy_Outliner (const char *);

	UXINLINE char * GetXrtGearScrollBarVert_Outliner () const;
	UXINLINE void SetXrtGearScrollBarVert_Outliner (const char *);

	UXINLINE char * GetXrtGearScrollBarVertDisplayPolicy_Outliner () const;
	UXINLINE void SetXrtGearScrollBarVertDisplayPolicy_Outliner (const char *);

	UXINLINE char * GetXrtGearSelectionPolicy_Outliner () const;
	UXINLINE void SetXrtGearSelectionPolicy_Outliner (const char *);

	UXINLINE char * GetXrtGearSelectionRestrictions_Outliner () const;
	UXINLINE void SetXrtGearSelectionRestrictions_Outliner (const char *);

	UXINLINE short GetXrtGearShadowThickness_Outliner () const;
	UXINLINE void SetXrtGearShadowThickness_Outliner (short);

	UXINLINE char * GetXrtGearTextHorizClipPolicy_Outliner () const;
	UXINLINE void SetXrtGearTextHorizClipPolicy_Outliner (const char *);

	UXINLINE char * GetXrtGearTreeData_Outliner () const;
	UXINLINE void SetXrtGearTreeData_Outliner (const char *);

	UXINLINE char GetXrtGearWidthChar_Outliner () const;
	UXINLINE void SetXrtGearWidthChar_Outliner (const char);

	UXINLINE int GetXrtGearWidthPreferredCount_Outliner () const;
	UXINLINE void SetXrtGearWidthPreferredCount_Outliner (int);

	UXINLINE char * GetXrtGearWidthResizePolicy_Outliner () const;
	UXINLINE void SetXrtGearWidthResizePolicy_Outliner (const char *);

	UXINLINE char * GetXrtGearWidthSizingPolicy_Outliner () const;
	UXINLINE void SetXrtGearWidthSizingPolicy_Outliner (const char *);

	UXINLINE char * GetEditable_Outliner () const;
	UXINLINE void SetEditable_Outliner(const char *);

	UXINLINE char * GetXrtGearEditor_Outliner () const;
	UXINLINE void SetXrtGearEditor_Outliner(const char *);

	// UXINLINE char * GetXrtGearEditNode_Outliner () const;
	// UXINLINE void SetXrtGearEditNode_Outliner(const char *);

	// UXINLINE int GetXrtGearEditColumn_Outliner () const;
	// UXINLINE void SetXrtGearEditColumn_Outliner(int);

	UXINLINE char * GetXrtGearEditType_Outliner () const;
	UXINLINE void SetXrtGearEditType_Outliner(const char *);

	UXINLINE char * GetXrtGearHighlightOnDrag_Outliner () const;
	UXINLINE void SetXrtGearHighlightOnDrag_Outliner(const char *);

	UXINLINE char * GetXrtGearNodeCheckForDuplicates_Outliner () const;
	UXINLINE void SetXrtGearNodeCheckForDuplicates_Outliner(const char *);

	// UXINLINE char * GetXrtGearTextEditor_Outliner () const;
	// UXINLINE void SetXrtGearTextEditor_Outliner(const char *);
};

/* NODE STYLE*/

class UxXrtNodeStyle : public UxGadget
{
    public:

	// Constructors
	UXINLINE UxXrtNodeStyle(void);
	UXINLINE UxXrtNodeStyle(const char*, swidget);

	// Initialisation
	UXINLINE swidget CreateSwidget (const char*, swidget);

	// Resource accessor functions
	UXINLINE char * GetFontList_NodeStyle () const;
	UXINLINE void SetFontList_NodeStyle (const char *);

	UXINLINE char * GetForeground_NodeStyle () const;
	UXINLINE void SetForeground_NodeStyle (const char *);

	UXINLINE char * GetXrtGearBackgroundSelected_NodeStyle () const;
	UXINLINE void SetXrtGearBackgroundSelected_NodeStyle (const char *);

	UXINLINE char * GetXrtGearFolderShortcutShow_NodeStyle () const;
	UXINLINE void SetXrtGearFolderShortcutShow_NodeStyle (const char *);

	UXINLINE char * GetXrtGearFontListSelected_NodeStyle () const;
	UXINLINE void SetXrtGearFontListSelected_NodeStyle (const char *);

	UXINLINE char * GetXrtGearForegroundSelected_NodeStyle () const;
	UXINLINE void SetXrtGearForegroundSelected_NodeStyle (const char *);

	UXINLINE char * GetXrtGearIconClosed_NodeStyle () const;
	UXINLINE void SetXrtGearIconClosed_NodeStyle (const char *);

	UXINLINE char * GetXrtGearIconClosedSelected_NodeStyle () const;
	UXINLINE void SetXrtGearIconClosedSelected_NodeStyle (const char *);

	UXINLINE char * GetXrtGearIconItem_NodeStyle () const;
	UXINLINE void SetXrtGearIconItem_NodeStyle (const char *);

	UXINLINE char * GetXrtGearIconItemSelected_NodeStyle () const;
	UXINLINE void SetXrtGearIconItemSelected_NodeStyle (const char *);

	UXINLINE char * GetXrtGearIconOpen_NodeStyle () const;
	UXINLINE void SetXrtGearIconOpen_NodeStyle (const char *);

	UXINLINE char * GetXrtGearIconOpenSelected_NodeStyle () const;
	UXINLINE void SetXrtGearIconOpenSelected_NodeStyle (const char *);

	UXINLINE short GetXrtGearLayoutSpacing_NodeStyle () const;
	UXINLINE void SetXrtGearLayoutSpacing_NodeStyle (short);

	UXINLINE char * GetXrtGearLineColor_NodeStyle () const;
	UXINLINE void SetXrtGearLineColor_NodeStyle (const char *);

	UXINLINE char * GetXrtGearLineStyle_NodeStyle () const;
	UXINLINE void SetXrtGearLineStyle_NodeStyle (const char *);

	UXINLINE short GetXrtGearLineWidth_NodeStyle () const;
	UXINLINE void SetXrtGearLineWidth_NodeStyle (short);

	UXINLINE char * GetXrtGearShortcutShow_NodeStyle () const;
	UXINLINE void SetXrtGearShortcutShow_NodeStyle (const char *);

	UXINLINE short GetXrtGearShortcutSize_NodeStyle () const;
	UXINLINE void SetXrtGearShortcutSize_NodeStyle (short);

	UXINLINE char * GetXrtGearShortcutColor_NodeStyle () const;
	UXINLINE void SetXrtGearShortcutColor_NodeStyle(const char *);
};

/*COLUMN*/

class UxXrtColumn : public UxGadget
{
    public:

	// Constructors
	UXINLINE UxXrtColumn(void);
	UXINLINE UxXrtColumn(const char*, swidget);

	// Initialisation
	UXINLINE swidget CreateSwidget (const char*, swidget);

	// Resource accessor functions
	UXINLINE char * GetFontList_Column () const;
	UXINLINE void SetFontList_Column (const char *);

	UXINLINE char * GetForeground_Column () const;
	UXINLINE void SetForeground_Column (const char *);

	UXINLINE short GetHeight_Column () const;
	UXINLINE void SetHeight_Column (short);

	UXINLINE short GetWidth_Column () const;
	UXINLINE void SetWidth_Column (short);

	UXINLINE char * GetXrtGearFontListSelected_Column () const;
	UXINLINE void SetXrtGearFontListSelected_Column (const char *);

	UXINLINE char * GetXrtGearLabel_Column () const;
	UXINLINE void SetXrtGearLabel_Column (const char *);

	UXINLINE char * GetXrtGearLabelAlignment_Column () const;
	UXINLINE void SetXrtGearLabelAlignment_Column (const char *);

	UXINLINE short GetXrtGearMarginLeft_Column () const;
	UXINLINE void SetXrtGearMarginLeft_Column (short);

	UXINLINE short GetXrtGearMarginRight_Column () const;
	UXINLINE void SetXrtGearMarginRight_Column (short);

	UXINLINE char * GetXrtGearNodeAlignment_Column () const;
	UXINLINE void SetXrtGearNodeAlignment_Column (const char *);

	UXINLINE char * GetXrtGearSelected_Column () const;
	UXINLINE void SetXrtGearSelected_Column (const char *);

	UXINLINE char * GetXrtGearWidthResizePolicy_Column () const;
	UXINLINE void SetXrtGearWidthResizePolicy_Column (const char *);

	UXINLINE char * GetXrtGearWidthSizingPolicy_Column () const;
	UXINLINE void SetXrtGearWidthSizingPolicy_Column (const char *);

	UXINLINE short GetXrtGearWidthMaximum_Column () const;
	UXINLINE void SetXrtGearWidthMaximum_Column (short);

	UXINLINE short GetXrtGearWidthMinimum_Column () const;
	UXINLINE void SetXrtGearWidthMinimum_Column (short);

	UXINLINE int GetXrtGearWidthPreferredCount_Column () const;
	UXINLINE void SetXrtGearWidthPreferredCount_Column (int);

	UXINLINE char * GetBackground_Column () const;
	UXINLINE void SetBackground_Column(const char *);

	UXINLINE char * GetEditable_Column () const;
	UXINLINE void SetEditable_Column(const char *);
};


#ifdef DESIGN_TIME

#define XRTGEAR_OUTLINER_TABLE(x)	xrtOutliner_res_table[x].prpty, xrtOutliner_res_table[x].name
#define XRTGEAR_NODESTYLE_TABLE(x)	xrtNodeStyle_res_table[x].prpty, xrtNodeStyle_res_table[x].name
#define XRTGEAR_COLUMN_TABLE(x)		xrtColumn_res_table[x].prpty, xrtColumn_res_table[x].name

extern Class_t UxC_XrtOutliner;

extern Class_t UxC_XrtNodeStyle;

extern Class_t UxC_XrtColumn;

#else /* (not DESIGN_TIME) */

#if defined(__alpha) && defined(__cplusplus)
#pragma message save
#pragma message disable narrowptr
#endif /* __alpha */

// Constructors
inline UxXrtOutliner::UxXrtOutliner(void){}
inline UxXrtOutliner::UxXrtOutliner(const char* name, swidget uXParent)
{
	CreateSwidget(name,uXParent);
}

// Initialisation
inline swidget UxXrtOutliner::CreateSwidget (const char* name, swidget parent)
{
	if (UxThis == NULL)
		UxThis = UxCreateSwidget( (char *) name,
					  xmXrtOutlinerWidgetClass, parent);
	return UxThis;
}

inline char * UxXrtOutliner::GetFontList_Outliner (void) const
	{ return (char * ) DDGetProp(XmNfontList);}
inline void UxXrtOutliner::SetFontList_Outliner (const char * val)
	{ DDSetProp(XmNfontList, ((XtArgVal)(val)));}

inline short UxXrtOutliner::GetHighlightThickness_Outliner (void) const
	{ return (short ) ShortGetProp(XmNhighlightThickness);}
inline void UxXrtOutliner::SetHighlightThickness_Outliner (short val)
	{ SetProp(XmNhighlightThickness, ((XtArgVal)(val)));}

inline char * UxXrtOutliner::GetScrollBarPlacement_Outliner (void) const
	{ return (char * ) GetProp(XmNscrollBarPlacement);}
inline void UxXrtOutliner::SetScrollBarPlacement_Outliner (const char * val)
	{ DDSetProp(XmNscrollBarPlacement, ((XtArgVal)(val)));}

inline char * UxXrtOutliner::GetXrtGearAutoSort_Outliner (void) const
	{ return (char * ) DDGetProp(XmNxrtGearAutoSort);}
inline void UxXrtOutliner::SetXrtGearAutoSort_Outliner (const char * val)
	{ DDSetProp(XmNxrtGearAutoSort, ((XtArgVal)(val)));}

inline char * UxXrtOutliner::GetXrtGearBorderLocation_Outliner (void) const
	{ return (char * ) DDGetProp(XmNxrtGearBorderLocation);}
inline void UxXrtOutliner::SetXrtGearBorderLocation_Outliner (const char * val)
	{ DDSetProp(XmNxrtGearBorderLocation, ((XtArgVal)(val)));}

inline char * UxXrtOutliner::GetXrtGearBorderType_Outliner (void) const
	{ return (char * ) DDGetProp(XmNxrtGearBorderType);}
inline void UxXrtOutliner::SetXrtGearBorderType_Outliner (const char * val)
	{ DDSetProp(XmNxrtGearBorderType, ((XtArgVal)(val)));}

inline char * UxXrtOutliner::GetXrtGearColumnLabelsShow_Outliner (void) const
	{ return (char * ) DDGetProp(XmNxrtGearColumnLabelsShow);}
inline void UxXrtOutliner::SetXrtGearColumnLabelsShow_Outliner (const char * val)
	{ DDSetProp(XmNxrtGearColumnLabelsShow, ((XtArgVal)(val)));}

inline char * UxXrtOutliner::GetXrtGearColumnSelected_Outliner (void) const
	{ return (char * ) DDGetProp(XmNxrtGearColumnSelected);}
inline void UxXrtOutliner::SetXrtGearColumnSelected_Outliner (const char * val)
	{ DDSetProp(XmNxrtGearColumnSelected, ((XtArgVal)(val)));}

inline char * UxXrtOutliner::GetXrtGearDoubleBuffer_Outliner (void) const
	{ return (char * ) DDGetProp(XmNxrtGearDoubleBuffer);}
inline void UxXrtOutliner::SetXrtGearDoubleBuffer_Outliner (const char * val)
	{ DDSetProp(XmNxrtGearDoubleBuffer, ((XtArgVal)(val)));}

inline char * UxXrtOutliner::GetXrtGearFolderStateMask_Outliner (void) const
	{ return (char * ) DDGetProp(XmNxrtGearFolderStateMask);}
inline void UxXrtOutliner::SetXrtGearFolderStateMask_Outliner (const char * val)
	{ DDSetProp(XmNxrtGearFolderStateMask, ((XtArgVal)(val)));}

inline int UxXrtOutliner::GetXrtGearHeightPreferredCount_Outliner (void) const
	{ return (int)IntGetProp(XmNxrtGearHeightPreferredCount);}
inline void UxXrtOutliner::SetXrtGearHeightPreferredCount_Outliner(int val)
	{ SetProp(XmNxrtGearHeightPreferredCount, ((XtArgVal)(val)));}

inline char * UxXrtOutliner::GetXrtGearHeightSizingPolicy_Outliner (void) const
	{ return (char * ) DDGetProp(XmNxrtGearHeightSizingPolicy);}
inline void UxXrtOutliner::SetXrtGearHeightSizingPolicy_Outliner (const char * val)
	{ DDSetProp(XmNxrtGearHeightSizingPolicy, ((XtArgVal)(val)));}

inline char * UxXrtOutliner::GetXrtGearHeightResizePolicy_Outliner (void) const
	{ return (char * ) DDGetProp(XmNxrtGearHeightResizePolicy);}
inline void UxXrtOutliner::SetXrtGearHeightResizePolicy_Outliner (const char * val)
	{ DDSetProp(XmNxrtGearHeightResizePolicy, ((XtArgVal)(val)));}

inline short UxXrtOutliner::GetXrtGearMarginHeight_Outliner (void) const
	{ return (short ) ShortGetProp(XmNxrtGearMarginHeight);}
inline void UxXrtOutliner::SetXrtGearMarginHeight_Outliner (short val)
	{ SetProp(XmNxrtGearMarginHeight, ((XtArgVal)(val)));}

inline short UxXrtOutliner::GetXrtGearMarginWidth_Outliner (void) const
	{ return (short ) ShortGetProp(XmNxrtGearMarginWidth);}
inline void UxXrtOutliner::SetXrtGearMarginWidth_Outliner (short val)
	{ SetProp(XmNxrtGearMarginWidth, ((XtArgVal)(val)));}

// inline voidFunction UxXrtOutliner::GetXrtGearNodeCompareProc_Outliner (void) const
// 	{ return (voidFunction) GetProp(XmNxrtGearNodeCompareProc);}
// inline void UxXrtOutliner::SetXrtGearNodeCompareProc_Outliner (voidFunction val) /*???*/
// 	{ SetProp(XmNxrtGearNodeCompareProc, ((XtArgVal)(val)));}

inline char * UxXrtOutliner::GetXrtGearNodeCurrent_Outliner (void) const
	{ return (char * ) DDGetProp(XmNxrtGearNodeCurrent);}
inline void UxXrtOutliner::SetXrtGearNodeCurrent_Outliner (const char * val)
	{ DDSetProp(XmNxrtGearNodeCurrent, ((XtArgVal)(val)));}

inline short UxXrtOutliner::GetXrtGearNodeHeight_Outliner (void) const
	{ return (short ) ShortGetProp(XmNxrtGearNodeHeight);}
inline void UxXrtOutliner::SetXrtGearNodeHeight_Outliner (short val)
	{ SetProp(XmNxrtGearNodeHeight, ((XtArgVal)(val)));}

inline int UxXrtOutliner::GetXrtGearNodeIndent_Outliner (void) const
	{ return (int)IntGetProp(XmNxrtGearNodeIndent);}
inline void UxXrtOutliner::SetXrtGearNodeIndent_Outliner (int val)
	{ SetProp(XmNxrtGearNodeIndent, ((XtArgVal)(val)));}

inline char * UxXrtOutliner::GetXrtGearNodeIndentPolicy_Outliner (void) const
	{ return (char * ) DDGetProp(XmNxrtGearNodeIndentPolicy);}
inline void UxXrtOutliner::SetXrtGearNodeIndentPolicy_Outliner (const char * val)
	{ DDSetProp(XmNxrtGearNodeIndentPolicy, ((XtArgVal)(val)));}

inline char * UxXrtOutliner::GetXrtGearNodeImportPolicy_Outliner (void) const
	{ return (char * ) DDGetProp(XmNxrtGearNodeImportPolicy);}
inline void UxXrtOutliner::SetXrtGearNodeImportPolicy_Outliner (const char * val)
	{ DDSetProp(XmNxrtGearNodeImportPolicy, ((XtArgVal)(val)));}

inline char * UxXrtOutliner::GetXrtGearNodeMovePolicy_Outliner (void) const
	{ return (char * ) DDGetProp(XmNxrtGearNodeMovePolicy);}
inline void UxXrtOutliner::SetXrtGearNodeMovePolicy_Outliner (const char * val)
	{ DDSetProp(XmNxrtGearNodeMovePolicy, ((XtArgVal)(val)));}

inline short UxXrtOutliner::GetXrtGearNodeSpacing_Outliner (void) const
	{ return (short ) ShortGetProp(XmNxrtGearNodeSpacing);}
inline void UxXrtOutliner::SetXrtGearNodeSpacing_Outliner (short val)
	{ SetProp(XmNxrtGearNodeSpacing, ((XtArgVal)(val)));}

inline char * UxXrtOutliner::GetXrtGearNodeStyleDefault_Outliner (void) const
	{ return (char * ) DDGetProp(XmNxrtGearNodeStyleDefault);}
inline void UxXrtOutliner::SetXrtGearNodeStyleDefault_Outliner (const char * val)
	{ DDSetProp(XmNxrtGearNodeStyleDefault, ((XtArgVal)(val)));}

inline char * UxXrtOutliner::GetXrtGearNodeTop_Outliner (void) const
	{ return (char * ) DDGetProp(XmNxrtGearNodeTop);}
inline void UxXrtOutliner::SetXrtGearNodeTop_Outliner (const char * val)
	{ DDSetProp(XmNxrtGearNodeTop, ((XtArgVal)(val)));}

inline char * UxXrtOutliner::GetXrtGearPSFontMapList_Outliner (void) const
	{ return (char * ) DDGetProp(XmNxrtGearPSFontMapList);}
inline void UxXrtOutliner::SetXrtGearPSFontMapList_Outliner (const char * val)
	{ DDSetProp(XmNxrtGearPSFontMapList, ((XtArgVal)(val)));}

inline char * UxXrtOutliner::GetXrtGearRepaint_Outliner (void) const
	{ return (char * ) DDGetProp(XmNxrtGearRepaint);}
inline void UxXrtOutliner::SetXrtGearRepaint_Outliner (const char * val)
	{ DDSetProp(XmNxrtGearRepaint, ((XtArgVal)(val)));}

inline char * UxXrtOutliner::GetXrtGearScrollBarHoriz_Outliner (void) const
	{ return (char * ) DDGetProp(XmNxrtGearScrollBarHoriz);}
inline void UxXrtOutliner::SetXrtGearScrollBarHoriz_Outliner (const char * val)
	{ DDSetProp(XmNxrtGearScrollBarHoriz, ((XtArgVal)(val)));}

inline char * UxXrtOutliner::GetXrtGearScrollBarHorizDisplayPolicy_Outliner (void) const
	{ return (char * ) DDGetProp(XmNxrtGearScrollBarHorizDisplayPolicy);}
inline void UxXrtOutliner::SetXrtGearScrollBarHorizDisplayPolicy_Outliner (const char * val)
	{ DDSetProp(XmNxrtGearScrollBarHorizDisplayPolicy, ((XtArgVal)(val)));}

inline char * UxXrtOutliner::GetXrtGearScrollBarVert_Outliner (void) const
	{ return (char * ) DDGetProp(XmNxrtGearScrollBarVert);}
inline void UxXrtOutliner::SetXrtGearScrollBarVert_Outliner (const char * val)
	{ DDSetProp(XmNxrtGearScrollBarVert, ((XtArgVal)(val)));}

inline char * UxXrtOutliner::GetXrtGearScrollBarVertDisplayPolicy_Outliner (void) const
	{ return (char * ) DDGetProp(XmNxrtGearScrollBarVertDisplayPolicy);}
inline void UxXrtOutliner::SetXrtGearScrollBarVertDisplayPolicy_Outliner (const char * val)
	{ DDSetProp(XmNxrtGearScrollBarVertDisplayPolicy, ((XtArgVal)(val)));}

inline char * UxXrtOutliner::GetXrtGearSelectionPolicy_Outliner (void) const
	{ return (char * ) DDGetProp(XmNxrtGearSelectionPolicy);}
inline void UxXrtOutliner::SetXrtGearSelectionPolicy_Outliner (const char * val)
	{ DDSetProp(XmNxrtGearSelectionPolicy, ((XtArgVal)(val)));}

inline char * UxXrtOutliner::GetXrtGearSelectionRestrictions_Outliner (void) const
	{ return (char * ) DDGetProp(XmNxrtGearSelectionRestrictions);}
inline void UxXrtOutliner::SetXrtGearSelectionRestrictions_Outliner (const char * val)
	{ DDSetProp(XmNxrtGearSelectionRestrictions, ((XtArgVal)(val)));}

inline short UxXrtOutliner::GetXrtGearShadowThickness_Outliner (void) const
	{ return (short ) ShortGetProp(XmNxrtGearShadowThickness);}
inline void UxXrtOutliner::SetXrtGearShadowThickness_Outliner (short val)
	{ SetProp(XmNxrtGearShadowThickness, ((XtArgVal)(val)));}

inline char * UxXrtOutliner::GetXrtGearTextHorizClipPolicy_Outliner (void) const
	{ return (char * ) DDGetProp(XmNxrtGearTextHorizClipPolicy);}
inline void UxXrtOutliner::SetXrtGearTextHorizClipPolicy_Outliner (const char * val)
	{ DDSetProp(XmNxrtGearTextHorizClipPolicy, ((XtArgVal)(val)));}

inline char * UxXrtOutliner::GetXrtGearTreeData_Outliner (void) const
	{ return (char * ) GetProp(XmNxrtGearTreeData);}
inline void UxXrtOutliner::SetXrtGearTreeData_Outliner (const char * val)
	{ SetProp(XmNxrtGearTreeData, ((XtArgVal)(val)));}

inline char UxXrtOutliner::GetXrtGearWidthChar_Outliner (void) const
	{ return (char ) CharGetProp(XmNxrtGearWidthChar);}
inline void UxXrtOutliner::SetXrtGearWidthChar_Outliner (const char val)
	{ SetProp(XmNxrtGearWidthChar, ((XtArgVal)(val)));}

inline int UxXrtOutliner::GetXrtGearWidthPreferredCount_Outliner (void) const
	{ return (int)IntGetProp(XmNxrtGearWidthPreferredCount);}
inline void UxXrtOutliner::SetXrtGearWidthPreferredCount_Outliner (int val)
	{ SetProp(XmNxrtGearWidthPreferredCount, ((XtArgVal)(val)));}

inline char * UxXrtOutliner::GetXrtGearWidthResizePolicy_Outliner (void) const
	{ return (char * ) DDGetProp(XmNxrtGearWidthResizePolicy);}
inline void UxXrtOutliner::SetXrtGearWidthResizePolicy_Outliner (const char * val)
	{ DDSetProp(XmNxrtGearWidthResizePolicy, ((XtArgVal)(val)));}

inline char * UxXrtOutliner::GetXrtGearWidthSizingPolicy_Outliner (void) const
	{ return (char * ) DDGetProp(XmNxrtGearWidthSizingPolicy);}
inline void  UxXrtOutliner::SetXrtGearWidthSizingPolicy_Outliner (const char * val)
	{ DDSetProp(XmNxrtGearWidthSizingPolicy, ((XtArgVal)(val)));}

inline char * UxXrtOutliner::GetEditable_Outliner (void) const
	{ return (char *) DDGetProp(XmNeditable);}
inline void UxXrtOutliner::SetEditable_Outliner(const char * val)
	{ DDSetProp(XmNeditable, ((XtArgVal)(val)));}

inline char * UxXrtOutliner::GetXrtGearEditor_Outliner (void) const
	{ return (char *) DDGetProp(XmNxrtGearEditor);}
inline void UxXrtOutliner::SetXrtGearEditor_Outliner(const char * val)
	{ DDSetProp(XmNxrtGearEditor, ((XtArgVal)(val)));}

// inline char * UxXrtOutliner::GetXrtGearEditNode_Outliner (void) const
// 	{ return (char *) DDGetProp(XmNxrtGearEditNode);}
// inline void UxXrtOutliner::SetXrtGearEditNode_Outliner(const char * val)
// 	{ DDSetProp(XmNxrtGearEditNode, ((XtArgVal)(val)));}

// inline int UxXrtOutliner::GetXrtGearEditColumn_Outliner (void) const
// 	{ return (int)IntGetProp(XmNxrtGearEditColumn);}
// inline void UxXrtOutliner::SetXrtGearEditColumn_Outliner(int val)
// 	{ SetProp(XmNxrtGearEditColumn, ((XtArgVal)(val)));}

inline char * UxXrtOutliner::GetXrtGearEditType_Outliner (void) const
	{ return (char *) DDGetProp(XmNxrtGearEditType);}
inline void UxXrtOutliner::SetXrtGearEditType_Outliner(const char * val)
	{ DDSetProp(XmNxrtGearEditType, ((XtArgVal)(val)));}

inline char * UxXrtOutliner::GetXrtGearHighlightOnDrag_Outliner (void) const
	{ return (char *) DDGetProp(XmNxrtGearHighlightOnDrag);}
inline void UxXrtOutliner::SetXrtGearHighlightOnDrag_Outliner(const char * val)
	{ DDSetProp(XmNxrtGearHighlightOnDrag, ((XtArgVal)(val)));}

inline char * UxXrtOutliner::GetXrtGearNodeCheckForDuplicates_Outliner (void) const
	{ return (char *) DDGetProp(XmNxrtGearNodeCheckForDuplicates);}
inline void UxXrtOutliner::SetXrtGearNodeCheckForDuplicates_Outliner(const char * val)
	{ DDSetProp(XmNxrtGearNodeCheckForDuplicates, ((XtArgVal)(val)));}

// inline char * UxXrtOutliner::GetXrtGearTextEditor_Outliner (void) const
// 	{ return (char *) DDGetProp(XmNxrtGearTextEditor);}
// inline void UxXrtOutliner::SetXrtGearTextEditor_Outliner(const char * val)
// 	{ DDSetProp(XmNxrtGearTextEditor, ((XtArgVal)(val)));}

// Constructors
inline UxXrtNodeStyle::UxXrtNodeStyle(void){}
inline UxXrtNodeStyle::UxXrtNodeStyle(const char* name, swidget uXParent)
{
	CreateSwidget(name,uXParent);
}

// Initialisation
inline swidget UxXrtNodeStyle::CreateSwidget (const char* name, swidget parent)
{
	if (UxThis == NULL)
		UxThis = UxCreateSwidget( (char *) name,
					  xmXrtNodeStyleObjectClass, parent);
	return UxThis;
}

inline char * UxXrtNodeStyle::GetFontList_NodeStyle (void) const
	{ return (char * ) DDGetProp(XmNfontList);}
inline void UxXrtNodeStyle::SetFontList_NodeStyle (const char * val)
	{ DDSetProp(XmNfontList, ((XtArgVal)(val)));}

inline char * UxXrtNodeStyle::GetForeground_NodeStyle (void) const
	{ return (char * ) DDGetProp(XmNforeground);}
inline void UxXrtNodeStyle::SetForeground_NodeStyle (const char * val)
	{ DDSetProp(XmNforeground, ((XtArgVal)(val)));}

inline char * UxXrtNodeStyle::GetXrtGearBackgroundSelected_NodeStyle (void) const
	{ return (char * ) DDGetProp(XmNxrtGearBackgroundSelected);}
inline void UxXrtNodeStyle::SetXrtGearBackgroundSelected_NodeStyle (const char * val)
	{ DDSetProp(XmNxrtGearBackgroundSelected, ((XtArgVal)(val)));}

inline char * UxXrtNodeStyle::GetXrtGearFolderShortcutShow_NodeStyle (void) const
	{ return (char * ) DDGetProp(XmNxrtGearFolderShortcutShow);}
inline void UxXrtNodeStyle::SetXrtGearFolderShortcutShow_NodeStyle (const char * val)
	{ DDSetProp(XmNxrtGearFolderShortcutShow, ((XtArgVal)(val)));}

inline char * UxXrtNodeStyle::GetXrtGearFontListSelected_NodeStyle (void) const
	{ return (char * ) DDGetProp(XmNxrtGearFontListSelected);}
inline void UxXrtNodeStyle::SetXrtGearFontListSelected_NodeStyle (const char * val)
	{ DDSetProp(XmNxrtGearFontListSelected, ((XtArgVal)(val)));}

inline char * UxXrtNodeStyle::GetXrtGearForegroundSelected_NodeStyle (void) const
	{ return (char * ) DDGetProp(XmNxrtGearForegroundSelected);}
inline void UxXrtNodeStyle::SetXrtGearForegroundSelected_NodeStyle (const char * val)
	{ DDSetProp(XmNxrtGearForegroundSelected, ((XtArgVal)(val)));}

inline char * UxXrtNodeStyle::GetXrtGearIconClosed_NodeStyle (void) const
	{ return (char * ) DDGetProp(XmNxrtGearIconClosed);}
inline void UxXrtNodeStyle::SetXrtGearIconClosed_NodeStyle (const char * val)
	{ DDSetProp(XmNxrtGearIconClosed, ((XtArgVal)(val)));}

inline char * UxXrtNodeStyle::GetXrtGearIconClosedSelected_NodeStyle (void) const
	{ return (char * ) DDGetProp(XmNxrtGearIconClosedSelected);}
inline void UxXrtNodeStyle::SetXrtGearIconClosedSelected_NodeStyle (const char * val)
	{ DDSetProp(XmNxrtGearIconClosedSelected, ((XtArgVal)(val)));}

inline char * UxXrtNodeStyle::GetXrtGearIconItem_NodeStyle (void) const
	{ return (char * ) DDGetProp(XmNxrtGearIconItem);}
inline void UxXrtNodeStyle::SetXrtGearIconItem_NodeStyle (const char * val)
	{ DDSetProp(XmNxrtGearIconItem, ((XtArgVal)(val)));}

inline char * UxXrtNodeStyle::GetXrtGearIconItemSelected_NodeStyle (void) const
	{ return (char * ) DDGetProp(XmNxrtGearIconItemSelected);}
inline void UxXrtNodeStyle::SetXrtGearIconItemSelected_NodeStyle (const char * val)
	{ DDSetProp(XmNxrtGearIconItemSelected, ((XtArgVal)(val)));}

inline char * UxXrtNodeStyle::GetXrtGearIconOpen_NodeStyle (void) const
	{ return (char * ) DDGetProp(XmNxrtGearIconOpen);}
inline void UxXrtNodeStyle::SetXrtGearIconOpen_NodeStyle (const char * val)
	{ DDSetProp(XmNxrtGearIconOpen, ((XtArgVal)(val)));}

inline char * UxXrtNodeStyle::GetXrtGearIconOpenSelected_NodeStyle (void) const
	{ return (char * ) DDGetProp(XmNxrtGearIconOpenSelected);}
inline void UxXrtNodeStyle::SetXrtGearIconOpenSelected_NodeStyle (const char * val)
	{ DDSetProp(XmNxrtGearIconOpenSelected, ((XtArgVal)(val)));}

inline short UxXrtNodeStyle::GetXrtGearLayoutSpacing_NodeStyle (void) const
	{ return (short ) ShortGetProp(XmNxrtGearLayoutSpacing);}
inline void UxXrtNodeStyle::SetXrtGearLayoutSpacing_NodeStyle (short val)
	{ SetProp(XmNxrtGearLayoutSpacing, ((XtArgVal)(val)));}

inline char * UxXrtNodeStyle::GetXrtGearLineColor_NodeStyle (void) const
	{ return (char * ) DDGetProp(XmNxrtGearLineColor);}
inline void UxXrtNodeStyle::SetXrtGearLineColor_NodeStyle (const char * val)
	{ DDSetProp(XmNxrtGearLineColor, ((XtArgVal)(val)));}

inline char * UxXrtNodeStyle::GetXrtGearLineStyle_NodeStyle (void) const
	{ return (char * ) DDGetProp(XmNxrtGearLineStyle);}
inline void UxXrtNodeStyle::SetXrtGearLineStyle_NodeStyle (const char * val)
	{ DDSetProp(XmNxrtGearLineStyle, ((XtArgVal)(val)));}

inline short UxXrtNodeStyle::GetXrtGearLineWidth_NodeStyle (void) const
	{ return (short ) ShortGetProp(XmNxrtGearLineWidth);}
inline void UxXrtNodeStyle::SetXrtGearLineWidth_NodeStyle (short val)
	{ SetProp(XmNxrtGearLineWidth, ((XtArgVal)(val)));}

inline char * UxXrtNodeStyle::GetXrtGearShortcutShow_NodeStyle (void) const
	{ return (char * ) DDGetProp(XmNxrtGearShortcutShow);}
inline void UxXrtNodeStyle::SetXrtGearShortcutShow_NodeStyle (const char * val)
	{ DDSetProp(XmNxrtGearShortcutShow, ((XtArgVal)(val)));}

inline short UxXrtNodeStyle::GetXrtGearShortcutSize_NodeStyle (void) const
	{ return (short ) ShortGetProp(XmNxrtGearShortcutSize);}
inline void UxXrtNodeStyle::SetXrtGearShortcutSize_NodeStyle (short val)
	{ SetProp(XmNxrtGearShortcutSize, ((XtArgVal)(val)));}

inline char * UxXrtNodeStyle::GetXrtGearShortcutColor_NodeStyle (void) const
	{ return (char *) DDGetProp(XmNxrtGearShortcutColor);}
inline void UxXrtNodeStyle::SetXrtGearShortcutColor_NodeStyle(const char * val)
	{ DDSetProp(XmNxrtGearShortcutColor, ((XtArgVal)(val)));}

// Constructors
inline UxXrtColumn::UxXrtColumn(void){}
inline UxXrtColumn::UxXrtColumn(const char* name, swidget uXParent)
{
	CreateSwidget(name,uXParent);
}

// Initialisation
inline swidget UxXrtColumn::CreateSwidget (const char* name, swidget parent)
{
	if (UxThis == NULL)
		UxThis = UxCreateSwidget( (char *) name,
					  xmXrtColumnObjectClass, parent);
	return UxThis;
}

inline char * UxXrtColumn::GetFontList_Column (void) const
	{ return (char * ) DDGetProp(XmNfontList);}
inline void UxXrtColumn::SetFontList_Column (const char * val)
	{ DDSetProp(XmNfontList, ((XtArgVal)(val)));}

inline char * UxXrtColumn::GetForeground_Column (void) const
	{ return (char * ) DDGetProp(XmNforeground);}
inline void UxXrtColumn::SetForeground_Column (const char * val)
	{ DDSetProp(XmNforeground, ((XtArgVal)(val)));}

inline short UxXrtColumn::GetHeight_Column (void) const
	{ return (short ) ShortGetProp(XmNheight);}
inline void UxXrtColumn::SetHeight_Column (short val)
	{ SetProp(XmNheight, ((XtArgVal)(val)));}

inline short UxXrtColumn::GetWidth_Column (void) const
	{ return (short ) ShortGetProp(XmNwidth);}
inline void UxXrtColumn::SetWidth_Column (short val)
	{ SetProp(XmNwidth, ((XtArgVal)(val)));}

inline char * UxXrtColumn::GetXrtGearFontListSelected_Column (void) const
	{ return (char * ) DDGetProp(XmNxrtGearFontListSelected);}
inline void UxXrtColumn::SetXrtGearFontListSelected_Column (const char * val)
	{ DDSetProp(XmNxrtGearFontListSelected, ((XtArgVal)(val)));}

inline char * UxXrtColumn::GetXrtGearLabel_Column (void) const
	{ return (char * ) DDGetProp(XmNxrtGearLabel);}
inline void UxXrtColumn::SetXrtGearLabel_Column (const char * val)
	{ DDSetProp(XmNxrtGearLabel, ((XtArgVal)(val)));}

inline char * UxXrtColumn::GetXrtGearLabelAlignment_Column (void) const
	{ return (char * ) DDGetProp(XmNxrtGearLabelAlignment);}
inline void UxXrtColumn::SetXrtGearLabelAlignment_Column (const char * val)
	{ DDSetProp(XmNxrtGearLabelAlignment, ((XtArgVal)(val)));}

inline short UxXrtColumn::GetXrtGearMarginLeft_Column (void) const
	{ return (short ) ShortGetProp(XmNxrtGearMarginLeft);}
inline void UxXrtColumn::SetXrtGearMarginLeft_Column (short val)
	{ SetProp(XmNxrtGearMarginLeft, ((XtArgVal)(val)));}

inline short UxXrtColumn::GetXrtGearMarginRight_Column (void) const
	{ return (short ) ShortGetProp(XmNxrtGearMarginRight);}
inline void UxXrtColumn::SetXrtGearMarginRight_Column (short val)
	{ SetProp(XmNxrtGearMarginRight, ((XtArgVal)(val)));}

inline char * UxXrtColumn::GetXrtGearNodeAlignment_Column (void) const
	{ return (char * ) DDGetProp(XmNxrtGearNodeAlignment);}
inline void UxXrtColumn::SetXrtGearNodeAlignment_Column (const char * val)
	{ DDSetProp(XmNxrtGearNodeAlignment, ((XtArgVal)(val)));}

inline char * UxXrtColumn::GetXrtGearSelected_Column (void) const
	{ return (char * ) DDGetProp(XmNxrtGearSelected);}
inline void UxXrtColumn::SetXrtGearSelected_Column (const char * val)
	{ DDSetProp(XmNxrtGearSelected, ((XtArgVal)(val)));}

inline char * UxXrtColumn::GetXrtGearWidthResizePolicy_Column (void) const
	{ return (char * ) DDGetProp(XmNxrtGearWidthResizePolicy);}
inline void UxXrtColumn::SetXrtGearWidthResizePolicy_Column (const char * val)
	{ DDSetProp(XmNxrtGearWidthResizePolicy, ((XtArgVal)(val)));}

inline char * UxXrtColumn::GetXrtGearWidthSizingPolicy_Column (void) const
	{ return (char * ) DDGetProp(XmNxrtGearWidthSizingPolicy);}
inline void UxXrtColumn::SetXrtGearWidthSizingPolicy_Column (const char * val)
	{ DDSetProp(XmNxrtGearWidthSizingPolicy, ((XtArgVal)(val)));}

inline short UxXrtColumn::GetXrtGearWidthMaximum_Column (void) const
	{ return (short ) ShortGetProp(XmNxrtGearWidthMaximum);}
inline void UxXrtColumn::SetXrtGearWidthMaximum_Column (short val)
	{ SetProp(XmNxrtGearWidthMaximum, ((XtArgVal)(val)));}

inline short UxXrtColumn::GetXrtGearWidthMinimum_Column (void) const
	{ return (short ) ShortGetProp(XmNxrtGearWidthMinimum);}
inline void UxXrtColumn::SetXrtGearWidthMinimum_Column (short val)
	{ SetProp(XmNxrtGearWidthMinimum, ((XtArgVal)(val)));}

inline int UxXrtColumn::GetXrtGearWidthPreferredCount_Column (void) const
	{ return (int)IntGetProp(XmNxrtGearWidthPreferredCount);}
inline void UxXrtColumn::SetXrtGearWidthPreferredCount_Column (int val)
	{ SetProp(XmNxrtGearWidthPreferredCount, ((XtArgVal)(val)));}

inline char * UxXrtColumn::GetBackground_Column (void) const
	{ return (char *) DDGetProp(XmNbackground);}
inline void UxXrtColumn::SetBackground_Column(const char * val)
	{ DDSetProp(XmNbackground, ((XtArgVal)(val)));}

inline char * UxXrtColumn::GetEditable_Column (void) const
	{ return (char *) DDGetProp(XmNeditable);}
inline void UxXrtColumn::SetEditable_Column(const char * val)
	{ DDSetProp(XmNeditable, ((XtArgVal)(val)));}

#if defined(__alpha) && defined(__cplusplus)
#pragma message restore
#endif /* __alpha */

#endif /* DESIGN_TIME */
#endif /* __cplusplus */
