/* ALL RIGHTS RESERVED
 *
 * This file is provided for demonstration and educational uses only.
 * Permission to use, copy, modify and distribute this file for
 * any purpose and without fee is hereby granted, provided that the
 * above copyright notice and this permission notice appear in all
 * copies, and that the name of KL Group not be used in advertising
 * or publicity pertaining to this material without the specific,
 * prior written permission of an authorized representative of
 * KL Group.
 *
 * KL GROUP MAKES NO REPRESENTATIONS AND EXTENDS NO WARRANTIES, EX-
 * PRESS OR IMPLIED, WITH RESPECT TO THE SOFTWARE, INCLUDING, BUT
 * NOT LIMITED TO, THE IMPLIED WARRANTIES OF MERCHANTABILITY AND
 * FITNESS FOR ANY PARTICULAR PURPOSE, AND THE WARRANTY AGAINST IN-
 * FRINGEMENT OF PATENTS OR OTHER INTELLECTUAL PROPERTY RIGHTS.  THE
 * SOFTWARE IS PROVIDED "AS IS", AND IN NO EVENT SHALL KL GROUP OR
 * ANY OF ITS AFFILIATES BE LIABLE FOR ANY DAMAGES, INCLUDING ANY
 * LOST PROFITS OR OTHER INCIDENTAL OR CONSEQUENTIAL DAMAGES
 * RELATING TO THE USE OF THIS SOFTWARE.
 *
 *
 * XRT/field widget UIM/X integration file
 *
 *  SCCSID -- @(#)UxXrtPanedW.h	1.1    98/11/05 KL Group Inc.
 */

/******************************************************************************
				UxXrtPanedW.h
******************************************************************************/

#ifndef UXXRTPANEDWINDOW_INCLUDED
#define UXXRTPANEDWINDOW_INCLUDED

#include <Xm/XrtGear.h>	/* Widget class public header file */
#include <Xm/XrtPanedW.h>
#include "Xrt_restable.h"
#include "UxXrtManager.h"
#include "UxXrtPanedW.hxx"  /* Include C++ header file (New in UIM/X 3.0)*/

#ifdef DESIGN_TIME
#ifndef NO_UX_MACROS

#define XRTGEAR_PANEDW_NAME(x)	xrtPanedWindow_res_table[x].name
#define XRTGEAR_PANEDW_PRPTY(x)	xrtPanedWindow_res_table[x].prpty
#define XRTGEAR_PANEDW_TABLE(x)	XRTGEAR_PANEDW_PRPTY(x),XRTGEAR_PANEDW_NAME(x)


/* Design-Time UxGet and UxPut macros for XrtGearAllowResize_PanedW */
#ifndef UxGetXrtGearAllowResize_PanedW
#define UxGetXrtGearAllowResize_PanedW(sw) \
	UxGET_string(sw, XRTGEAR_PANEDWINDOW_TABLE(xrtPanedWindowResNumAllowResize))
#endif
#ifndef UxPutXrtGearAllowResize_PanedW
#define UxPutXrtGearAllowResize_PanedW(sw, val) \
	UxPUT_string(sw, XRTGEAR_PANEDWINDOW_TABLE(xrtPanedWindowResNumAllowResize), val)
#endif

/* Design-Time UxGet and UxPut macros for XrtGearMarginHeight_PanedW */
#ifndef UxGetXrtGearMarginHeight_PanedW
#define UxGetXrtGearMarginHeight_PanedW(sw) \
	UxGET_short(sw, XRTGEAR_PANEDWINDOW_TABLE(xrtPanedWindowResNumMarginHeight))
#endif
#ifndef UxPutXrtGearMarginHeight_PanedW
#define UxPutXrtGearMarginHeight_PanedW(sw, val) \
	UxPUT_short(sw, XRTGEAR_PANEDWINDOW_TABLE(xrtPanedWindowResNumMarginHeight), val)
#endif

/* Design-Time UxGet and UxPut macros for XrtGearMarginWidth_PanedW */
#ifndef UxGetXrtGearMarginWidth_PanedW
#define UxGetXrtGearMarginWidth_PanedW(sw) \
	UxGET_short(sw, XRTGEAR_PANEDWINDOW_TABLE(xrtPanedWindowResNumMarginWidth))
#endif
#ifndef UxPutXrtGearMarginWidth_PanedW
#define UxPutXrtGearMarginWidth_PanedW(sw, val) \
	UxPUT_short(sw, XRTGEAR_PANEDWINDOW_TABLE(xrtPanedWindowResNumMarginWidth), val)
#endif

/* Design-Time UxGet and UxPut macros for XrtGearMaximum_PanedW */
#ifndef UxGetXrtGearMaximum_PanedW
#define UxGetXrtGearMaximum_PanedW(sw) \
	UxGET_short(sw, XRTGEAR_PANEDWINDOW_TABLE(xrtPanedWindowResNumMaximum))
#endif
#ifndef UxPutXrtGearMaximum_PanedW
#define UxPutXrtGearMaximum_PanedW(sw, val) \
	UxPUT_short(sw, XRTGEAR_PANEDWINDOW_TABLE(xrtPanedWindowResNumMaximum), val)
#endif

/* Design-Time UxGet and UxPut macros for XrtGearMinimum_PanedW */
#ifndef UxGetXrtGearMinimum_PanedW
#define UxGetXrtGearMinimum_PanedW(sw) \
	UxGET_short(sw, XRTGEAR_PANEDWINDOW_TABLE(xrtPanedWindowResNumMinimum))
#endif
#ifndef UxPutXrtGearMinimum_PanedW
#define UxPutXrtGearMinimum_PanedW(sw, val) \
	UxPUT_short(sw, XRTGEAR_PANEDWINDOW_TABLE(xrtPanedWindowResNumMinimum), val)
#endif

/* Design-Time UxGet and UxPut macros for XrtGearOrientation_PanedW */
#ifndef UxGetXrtGearOrientation_PanedW
#define UxGetXrtGearOrientation_PanedW(sw) \
	UxGET_string(sw, XRTGEAR_PANEDWINDOW_TABLE(xrtPanedWindowResNumOrientation))
#endif
#ifndef UxPutXrtGearOrientation_PanedW
#define UxPutXrtGearOrientation_PanedW(sw, val) \
	UxPUT_string(sw, XRTGEAR_PANEDWINDOW_TABLE(xrtPanedWindowResNumOrientation), val)
#endif

/* Design-Time UxGet and UxPut macros for xrtGearPosition_PanedW */
#ifndef UxGetXrtGearPosition_PanedW
#define UxGetXrtGearPosition_PanedW(sw) \
	UxGET_short(sw, XRTGEAR_PANEDWINDOW_TABLE(xrtPanedWResNumPosition))
#endif
#ifndef UxPutXrtGearPosition_PanedW
#define UxPutXrtGearPosition_PanedW(sw, val) \
	UxPUT_short(sw, XRTGEAR_PANEDWINDOW_TABLE(xrtPanedWResNumPosition), val)
#endif

/* Design-Time UxGet and UxPut macros for XrtGearPositionIndex_PanedW */
#ifndef UxGetXrtGearPositionIndex_PanedW
#define UxGetXrtGearPositionIndex_PanedW(sw) \
	UxGET_short(sw, XRTGEAR_PANEDWINDOW_TABLE(xrtPanedWindowResNumPositionIndex))
#endif
#ifndef UxPutXrtGearPositionIndex_PanedW
#define UxPutXrtGearPositionIndex_PanedW(sw, val) \
	UxPUT_short(sw, XRTGEAR_PANEDWINDOW_TABLE(xrtPanedWindowResNumPositionIndex), val)
#endif

/* Design-Time UxGet and UxPut macros for XrtGearRecomputeSize_PanedW */
#ifndef UxGetXrtGearRecomputeSize_PanedW
#define UxGetXrtGearRecomputeSize_PanedW(sw) \
	UxGET_string(sw, XRTGEAR_PANEDWINDOW_TABLE(xrtPanedWindowResNumRecomputeSize))
#endif
#ifndef UxPutXrtGearRecomputeSize_PanedW
#define UxPutXrtGearRecomputeSize_PanedW(sw, val) \
	UxPUT_string(sw, XRTGEAR_PANEDWINDOW_TABLE(xrtPanedWindowResNumRecomputeSize), val)
#endif

/* Design-Time UxGet and UxPut macros for XrtGearSashHeight_PanedW */
#ifndef UxGetXrtGearSashHeight_PanedW
#define UxGetXrtGearSashHeight_PanedW(sw) \
	UxGET_short(sw, XRTGEAR_PANEDWINDOW_TABLE(xrtPanedWindowResNumSashHeight))
#endif
#ifndef UxPutXrtGearSashHeight_PanedW
#define UxPutXrtGearSashHeight_PanedW(sw, val) \
	UxPUT_short(sw, XRTGEAR_PANEDWINDOW_TABLE(xrtPanedWindowResNumSashHeight), val)
#endif

/* Design-Time UxGet and UxPut macros for XrtGearSashIndent_PanedW */
#ifndef UxGetXrtGearSashIndent_PanedW
#define UxGetXrtGearSashIndent_PanedW(sw) \
	UxGET_short(sw, XRTGEAR_PANEDWINDOW_TABLE(xrtPanedWindowResNumSashIndent))
#endif
#ifndef UxPutXrtGearSashIndent_PanedW
#define UxPutXrtGearSashIndent_PanedW(sw, val) \
	UxPUT_short(sw, XRTGEAR_PANEDWINDOW_TABLE(xrtPanedWindowResNumSashIndent), val)
#endif

/* Design-Time UxGet and UxPut macros for XrtGearSashShadowThickness_PanedW */
#ifndef UxGetXrtGearSashShadowThickness_PanedW
#define UxGetXrtGearSashShadowThickness_PanedW(sw) \
	UxGET_short(sw, XRTGEAR_PANEDWINDOW_TABLE(xrtPanedWindowResNumSashShadowThickness))
#endif
#ifndef UxPutXrtGearSashShadowThickness_PanedW
#define UxPutXrtGearSashShadowThickness_PanedW(sw, val) \
	UxPUT_short(sw, XRTGEAR_PANEDWINDOW_TABLE(xrtPanedWindowResNumSashShadowThickness), val)
#endif

/* Design-Time UxGet and UxPut macros for XrtGearSashWidth_PanedW */
#ifndef UxGetXrtGearSashWidth_PanedW
#define UxGetXrtGearSashWidth_PanedW(sw) \
	UxGET_short(sw, XRTGEAR_PANEDWINDOW_TABLE(xrtPanedWindowResNumSashWidth))
#endif
#ifndef UxPutXrtGearSashWidth_PanedW
#define UxPutXrtGearSashWidth_PanedW(sw, val) \
	UxPUT_short(sw, XRTGEAR_PANEDWINDOW_TABLE(xrtPanedWindowResNumSashWidth), val)
#endif

/* Design-Time UxGet and UxPut macros for XrtGearSeparatorShow_PanedW */
#ifndef UxGetXrtGearSeparatorShow_PanedW
#define UxGetXrtGearSeparatorShow_PanedW(sw) \
	UxGET_string(sw, XRTGEAR_PANEDWINDOW_TABLE(xrtPanedWindowResNumSeparatorShow))
#endif
#ifndef UxPutXrtGearSeparatorShow_PanedW
#define UxPutXrtGearSeparatorShow_PanedW(sw, val) \
	UxPUT_string(sw, XRTGEAR_PANEDWINDOW_TABLE(xrtPanedWindowResNumSeparatorShow), val)
#endif

/* Design-Time UxGet and UxPut macros for XrtGearSkipAdjust_PanedW */
#ifndef UxGetXrtGearSkipAdjust_PanedW
#define UxGetXrtGearSkipAdjust_PanedW(sw) \
	UxGET_string(sw, XRTGEAR_PANEDWINDOW_TABLE(xrtPanedWindowResNumSkipAdjust))
#endif
#ifndef UxPutXrtGearSkipAdjust_PanedW
#define UxPutXrtGearSkipAdjust_PanedW(sw, val) \
	UxPUT_string(sw, XRTGEAR_PANEDWINDOW_TABLE(xrtPanedWindowResNumSkipAdjust), val)
#endif

/* Design-Time UxGet and UxPut macros for XrtGearSpacing_PanedW */
#ifndef UxGetXrtGearSpacing_PanedW
#define UxGetXrtGearSpacing_PanedW(sw) \
	UxGET_short(sw, XRTGEAR_PANEDWINDOW_TABLE(xrtPanedWindowResNumSpacing))
#endif
#ifndef UxPutXrtGearSpacing_PanedW
#define UxPutXrtGearSpacing_PanedW(sw, val) \
	UxPUT_short(sw, XRTGEAR_PANEDWINDOW_TABLE(xrtPanedWindowResNumSpacing), val)
#endif

#endif /* NO_UX_MACROS */

extern Class_t	UxC_XrtPanedWindow;

/* Design-time create macro */
#ifndef UxCreateXrtPanedWindow
#define UxCreateXrtPanedWindow(name, parent) \
	UxCreateSwidget(UxC_XrtPanedWindow, name, parent)
#endif

#else /* Not DESIGN_TIME */

#ifndef UxGetXrtGearAllowResize_PanedW
#define UxGetXrtGearAllowResize_PanedW(sw) \
	(char *) UxDDGetProp(sw, XmNxrtGearAllowResize)
#endif
#ifndef UxPutXrtGearAllowResize_PanedW
#define UxPutXrtGearAllowResize_PanedW(sw, val) \
	UxDDPutProp(sw, XmNxrtGearAllowResize, (XtArgVal)(val))
#endif

#ifndef UxGetXrtGearMarginHeight_PanedW
#define UxGetXrtGearMarginHeight_PanedW(sw) \
	(short)UxShortGetProp(sw, XmNxrtGearMarginHeight)
#endif
#ifndef UxPutXrtGearMarginHeight_PanedW
#define UxPutXrtGearMarginHeight_PanedW(sw, val) \
	UxPutProp(sw, XmNxrtGearMarginHeight, (XtArgVal)(val))
#endif

#ifndef UxGetXrtGearMarginWidth_PanedW
#define UxGetXrtGearMarginWidth_PanedW(sw) \
	(short)UxShortGetProp(sw, XmNxrtGearMarginWidth)
#endif
#ifndef UxPutXrtGearMarginWidth_PanedW
#define UxPutXrtGearMarginWidth_PanedW(sw, val) \
	UxPutProp(sw, XmNxrtGearMarginWidth, (XtArgVal)(val))
#endif

#ifndef UxGetXrtGearMaximum_PanedW
#define UxGetXrtGearMaximum_PanedW(sw) \
	(short)UxShortGetProp(sw, XmNxrtGearMaximum)
#endif
#ifndef UxPutXrtGearMaximum_PanedW
#define UxPutXrtGearMaximum_PanedW(sw, val) \
	UxPutProp(sw, XmNxrtGearMaximum, (XtArgVal)(val))
#endif

#ifndef UxGetXrtGearMinimum_PanedW
#define UxGetXrtGearMinimum_PanedW(sw) \
	(short)UxShortGetProp(sw, XmNxrtGearMinimum)
#endif
#ifndef UxPutXrtGearMinimum_PanedW
#define UxPutXrtGearMinimum_PanedW(sw, val) \
	UxPutProp(sw, XmNxrtGearMinimum, (XtArgVal)(val))
#endif

#ifndef UxGetXrtGearOrientation_PanedW
#define UxGetXrtGearOrientation_PanedW(sw) \
	(char *) UxDDGetProp(sw, XmNxrtGearOrientation)
#endif
#ifndef UxPutXrtGearOrientation_PanedW
#define UxPutXrtGearOrientation_PanedW(sw, val) \
	UxDDPutProp(sw, XmNxrtGearOrientation, (XtArgVal)(val))
#endif

#ifndef UxGetXrtGearPosition_PanedW
#define UxGetXrtGearPosition_PanedW(sw) \
	(short)UxShortGetProp(sw, XmNxrtGearPosition)
#endif
#ifndef UxPutXrtGearPosition_PanedW
#define UxPutXrtGearPosition_PanedW(sw, val) \
	UxPutProp(sw, XmNxrtGearPosition, (XtArgVal)(val))
#endif

#ifndef UxGetXrtGearPositionIndex_PanedW
#define UxGetXrtGearPositionIndex_PanedW(sw) \
	(short)UxShortGetProp(sw, XmNxrtGearPosition)
#endif
#ifndef UxPutXrtGearPositionIndex_PanedW
#define UxPutXrtGearPositionIndex_PanedW(sw, val) \
	UxPutProp(sw, XmNxrtGearPositionIndex, (XtArgVal)(val))
#endif

#ifndef UxGetXrtGearRecomputeSize_PanedW
#define UxGetXrtGearRecomputeSize_PanedW(sw) \
	(char *) UxDDGetProp(sw, XmNxrtGearRecomputeSize)
#endif
#ifndef UxPutXrtGearRecomputeSize_PanedW
#define UxPutXrtGearRecomputeSize_PanedW(sw, val) \
	UxDDPutProp(sw, XmNxrtGearRecomputeSize, (XtArgVal)(val))
#endif

#ifndef UxGetXrtGearSashHeight_PanedW
#define UxGetXrtGearSashHeight_PanedW(sw) \
	(short)UxShortGetProp(sw, XmNxrtGearSashHeight)
#endif
#ifndef UxPutXrtGearSashHeight_PanedW
#define UxPutXrtGearSashHeight_PanedW(sw, val) \
	UxPutProp(sw, XmNxrtGearSashHeight, (XtArgVal)(val))
#endif

#ifndef UxGetXrtGearSashIndent_PanedW
#define UxGetXrtGearSashIndent_PanedW(sw) \
	(short)UxShortGetProp(sw, XmNxrtGearSashIndent)
#endif
#ifndef UxPutXrtGearSashIndent_PanedW
#define UxPutXrtGearSashIndent_PanedW(sw, val) \
	UxPutProp(sw, XmNxrtGearSashIndent, (XtArgVal)(val))
#endif

#ifndef UxGetXrtGearSashShadowThickness_PanedW
#define UxGetXrtGearSashShadowThickness_PanedW(sw) \
	(short)UxShortGetProp(sw, XmNxrtGearSashShadowThickness)
#endif
#ifndef UxPutXrtGearSashShadowThickness_PanedW
#define UxPutXrtGearSashShadowThickness_PanedW(sw, val) \
	UxPutProp(sw, XmNxrtGearSashShadowThickness, (XtArgVal)(val))
#endif

#ifndef UxGetXrtGearSashWidth_PanedW
#define UxGetXrtGearSashWidth_PanedW(sw) \
	(short)UxShortGetProp(sw, XmNxrtGearSashWidth)
#endif
#ifndef UxPutXrtGearSashWidth_PanedW
#define UxPutXrtGearSashWidth_PanedW(sw, val) \
	UxPutProp(sw, XmNxrtGearSashWidth, (XtArgVal)(val))
#endif

#ifndef UxGetXrtGearSeparatorShow_PanedW
#define UxGetXrtGearSeparatorShow_PanedW(sw) \
	(char *) UxDDGetProp(sw, XmNxrtGearSeparatorShow)
#endif
#ifndef UxPutXrtGearSeparatorShow_PanedW
#define UxPutXrtGearSeparatorShow_PanedW(sw, val) \
	UxDDPutProp(sw, XmNxrtGearSeparatorShow, (XtArgVal)(val))
#endif

#ifndef UxGetXrtGearSkipAdjust_PanedW
#define UxGetXrtGearSkipAdjust_PanedW(sw) \
	(char *) UxDDGetProp(sw, XmNxrtGearSkipAdjust)
#endif
#ifndef UxPutXrtGearSkipAdjust_PanedW
#define UxPutXrtGearSkipAdjust_PanedW(sw, val) \
	UxDDPutProp(sw, XmNxrtGearSkipAdjust, (XtArgVal)(val))
#endif

#ifndef UxGetXrtGearSpacing_PanedW
#define UxGetXrtGearSpacing_PanedW(sw) \
	(short)UxShortGetProp(sw, XmNxrtGearSpacing)
#endif
#ifndef UxPutXrtGearSpacing_PanedW
#define UxPutXrtGearSpacing_PanedW(sw, val) \
	UxPutProp(sw, XmNxrtGearSpacing, (XtArgVal)(val))
#endif

/* Runtime create macro */
#ifndef UxCreateXrtPanedWindow
#define UxCreateXrtPanedWindow(name, parent) \
	UxCreateSwidget(name, xmXrtPanedWindowWidgetClass, parent)
#endif

#endif /* DESIGN_TIME */

#endif /* UXXRTDATEFIELD_INCLUDED */

/***END*OF*FILE***************************************************************/
