/* ALL RIGHTS RESERVED
 *
 * This file is provided for demonstration and educational uses only.
 * Permission to use, copy, modify and distribute this file for
 * any purpose and without fee is hereby granted, provided that the
 * above copyright notice and this permission notice appear in all
 * copies, and that the name of KL Group not be used in advertising
 * or publicity pertaining to this material without the specific,
 * prior written permission of an authorized representative of
 * KL Group.
 *
 * KL GROUP MAKES NO REPRESENTATIONS AND EXTENDS NO WARRANTIES, EX-
 * PRESS OR IMPLIED, WITH RESPECT TO THE SOFTWARE, INCLUDING, BUT
 * NOT LIMITED TO, THE IMPLIED WARRANTIES OF MERCHANTABILITY AND
 * FITNESS FOR ANY PARTICULAR PURPOSE, AND THE WARRANTY AGAINST IN-
 * FRINGEMENT OF PATENTS OR OTHER INTELLECTUAL PROPERTY RIGHTS.  THE
 * SOFTWARE IS PROVIDED "AS IS", AND IN NO EVENT SHALL KL GROUP OR
 * ANY OF ITS AFFILIATES BE LIABLE FOR ANY DAMAGES, INCLUDING ANY
 * LOST PROFITS OR OTHER INCIDENTAL OR CONSEQUENTIAL DAMAGES
 * RELATING TO THE USE OF THIS SOFTWARE.
 *
 *
 * XRT/gear widget UIM/X integration file
 *
 *  SCCSID -- @(#)UxXrtPanedW.hxx	1.2    99/01/29 KL Group Inc.
 */

#if defined(__cplusplus) && !defined(XT_CODE) && !defined(NO_UXBINDINGS)  && !defined(UIMX2_9)

class UxXrtPanedWindow : public UxXrtManager
{
    public:


	// Constructors
	UXINLINE UxXrtPanedWindow(void);
	UXINLINE UxXrtPanedWindow(const char* name , swidget uXParent);

	// Initialisation
	UXINLINE swidget CreateSwidget (const char* name, swidget parent);

	// Resource accessor functions
	UXINLINE short GetXrtGearMarginHeight_PanedW () const;
	UXINLINE void SetXrtGearMarginHeight_PanedW(short);

	UXINLINE short GetXrtGearMarginWidth_PanedW () const;
	UXINLINE void SetXrtGearMarginWidth_PanedW(short);

	UXINLINE char * GetXrtGearOrientation_PanedW () const;
	UXINLINE void SetXrtGearOrientation_PanedW(const char *);

	UXINLINE char * GetXrtGearRecomputeSize_PanedW () const;
	UXINLINE void SetXrtGearRecomputeSize_PanedW(const char *);

	UXINLINE short GetXrtGearSashHeight_PanedW () const;
	UXINLINE void SetXrtGearSashHeight_PanedW(short);

	UXINLINE short GetXrtGearSashIndent_PanedW () const;
	UXINLINE void SetXrtGearSashIndent_PanedW(short);

	UXINLINE short GetXrtGearSashShadowThickness_PanedW () const;
	UXINLINE void SetXrtGearSashShadowThickness_PanedW(short);

	UXINLINE short GetXrtGearSashWidth_PanedW () const;
	UXINLINE void SetXrtGearSashWidth_PanedW(short);

	UXINLINE char * GetXrtGearSeparatorShow_PanedW () const;
	UXINLINE void SetXrtGearSeparatorShow_PanedW(const char *);

	UXINLINE short GetXrtGearSpacing_PanedW () const;
	UXINLINE void SetXrtGearSpacing_PanedW(short);

};

#ifdef DESIGN_TIME

#define XRTGEAR_PANEDW_NAME(x)	xrtPanedWindow_res_table[x].name
#define XRTGEAR_PANEDW_PRPTY(x)	xrtPanedWindow_res_table[x].prpty
#define XRTGEAR_PANEDW_TABLE(x)	XRTGEAR_PANEDW_PRPTY(x),XRTGEAR_PANEDW_NAME(x)

extern Class_t UxC_XrtPanedWindow;

#else /* (not DESIGN_TIME) */

#if defined(__alpha) && defined(__cplusplus)
#pragma message save
#pragma message disable narrowptr
#endif /* __alpha */

// Constructors
inline UxXrtPanedWindow::UxXrtPanedWindow(void){}
inline UxXrtPanedWindow::UxXrtPanedWindow(const char* name, swidget uXParent)
{
	UxXrtPanedWindow::CreateSwidget(name,uXParent);
}
	
// Initialisation
inline swidget UxXrtPanedWindow::CreateSwidget (const char* name,swidget parent)
{
	if (UxThis == NULL)
		UxThis = UxCreateSwidget( (char *) name,
					xmXrtPanedWindowWidgetClass, parent);
	return UxThis;
}
	
inline short UxXrtPanedWindow::GetXrtGearMarginHeight_PanedW (void) const
	{ return (short) ShortGetProp(XmNxrtGearMarginHeight);}
inline void UxXrtPanedWindow::SetXrtGearMarginHeight_PanedW(short val)
	{ SetProp(XmNxrtGearMarginHeight, ((XtArgVal)(val)));}

inline short UxXrtPanedWindow::GetXrtGearMarginWidth_PanedW (void) const
	{ return (short) ShortGetProp(XmNxrtGearMarginWidth);}
inline void UxXrtPanedWindow::SetXrtGearMarginWidth_PanedW(short val)
	{ SetProp(XmNxrtGearMarginWidth, ((XtArgVal)(val)));}

inline char * UxXrtPanedWindow::GetXrtGearOrientation_PanedW (void) const
	{ return (char *) DDGetProp(XmNxrtGearOrientation);}
inline void UxXrtPanedWindow::SetXrtGearOrientation_PanedW(const char * val)
	{ DDSetProp(XmNxrtGearOrientation, ((XtArgVal)(val)));}

inline char * UxXrtPanedWindow::GetXrtGearRecomputeSize_PanedW (void) const
	{ return (char *) DDGetProp(XmNxrtGearRecomputeSize);}
inline void UxXrtPanedWindow::SetXrtGearRecomputeSize_PanedW(const char * val)
	{ DDSetProp(XmNxrtGearRecomputeSize, ((XtArgVal)(val)));}

inline short UxXrtPanedWindow::GetXrtGearSashHeight_PanedW (void) const
	{ return (short) ShortGetProp(XmNxrtGearSashHeight);}
inline void UxXrtPanedWindow::SetXrtGearSashHeight_PanedW(short val)
	{ SetProp(XmNxrtGearSashHeight, ((XtArgVal)(val)));}

inline short UxXrtPanedWindow::GetXrtGearSashIndent_PanedW (void) const
	{ return (short) ShortGetProp(XmNxrtGearSashIndent);}
inline void UxXrtPanedWindow::SetXrtGearSashIndent_PanedW(short val)
	{ SetProp(XmNxrtGearSashIndent, ((XtArgVal)(val)));}

inline short UxXrtPanedWindow::GetXrtGearSashShadowThickness_PanedW (void) const
	{ return (short) ShortGetProp(XmNxrtGearSashShadowThickness);}
inline void UxXrtPanedWindow::SetXrtGearSashShadowThickness_PanedW(short val)
	{ SetProp(XmNxrtGearSashShadowThickness, ((XtArgVal)(val)));}

inline short UxXrtPanedWindow::GetXrtGearSashWidth_PanedW (void) const
	{ return (short) ShortGetProp(XmNxrtGearSashWidth);}
inline void UxXrtPanedWindow::SetXrtGearSashWidth_PanedW(short val)
	{ SetProp(XmNxrtGearSashWidth, ((XtArgVal)(val)));}

inline char * UxXrtPanedWindow::GetXrtGearSeparatorShow_PanedW (void) const
	{ return (char *) DDGetProp(XmNxrtGearSeparatorShow);}
inline void UxXrtPanedWindow::SetXrtGearSeparatorShow_PanedW(const char * val)
	{ DDSetProp(XmNxrtGearSeparatorShow, ((XtArgVal)(val)));}

inline short UxXrtPanedWindow::GetXrtGearSpacing_PanedW (void) const
	{ return (short) ShortGetProp(XmNxrtGearSpacing);}
inline void UxXrtPanedWindow::SetXrtGearSpacing_PanedW(short val)
	{ SetProp(XmNxrtGearSpacing, ((XtArgVal)(val)));}

#if defined(__alpha) && defined(__cplusplus)
#pragma message restore
#endif /* __alpha */

#endif /* DESIGN_TIME */
#endif /* __cplusplus */


