/* ALL RIGHTS RESERVED
 *
 * This file is provided for demonstration and educational uses only.
 * Permission to use, copy, modify and distribute this file for
 * any purpose and without fee is hereby granted, provided that the
 * above copyright notice and this permission notice appear in all
 * copies, and that the name of KL Group not be used in advertising
 * or publicity pertaining to this material without the specific,
 * prior written permission of an authorized representative of
 * KL Group.
 *
 * KL GROUP MAKES NO REPRESENTATIONS AND EXTENDS NO WARRANTIES, EX-
 * PRESS OR IMPLIED, WITH RESPECT TO THE SOFTWARE, INCLUDING, BUT
 * NOT LIMITED TO, THE IMPLIED WARRANTIES OF MERCHANTABILITY AND
 * FITNESS FOR ANY PARTICULAR PURPOSE, AND THE WARRANTY AGAINST IN-
 * FRINGEMENT OF PATENTS OR OTHER INTELLECTUAL PROPERTY RIGHTS.  THE
 * SOFTWARE IS PROVIDED "AS IS", AND IN NO EVENT SHALL KL GROUP OR
 * ANY OF ITS AFFILIATES BE LIABLE FOR ANY DAMAGES, INCLUDING ANY
 * LOST PROFITS OR OTHER INCIDENTAL OR CONSEQUENTIAL DAMAGES
 * RELATING TO THE USE OF THIS SOFTWARE.
 *
 *
 * XRT/field widget UIM/X integration file
 *
 * $AstecId: UxXrtSpinBox.h,v 1.3 2000/06/19 08:32:34 kosaka Exp $
 *
 *  SCCSID -- @(#)UxXrtSpinBox.h	1.8    98/11/05 KL Group Inc.
 */

/******************************************************************************
				UxXrtSpinBox.h
******************************************************************************/

#ifndef UXXRTSPINBOX_INCLUDED
#define UXXRTSPINBOX_INCLUDED

#include <Xm/XrtField.h>	/* Widget class public header file */
#include "Xrt_restable.h"
#include "UxXrtField.h"
#include "UxXrtFldManager.h"
#include "UxXrtSpinBox.hxx"  /* Include C++ header file (New in UIM/X 3.0)*/

#ifdef DESIGN_TIME
#ifndef NO_UX_MACROS

#define XRTSPNFLD_TABLE(x)	xrtfldspn_res_table[x].prpty, xrtfldspn_res_table[x].name

/* Design-Time UxGet and UxPut macros for xrtSpinArrowLayout */
#ifndef UxGetXrtSpinArrowLayout
#define UxGetXrtSpinArrowLayout(sw) \
	UxGET_string(sw, XRTSPNFLD_TABLE(xrtFldResNumSpinArrowLayout))
#endif
#ifndef UxPutXrtSpinArrowLayout
#define UxPutXrtSpinArrowLayout(sw, val) \
	UxPUT_string(sw, XRTSPNFLD_TABLE(xrtFldResNumSpinArrowLayout), val)
#endif

/* Design-Time UxGet and UxPut macros for xrtSpinArrowOrientation */
#ifndef UxGetXrtSpinArrowOrientation
#define UxGetXrtSpinArrowOrientation(sw) \
	UxGET_string(sw, XRTSPNFLD_TABLE(xrtFldResNumSpinArrowOrientation))
#endif
#ifndef UxPutXrtSpinArrowOrientation
#define UxPutXrtSpinArrowOrientation(sw, val) \
	UxPUT_string(sw, XRTSPNFLD_TABLE(xrtFldResNumSpinArrowOrientation), val)
#endif

/* (pds) Design-Time UxGet and UxPut macros for xrtSpinArrowType */
#ifndef UxGetXrtSpinArrowType
#define UxGetXrtSpinArrowType(sw) \
	UxGET_string(sw, XRTSPNFLD_TABLE(xrtFldResNumSpinArrowType))
#endif
#ifndef UxPutXrtSpinArrowType
#define UxPutXrtSpinArrowType(sw, val) \
	UxPUT_string(sw, XRTSPNFLD_TABLE(xrtFldResNumSpinArrowType), val)
#endif

/* Design-Time UxGet and UxPut macros for xrtSpinDecrArrow */
#ifndef UxGetXrtSpinDecrArrow
#define UxGetXrtSpinDecrArrow(sw) \
	UxGET_string(sw, XRTSPNFLD_TABLE(xrtFldResNumSpinDecrArrow))
#endif
#ifndef UxPutXrtSpinDecrArrow
#define UxPutXrtSpinDecrArrow(sw, val) \
	UxPUT_string(sw, XRTSPNFLD_TABLE(xrtFldResNumSpinDecrArrow), val)
#endif

/* Design-Time UxGet and UxPut macros for xrtSpinDecrArrowClass */
#ifndef UxGetXrtSpinDecrArrowClass
#define UxGetXrtSpinDecrArrowClass(sw) \
	UxGET_string(sw, XRTSPNFLD_TABLE(xrtFldResNumSpinDecrArrowClass))
#endif
#ifndef UxPutXrtSpinDecrArrowClass
#define UxPutXrtSpinDecrArrowClass(sw, val) \
	UxPUT_string(sw, XRTSPNFLD_TABLE(xrtFldResNumSpinDecrArrowClass), val)
#endif

/* Design-Time UxGet and UxPut macros for xrtSpinField */
#ifndef UxGetXrtSpinField
#define UxGetXrtSpinField(sw) \
	UxGET_string(sw, XRTSPNFLD_TABLE(xrtFldResNumSpinField))
#endif
#ifndef UxPutXrtSpinField
#define UxPutXrtSpinField(sw, val) \
	UxPUT_string(sw, XRTSPNFLD_TABLE(xrtFldResNumSpinField), val)
#endif

/* Design-Time UxGet and UxPut macros for xrtSpinFieldClass */
#ifndef UxGetXrtSpinFieldClass
#define UxGetXrtSpinFieldClass(sw) \
	UxGET_string(sw, XRTSPNFLD_TABLE(xrtFldResNumSpinFieldClass))
#endif
#ifndef UxPutXrtSpinFieldClass
#define UxPutXrtSpinFieldClass(sw, val) \
	UxPUT_string(sw, XRTSPNFLD_TABLE(xrtFldResNumSpinFieldClass), val)
#endif

/* Design-Time UxGet and UxPut macros for xrtSpinFieldName */
#ifndef UxGetXrtSpinFieldName
#define UxGetXrtSpinFieldName(sw) \
	UxGET_string(sw, XRTSPNFLD_TABLE(xrtFldResNumSpinFieldName))
#endif
#ifndef UxPutXrtSpinFieldName
#define UxPutXrtSpinFieldName(sw, val) \
	UxPUT_string(sw, XRTSPNFLD_TABLE(xrtFldResNumSpinFieldName), val)
#endif

/* Design-Time UxGet and UxPut macros for xrtSpinFieldType */
#ifndef UxGetXrtSpinFieldType
#define UxGetXrtSpinFieldType(sw) \
	UxGET_string(sw, XRTSPNFLD_TABLE(xrtFldResNumSpinFieldType))
#endif
#ifndef UxPutXrtSpinFieldType
#define UxPutXrtSpinFieldType(sw, val) \
	UxPUT_string(sw, XRTSPNFLD_TABLE(xrtFldResNumSpinFieldType), val)
#endif

/* Design-Time UxGet and UxPut macros for xrtSpinIncrArrow */
#ifndef UxGetXrtSpinIncrArrow
#define UxGetXrtSpinIncrArrow(sw) \
	UxGET_string(sw, XRTSPNFLD_TABLE(xrtFldResNumSpinIncrArrow))
#endif
#ifndef UxPutXrtSpinIncrArrow
#define UxPutXrtSpinIncrArrow(sw, val) \
	UxPUT_string(sw, XRTSPNFLD_TABLE(xrtFldResNumSpinIncrArrow), val)
#endif

/* Design-Time UxGet and UxPut macros for xrtSpinIncrArrowClass */
#ifndef UxGetXrtSpinIncrArrowClass
#define UxGetXrtSpinIncrArrowClass(sw) \
	UxGET_string(sw, XRTSPNFLD_TABLE(xrtFldResNumSpinIncrArrowClass))
#endif
#ifndef UxPutXrtSpinIncrArrowClass
#define UxPutXrtSpinIncrArrowClass(sw, val) \
	UxPUT_string(sw, XRTSPNFLD_TABLE(xrtFldResNumSpinIncrArrowClass), val)
#endif

/* (pds) Design-Time UxGet and UxPut macros for xrtSpinSpacing */
#ifndef UxGetXrtSpinSpacing
#define UxGetXrtSpinSpacing(sw) \
	UxGET_short(sw, XRTSPNFLD_TABLE(xrtFldResNumSpinSpacing))
#endif
#ifndef UxPutXrtSpinSpacing
#define UxPutXrtSpinSpacing(sw, val) \
	UxPUT_short(sw, XRTSPNFLD_TABLE(xrtFldResNumSpinSpacing), val)
#endif

/* Design-Time UxGet and UxPut macros for xrtSpinType */
#ifndef UxGetXrtSpinType
#define UxGetXrtSpinType(sw) \
	UxGET_string(sw, XRTSPNFLD_TABLE(xrtFldResNumSpinType))
#endif
#ifndef UxPutXrtSpinType
#define UxPutXrtSpinType(sw, val) \
	UxPUT_string(sw, XRTSPNFLD_TABLE(xrtFldResNumSpinType), val)
#endif

#endif /* NO_UX_MACROS */

extern Class_t	UxC_XrtSpinBox;
/* Design-time create macro */
#ifndef UxCreateXrtSpinBox
#define UxCreateXrtSpinBox(name, parent) \
	UxCreateSwidget(UxC_XrtSpinBox, name, parent)
#endif

#else /* Not DESIGN_TIME */

#ifndef UxGetXrtSpinArrowLayout
#define UxGetXrtSpinArrowLayout(sw) \
	(char *) UxDDGetProp(sw, XmNxrtSpinArrowLayout)
#endif
#ifndef UxPutXrtSpinArrowLayout
#define UxPutXrtSpinArrowLayout(sw, val) \
	UxDDPutProp(sw, XmNxrtSpinArrowLayout, (XtArgVal)(val))
#endif

#ifndef UxGetXrtSpinArrowOrientation
#define UxGetXrtSpinArrowOrientation(sw) \
	(char *) UxDDGetProp(sw, XmNxrtSpinArrowOrientation)
#endif
#ifndef UxPutXrtSpinArrowOrientation
#define UxPutXrtSpinArrowOrientation(sw, val) \
	UxDDPutProp(sw, XmNxrtSpinArrowOrientation, (XtArgVal)(val))
#endif
/* pds */
#ifndef UxGetXrtSpinArrowType
#define UxGetXrtSpinArrowType(sw) \
	(char *) UxDDGetProp(sw, XmNxrtSpinArrowType)
#endif
#ifndef UxPutXrtSpinArrowType
#define UxPutXrtSpinArrowType(sw, val) \
	UxDDPutProp(sw, XmNxrtSpinArrowType, (XtArgVal)(val))
#endif

#ifndef UxGetXrtSpinDecrArrow
#define UxGetXrtSpinDecrArrow(sw) \
	(char *) UxDDGetProp(sw, XmNxrtSpinDecrArrow)
#endif
#ifndef UxPutXrtSpinDecrArrow
#define UxPutXrtSpinDecrArrow(sw, val) \
	UxDDPutProp(sw, XmNxrtSpinDecrArrow, (XtArgVal)(val))
#endif

#ifndef UxGetXrtSpinDecrArrowClass
#define UxGetXrtSpinDecrArrowClass(sw) \
	(char *) UxDDGetProp(sw, XmNxrtSpinDecrArrowClass)
#endif
#ifndef UxPutXrtSpinDecrArrowClass
#define UxPutXrtSpinDecrArrowClass(sw, val) \
	UxDDPutProp(sw, XmNxrtSpinDecrArrowClass, (XtArgVal)(val))
#endif

#ifndef UxGetXrtSpinField
#define UxGetXrtSpinField(sw) \
	(char *) UxDDGetProp(sw, XmNxrtSpinField)
#endif
#ifndef UxPutXrtSpinField
#define UxPutXrtSpinField(sw, val) \
	UxDDPutProp(sw, XmNxrtSpinField, (XtArgVal)(val))
#endif

#ifndef UxGetXrtSpinFieldClass
#define UxGetXrtSpinFieldClass(sw) \
	(char *) UxDDGetProp(sw, XmNxrtSpinFieldClass)
#endif
#ifndef UxPutXrtSpinFieldClass
#define UxPutXrtSpinFieldClass(sw, val) \
	UxDDPutProp(sw, XmNxrtSpinFieldClass, (XtArgVal)(val))
#endif

#ifndef UxGetXrtSpinFieldName
#define UxGetXrtSpinFieldName(sw) \
	(char *) UxDDGetProp(sw, XmNxrtSpinFieldName)
#endif
#ifndef UxPutXrtSpinFieldName
#define UxPutXrtSpinFieldName(sw, val) \
	UxDDPutProp(sw, XmNxrtSpinFieldName, (XtArgVal)(val))
#endif

#ifndef UxGetXrtSpinFieldType
#define UxGetXrtSpinFieldType(sw) \
	(char *) UxDDGetProp(sw, XmNxrtSpinFieldType)
#endif
#ifndef UxPutXrtSpinFieldType
#define UxPutXrtSpinFieldType(sw, val) \
	UxDDPutProp(sw, XmNxrtSpinFieldType, (XtArgVal)(val))
#endif

#ifndef UxGetXrtSpinIncrArrow
#define UxGetXrtSpinIncrArrow(sw) \
	(char *) UxDDGetProp(sw, XmNxrtSpinIncrArrow)
#endif
#ifndef UxPutXrtSpinIncrArrow
#define UxPutXrtSpinIncrArrow(sw, val) \
	UxDDPutProp(sw, XmNxrtSpinIncrArrow, (XtArgVal)(val))
#endif

#ifndef UxGetXrtSpinIncrArrowClass
#define UxGetXrtSpinIncrArrowClass(sw) \
	(char *) UxDDGetProp(sw, XmNxrtSpinIncrArrowClass)
#endif
#ifndef UxPutXrtSpinIncrArrowClass
#define UxPutXrtSpinIncrArrowClass(sw, val) \
	UxDDPutProp(sw, XmNxrtSpinIncrArrowClass, (XtArgVal)(val))
#endif
/* pds */ 
#ifndef UxGetXrtSpinSpacing
#define UxGetXrtSpinSpacing(sw) \
	(short) UxShortGetProp(sw, XmNxrtSpinSpacing)
#endif
#ifndef UxPutXrtSpinSpacing
#define UxPutXrtSpinSpacing(sw, val) \
	UxPutProp(sw, XmNxrtSpinSpacing, (XtArgVal)(val))
#endif

#ifndef UxGetXrtSpinType
#define UxGetXrtSpinType(sw) \
	(char *) UxDDGetProp(sw, XmNxrtSpinType)
#endif
#ifndef UxPutXrtSpinType
#define UxPutXrtSpinType(sw, val) \
	UxDDPutProp(sw, XmNxrtSpinType, (XtArgVal)(val))
#endif

/* Runtime create macro */
#ifndef UxCreateXrtSpinBox
#define UxCreateXrtSpinBox(name, parent) \
	UxCreateSwidget(name, xmXrtSpinBoxWidgetClass, parent)
#endif

#endif /* DESIGN_TIME */

#endif /* UXXRTSPINBOX_INCLUDED */

/***END*OF*FILE***************************************************************/
