/* ALL RIGHTS RESERVED
 *
 * This file is provided for demonstration and educational uses only.
 * Permission to use, copy, modify and distribute this file for
 * any purpose and without fee is hereby granted, provided that the
 * above copyright notice and this permission notice appear in all
 * copies, and that the name of KL Group not be used in advertising
 * or publicity pertaining to this material without the specific,
 * prior written permission of an authorized representative of
 * KL Group.
 *
 * KL GROUP MAKES NO REPRESENTATIONS AND EXTENDS NO WARRANTIES, EX-
 * PRESS OR IMPLIED, WITH RESPECT TO THE SOFTWARE, INCLUDING, BUT
 * NOT LIMITED TO, THE IMPLIED WARRANTIES OF MERCHANTABILITY AND
 * FITNESS FOR ANY PARTICULAR PURPOSE, AND THE WARRANTY AGAINST IN-
 * FRINGEMENT OF PATENTS OR OTHER INTELLECTUAL PROPERTY RIGHTS.  THE
 * SOFTWARE IS PROVIDED "AS IS", AND IN NO EVENT SHALL KL GROUP OR
 * ANY OF ITS AFFILIATES BE LIABLE FOR ANY DAMAGES, INCLUDING ANY
 * LOST PROFITS OR OTHER INCIDENTAL OR CONSEQUENTIAL DAMAGES
 * RELATING TO THE USE OF THIS SOFTWARE.
 *
 *
 * XRT/gear widget UIM/X integration file
 *
 *  SCCSID -- @(#)UxXrtTabB.hxx	1.4    97/02/26 KL Group Inc.
 */

#if defined(__cplusplus) && !defined(XT_CODE) && !defined(NO_UXBINDINGS)  && !defined(UIMX2_9)

class UxXrtTabB : public UxPushButton
{
    public:

	// Constructors
	UXINLINE UxXrtTabB(void);
	UXINLINE UxXrtTabB(const char*, swidget);

	// Initialisation
	UXINLINE swidget CreateSwidget (const char*, swidget);

	// Resource accessor functions
	UXINLINE char * GetXrtGearAnchorSide_TabB () const;
	UXINLINE void SetXrtGearAnchorSide_TabB (const char *);

	UXINLINE short GetXrtGearCornerSize_TabB () const;
	UXINLINE void SetXrtGearCornerSize_TabB (short);

	UXINLINE char * GetXrtGearLabelPixmap_TabB () const;
	UXINLINE void SetXrtGearLabelPixmap_TabB (const char *);

	UXINLINE char * GetXrtGearLabelType_TabB () const;
	UXINLINE void SetXrtGearLabelType_TabB (const char *);

	UXINLINE short GetXrtGearLayoutSpacing_TabB () const;
	UXINLINE void SetXrtGearLayoutSpacing_TabB (short);

	UXINLINE char * GetXrtGearMask_TabB () const;
	UXINLINE void SetXrtGearMask_TabB (const char *);

	UXINLINE char * GetXrtGearPixmapRotation_TabB () const;
	UXINLINE void SetXrtGearPixmapRotation_TabB (const char *);

	UXINLINE char * GetXrtGearStringLayout_TabB () const;
	UXINLINE void SetXrtGearStringLayout_TabB (const char *);

	UXINLINE char * GetXrtGearStyle_TabB () const;
	UXINLINE void SetXrtGearStyle_TabB (const char *);

	UXINLINE char * GetXrtGearStringRotation_TabB () const;
	UXINLINE void SetXrtGearStringRotation_TabB (const char *);

};

#ifdef DESIGN_TIME

#define XRTGEAR_TABB_TABLE(x)	xrtTabB_res_table[x].prpty, xrtTabB_res_table[x].name

extern Class_t UxC_XrtTabB;

#else /* (not DESIGN_TIME) */

#if defined(__alpha) && defined(__cplusplus)
#pragma message save
#pragma message disable narrowptr
#endif /* __alpha */

// Constructors
inline UxXrtTabB::UxXrtTabB(void){}
inline UxXrtTabB::UxXrtTabB(const char* name, swidget uXParent)
{
	CreateSwidget(name,uXParent);
}

// Initialisation
inline swidget UxXrtTabB::CreateSwidget (const char* name, swidget parent)
{
	if (UxThis == NULL)
		UxThis = UxCreateSwidget( (char *) name,
					  xmXrtTabButtonWidgetClass, parent);
	return UxThis;
}

inline char * UxXrtTabB::GetXrtGearAnchorSide_TabB (void) const
	{ return (char * ) DDGetProp(XmNxrtGearAnchorSide);}
inline void UxXrtTabB::SetXrtGearAnchorSide_TabB (const char * val)
	{ DDSetProp(XmNxrtGearAnchorSide, ((XtArgVal)(val)));}

inline short UxXrtTabB::GetXrtGearCornerSize_TabB (void) const
	{ return (short)ShortGetProp(XmNxrtGearCornerSize);}
inline void UxXrtTabB::SetXrtGearCornerSize_TabB (short val)
	{ SetProp(XmNxrtGearCornerSize, ((XtArgVal)(val)));}

inline char * UxXrtTabB::GetXrtGearLabelPixmap_TabB (void) const
	{ return (char * ) DDGetProp(XmNxrtGearLabelPixmap);}
inline void UxXrtTabB::SetXrtGearLabelPixmap_TabB (const char * val)
	{ DDSetProp(XmNxrtGearLabelPixmap, ((XtArgVal)(val)));}

inline char * UxXrtTabB::GetXrtGearLabelType_TabB (void) const
	{ return (char * ) DDGetProp(XmNxrtGearLabelType);}
inline void UxXrtTabB::SetXrtGearLabelType_TabB (const char * val)
	{ DDSetProp(XmNxrtGearLabelType, ((XtArgVal)(val)));}

inline short UxXrtTabB::GetXrtGearLayoutSpacing_TabB (void) const
	{ return (short) ShortGetProp(XmNxrtGearLayoutSpacing);}
inline void UxXrtTabB::SetXrtGearLayoutSpacing_TabB (short val)
	{ SetProp(XmNxrtGearLayoutSpacing, ((XtArgVal)(val)));}

inline char * UxXrtTabB::GetXrtGearMask_TabB (void) const
	{ return (char * ) DDGetProp(XmNxrtGearMask);}
inline void UxXrtTabB::SetXrtGearMask_TabB (const char * val)
	{ DDSetProp(XmNxrtGearMask, ((XtArgVal)(val)));}

inline char * UxXrtTabB::GetXrtGearPixmapRotation_TabB (void) const
	{ return (char * ) DDGetProp(XmNxrtGearPixmapRotation);}
inline void UxXrtTabB::SetXrtGearPixmapRotation_TabB (const char * val)
	{ DDSetProp(XmNxrtGearPixmapRotation, ((XtArgVal)(val)));}

inline char * UxXrtTabB::GetXrtGearStringLayout_TabB (void) const
	{ return (char * ) DDGetProp(XmNxrtGearStringLayout);}
inline void UxXrtTabB::SetXrtGearStringLayout_TabB (const char * val)
	{ DDSetProp(XmNxrtGearStringLayout, ((XtArgVal)(val)));}

inline char * UxXrtTabB::GetXrtGearStyle_TabB (void) const
	{ return (char * ) DDGetProp(XmNxrtGearStyle);}
inline void UxXrtTabB::SetXrtGearStyle_TabB (const char * val)
	{ DDSetProp(XmNxrtGearStyle, ((XtArgVal)(val)));}

inline char * UxXrtTabB::GetXrtGearStringRotation_TabB (void) const
	{ return (char * ) DDGetProp(XmNxrtGearStringRotation);}
inline void UxXrtTabB::SetXrtGearStringRotation_TabB (const char * val)
	{ DDSetProp(XmNxrtGearStringRotation, ((XtArgVal)(val)));}

#if defined(__alpha) && defined(__cplusplus)
#pragma message restore
#endif /* __alpha */

#endif /* DESIGN_TIME */
#endif /* __cplusplus */
