/* ALL RIGHTS RESERVED
 *
 * This file is provided for demonstration and educational uses only.
 * Permission to use, copy, modify and distribute this file for
 * any purpose and without fee is hereby granted, provided that the
 * above copyright notice and this permission notice appear in all
 * copies, and that the name of KL Group not be used in advertising
 * or publicity pertaining to this material without the specific,
 * prior written permission of an authorized representative of
 * KL Group.
 *
 * KL GROUP MAKES NO REPRESENTATIONS AND EXTENDS NO WARRANTIES, EX-
 * PRESS OR IMPLIED, WITH RESPECT TO THE SOFTWARE, INCLUDING, BUT
 * NOT LIMITED TO, THE IMPLIED WARRANTIES OF MERCHANTABILITY AND
 * FITNESS FOR ANY PARTICULAR PURPOSE, AND THE WARRANTY AGAINST IN-
 * FRINGEMENT OF PATENTS OR OTHER INTELLECTUAL PROPERTY RIGHTS.  THE
 * SOFTWARE IS PROVIDED "AS IS", AND IN NO EVENT SHALL KL GROUP OR
 * ANY OF ITS AFFILIATES BE LIABLE FOR ANY DAMAGES, INCLUDING ANY
 * LOST PROFITS OR OTHER INCIDENTAL OR CONSEQUENTIAL DAMAGES
 * RELATING TO THE USE OF THIS SOFTWARE.
 *
 *
 * XRT/3d widget UIM/X integration file
 *
 * $AstecId: Xrt3d_resnum.h,v 1.2 1999/10/09 17:53:40 nakayama Exp $
 *
 *  SCCSID -- @(#)Xrt3d.resnum.h	1.4    98/11/05 KL Group Inc.
 */

/******************************************************************************
				Xrt3d.resnum.h
******************************************************************************/

#ifndef XRT3D_RESNUM_H 
#define XRT3D_RESNUM_H

typedef enum {
  xrt3dResNumAxisStrokeFont,
  xrt3dResNumAxisStrokeSize,
  xrt3dResNumAxisTitleStrokeFont,
  xrt3dResNumAxisTitleStrokeSize,
  xrt3dResNumBackgroundColor,
  xrt3dResNumContourStyles,
  xrt3dResNumDataAreaBackgroundColor,
  xrt3dResNumDebug,
  xrt3dResNumDistnMethod,
  xrt3dResNumDistnTable,
  xrt3dResNumDoubleBuffer,
  xrt3dResNumDrawContours,
  xrt3dResNumDrawHiddenLines,
  xrt3dResNumDrawMesh,
  xrt3dResNumDrawShaded,
  xrt3dResNumDrawZones,
  xrt3dResNumExposeCallback,
  xrt3dResNumFooterAdjust,
  xrt3dResNumFooterBackgroundColor,
  xrt3dResNumFooterBorder,
  xrt3dResNumFooterBorderWidth,
  xrt3dResNumFooterFont,
  xrt3dResNumFooterForegroundColor,
  xrt3dResNumFooterHeight,
  xrt3dResNumFooterStrings,
  xrt3dResNumFooterWidth,
  xrt3dResNumFooterX,
  xrt3dResNumFooterXUseDefault,
  xrt3dResNumFooterY,
  xrt3dResNumFooterYUseDefault,
  xrt3dResNumForegroundColor,
  xrt3dResNumGraphBackgroundColor,
  xrt3dResNumGraphBorder,
  xrt3dResNumGraphBorderWidth,
  xrt3dResNumGraphForegroundColor,
  xrt3dResNumGraphHeight,
  xrt3dResNumGraphHeightUseDefault,
  xrt3dResNumGraphWidth,
  xrt3dResNumGraphWidthUseDefault,
  xrt3dResNumGraphX,
  xrt3dResNumGraphXUseDefault,
  xrt3dResNumGraphY,
  xrt3dResNumGraphYUseDefault,
  xrt3dResNumHeaderAdjust,
  xrt3dResNumHeaderBackgroundColor,
  xrt3dResNumHeaderBorder,
  xrt3dResNumHeaderBorderWidth,
  xrt3dResNumHeaderFont,
  xrt3dResNumHeaderForegroundColor,
  xrt3dResNumHeaderHeight,
  xrt3dResNumHeaderStrings,
  xrt3dResNumHeaderWidth,
  xrt3dResNumHeaderX,
  xrt3dResNumHeaderXUseDefault,
  xrt3dResNumHeaderY,
  xrt3dResNumHeaderYUseDefault,
  xrt3dResNumLegendAnchor,
  xrt3dResNumLegendBackgroundColor,
  xrt3dResNumLegendBorder,
  xrt3dResNumLegendBorderWidth,
  xrt3dResNumLegendFont,
  xrt3dResNumLegendForegroundColor,
  xrt3dResNumLegendHeight,
  xrt3dResNumLegendLabelFunc,
  xrt3dResNumLegendOrientation,
  xrt3dResNumLegendShow,
  xrt3dResNumLegendStrings,
  xrt3dResNumLegendStyle,
  xrt3dResNumLegendWidth,
  xrt3dResNumLegendX,
  xrt3dResNumLegendXUseDefault,
  xrt3dResNumLegendY,
  xrt3dResNumLegendYUseDefault,
  xrt3dResNumMapCallback,
  xrt3dResNumMeshBottomColor,
  xrt3dResNumMeshTopColor,
  xrt3dResNumModifyCallback,
  xrt3dResNumNumDistnLevels,
  xrt3dResNumPerspectiveDepth,
  xrt3dResNumPickCallback,
  xrt3dResNumPreviewMethod,
  xrt3dResNumProjectZMax,
  xrt3dResNumProjectZMin,
  xrt3dResNumRepaint,
  xrt3dResNumResizeCallback,
  xrt3dResNumRotateCallback,
  xrt3dResNumSolidSurface,
  xrt3dResNumSurfaceBottomColor,
  xrt3dResNumSurfaceData,
  xrt3dResNumSurfaceTopColor,
  xrt3dResNumTextList,
  xrt3dResNumTransformCallback,
  xrt3dResNumType,
  xrt3dResNumViewNormalized,
  xrt3dResNumViewScale,
  xrt3dResNumViewXTranslate,
  xrt3dResNumViewYTranslate,
  xrt3dResNumXAnnoMethod,
  xrt3dResNumXAxisShow,
  xrt3dResNumXAxisTitle,
  xrt3dResNumXBarFormat,
  xrt3dResNumXBarSpacing,
  xrt3dResNumXDataLabels,
  xrt3dResNumXGridLines,
  xrt3dResNumXMax,
  xrt3dResNumXMaxUseDefault,
  xrt3dResNumXMeshFilter,
  xrt3dResNumXMeshShow,
  xrt3dResNumXMin,
  xrt3dResNumXMinUseDefault,
  xrt3dResNumXRotation,
  xrt3dResNumXScale,
  xrt3dResNumXValueLabels,
  xrt3dResNumXYColors,
  xrt3dResNumYAnnoMethod,
  xrt3dResNumYAxisShow,
  xrt3dResNumYAxisTitle,
  xrt3dResNumYBarFormat,
  xrt3dResNumYBarSpacing,
  xrt3dResNumYDataLabels,
  xrt3dResNumYGridLines,
  xrt3dResNumYMax,
  xrt3dResNumYMaxUseDefault,
  xrt3dResNumYMeshFilter,
  xrt3dResNumYMeshShow,
  xrt3dResNumYMin,
  xrt3dResNumYMinUseDefault,
  xrt3dResNumYRotation,
  xrt3dResNumYScale,
  xrt3dResNumYValueLabels,
  xrt3dResNumZAnnoMethod,
  xrt3dResNumZAxisShow,
  xrt3dResNumZAxisTitle,
  xrt3dResNumZGridLines,
  xrt3dResNumZMax,
  xrt3dResNumZMaxUseDefault,
  xrt3dResNumZMin,
  xrt3dResNumZMinUseDefault,
  xrt3dResNumZOrigin,
  xrt3dResNumZRotation,
  xrt3dResNumZScale,
  xrt3dResNumZValueLabels,
  xrt3dResNumZoneData,
  xrt3dResNumZoneMethod,

  xrt3dResNumColorFunc,
  xrt3dResNumDataStyles,
  xrt3dResNumDataStylesUseDefault,
  xrt3dResNumDrawDropLines,
  xrt3dResNumFooterImage,
  xrt3dResNumFooterImageLayout,
  xrt3dResNumFooterImageMinimumSize,
  xrt3dResNumGraphImage,
  xrt3dResNumGraphImageLayout,
  xrt3dResNumHeaderImage,
  xrt3dResNumHeaderImageLayout,
  xrt3dResNumHeaderImageMinimumSize,
  xrt3dResNumImage,
  xrt3dResNumImageLayout,
  xrt3dResNumLegendDistnRange,
  xrt3dResNumLegendImage,
  xrt3dResNumLegendImageLayout,
  xrt3dResNumLegendLabelFilter,
  xrt3dResNumLegendTitle,
  xrt3dResNumXGridLineStyle,
  xrt3dResNumXGridLineStyleUseDefault,
  xrt3dResNumYGridLineStyle,
  xrt3dResNumYGridLineStyleUseDefault,
  xrt3dResNumZGridLineStyle,
  xrt3dResNumZGridLineStyleUseDefault,
	size_xrt3dResNum			/* holds number of enums defined */
	/* don't add new enums after size_xrt3dResNum*/
} Xrt3dResNum;

typedef enum {
  xrt3dTextResNumAdjust,
  xrt3dTextResNumAttachIndexX,
  xrt3dTextResNumAttachIndexY,
  xrt3dTextResNumAttachMethod,
  xrt3dTextResNumAttachPixelX,
  xrt3dTextResNumAttachPixelY,
  xrt3dTextResNumAttachPointX,
  xrt3dTextResNumAttachPointY,
  xrt3dTextResNumAttachPointZ,
  xrt3dTextResNumBackgroundColor,
  xrt3dTextResNumBorder,
  xrt3dTextResNumBorderWidth,
  xrt3dTextResNumFont,
  xrt3dTextResNumForegroundColor,
  xrt3dTextResNumLineShow,
  xrt3dTextResNumOffsetX,
  xrt3dTextResNumOffsetY,
  xrt3dTextResNumPrintFont,
  xrt3dTextResNumPlane,
  xrt3dTextResNumShow,
  xrt3dTextResNumStrings,
  xrt3dTextResNumStrokeFont,
  xrt3dTextResNumStrokeSize,

  xrt3dTextResNumAttachIndexPoint,
  xrt3dTextResNumAttachIndexSeries,
  xrt3dTextResNumImage,
  xrt3dTextResNumImageLayout,
  xrt3dTextResNumImageMinimumSize,
	size_xrt3dTextResNum			/* holds number of enums defined */
	/* don't add new enums after size_xrt3dResNum*/
} Xrt3dTextResNum;

#endif
