/* ALL RIGHTS RESERVED
 *
 * This file is provided for demonstration and educational uses only.
 * Permission to use, copy, modify and distribute this file for
 * any purpose and without fee is hereby granted, provided that the
 * above copyright notice and this permission notice appear in all
 * copies, and that the name of KL Group not be used in advertising
 * or publicity pertaining to this material without the specific,
 * prior written permission of an authorized representative of
 * KL Group.
 *
 * KL GROUP MAKES NO REPRESENTATIONS AND EXTENDS NO WARRANTIES, EX-
 * PRESS OR IMPLIED, WITH RESPECT TO THE SOFTWARE, INCLUDING, BUT
 * NOT LIMITED TO, THE IMPLIED WARRANTIES OF MERCHANTABILITY AND
 * FITNESS FOR ANY PARTICULAR PURPOSE, AND THE WARRANTY AGAINST IN-
 * FRINGEMENT OF PATENTS OR OTHER INTELLECTUAL PROPERTY RIGHTS.  THE
 * SOFTWARE IS PROVIDED "AS IS", AND IN NO EVENT SHALL KL GROUP OR
 * ANY OF ITS AFFILIATES BE LIABLE FOR ANY DAMAGES, INCLUDING ANY
 * LOST PROFITS OR OTHER INCIDENTAL OR CONSEQUENTIAL DAMAGES
 * RELATING TO THE USE OF THIS SOFTWARE.
 *
 *
 * XRT/field widget UIM/X integration file
 *
 *  SCCSID -- @(#)XrtFld.cl.h	1.9    99/01/29 KL Group Inc.
 */

/******************************************************************************
				XrtFld.cl.h
******************************************************************************/

#ifndef XRTFLD_CL_H
#define XRTFLD_CL_H

#include "text.cl.h"	/* swidget-superclass header file */
#include "mgr.cl.h"

/*  Definitions for UxXrtFldManagerPart  */
typedef struct UxXrtFldManagerPart {
	int mumble;
} UxXrtFldManagerPart;

/* Definitions for XrtFldManager */
typedef struct xrtFldManager
{
	UxObjectPart    		objectPart;
	UxVeditablePart 		veditablePart;
	UxShadowWidgetPart  	ShadowWidgetPart;
	UxRectObjectPart    	RectObjectPart;
	UxCorePart      		CorePart;
	UxCompositeClassPart	CompositePart;
	UxManagerClassPart		ManagerPart;
	UxXrtFldManagerPart		XrtFldManagerPart;
} xrtFldManager;

typedef	struct	UxXrtFldManagerClassPart
{
	int	mumble;		/* Just in case */
} UxXrtFldManagerClassPart;

typedef	struct UxXrtFldManagerClass
{
	UxObjectClassPart			object;
	UxVeditableClassPart		veditble;
	UxShadowWidgetClassPart		ShadowWidget;
	UxRectObjectClassPart		RectObject;
	UxCoreClassPart				Core;
	UxCompositeClassPart		Composite;
	UxManagerClassPart			manager;
	UxXrtFldManagerClassPart		XrtFldManager;
} UxXrtFldManagerClass;

/*  Definitions for UxXrtFieldPart  */
typedef struct UxXrtFieldPart {
	int mumble;
} UxXrtFieldPart;

/*  Definitions for UxXrtFloatFieldPart  */
typedef struct UxXrtFloatFieldPart {
	int mumble;
} UxXrtFloatFieldPart;

/* Definitions for XrtField */
typedef struct xrtfield
{
	UxObjectPart    	objectPart;
	UxVeditablePart 	veditablePart;
	UxShadowWidgetPart  ShadowWidgetPart;
	UxRectObjectPart    RectObjectPart;
	UxCorePart      	CorePart;
	UxPrimitivePart 	primitivePart;
	UxTextPart      	textPart;
	UxXrtFieldPart		xrtfieldPart;
} xrtField;

/* Definitions for XrtFloatField */
typedef struct xrtfloatfield
{
	UxObjectPart    	objectPart;
	UxVeditablePart 	veditablePart;
	UxShadowWidgetPart  ShadowWidgetPart;
	UxRectObjectPart    RectObjectPart;
	UxCorePart      	CorePart;
	UxPrimitivePart 	primitivePart;
	UxTextPart      	textPart;
	UxXrtFieldPart		xrtfieldPart;
	UxXrtFloatFieldPart	xrtfloatfieldPart;
} xrtFloatField;

typedef	struct	UxXrtFieldClassPart
{
	Resource_t		*RD_xrtFldAllowNull;
	Resource_t		*RD_xrtFldCase;
	Resource_t		*RD_xrtFldCompleteCallback;
	Resource_t		*RD_xrtFldConvertCallback;
	Resource_t		*RD_xrtFldDefaultBackground;
	Resource_t		*RD_xrtFldDefaultForeground;
	Resource_t		*RD_xrtFldDisplayFormat;
	Resource_t		*RD_xrtFldDisplayFormatString;
	Resource_t		*RD_xrtFldDisplayHorizScrollBar;
	Resource_t		*RD_xrtFldDisplayVertScrollBar;
	Resource_t		*RD_xrtFldEditFormat;
	Resource_t		*RD_xrtFldEnterCallback;
	Resource_t		*RD_xrtFldErrorBackground;
	Resource_t		*RD_xrtFldErrorCallback;
	Resource_t		*RD_xrtFldErrorForeground;
	Resource_t		*RD_xrtFldErrorString;
	Resource_t		*RD_xrtFldExitCallback;
	Resource_t		*RD_xrtFldInvalidChars;
	Resource_t		*RD_xrtFldIsDefault;
	Resource_t		*RD_xrtFldIsModified;
	Resource_t		*RD_xrtFldIsValid;
	Resource_t		*RD_xrtFldLastError;
	Resource_t		*RD_xrtFldMask;
	Resource_t		*RD_xrtFldMaskChars;
	Resource_t		*RD_xrtFldMatchMask;
	Resource_t		*RD_xrtFldMatchPickList;
	Resource_t		*RD_xrtFldMaxLineLength;
	Resource_t		*RD_xrtFldMaxLines;
	Resource_t		*RD_xrtFldMenuAlignment; 
	Resource_t		*RD_xrtFldMenuCallback;
	Resource_t		*RD_xrtFldMenuList;
	Resource_t		*RD_xrtFldOverstrike;
	Resource_t		*RD_xrtFldPickListIndex;
	Resource_t		*RD_xrtFldPromptString;
	Resource_t		*RD_xrtFldRange;
	Resource_t		*RD_xrtFldSearchPolicy; 
	Resource_t		*RD_xrtFldSpinCallback;
	Resource_t		*RD_xrtFldValidChars;
	Resource_t		*RD_xrtFldValidateCallback;
	Resource_t		*RD_xrtFldVisibleItemCount;
	/*new*/
	Resource_t		*RD_xrtFldAutoComplete;
	Resource_t		*RD_xrtFldCreatePopups;
	Resource_t		*RD_xrtFldPopupType;
	int	mumble;		/* Just in case */
} UxXrtFieldClassPart;

typedef	struct	UxXrtStringFieldClassPart
{
	Resource_t		*RD_xrtFldDefaultValue;
	Resource_t		*RD_xrtFldInternalValue;
	Resource_t		*RD_xrtFldMax;
	Resource_t		*RD_xrtFldMin;
	Resource_t		*RD_xrtFldPickList;
	int	mumble;		/* Just in case */
} UxXrtStringFieldClassPart;

typedef	struct	UxXrtDateFieldClassPart
{
	Resource_t		*RD_xrtFldCounterIncrement;
	Resource_t		*RD_xrtFldDefaultValue;
	Resource_t		*RD_xrtFldDisplayFormatString;
	Resource_t		*RD_xrtFldEnterFormatList;
	Resource_t		*RD_xrtFldInternalValue;
	Resource_t		*RD_xrtFldInternalValueLong;
	Resource_t		*RD_xrtFldMax;
	Resource_t		*RD_xrtFldMilleniumThreshold; 
	Resource_t		*RD_xrtFldMin;
	Resource_t		*RD_xrtFldPickList;
	/*new*/
	Resource_t		*RD_xrtFldCalendar;
	Resource_t		*RD_xrtFldCalendarCallback;
	Resource_t		*RD_xrtFldSpinPolicy;
	int	mumble;		/* Just in case */
} UxXrtDateFieldClassPart;

typedef	struct	UxXrtFloatFieldClassPart
{
	Resource_t		*RD_xrtFldCounterIncrement;
	Resource_t		*RD_xrtFldDecimalPlaces;
	Resource_t		*RD_xrtFldDefaultValue;
	Resource_t		*RD_xrtFldDisplayFormatString;
	Resource_t		*RD_xrtFldInternalValue;
	Resource_t		*RD_xrtFldLeadingZero;
	Resource_t		*RD_xrtFldMax;
	Resource_t		*RD_xrtFldMin;
	Resource_t		*RD_xrtFldNegativeFormat;
	Resource_t		*RD_xrtFldPickList;
	int	mumble;		/* Just in case */
} UxXrtFloatFieldClassPart;

typedef	struct	UxXrtCurrencyFieldClassPart
{
	int	mumble;		/* Just in case */
} UxXrtCurrencyFieldClassPart;

typedef	struct	UxXrtIntFieldClassPart
{
	Resource_t		*RD_xrtFldCounterIncrement;
	Resource_t		*RD_xrtFldDefaultValue;
	Resource_t		*RD_xrtFldDisplayFormatString;
	Resource_t		*RD_xrtFldInternalValue;
	Resource_t		*RD_xrtFldMax;
	Resource_t		*RD_xrtFldMin;
	Resource_t		*RD_xrtFldNegativeFormat;
	Resource_t		*RD_xrtFldPickList;
	int	mumble;		/* Just in case */
} UxXrtIntFieldClassPart;

typedef	struct	UxXrtComboBoxClassPart
{
	Resource_t		*RD_xrtComboArrow;
	Resource_t		*RD_xrtComboArrowClass;
	Resource_t		*RD_xrtComboArrowType; 
	Resource_t		*RD_xrtComboField;
	Resource_t		*RD_xrtComboFieldClass;
	Resource_t		*RD_xrtComboFieldType;
	Resource_t		*RD_xrtComboSpacing;  
	int	mumble;		/* Just in case */
} UxXrtComboBoxClassPart;

typedef	struct	UxXrtSpinBoxClassPart
{
	Resource_t		*RD_xrtSpinArrowLayout;
	Resource_t		*RD_xrtSpinArrowOrientation;
	Resource_t		*RD_xrtSpinArrowType; 
	Resource_t		*RD_xrtSpinDecrArrow;
	Resource_t		*RD_xrtSpinDecrArrowClass;
	Resource_t		*RD_xrtSpinField;
	Resource_t		*RD_xrtSpinFieldClass;
	Resource_t		*RD_xrtSpinFieldName;
	Resource_t		*RD_xrtSpinFieldType;
	Resource_t		*RD_xrtSpinIncrArrow;
	Resource_t		*RD_xrtSpinIncrArrowClass;
	Resource_t		*RD_xrtSpinSpacing;  
	Resource_t		*RD_xrtSpinType;
	int	mumble;		/* Just in case */
} UxXrtSpinBoxClassPart;

typedef	struct	UxXrtCalendarClassPart
{
	Resource_t		*RD_xrtCalendarCellMargin;
	Resource_t		*RD_xrtCalendarCellHighlightColor;
	Resource_t		*RD_xrtCalendarCellHighlightThickness;
	Resource_t		*RD_xrtCalendarCreateMonth;
	Resource_t		*RD_xrtCalendarCreateTime;
	Resource_t		*RD_xrtCalendarCreateYear;
	Resource_t		*RD_xrtCalendarEnabled;
	Resource_t		*RD_xrtCalendarFirstDayOfWeek;
	Resource_t		*RD_xrtCalendarFullWeekdayNames;
	Resource_t		*RD_xrtCalendarHeaderNumChars;
	Resource_t		*RD_xrtCalendarHeaderBackground;
	Resource_t		*RD_xrtCalendarHeaderFontList;
	Resource_t		*RD_xrtCalendarHeaderForeground;
	Resource_t		*RD_xrtCalendarMarginBottom;
	Resource_t		*RD_xrtCalendarMarginLeft;
	Resource_t		*RD_xrtCalendarMarginRight;
	Resource_t		*RD_xrtCalendarMarginTop;
	Resource_t		*RD_xrtCalendarMaxRollDate;
	Resource_t		*RD_xrtCalendarMinRollDate;
	Resource_t		*RD_xrtCalendarModifyCallback ;
	Resource_t		*RD_xrtCalendarSpecialDayBackground;
	Resource_t		*RD_xrtCalendarSpecialDayForeground;
	Resource_t		*RD_xrtCalendarSpecialDays;
	Resource_t		*RD_xrtCalendarSelectedBackground;
	Resource_t		*RD_xrtCalendarSelectedForeground;
	Resource_t		*RD_xrtCalendarValue;
	Resource_t		*RD_xrtCalendarValueLong;
	int	mumble;		/* Just in case */
} UxXrtCalendarClassPart;

/*
 *	Define classes for each widget
 */

typedef	struct UxXrtFieldClass
{
	UxObjectClassPart			object;
	UxVeditableClassPart		veditble;
	UxShadowWidgetClassPart		ShadowWidget;
	UxRectObjectClassPart		RectObject;
	UxCoreClassPart				Core;
	UxPrimitiveClassPart		primitive;
	UxTextClassPart				text;
	UxXrtFieldClassPart			XrtField;
} UxXrtFieldClass;

typedef	struct UxXrtStringFieldClass
{
	UxObjectClassPart			object;
	UxVeditableClassPart		veditble;
	UxShadowWidgetClassPart		ShadowWidget;
	UxRectObjectClassPart		RectObject;
	UxCoreClassPart				Core;
	UxPrimitiveClassPart		primitive;
	UxTextClassPart				text;
	UxXrtFieldClassPart			XrtField;
	UxXrtStringFieldClassPart	XrtStringField;
} UxXrtStringFieldClass;

typedef	struct UxXrtDateFieldClass
{
	UxObjectClassPart			object;
	UxVeditableClassPart		veditble;
	UxShadowWidgetClassPart		ShadowWidget;
	UxRectObjectClassPart		RectObject;
	UxCoreClassPart				Core;
	UxPrimitiveClassPart		primitive;
	UxTextClassPart				text;
	UxXrtFieldClassPart			XrtField;
	UxXrtDateFieldClassPart		XrtDateField;
} UxXrtDateFieldClass;

typedef	struct UxXrtFloatFieldClass
{
	UxObjectClassPart			object;
	UxVeditableClassPart		veditble;
	UxShadowWidgetClassPart		ShadowWidget;
	UxRectObjectClassPart		RectObject;
	UxCoreClassPart				Core;
	UxPrimitiveClassPart		primitive;
	UxTextClassPart				text;
	UxXrtFieldClassPart			XrtField;
	UxXrtFloatFieldClassPart	XrtFloatField;
} UxXrtFloatFieldClass;

typedef	struct UxXrtCurrencyFieldClass
{
	UxObjectClassPart			object;
	UxVeditableClassPart		veditble;
	UxShadowWidgetClassPart		ShadowWidget;
	UxRectObjectClassPart		RectObject;
	UxCoreClassPart				Core;
	UxPrimitiveClassPart		primitive;
	UxTextClassPart				text;
	UxXrtFieldClassPart			XrtField;
	UxXrtFloatFieldClassPart	XrtFloatField;
	UxXrtCurrencyFieldClassPart	XrtIntField;
} UxXrtCurrencyFieldClass;

typedef	struct UxXrtIntFieldClass
{
	UxObjectClassPart			object;
	UxVeditableClassPart		veditble;
	UxShadowWidgetClassPart		ShadowWidget;
	UxRectObjectClassPart		RectObject;
	UxCoreClassPart				Core;
	UxPrimitiveClassPart		primitive;
	UxTextClassPart				text;
	UxXrtFieldClassPart			XrtField;
	UxXrtIntFieldClassPart		XrtIntField;
} UxXrtIntFieldClass;

typedef	struct UxXrtComboBoxClass
{
	UxObjectClassPart			object;
	UxVeditableClassPart		veditble;
	UxShadowWidgetClassPart		ShadowWidget;
	UxRectObjectClassPart		RectObject;
	UxCoreClassPart				Core;
	UxCompositeClassPart		composite;
	UxManagerClassPart			manager;
	UxXrtFldManagerClassPart	XrtFldManager;
	UxXrtComboBoxClassPart		XrtComboBox;
} UxXrtComboBoxClass;

typedef	struct UxXrtSpinBoxClass
{
	UxObjectClassPart			object;
	UxVeditableClassPart		veditble;
	UxShadowWidgetClassPart		ShadowWidget;
	UxRectObjectClassPart		RectObject;
	UxCoreClassPart				Core;
	UxCompositeClassPart		composite;
	UxManagerClassPart			manager;
	UxXrtFldManagerClassPart	XrtFldManager;
	UxXrtSpinBoxClassPart		XrtSpinBox;
} UxXrtSpinBoxClass;

typedef	struct UxXrtCalendarClass
{
	UxObjectClassPart			object;
	UxVeditableClassPart		veditble;
	UxShadowWidgetClassPart		ShadowWidget;
	UxRectObjectClassPart		RectObject;
	UxCoreClassPart				Core;
	UxCompositeClassPart		composite;
	UxManagerClassPart			manager;
	UxXrtFldManagerClassPart	XrtFldManager;
	UxXrtCalendarClassPart		XrtCalendar;
} UxXrtCalendarClass;



/* Definition of the XrtField instance structure
   (there are no instance properties so the XrtField instance structure
    is the same as the text instance structure) */

typedef	manager			UxXrtFldManager;

typedef text			UxXrtField;
typedef xrtField		UxXrtStringField;
typedef xrtField		UxXrtDateField;
typedef xrtField		UxXrtFloatField;
typedef xrtFloatField	UxXrtCurrencyField;
typedef xrtField		UxXrtIntField;
typedef xrtFldManager	UxXrtComboBox;
typedef xrtFldManager	UxXrtSpinBox;
typedef xrtFldManager	UxXrtCalendar;

/* Declarations of global variables for XrtField class */

extern Class_t		UxC_XrtFldManager; /*base class*/

extern Class_t		UxC_XrtField;
extern Class_t		UxC_XrtStringField;
extern Class_t		UxC_XrtDateField;
extern Class_t		UxC_XrtFloatField;
extern Class_t		UxC_XrtCurrencyField;
extern Class_t		UxC_XrtIntField;
extern Class_t		UxC_XrtComboBox;
extern Class_t		UxC_XrtSpinBox;
extern Class_t		UxC_XrtCalendar;

#include "Xrt_restable.h"

#ifndef UxGetRD_xrtComboFieldType
#define UxGetRD_xrtComboFieldType(o) (Resource_t*)UxPNTR_get_prop(o, xrtfldcmb_res_table[xrtFldResNumComboFieldType].prpty)
#endif

#ifndef UxGetRD_xrtSpinFieldType
#define UxGetRD_xrtSpinFieldType(o) (Resource_t*)UxPNTR_get_prop(o, xrtfldspn_res_table[xrtFldResNumSpinFieldType].prpty)
#endif

#endif /* XRTFLD_CL_H */
