/* ALL RIGHTS RESERVED
 *
 * This file is provided for demonstration and educational uses only.
 * Permission to use, copy, modify and distribute this file for
 * any purpose and without fee is hereby granted, provided that the
 * above copyright notice and this permission notice appear in all
 * copies, and that the name of KL Group not be used in advertising
 * or publicity pertaining to this material without the specific,
 * prior written permission of an authorized representative of
 * KL Group.
 *
 * KL GROUP MAKES NO REPRESENTATIONS AND EXTENDS NO WARRANTIES, EX-
 * PRESS OR IMPLIED, WITH RESPECT TO THE SOFTWARE, INCLUDING, BUT
 * NOT LIMITED TO, THE IMPLIED WARRANTIES OF MERCHANTABILITY AND
 * FITNESS FOR ANY PARTICULAR PURPOSE, AND THE WARRANTY AGAINST IN-
 * FRINGEMENT OF PATENTS OR OTHER INTELLECTUAL PROPERTY RIGHTS.  THE
 * SOFTWARE IS PROVIDED "AS IS", AND IN NO EVENT SHALL KL GROUP OR
 * ANY OF ITS AFFILIATES BE LIABLE FOR ANY DAMAGES, INCLUDING ANY
 * LOST PROFITS OR OTHER INCIDENTAL OR CONSEQUENTIAL DAMAGES
 * RELATING TO THE USE OF THIS SOFTWARE.
 *
 *
 * XRT/graph widget UIM/X integration file
 *
 * $AstecId: XrtGph.cl.h,v 1.2 1999/10/09 17:53:40 nakayama Exp $
 *
 *  SCCSID -- @(#)XrtGph.cl.h	1.3    98/11/05 KL Group Inc.
 */

/******************************************************************************
				XrtGph.cl.h
******************************************************************************/

#ifndef XRTGPH_CL_H
#define XRTGPH_CL_H

#include "prim.cl.h"	/* swidget-superclass header file */

typedef	struct	UxXrtGraphClassPart
{
	Resource_t		*RD_xrtAngleUnit; 
	Resource_t		*RD_xrtAxisBoundingBox;
	Resource_t		*RD_xrtAxisFont;
	Resource_t		*RD_xrtBackgroundColor;
	Resource_t		*RD_xrtBarClusterOverlap;
	Resource_t		*RD_xrtBarClusterWidth;
	Resource_t		*RD_xrtBorder; 
	Resource_t		*RD_xrtCandleComplex; 
	Resource_t		*RD_xrtData;
	Resource_t		*RD_xrtData2;
	Resource_t		*RD_xrtDataAreaBackgroundColor;
	Resource_t		*RD_xrtDataAreaForegroundColor; 
	Resource_t		*RD_xrtDataStyles;
	Resource_t		*RD_xrtDataStyles2;
	Resource_t		*RD_xrtDataStyles2UseDefault;
	Resource_t		*RD_xrtDataStylesUseDefault;
	Resource_t		*RD_xrtDebug;
	Resource_t		*RD_xrtDoubleBuffer;
	Resource_t		*RD_xrtExposeCallback;
	Resource_t		*RD_xrtFooterAdjust;
	Resource_t		*RD_xrtFooterBackgroundColor;
	Resource_t		*RD_xrtFooterBorder;
	Resource_t		*RD_xrtFooterBorderWidth;
	Resource_t		*RD_xrtFooterFont;
	Resource_t		*RD_xrtFooterForegroundColor;
	Resource_t		*RD_xrtFooterHeight;
	Resource_t		*RD_xrtFooterStrings;
	Resource_t		*RD_xrtFooterWidth;
	Resource_t		*RD_xrtFooterX;
	Resource_t		*RD_xrtFooterXUseDefault;
	Resource_t		*RD_xrtFooterY;
	Resource_t		*RD_xrtFooterYUseDefault;
	Resource_t		*RD_xrtForegroundColor;
	Resource_t		*RD_xrtFrontDataset;
	Resource_t		*RD_xrtGraph3dShading; 
	Resource_t		*RD_xrtGraphBackgroundColor;
	Resource_t		*RD_xrtGraphBorder;
	Resource_t		*RD_xrtGraphBorderWidth;
	Resource_t		*RD_xrtGraphDepth;
	Resource_t		*RD_xrtGraphForegroundColor;
	Resource_t		*RD_xrtGraphHeight;
	Resource_t		*RD_xrtGraphHeightUseDefault;
	Resource_t		*RD_xrtGraphInclination;
	Resource_t		*RD_xrtGraphMarginBottom;
	Resource_t		*RD_xrtGraphMarginBottomUseDefault;
	Resource_t		*RD_xrtGraphMarginLeft;
	Resource_t		*RD_xrtGraphMarginLeftUseDefault;
	Resource_t		*RD_xrtGraphMarginRight;
	Resource_t		*RD_xrtGraphMarginRightUseDefault;
	Resource_t		*RD_xrtGraphMarginTop;
	Resource_t		*RD_xrtGraphMarginTopUseDefault;
	Resource_t		*RD_xrtGraphRotation;
	Resource_t		*RD_xrtGraphShowOutlines; 
	Resource_t		*RD_xrtGraphWidth;
	Resource_t		*RD_xrtGraphWidthUseDefault;
	Resource_t		*RD_xrtGraphX;
	Resource_t		*RD_xrtGraphXUseDefault;
	Resource_t		*RD_xrtGraphY;
	Resource_t		*RD_xrtGraphYUseDefault;
	Resource_t		*RD_xrtHeaderAdjust;
	Resource_t		*RD_xrtHeaderBackgroundColor;
	Resource_t		*RD_xrtHeaderBorder;
	Resource_t		*RD_xrtHeaderBorderWidth;
	Resource_t		*RD_xrtHeaderFont;
	Resource_t		*RD_xrtHeaderForegroundColor;
	Resource_t		*RD_xrtHeaderHeight;
	Resource_t		*RD_xrtHeaderStrings;
	Resource_t		*RD_xrtHeaderWidth;
	Resource_t		*RD_xrtHeaderX;
	Resource_t		*RD_xrtHeaderXUseDefault;
	Resource_t		*RD_xrtHeaderY;
	Resource_t		*RD_xrtHeaderYUseDefault;
	Resource_t		*RD_xrtHiLoCloseShow; 
	Resource_t		*RD_xrtHiLoOpenCloseFullWidth; 
	Resource_t		*RD_xrtHiLoOpenShow; 
	Resource_t		*RD_xrtInvertOrientation;
	Resource_t		*RD_xrtLegendAnchor;
	Resource_t		*RD_xrtLegendBackgroundColor;
	Resource_t		*RD_xrtLegendBorder;
	Resource_t		*RD_xrtLegendBorderWidth;
	Resource_t		*RD_xrtLegendFont;
	Resource_t		*RD_xrtLegendForegroundColor;
	Resource_t		*RD_xrtLegendHeight;
	Resource_t		*RD_xrtLegendOrientation;
	Resource_t		*RD_xrtLegendShow;
	Resource_t		*RD_xrtLegendWidth;
	Resource_t		*RD_xrtLegendX;
	Resource_t		*RD_xrtLegendXUseDefault;
	Resource_t		*RD_xrtLegendY;
	Resource_t		*RD_xrtLegendYUseDefault;
	Resource_t		*RD_xrtMapCallback;
	Resource_t		*RD_xrtMarkerDataStyle;
	Resource_t		*RD_xrtMarkerDataStyleUseDefault;
	Resource_t		*RD_xrtMarkerDataset;
	Resource_t		*RD_xrtModifyCallback;
	Resource_t		*RD_xrtOtherDataStyle;
	Resource_t		*RD_xrtOtherDataStyleUseDefault;
	Resource_t		*RD_xrtOtherLabel;
	Resource_t		*RD_xrtPickCallback;
	Resource_t		*RD_xrtPieMinSlices;
	Resource_t		*RD_xrtPieOrder;
	Resource_t		*RD_xrtPieThresholdMethod;
	Resource_t		*RD_xrtPieThresholdValue;
	Resource_t		*RD_xrtPointLabels;
	Resource_t		*RD_xrtPointLabels2;
	Resource_t		*RD_xrtPolarHalfRange; 
	Resource_t		*RD_xrtRepaint;
	Resource_t		*RD_xrtResizeCallback;
	Resource_t		*RD_xrtRotateCallback;
	Resource_t		*RD_xrtSetLabels;
	Resource_t		*RD_xrtSetLabels2;
	Resource_t		*RD_xrtTimeBase;
	Resource_t		*RD_xrtTimeFormat;
	Resource_t		*RD_xrtTimeFormatUseDefault;
	Resource_t		*RD_xrtTimeUnit;
	Resource_t		*RD_xrtTransformCallback;
	Resource_t		*RD_xrtType;
	Resource_t		*RD_xrtType2;
	Resource_t		*RD_xrtXAnnoPlacement;
	Resource_t		*RD_xrtXAnnotationMethod;
	Resource_t		*RD_xrtXAnnotationRotation;
	Resource_t		*RD_xrtXAxisLabelFormat; 
	Resource_t		*RD_xrtXAxisLogarithmic;
	Resource_t		*RD_xrtXAxisMax;
	Resource_t		*RD_xrtXAxisMaxUseDefault;
	Resource_t		*RD_xrtXAxisMin;
	Resource_t		*RD_xrtXAxisMinUseDefault;
	Resource_t		*RD_xrtXAxisReversed;
	Resource_t		*RD_xrtXAxisShow;
	Resource_t		*RD_xrtXGrid;
	Resource_t		*RD_xrtXGridDataStyle;
	Resource_t		*RD_xrtXGridDataStyleUseDefault;
	Resource_t		*RD_xrtXGridUseDefault;
	Resource_t		*RD_xrtXLabels;
	Resource_t		*RD_xrtXMarker;
	Resource_t		*RD_xrtXMarkerDataStyle; 
	Resource_t		*RD_xrtXMarkerDataStyleUseDefault; 
	Resource_t		*RD_xrtXMarkerMethod; 
	Resource_t		*RD_xrtXMarkerPoint;
	Resource_t		*RD_xrtXMarkerSet;
	Resource_t		*RD_xrtXMarkerShow;
	Resource_t		*RD_xrtXMax;
	Resource_t		*RD_xrtXMaxUseDefault;
	Resource_t		*RD_xrtXMin;
	Resource_t		*RD_xrtXMinUseDefault;
	Resource_t		*RD_xrtXNum;
	Resource_t		*RD_xrtXNumMethod;
	Resource_t		*RD_xrtXNumUseDefault;
	Resource_t		*RD_xrtXOrigin;
	Resource_t		*RD_xrtXOriginBase; 
	Resource_t		*RD_xrtXOriginPlacement;
	Resource_t		*RD_xrtXOriginUseDefault;
	Resource_t		*RD_xrtXPrecision;
	Resource_t		*RD_xrtXPrecisionUseDefault;
	Resource_t		*RD_xrtXTick;
	Resource_t		*RD_xrtXTickUseDefault;
	Resource_t		*RD_xrtXTitle;
	Resource_t		*RD_xrtXTitleRotation;
	Resource_t		*RD_xrtY2AnnoPlacement; 
	Resource_t		*RD_xrtY2AnnotationAngle; 
	Resource_t		*RD_xrtY2AnnotationAngleUseDefault; 
	Resource_t		*RD_xrtY2AnnotationMethod;
	Resource_t		*RD_xrtY2AnnotationRotation;
	Resource_t		*RD_xrtY2Axis100Percent; 
	Resource_t		*RD_xrtY2AxisLabelFormat; 
	Resource_t		*RD_xrtY2AxisLogarithmic;
	Resource_t		*RD_xrtY2AxisMax;
	Resource_t		*RD_xrtY2AxisMaxUseDefault;
	Resource_t		*RD_xrtY2AxisMin;
	Resource_t		*RD_xrtY2AxisMinUseDefault;
	Resource_t		*RD_xrtY2AxisReversed;
	Resource_t		*RD_xrtY2AxisShow;
	Resource_t		*RD_xrtY2Grid; 
	Resource_t		*RD_xrtY2GridDataStyle; 
	Resource_t		*RD_xrtY2GridDataStyleUseDefault; 
	Resource_t		*RD_xrtY2GridUseDefault; 
	Resource_t		*RD_xrtY2Labels;
	Resource_t		*RD_xrtY2Max;
	Resource_t		*RD_xrtY2MaxUseDefault;
	Resource_t		*RD_xrtY2Min;
	Resource_t		*RD_xrtY2MinUseDefault;
	Resource_t		*RD_xrtY2Num;
	Resource_t		*RD_xrtY2NumMethod;
	Resource_t		*RD_xrtY2NumUseDefault;
	Resource_t		*RD_xrtY2Origin; 
	Resource_t		*RD_xrtY2OriginPlacement; 
	Resource_t		*RD_xrtY2OriginUseDefault; 
	Resource_t		*RD_xrtY2Precision;
	Resource_t		*RD_xrtY2PrecisionUseDefault;
	Resource_t		*RD_xrtY2Tick;
	Resource_t		*RD_xrtY2TickUseDefault;
	Resource_t		*RD_xrtY2Title;
	Resource_t		*RD_xrtY2TitleRotation;
	Resource_t		*RD_xrtYAnnoPlacement;
	Resource_t		*RD_xrtYAnnotationAngle; 
	Resource_t		*RD_xrtYAnnotationAngleUseDefault; 
	Resource_t		*RD_xrtYAnnotationMethod;
	Resource_t		*RD_xrtYAnnotationRotation;
	Resource_t		*RD_xrtYAxis100Percent; 
	Resource_t		*RD_xrtYAxisConst;
	Resource_t		*RD_xrtYAxisLabelFormat; 
	Resource_t		*RD_xrtYAxisLogarithmic;
	Resource_t		*RD_xrtYAxisMax;
	Resource_t		*RD_xrtYAxisMaxUseDefault;
	Resource_t		*RD_xrtYAxisMin;
	Resource_t		*RD_xrtYAxisMinUseDefault;
	Resource_t		*RD_xrtYAxisMult;
	Resource_t		*RD_xrtYAxisReversed;
	Resource_t		*RD_xrtYAxisShow;
	Resource_t		*RD_xrtYGrid;
	Resource_t		*RD_xrtYGridDataStyle;
	Resource_t		*RD_xrtYGridDataStyleUseDefault;
	Resource_t		*RD_xrtYGridUseDefault;
	Resource_t		*RD_xrtYLabels;
	Resource_t		*RD_xrtYMarker;
	Resource_t		*RD_xrtYMarkerDataStyle; 
	Resource_t		*RD_xrtYMarkerDataStyleUseDefault; 
	Resource_t		*RD_xrtYMarkerShow;
	Resource_t		*RD_xrtYMax;
	Resource_t		*RD_xrtYMaxUseDefault;
	Resource_t		*RD_xrtYMin;
	Resource_t		*RD_xrtYMinUseDefault;
	Resource_t		*RD_xrtYNum;
	Resource_t		*RD_xrtYNumMethod;
	Resource_t		*RD_xrtYNumUseDefault;
	Resource_t		*RD_xrtYOrigin;
	Resource_t		*RD_xrtYOriginPlacement;
	Resource_t		*RD_xrtYOriginUseDefault;
	Resource_t		*RD_xrtYPrecision;
	Resource_t		*RD_xrtYPrecisionUseDefault;
	Resource_t		*RD_xrtYTick;
	Resource_t		*RD_xrtYTickUseDefault;
	Resource_t		*RD_xrtYTitle;
	Resource_t		*RD_xrtYTitleRotation;
	Resource_t		*RD_xrtZoomAxisCallback;
	/*new*/
	Resource_t		*RD_xrtBubbleMax;
	Resource_t		*RD_xrtBubbleMethod;
	Resource_t		*RD_xrtBubbleMin;
	Resource_t		*RD_xrtColorFunc;
	Resource_t		*RD_xrtExtraDefaultDataStyles;
	Resource_t		*RD_xrtFooterImage;
	Resource_t		*RD_xrtFooterImageLayout;
	Resource_t		*RD_xrtFooterImageMinimumSize;
	Resource_t		*RD_xrtDataAreaImage;
	Resource_t		*RD_xrtDataAreaImageLayout;
	Resource_t		*RD_xrtGraphImage;
	Resource_t		*RD_xrtGraphImageLayout;
	Resource_t		*RD_xrtHeaderImage;
	Resource_t		*RD_xrtHeaderImageLayout;
	Resource_t		*RD_xrtHeaderImageMinimumSize;
	Resource_t		*RD_xrtImage;
	Resource_t		*RD_xrtImageLayout;
	Resource_t		*RD_xrtIsStacked;
	Resource_t		*RD_xrtIsStacked2;
	Resource_t		*RD_xrtLegendImage;
	Resource_t		*RD_xrtLegendImageLayout;
	Resource_t		*RD_xrtLegendReversed;
	Resource_t		*RD_xrtLegendTitle;
	Resource_t		*RD_xrtPieMergeMissingSlices;
	Resource_t		*RD_xrtPieStartAngle;
	Resource_t		*RD_xrtPolarAxisAllowNegatives;
	Resource_t		*RD_xrtXAxisDataStyle;
	Resource_t		*RD_xrtXAxisDataStyleUseDefault;
	Resource_t		*RD_xrtY2AxisDataStyle;
	Resource_t		*RD_xrtY2AxisDataStyleUseDefault;
	Resource_t		*RD_xrtYAxisDataStyle;
	Resource_t		*RD_xrtYAxisDataStyleUseDefault;
	int	mumble;		/* Just in case */
} UxXrtGraphClassPart;

typedef	struct UxXrtGraphClass
{
	UxObjectClassPart		object;
	UxVeditableClassPart	veditble;
	UxShadowWidgetClassPart	ShadowWidget;
	UxRectObjectClassPart	RectObject;
	UxCoreClassPart			Core;
	UxPrimitiveClassPart	primitive;
	UxXrtGraphClassPart		XrtGraph;
} UxXrtGraphClass;

/* Definition of the XrtGraph instance structure
   (there are no instance properties so the XrtGraph instance structure
    is the same as the primitive instance structure) */

typedef primitive	UxXrtGraph;

/* Declarations of global variables for XrtGraph class */

extern Class_t		UxC_XrtGraph;

#include "Xrt_restable.h"

#endif /* XRTGPH_CL_H */
