/*------------------------------------------------------------------------------
 * $Source: /rcs/rcs2/catalog/cat_macros.h,v $
 * $Date: 1997/10/18 18:29:38 $		$Revision: 2.19.65.5 $
 *------------------------------------------------------------------------------
 *		Copyright (c) 1995, Visual Edge Software Ltd.
 *
 * ALL  RIGHTS  RESERVED.  Permission  to  use,  copy,  modify,  and
 * distribute  this  software  and its documentation for any purpose
 * and  without  fee  is  hereby  granted,  provided  that the above
 * copyright  notice  appear  in  all  copies  and  that  both  that
 * copyright  notice and this permission notice appear in supporting
 * documentation,  and that  the name of Visual Edge Software not be
 * used  in advertising  or publicity  pertaining to distribution of
 * the software without specific, written prior permission. The year
 * included in the notice is the year of the creation of the work.
 *------------------------------------------------------------------------------
 * X/OPEN Message Catalog Macros
 *----------------------------------------------------------------------------*/

#ifndef _CAT_MACROS_H
#define _CAT_MACROS_H

/*--- include files ---*/

#include <uimx_cat.h>

/* Files that appear in design and run time */

#include <misc1_ds.h>

/* Files that appear in design time only */

#ifndef RUNTIME

#include <action_i_ds.h>
#include <cmpnt_ds.h>
#include <common_ds.h>
#include <compound_ds.h>
#include <connect_i_ds.h>
#include <consEdit_ds.h>
#include <cr_menu_ds.h>
#include <decls_i_ds.h>
#include <dialog_i_ds.h>
#include <event_i_ds.h>
#include <file_ds.h>
#include <helpBalloon_ds.h>
#include <ifBrow_ds.h>
#include <interp_i_ds.h>
#ifdef XRT
#include <kl_ds.h>
#endif /* XRT */
#include <load_i_ds.h>
#include <medit_ds.h>
#include <menus_ds.h>
#include <misc_ds.h>
#include <msg_ds.h>
#include <mwe_ds.h>
#include <names_ds.h>
#include <option_ds.h>
#include <pal_i_ds.h>
#include <parseval_ds.h>
#include <pedit_ds.h>
#include <pj_if_ds.h>
#include <proj_i_ds.h>
#include <UxSb_ds.h>
#include <sddArea_ds.h>
#include <string_ds.h>
#include <swidget_ds.h>
#include <symb_ds.h>
#include <text_i_ds.h>
#include <trans_ds.h>
#include <ttab_i_ds.h>
#include <veos_ds.h>
#include <vmem_ds.h>

#ifdef _IBMR2
#include <ibmdyn_ds.h>
#endif /* _IBMR2 */

#endif /* RUNTIME */

/*--- macro functions ---*/

/* Macros that appear in design and run time */

#define CGETS_MISC1(ms)		UXCATGETS(MC_MISC1,MS_MISC1_,ms)

/* Macros that appear in design time only */

#ifndef RUNTIME

#define CGETS_ACT(ms)		UXCATGETS(MC_ACTION,MS_AE_,ms)
#define CGETS_BROW(ms)		UXCATGETS(MC_BROWSER_I,MS_,ms)
#define CGETS_CMPNT(ms)		UXCATGETS(MC_COMPONENT,MS_CMPNT_,ms)
#define CGETS_COM(ms)		UXCATGETS(MC_COMMON,MS_,ms)
#define CGETS_COMPD(ms)		UXCATGETS(MC_COMPOUND_RESOURCES,MS_COMPOUND_,ms)
#define CGETS_CONN(ms)		UXCATGETS(MC_CONNEDIT,MS_,ms)
#define CGETS_CONSED(ms)	UXCATGETS(MC_CONSED,MS_CONSED_,ms)
#define CGETS_CRMENU(ms)	UXCATGETS(MC_CRMENUS,MS_,ms)
#define CGETS_DECL(ms)		UXCATGETS(MC_DECL_EDT,MS_DE_,ms)
#define CGETS_DIAG(ms)		UXCATGETS(MC_DIALOG,MS_,ms)
#define CGETS_EVT(ms)		UXCATGETS(MC_EVENT,MS_,ms)
#define CGETS_FILE(ms)		UXCATGETS(MC_FILE,MS_FL_,ms)
#define CGETS_BALLOON(ms)	UXCATGETS(MC_BALLOON,MS_BALLOON_,ms)
#define CGETS_INTERP(ms)	UXCATGETS(MC_INTERP,MS_INTERP_,ms)
#define CGETS_KL(ms)		UXCATGETS(MC_KL,MS_KL_,ms)
#define CGETS_LOAD(ms)		UXCATGETS(MC_LOAD_SAVE,MS_LS_,ms)
#define CGETS_MEDIT(ms)		UXCATGETS(MC_MEDIT,MS_ME_,ms)
#define CGETS_MENUS(ms)		UXCATGETS(MC_MENUS,MS_MNU_,ms)
#define CGETS_MISC(ms)		UXCATGETS(MC_MISC,MS_MISC_,ms)
#define CGETS_MSG(ms)		UXCATGETS(MC_MSG,MS_MSG_,ms)
#define CGETS_MWE(ms)		UXCATGETS(MC_MWE,MS_MWE_,ms)
#define CGETS_NAMES(ms)		UXCATGETS(MC_NAMES,MS_NAMES_,ms)
#define CGETS_OPT(ms)		UXCATGETS(MC_OPTION,MS_OPT_,ms)
#define CGETS_PAL(ms)		UXCATGETS(MC_PALETTE,MS_,ms)
#define CGETS_PARS(ms)		UXCATGETS(MC_PARSEVAL,MS_,ms)
#define CGETS_PEDIT(ms)		UXCATGETS(MC_PEDIT,MS_,ms)
#define CGETS_PJIF(ms)		UXCATGETS(MC_PJ_IFACES,MS_PJ_,ms)
#define CGETS_PROJ(ms)		UXCATGETS(MC_MFPROJWIN,MS_,ms)
#define CGETS_SB(ms)		UXCATGETS(MC_SB,MS_SB_,ms)
#define CGETS_SDD(ms)		UXCATGETS(MC_SDD_AREA,MS_SDD_,ms)
#define CGETS_STR(ms)		UXCATGETS(MC_STRING,MS_,ms)
#define CGETS_SWID(ms)		UXCATGETS(MC_SWIDGET,MS_SW_,ms)
#define CGETS_SYMB(ms)		UXCATGETS(MC_SYMB,MS_,ms)
#define CGETS_TEXT(ms)		UXCATGETS(MC_TEXT_EDT,MS_TE_,ms)
#define CGETS_TRANS(ms)		UXCATGETS(MC_TRANS,MS_TR_,ms)
#define CGETS_TTAB(ms)		UXCATGETS(MC_TRANS_TAB,MS_,ms)
#define CGETS_VEOS(ms)		UXCATGETS(MC_VEOS,MS_VE_,ms)
#define CGETS_VMEM(ms)		UXCATGETS(MC_VMEM,MS_VM_,ms)

#ifdef _IBMR2
#define CGETS_IBMDYN(ms)	UXCATGETS(MC_MAKEDYN,MS_,ms)
#endif /* _IBMR2 */

#endif /* !RUNTIME */

#endif /* _CAT_MACROS_H */
