/*---------------------------------------------------------------------
 * $Source: /rcs/rcs2/include/geometry.h,v $
 * $Date: 1996/11/09 16:23:16 $		$Revision: 2.3.65.1 $
 *---------------------------------------------------------------------
 *             Copyright 1991, Visual Edge Software Ltd.
 *
 * ALL  RIGHTS  RESERVED.  Permission  to  use,  copy,  modify,  and
 * distribute  this  software  and its documentation for any purpose
 * and  without  fee  is  hereby  granted,  provided  that the above
 * copyright  notice  appear  in  all  copies  and  that  both  that
 * copyright  notice and this permission notice appear in supporting
 * documentation,  and that  the name of Visual Edge Software not be
 * used  in advertising  or publicity  pertaining to distribution of
 * the software without specific, written prior permission. The year
 * included in the notice is the year of the creation of the work.
 *---------------------------------------------------------------------
 * Declarations for geometry management
 *--------------------------------------------------------------------*/

#ifndef	_GEOMETRY_H_
#define	_GEOMETRY_H_

/* needed include files. */
#include "uxproto.h"

/* Macro Symbols */

/* which interface is geometry for. */ 

/* Project Window */
#define PRJ_GEOMETRY		0
/* Browser */
#define BR_GEOMETRY		1
/* Property Editor */
#define PE_GEOMETRY		2

/* default settings. */

/* Project Window */
#define PW_DEFAULT_X  		50
#define PW_DEFAULT_Y 		50
#define PW_DEFAULT_WIDTH  	500
#define PW_DEFAULT_HEIGHT 	300
#define PW_DEFAULT_GEOMETRY 	"500x300+50+50"
/* Browser */
#define BR_DEFAULT_X  		0
#define BR_DEFAULT_Y 		0
#define BR_DEFAULT_WIDTH  	500
#define BR_DEFAULT_HEIGHT 	300
#define BR_DEFAULT_GEOMETRY 	"500x300"
/* Property Editor */
#define PE_DEFAULT_X  		0
#define PE_DEFAULT_Y 		0
#define PE_DEFAULT_WIDTH	600
#define PE_DEFAULT_HEIGHT	500
#define PE_DEFAULT_GEOMETRY 	"600x500"

/* External function declarations */
char * UxGetDefaultGeometry UXPROTO(( int, int*, int*, int*, int* ));

#endif /* _GEOMETRY_H_ */
