/* $AstecId: XrtTbl_xtype.c,v 1.5 1999/11/24 07:45:39 nakayama Exp nakayama $ */
/* ALL RIGHTS RESERVED
 *
 * This file is provided for demonstration and educational uses only.
 * Permission to use, copy, modify and distribute this file for
 * any purpose and without fee is hereby granted, provided that the
 * above copyright notice and this permission notice appear in all
 * copies, and that the name of KL Group not be used in advertising
 * or publicity pertaining to this material without the specific,
 * prior written permission of an authorized representative of
 * KL Group.
 *
 * KL GROUP MAKES NO REPRESENTATIONS AND EXTENDS NO WARRANTIES, EX-
 * PRESS OR IMPLIED, WITH RESPECT TO THE SOFTWARE, INCLUDING, BUT
 * NOT LIMITED TO, THE IMPLIED WARRANTIES OF MERCHANTABILITY AND
 * FITNESS FOR ANY PARTICULAR PURPOSE, AND THE WARRANTY AGAINST IN-
 * FRINGEMENT OF PATENTS OR OTHER INTELLECTUAL PROPERTY RIGHTS.  THE
 * SOFTWARE IS PROVIDED "AS IS", AND IN NO EVENT SHALL KL GROUP OR
 * ANY OF ITS AFFILIATES BE LIABLE FOR ANY DAMAGES, INCLUDING ANY
 * LOST PROFITS OR OTHER INCIDENTAL OR CONSEQUENTIAL DAMAGES
 * RELATING TO THE USE OF THIS SOFTWARE.
 *
 *
 * XRT/table widget UIM/X integration file
 *
 *  SCCSID -- @(#)XrtTbl_xtype.c	1.15    99/01/29 KL Group Inc.
 */

/******************************************************************************
				XrtTbl_xtype.c
******************************************************************************/

#include <Xm/Xm.h>

#include <UxLib.h>
#include <vtypes.h>
#include <utype.h>
#include <ctype.h>
#include <string.h>

#include <malloc.h>

#ifdef DESIGN_TIME

#include "veos.h"       		/* Visual Edge object system */
#include "valuesOf.h"   		/* ValuesOf & Validator functions */
#include "resource.h"
#include "resvalue.h"
#include "plist.cl.h"
#include "observer.h"

#endif /* DESIGN_TIME */

#include "Xrt_restable.h"

#include   <Xm/XrtTable.h>

#include <cat_macros.h>

/* Begin new XRT/table types */

int     UxXT_XrtTblAlignment;
int     UxXT_XrtTblAlignmentSeries;
int     UxXT_XrtTblAttachment;
int     UxXT_XrtTblBooleanSeries;
int     UxXT_XrtTblBorderSides;
int     UxXT_XrtTblBorderSidesSeries;
int     UxXT_XrtTblBorderType;
int     UxXT_XrtTblBorderTypeSeries;
int     UxXT_XrtTblCase;
int     UxXT_XrtTblCaseSeries;
int     UxXT_XrtTblCellSizeSeries;
int     UxXT_XrtTblCellValues;
int     UxXT_XrtTblColorSeries;
int		UxXT_XrtTblColumnPlacement;
int		UxXT_XrtTblContext;
int		UxXT_XrtTblCursorCorner;
int		UxXT_XrtTblCursorHorizontal;
int		UxXT_XrtTblCursorNonTrvrsbl;
int		UxXT_XrtTblCursorTrvrsbl;
int		UxXT_XrtTblCursorVertical;
int     UxXT_XrtTblDataType;
int     UxXT_XrtTblDataTypeSeries;
int     UxXT_XrtTblDispScrollBar;
int     UxXT_XrtTblDoubleBuffer;
int     UxXT_XrtTblFontList;
int     UxXT_XrtTblFontListSeries;
int     UxXT_XrtTblIntSeries;
int     UxXT_XrtTblLabelBorderType;
int     UxXT_XrtTblLocation;
int     UxXT_XrtTblMode;				
int     UxXT_XrtTblJumpScroll;
int     UxXT_XrtTblOverflow;
int     UxXT_XrtTblOverflowSeries;
int     UxXT_XrtTblPixmap;
int     UxXT_XrtTblPixmapLayout;
int     UxXT_XrtTblPixmapLayoutSeries;
int     UxXT_XrtTblPixmapSeries;
int     UxXT_XrtTblPSFontMapList;			
int     UxXT_XrtTblRange;
int     UxXT_XrtTblRangeList;
int     UxXT_XrtTblRepaint;								
int     UxXT_XrtTblResize;
int     UxXT_XrtTblRotation;
int     UxXT_XrtTblRowPlacement;
int     UxXT_XrtTblSBPosition;
int     UxXT_XrtTblSelectionPolicy;
int     UxXT_XrtTblStringSeries;
int     UxXT_XrtTblStringTable; 			          
int     UxXT_XrtTblValidatePolicy;
int     UxXT_XrtTblWidgetSeries;
int     UxXT_XrtTblXmStringGetMode;			
int     UxXT_XrtTblXmStringList;
int     UxXT_XrtTblXmStringSetMode;			

int     UxXT_XrtTblCurrencyPickList;
int     UxXT_XrtTblCurrencyPickListSeries;
int     UxXT_XrtTblDatePickList;
int     UxXT_XrtTblDatePickListSeries;
int     UxXT_XrtTblFloatPickList;
int     UxXT_XrtTblFloatPickListSeries;
int     UxXT_XrtTblIntPickList;
int     UxXT_XrtTblIntPickListSeries;
int     UxXT_XrtTblPreviewScrolling;
int     UxXT_XrtTblSensitiveSeries;
int     UxXT_XrtTblStringPickList;
int     UxXT_XrtTblStringPickListSeries;

/* Define three static arrays for each enumerated type */

/* Alignment */
static char * uXrtTblAlignment[] = {
	"Alignment_Topbegin",
	"Alignment_Topcenter",
	"Alignment_Topend",
	"Alignment_Middlebegin",
	"Alignment_Middlecenter",
	"Alignment_Middleend",
	"Alignment_Bottombegin",
	"Alignment_Bottomcenter",
	"Alignment_Bottomend"
};
static unsigned char xXrtTblAlignment[] = {
	XRTTBL_ALIGNMENT_TOPBEGIN,
	XRTTBL_ALIGNMENT_TOPCENTER,
	XRTTBL_ALIGNMENT_TOPEND,
	XRTTBL_ALIGNMENT_MIDDLEBEGIN,
	XRTTBL_ALIGNMENT_MIDDLECENTER,
	XRTTBL_ALIGNMENT_MIDDLEEND,
	XRTTBL_ALIGNMENT_BOTTOMBEGIN,
	XRTTBL_ALIGNMENT_BOTTOMCENTER,
	XRTTBL_ALIGNMENT_BOTTOMEND
};
static char * dXrtTblAlignment[] = {
	"XRTTBL_ALIGNMENT_TOPBEGIN",
	"XRTTBL_ALIGNMENT_TOPCENTER",
	"XRTTBL_ALIGNMENT_TOPEND",
	"XRTTBL_ALIGNMENT_MIDDLEBEGIN",
	"XRTTBL_ALIGNMENT_MIDDLECENTER",
	"XRTTBL_ALIGNMENT_MIDDLEEND",
	"XRTTBL_ALIGNMENT_BOTTOMBEGIN",
	"XRTTBL_ALIGNMENT_BOTTOMCENTER",
	"XRTTBL_ALIGNMENT_BOTTOMEND"
};

/* Attachment */
static char * uXrtTblAttachment[] = {
	"Attach_Cells",
	"Attach_Side"
};
static unsigned char xXrtTblAttachment[] = {
	XRTTBL_ATTACH_CELLS,
	XRTTBL_ATTACH_SIDE
};
static char * dXrtTblAttachment[] = {
	"XRTTBL_ATTACH_CELLS",
	"XRTTBL_ATTACH_SIDE"
};

/* BorderSides */
static char * uXrtTblBorderSides[] = {
	"Borderside_None",
	"Borderside_Left",
	"Borderside_Top",
	"Borderside_Left+Xrttbl_Borderside_Top",
	"Borderside_Bottom",
	"Borderside_Bottom+Xrttbl_Borderside_Left",
	"Borderside_Bottom+Xrttbl_Borderside_Top",
	"Borderside_Bottom+Xrttbl_Borderside_Left+Xrttbl_Borderside_Top",
	"Borderside_Right",
	"Borderside_Right+Xrttbl_Borderside_Left",
	"Borderside_Right+Xrttbl_Borderside_Top",
	"Borderside_Right+Xrttbl_Borderside_Left+Xrttbl_Borderside_Top",
	"Borderside_Right+Xrttbl_Borderside_Bottom",
	"Borderside_Right+Xrttbl_Borderside_Bottom+Xrttbl_Borderside_Left",
	"Borderside_Right+Xrttbl_Borderside_Bottom+Xrttbl_Borderside_Top",
	"Borderside_All"
};
static unsigned char xXrtTblBorderSides[] = {
	XRTTBL_BORDERSIDE_NONE,
	XRTTBL_BORDERSIDE_LEFT,
	XRTTBL_BORDERSIDE_TOP,
	XRTTBL_BORDERSIDE_LEFT+XRTTBL_BORDERSIDE_TOP,
	XRTTBL_BORDERSIDE_BOTTOM,
	XRTTBL_BORDERSIDE_BOTTOM+XRTTBL_BORDERSIDE_LEFT,
	XRTTBL_BORDERSIDE_BOTTOM+XRTTBL_BORDERSIDE_TOP,
	XRTTBL_BORDERSIDE_BOTTOM+XRTTBL_BORDERSIDE_LEFT+XRTTBL_BORDERSIDE_TOP,
	XRTTBL_BORDERSIDE_RIGHT,
	XRTTBL_BORDERSIDE_RIGHT+XRTTBL_BORDERSIDE_LEFT,
	XRTTBL_BORDERSIDE_RIGHT+XRTTBL_BORDERSIDE_TOP,
	XRTTBL_BORDERSIDE_RIGHT+XRTTBL_BORDERSIDE_LEFT+XRTTBL_BORDERSIDE_TOP,
	XRTTBL_BORDERSIDE_RIGHT+XRTTBL_BORDERSIDE_BOTTOM,
	XRTTBL_BORDERSIDE_RIGHT+XRTTBL_BORDERSIDE_BOTTOM+XRTTBL_BORDERSIDE_LEFT,
	XRTTBL_BORDERSIDE_RIGHT+XRTTBL_BORDERSIDE_BOTTOM+XRTTBL_BORDERSIDE_TOP,
	XRTTBL_BORDERSIDE_ALL
};
static char * dXrtTblBorderSides[] = {
	"XRTTBL_BORDERSIDE_NONE",
	"XRTTBL_BORDERSIDE_LEFT",
	"XRTTBL_BORDERSIDE_TOP",
	"XRTTBL_BORDERSIDE_LEFT+XRTTBL_BORDERSIDE_TOP",
	"XRTTBL_BORDERSIDE_BOTTOM",
	"XRTTBL_BORDERSIDE_BOTTOM+XRTTBL_BORDERSIDE_LEFT",
	"XRTTBL_BORDERSIDE_BOTTOM+XRTTBL_BORDERSIDE_TOP",
	"XRTTBL_BORDERSIDE_BOTTOM+XRTTBL_BORDERSIDE_LEFT+XRTTBL_BORDERSIDE_TOP",
	"XRTTBL_BORDERSIDE_RIGHT",
	"XRTTBL_BORDERSIDE_RIGHT+XRTTBL_BORDERSIDE_LEFT",
	"XRTTBL_BORDERSIDE_RIGHT+XRTTBL_BORDERSIDE_TOP",
	"XRTTBL_BORDERSIDE_RIGHT+XRTTBL_BORDERSIDE_LEFT+XRTTBL_BORDERSIDE_TOP",
	"XRTTBL_BORDERSIDE_RIGHT+XRTTBL_BORDERSIDE_BOTTOM",
	"XRTTBL_BORDERSIDE_RIGHT+XRTTBL_BORDERSIDE_BOTTOM+XRTTBL_BORDERSIDE_LEFT",
	"XRTTBL_BORDERSIDE_RIGHT+XRTTBL_BORDERSIDE_BOTTOM+XRTTBL_BORDERSIDE_TOP",
	"XRTTBL_BORDERSIDE_ALL"
};

/* BorderType */
static char * uXrtTblBorderType[] = {
	"Border_None",
	"Border_Etched_In",
	"Border_Etched_Out",
	"Border_In",
	"Border_Out",
	"Border_Plain",
	"Border_Frame_In",
	"Border_Frame_Out"
};
static unsigned char xXrtTblBorderType[] = {
	XRTTBL_BORDER_NONE,
	XRTTBL_BORDER_ETCHED_IN,
	XRTTBL_BORDER_ETCHED_OUT,
	XRTTBL_BORDER_IN,
	XRTTBL_BORDER_OUT,
	XRTTBL_BORDER_PLAIN,
	XRTTBL_BORDER_FRAME_IN,
	XRTTBL_BORDER_FRAME_OUT
};
static char * dXrtTblBorderType[] = {
	"XRTTBL_BORDER_NONE",
	"XRTTBL_BORDER_ETCHED_IN",
	"XRTTBL_BORDER_ETCHED_OUT",
	"XRTTBL_BORDER_IN",
	"XRTTBL_BORDER_OUT",
	"XRTTBL_BORDER_PLAIN",
	"XRTTBL_BORDER_FRAME_IN",
	"XRTTBL_BORDER_FRAME_OUT"
};

/* Case */
static char * uXrtTblCase[] = {
	"Case_As_Is",
	"Case_Lower",
	"Case_Upper"
};
static unsigned char xXrtTblCase[] = {
	XRTTBL_CASE_AS_IS,
	XRTTBL_CASE_LOWER,
	XRTTBL_CASE_UPPER
};
static char * dXrtTblCase[] = {
	"XRTTBL_CASE_AS_IS",
	"XRTTBL_CASE_LOWER",
	"XRTTBL_CASE_UPPER"
};

/* ColumnPlacement */
static char * uXrtTblColumnPlacement[] = {
	"Place_Left",
	"Place_Right"
};
static unsigned char xXrtTblColumnPlacement[] = {
	XRTTBL_PLACE_LEFT,
	XRTTBL_PLACE_RIGHT
};
static char * dXrtTblColumnPlacement[] = {
	"XRTTBL_PLACE_LEFT",
	"XRTTBL_PLACE_RIGHT"
};

/* DataType */
static char * uXrtTblDataType[] = {
	"Type_Field_Currency",
	"Type_Field_Date",
	"Type_Field_Float",
	"Type_Field_Int",
	"Type_Field_None",
	"Type_Field_String",
	"Type_Field_Combo_Currency",
	"Type_Field_Combo_Date",
	"Type_Field_Combo_Float",
	"Type_Field_Combo_Int",
	"Type_Field_Combo_String",
	"Type_Field_Spin_Currency",
	"Type_Field_Spin_Date",
	"Type_Field_Spin_Float",
	"Type_Field_Spin_Int",
	"Type_Field_Spin_String",
	"Type_Boolean",
	"Type_Double",
	"Type_Float",
	"Type_Int",
	"Type_String",
	"Type_Last"
};
static unsigned char xXrtTblDataType[] = {
	XRTTBL_TYPE_FIELD_CURRENCY,
	XRTTBL_TYPE_FIELD_DATE,
	XRTTBL_TYPE_FIELD_FLOAT,
	XRTTBL_TYPE_FIELD_INT,
	XRTTBL_TYPE_FIELD_NONE,
	XRTTBL_TYPE_FIELD_STRING,
	XRTTBL_TYPE_FIELD_COMBO_CURRENCY,
	XRTTBL_TYPE_FIELD_COMBO_DATE,
	XRTTBL_TYPE_FIELD_COMBO_FLOAT,
	XRTTBL_TYPE_FIELD_COMBO_INT,
	XRTTBL_TYPE_FIELD_COMBO_STRING,
	XRTTBL_TYPE_FIELD_SPIN_CURRENCY,
	XRTTBL_TYPE_FIELD_SPIN_DATE,
	XRTTBL_TYPE_FIELD_SPIN_FLOAT,
	XRTTBL_TYPE_FIELD_SPIN_INT,
	XRTTBL_TYPE_FIELD_SPIN_STRING,
	XRTTBL_TYPE_BOOLEAN,
	XRTTBL_TYPE_DOUBLE,
	XRTTBL_TYPE_FLOAT,
	XRTTBL_TYPE_INT,
	XRTTBL_TYPE_STRING,
	XRTTBL_TYPE_LAST
};
static char * dXrtTblDataType[] = {
	"XRTTBL_TYPE_FIELD_CURRENCY",
	"XRTTBL_TYPE_FIELD_DATE",
	"XRTTBL_TYPE_FIELD_FLOAT",
	"XRTTBL_TYPE_FIELD_INT",
	"XRTTBL_TYPE_FIELD_NONE",
	"XRTTBL_TYPE_FIELD_STRING",
	"XRTTBL_TYPE_FIELD_COMBO_CURRENCY",
	"XRTTBL_TYPE_FIELD_COMBO_DATE",
	"XRTTBL_TYPE_FIELD_COMBO_FLOAT",
	"XRTTBL_TYPE_FIELD_COMBO_INT",
	"XRTTBL_TYPE_FIELD_COMBO_STRING",
	"XRTTBL_TYPE_FIELD_SPIN_CURRENCY",
	"XRTTBL_TYPE_FIELD_SPIN_DATE",
	"XRTTBL_TYPE_FIELD_SPIN_FLOAT",
	"XRTTBL_TYPE_FIELD_SPIN_INT",
	"XRTTBL_TYPE_FIELD_SPIN_STRING",
	"XRTTBL_TYPE_BOOLEAN",
	"XRTTBL_TYPE_DOUBLE",
	"XRTTBL_TYPE_FLOAT",
	"XRTTBL_TYPE_INT",
	"XRTTBL_TYPE_STRING",
	"XRTTBL_TYPE_LAST"
};

/* Display Scroll Bar */
static char * uXrtTblDispScrollBar[] = {
	"Dispsb_As_Needed",
	"Dispsb_Always",
	"Dispsb_Never"
};
static unsigned char xXrtTblDispScrollBar[] = {
	XRTTBL_DISPSB_AS_NEEDED,
	XRTTBL_DISPSB_ALWAYS,
	XRTTBL_DISPSB_NEVER
};
static char * dXrtTblDispScrollBar[] = {
	"XRTTBL_DISPSB_AS_NEEDED",
	"XRTTBL_DISPSB_ALWAYS",
	"XRTTBL_DISPSB_NEVER"
};

/* DoubleBuffer */
static char * uXrtTblDoubleBuffer[] = {
	"Doublebuffer_None",
	"Doublebuffer_Cell",
	"Doublebuffer_Window"
};
static unsigned char xXrtTblDoubleBuffer[] = {
	XRTTBL_DOUBLEBUFFER_NONE,
	XRTTBL_DOUBLEBUFFER_CELL,
	XRTTBL_DOUBLEBUFFER_WINDOW
};
static char * dXrtTblDoubleBuffer[] = {
	"XRTTBL_DOUBLEBUFFER_NONE",
	"XRTTBL_DOUBLEBUFFER_CELL",
	"XRTTBL_DOUBLEBUFFER_WINDOW"
};

/* JumpScroll */
static char * uXrtTblJumpScroll[] = {
	"Jump_None",
	"Jump_Horizontal",
	"Jump_Vertical",
	"Jump_All"
};
static unsigned char xXrtTblJumpScroll[] = {
	XRTTBL_JUMP_NONE,
	XRTTBL_JUMP_HORIZONTAL,
	XRTTBL_JUMP_VERTICAL,
	XRTTBL_JUMP_ALL
};
static char * dXrtTblJumpScroll[] = {
	"XRTTBL_JUMP_NONE",
	"XRTTBL_JUMP_HORIZONTAL",
	"XRTTBL_JUMP_VERTICAL",
	"XRTTBL_JUMP_ALL"
};

/* LabelBorderType */
static char * uXrtTblLabelBorderType[] = {
	"Border_None",
	"Border_Etched_In",
	"Border_Etched_Out",
	"Border_In",
	"Border_Out",
	"Border_Bezel",
    "Border_Shadow",
    "Border_Plain"
};
static unsigned char xXrtTblLabelBorderType[] = {
	XRTLBL_BORDER_NONE,
	XRTLBL_BORDER_ETCHED_IN,
	XRTLBL_BORDER_ETCHED_OUT,
	XRTLBL_BORDER_IN,
	XRTLBL_BORDER_OUT,
	XRTLBL_BORDER_BEZEL,
    XRTLBL_BORDER_SHADOW,
    XRTLBL_BORDER_PLAIN
};
static char * dXrtTblLabelBorderType[] = {
	"XRTLBL_BORDER_NONE",
	"XRTLBL_BORDER_ETCHED_IN",
	"XRTLBL_BORDER_ETCHED_OUT",
	"XRTLBL_BORDER_IN",
	"XRTLBL_BORDER_OUT",
	"XRTLBL_BORDER_BEZEL",
    "XRTLBL_BORDER_SHADOW",
    "XRTLBL_BORDER_PLAIN"
};

/* Location */
static char * uXrtTblLocation[] = {
	"Location_None",
	"Location_Top",
	"Location_Left",
	"Location_Bottom",
	"Location_Right"
};
static unsigned char xXrtTblLocation[] = {
	XRTTBL_LOCATION_NONE,
	XRTTBL_LOCATION_TOP,
	XRTTBL_LOCATION_LEFT,
	XRTTBL_LOCATION_BOTTOM,
	XRTTBL_LOCATION_RIGHT
};
static char * dXrtTblLocation[] = {
	"XRTTBL_LOCATION_NONE",
	"XRTTBL_LOCATION_TOP",
	"XRTTBL_LOCATION_LEFT",
	"XRTTBL_LOCATION_BOTTOM",
	"XRTTBL_LOCATION_RIGHT"
};

/* Mode */
static char * uXrtTblMode[] = {
	"Mode_List",
	"Mode_Table",
};
static unsigned char xXrtTblMode[] = {
	XRTTBL_MODE_LIST,
	XRTTBL_MODE_TABLE,
};
static char * dXrtTblMode[] = {
	"XRTTBL_MODE_LIST",
	"XRTTBL_MODE_TABLE",
};

/* Overflow */
static char * uXrtTblOverflow[] = {
	"Overflow_None",
	"Overflow_Horizontal"
};
static unsigned char xXrtTblOverflow[] = {
	XRTTBL_OVERFLOW_NONE,
	XRTTBL_OVERFLOW_HORIZONTAL
};
static char * dXrtTblOverflow[] = {
	"XRTTBL_OVERFLOW_NONE",
	"XRTTBL_OVERFLOW_HORIZONTAL"
};

/* Pixmap Layout */
static char * uXrtTblPixmapLayout[] = {
	"Pixmap_Topleft",
	"Pixmap_Topcenter",
	"Pixmap_Topright",
	"Pixmap_Middleleft",
	"Pixmap_Middlecenter",
	"Pixmap_Middleright",
	"Pixmap_Bottomleft",
	"Pixmap_Bottomcenter",
	"Pixmap_Bottomright",
	"Pixmap_Tile"
};
static unsigned char xXrtTblPixmapLayout[] = {
	XRTTBL_PIXMAP_TOPLEFT,
	XRTTBL_PIXMAP_TOPCENTER,
	XRTTBL_PIXMAP_TOPRIGHT,
	XRTTBL_PIXMAP_MIDDLELEFT,
	XRTTBL_PIXMAP_MIDDLECENTER,
	XRTTBL_PIXMAP_MIDDLERIGHT,
	XRTTBL_PIXMAP_BOTTOMLEFT,
	XRTTBL_PIXMAP_BOTTOMCENTER,
	XRTTBL_PIXMAP_BOTTOMRIGHT,
	XRTTBL_PIXMAP_TILE
};
static char * dXrtTblPixmapLayout[] = {
	"XRTTBL_PIXMAP_TOPLEFT",
	"XRTTBL_PIXMAP_TOPCENTER",
	"XRTTBL_PIXMAP_TOPRIGHT",
	"XRTTBL_PIXMAP_MIDDLELEFT",
	"XRTTBL_PIXMAP_MIDDLECENTER",
	"XRTTBL_PIXMAP_MIDDLERIGHT",
	"XRTTBL_PIXMAP_BOTTOMLEFT",
	"XRTTBL_PIXMAP_BOTTOMCENTER",
	"XRTTBL_PIXMAP_BOTTOMRIGHT",
	"XRTTBL_PIXMAP_TILE"
};

/* Scroll Bar Position */
static char * uXrtTblSBPosition[] = {
	"Sbposition_Cells",
	"Sbposition_Side"
};
static unsigned char xXrtTblSBPosition[] = {
	XRTTBL_SBPOSITION_CELLS,
	XRTTBL_SBPOSITION_SIDE
};
static char * dXrtTblSBPosition[] = {
	"XRTTBL_SBPOSITION_CELLS",
	"XRTTBL_SBPOSITION_SIDE"
};

/*Repaint*/
static char * uXrtTblRepaint[] = {
	"Repaint_On",
	"Repaint_Off",
	"Repaint_Nocalc"
};

static unsigned char xXrtTblRepaint[] = {
	XRTTBL_REPAINT_ON,
	XRTTBL_REPAINT_OFF,
	XRTTBL_REPAINT_NOCALC
};

static char* dXrtTblRepaint[] = {
	"XRTTBL_REPAINT_ON",
	"XRTTBL_REPAINT_OFF",
	"XRTTBL_REPAINT_NOCALC"
};

/* Resize */
static char * uXrtTblResize[] = {
	"Resize_None",
	"Resize_Horizontal",
	"Resize_Vertical",
	"Resize_All"
};
static unsigned char xXrtTblResize[] = {
	XRTTBL_RESIZE_NONE,
	XRTTBL_RESIZE_HORIZONTAL,
	XRTTBL_RESIZE_VERTICAL,
	XRTTBL_RESIZE_ALL
};
static char * dXrtTblResize[] = {
	"XRTTBL_RESIZE_NONE",
	"XRTTBL_RESIZE_HORIZONTAL",
	"XRTTBL_RESIZE_VERTICAL",
	"XRTTBL_RESIZE_ALL"
};

/* Rotation */
static char * uXrtTblRotation[] = {
    "Rotate_None",
    "Rotate_90",
    "Rotate_270"
};
static unsigned char xXrtTblRotation[] = {
    XRTLBL_ROTATE_NONE,
    XRTLBL_ROTATE_90,
    XRTLBL_ROTATE_270
};
static char * dXrtTblRotation[] = {
    "XRTLBL_ROTATE_NONE",
    "XRTLBL_ROTATE_90",
    "XRTLBL_ROTATE_270"
};

/* Row Placement */
static char * uXrtTblRowPlacement[] = {
	"Place_Top",
	"Place_Bottom"
};
static unsigned char xXrtTblRowPlacement[] = {
	XRTTBL_PLACE_TOP,
	XRTTBL_PLACE_BOTTOM
};
static char * dXrtTblRowPlacement[] = {
	"XRTTBL_PLACE_TOP",
	"XRTTBL_PLACE_BOTTOM"
};

/* Selection Policy  */
static char * uXrtTblSelectionPolicy[] = {
	"Select_None",
	"Select_Single",
	"Select_Range",
	"Select_Multirange"
};
static unsigned char xXrtTblSelectionPolicy[] = {
	XRTTBL_SELECT_NONE,
	XRTTBL_SELECT_SINGLE,
	XRTTBL_SELECT_RANGE,
	XRTTBL_SELECT_MULTIRANGE
};
static char * dXrtTblSelectionPolicy[] = {
	"XRTTBL_SELECT_NONE",
	"XRTTBL_SELECT_SINGLE",
	"XRTTBL_SELECT_RANGE",
	"XRTTBL_SELECT_MULTIRANGE"
};

/* Validate Policy */
static char * uXrtTblValidatePolicy[] = {
	"Validate_Never",
	"Validate_User_Edit",
	"Validate_Set",
	"Validate_Always"
};
static unsigned char xXrtTblValidatePolicy[] = {
	XRTTBL_VALIDATE_NEVER,
	XRTTBL_VALIDATE_USER_EDIT,
	XRTTBL_VALIDATE_SET,
	XRTTBL_VALIDATE_ALWAYS
};
static char * dXrtTblValidatePolicy[] = {
	"XRTTBL_VALIDATE_NEVER",
	"XRTTBL_VALIDATE_USER_EDIT",
	"XRTTBL_VALIDATE_SET",
	"XRTTBL_VALIDATE_ALWAYS"
};


/* XmString Get */
static char * uXrtTblXmStringGetMode[] = {
	"Get_Xmstring",	
	"Get_String"	
};
static unsigned char xXrtTblXmStringGetMode[] = {
	XRTTBL_GET_XMSTRING,	
	XRTTBL_GET_STRING	
};
static char * dXrtTblXmStringGetMode[] = {
	"XRTTBL_GET_XMSTRING",	
	"XRTTBL_GET_STRING"	
};

/* XmString Set */
static char * uXrtTblXmStringSetMode[] = {
	"Set_Xmstring",	
	"Set_String",	
	"Set_Examine"	
};
static unsigned char xXrtTblXmStringSetMode[] = {
	XRTTBL_SET_XMSTRING,	
	XRTTBL_SET_STRING,	
	XRTTBL_SET_EXAMINE	
};
static char * dXrtTblXmStringSetMode[] = {
	"XRTTBL_SET_XMSTRING",	
	"XRTTBL_SET_STRING",	
	"XRTTBL_SET_EXAMINE"	
};

static char * uXrtTblPreviewScrolling[] = {
	"Preview_None",
	"Preview_Vertical",
	"Preview_Horizontal",
	"Preview_Both"
};
static unsigned char xXrtTblPreviewScrolling[] = {
	XRTTBL_PREVIEW_NONE,
	XRTTBL_PREVIEW_VERTICAL,
	XRTTBL_PREVIEW_HORIZONTAL,
	XRTTBL_PREVIEW_BOTH
};
static char * dXrtTblPreviewScrolling[] = {
	"XRTTBL_PREVIEW_NONE",
	"XRTTBL_PREVIEW_VERTICAL",
	"XRTTBL_PREVIEW_HORIZONTAL",
	"XRTTBL_PREVIEW_BOTH"
};

#ifndef   RUNTIME

/*
 * ValuesOf functions for both enumerated types and other Xtypes
 */

int
UxValuesOfXrtTblAlignment(ulist, n)
char ***ulist;
int  *n;
{
	*ulist = uXrtTblAlignment;
	*n = XtNumber(uXrtTblAlignment);
	return(*n);
}

int
UxValuesOfXrtTblAlignmentSeries(s, n)
char ***s;
int  *n;
{
	static char *values[1];

	values[0] = CGETS_KL(VALOF_TBLALIGNMENTSERIES);
	*s = values;
	*n = 1;
	return 0;
}

int
UxValuesOfXrtTblAttachment(ulist, n)
char ***ulist;
int  *n;
{
	*ulist = uXrtTblAttachment;
	*n = XtNumber(uXrtTblAttachment);
	return(*n);
}

int
UxValuesOfXrtTblBooleanSeries(s, n)
char ***s;
int  *n;
{
	static char *values[1];

	values[0] = CGETS_KL(VALOF_TBLBOOLEANSERIES);
	*s = values;
	*n = 1;
	return 0;
}

int
UxValuesOfXrtTblBorderSides(ulist, n)
char ***ulist;
int  *n;
{
	*ulist = uXrtTblBorderSides;
	*n = XtNumber(uXrtTblBorderSides);
	return(*n);
}

int
UxValuesOfXrtTblBorderSidesSeries(s, n)
char ***s;
int  *n;
{
	static char *values[1];

	values[0] = CGETS_KL(VALOF_TBLBORDERSIDESSERIES);
	*s = values;
	*n = 1;
	return 0;
}

int
UxValuesOfXrtTblBorderType(ulist, n)
char ***ulist;
int  *n;
{
	*ulist = uXrtTblBorderType;
	*n = XtNumber(uXrtTblBorderType);
	return(*n);
}

int
UxValuesOfXrtTblBorderTypeSeries(s, n)
char ***s;
int  *n;
{
	static char *values[1];

	values[0] = CGETS_KL(VALOF_TBLBORDERTYPESERIES);
	*s = values;
	*n = 1;
	return 0;
}

int
UxValuesOfXrtTblCase(ulist, n)
char ***ulist;
int  *n;
{
	*ulist = uXrtTblCase;
	*n = XtNumber(uXrtTblCase);
	return(*n);
}

int
UxValuesOfXrtTblCaseSeries(s, n)
char ***s;
int  *n;
{
	static char *values[1];

	values[0] = CGETS_KL(VALOF_TBLCASESERIES);
	*s = values;
	*n = 1;
	return 0;
}

int
UxValuesOfXrtTblCellSizeSeries(s, n)
char ***s;
int  *n;
{
	static char *values[1];

	values[0] = CGETS_KL(VALOF_TBLCELLSIZESERIES);
	*s = values;
	*n = 1;
	return 0;
}

int
UxValuesOfXrtTblCellValues(s, n)
char ***s;
int  *n;
{
	static char *values[1];

	values[0] = CGETS_KL(VALOF_TBLCELLVALUES);
	*s = values;
	*n = 1;
	return 0;
}

int
UxValuesOfXrtTblColorSeries(s, n)
char ***s;
int  *n;
{
	static char *values[1];

	values[0] = CGETS_KL(VALOF_TBLCOLORSERIES);
	*s = values;
	*n = 1;
	return 0;
}

int
UxValuesOfXrtTblColumnPlacement(ulist, n)
char ***ulist;
int  *n;
{
	*ulist = uXrtTblColumnPlacement;
	*n = XtNumber(uXrtTblColumnPlacement);
	return(*n);
}

int
UxValuesOfXrtTblContext(s, n)
char ***s;
int  *n;
{
	static char *values[1];

	values[0] = CGETS_KL(VALOF_TBLCONTEXT);
	*s = values;
	*n = 1;
	return 0;
}

int
UxValuesOfXrtTblCursor(s, n)
char ***s;
int  *n;
{
	static char *values[1];

	values[0] = CGETS_KL(VALOF_TBLCURSOR);
	*s = values;
	*n = 1;
	return 0;
}

int
UxValuesOfXrtTblDataType(ulist, n)
char ***ulist;
int  *n;
{
	*ulist = uXrtTblDataType;
	*n = XtNumber(uXrtTblDataType);
	return(*n);
}

int
UxValuesOfXrtTblDataTypeSeries(s, n)
char ***s;
int  *n;
{
	static char *values[1];

	values[0] = CGETS_KL(VALOF_TBLDATATYPESERIES);
	*s = values;
	*n = 1;
	return 0;
}

int
UxValuesOfXrtTblDispScrollBar(ulist, n)
char ***ulist;
int  *n;
{
	*ulist = uXrtTblDispScrollBar;
	*n = XtNumber(uXrtTblDispScrollBar);
	return( *n);
}

int
UxValuesOfXrtTblDoubleBuffer(ulist, n)
char ***ulist;
int  *n;
{
	*ulist = uXrtTblDoubleBuffer;
	*n = XtNumber(uXrtTblDoubleBuffer);
	return( *n);
}

int
UxValuesOfXrtTblFontList(s, n)
char ***s;
int  *n;
{
	static char *values[1];

	values[0] = CGETS_KL(VALOF_TBLFONTLIST);
	*s = values;
	*n = 1;
	return 0;
}

int
UxValuesOfXrtTblFontListSeries(s, n)
char ***s;
int  *n;
{
	static char *values[1];

	values[0] = CGETS_KL(VALOF_TBLFONTLISTSERIES);
	*s = values;
	*n = 1;
	return 0;
}

int
UxValuesOfXrtTblIntSeries(s, n)
char ***s;
int  *n;
{
	static char *values[1];

	values[0] = CGETS_KL(VALOF_TBLINTSERIES);
	*s = values;
	*n = 1;
	return 0;
}

int
UxValuesOfXrtTblJumpScroll(ulist, n)
char ***ulist;
int  *n;
{
	*ulist = uXrtTblJumpScroll;
	*n = XtNumber(uXrtTblJumpScroll);
	return(*n);
}

int
UxValuesOfXrtTblLabelBorderType(ulist, n)
char ***ulist;
int  *n;
{
	*ulist = uXrtTblLabelBorderType;
	*n = XtNumber(uXrtTblLabelBorderType);
	return(*n);
}

int
UxValuesOfXrtTblLocation(ulist, n)
char ***ulist;
int  *n;
{
	*ulist = uXrtTblLocation;
	*n = XtNumber(uXrtTblLocation);
	return(*n);
}

int
UxValuesOfXrtTblMode(ulist, n)
char ***ulist;
int  *n;
{
	*ulist = uXrtTblMode;
	*n = XtNumber(uXrtTblMode);
	return(*n);
}

int
UxValuesOfXrtTblOverflow(ulist, n)
char ***ulist;
int  *n;
{
	*ulist = uXrtTblOverflow;
	*n = XtNumber(uXrtTblOverflow);
	return(*n);
}

int
UxValuesOfXrtTblOverflowSeries(s, n)
char ***s;
int  *n;
{
	static char *values[1];

	values[0] = CGETS_KL(VALOF_TBLOVERFLOWSERIES);
	*s = values;
	*n = 1;
	return 0;
}

int
UxValuesOfXrtTblPixel(s, n)
char ***s;
int  *n;
{
	static char *values[1];

	values[0]= CGETS_KL(VALOF_TBLPIXEL);
	*s = values;
	*n = 1;
	return 0;
}

int
UxValuesOfXrtTblPixmap(s, n)
char ***s;
int  *n;
{
	static char *values[1];

	values[0]= CGETS_KL(VALOF_TBLPIXMAP);
	*s = values;
	*n = 1;
	return 0;
}

int
UxValuesOfXrtTblPixmapLayout(ulist, n)
char ***ulist;
int  *n;
{
	*ulist = uXrtTblPixmapLayout;
	*n = XtNumber(uXrtTblPixmapLayout);
	return(*n);
}

int
UxValuesOfXrtTblPixmapLayoutSeries(s, n)
char ***s;
int  *n;
{
	static char *values[1];

	values[0] = CGETS_KL(VALOF_TBLPIXMAPLAYOUTSERIES);
	*s = values;
	*n = 1;
	return 0;
}

int
UxValuesOfXrtTblPSFontMapList(s, n)
char ***s;
int  *n;
{
	static char *values[1];

	values[0] = CGETS_KL(VALOF_TBLPSFONTMAPLIST);
	*s = values;
	*n = 1;
	return 0;
}

int
UxValuesOfXrtTblPixmapSeries(s, n)
char ***s;
int  *n;
{
	static char *values[1];

	values[0] = CGETS_KL(VALOF_TBLPIXMAPSERIES);
	*s = values;
	*n = 1;
	return 0;
}


int
UxValuesOfXrtTblRange(s, n)
char ***s;
int  *n;
{
	static char *values[1];

	values[0] = CGETS_KL(VALOF_TBLRANGE);
	*s = values;
	*n = 1;
	return 0;
}

int
UxValuesOfXrtTblRangeList(s, n)
char ***s;
int  *n;
{
	static char *values[1];

	values[0] = CGETS_KL(VALOF_TBLRANGELIST);
	*s = values;
	*n = 1;
	return 0;
}

int
UxValuesOfXrtTblRepaint(ulist, n)
char ***ulist;
int  *n;
{
	*ulist = uXrtTblRepaint;
	*n = XtNumber(uXrtTblRepaint);
	return(*n);
}

int
UxValuesOfXrtTblResize(ulist, n)
char ***ulist;
int  *n;
{
	*ulist = uXrtTblResize;
	*n = XtNumber(uXrtTblResize);
	return(*n);
}

int
UxValuesOfXrtTblRotation(ulist, n)
char ***ulist;
int  *n;
{
	*ulist = uXrtTblRotation;
	*n = XtNumber(uXrtTblRotation);
	return(*n);
}

int
UxValuesOfXrtTblRowPlacement(ulist, n)
char ***ulist;
int  *n;
{
	*ulist = uXrtTblRowPlacement;
	*n = XtNumber(uXrtTblRowPlacement);
	return(*n);
}

int
UxValuesOfXrtTblSBPosition(ulist, n)
char ***ulist;
int  *n;
{
	*ulist = uXrtTblSBPosition;
	*n = XtNumber(uXrtTblSBPosition);
	return(*n);
}

int
UxValuesOfXrtTblSelectionPolicy(ulist, n)
char ***ulist;
int  *n;
{
	*ulist = uXrtTblSelectionPolicy;
	*n = XtNumber(uXrtTblSelectionPolicy);
	return( *n);
}

int
UxValuesOfXrtTblStringSeries(s, n)
char ***s;
int  *n;
{
	static char *values[1];

	values[0] = CGETS_KL(VALOF_TBLSTRINGSERIES);
	*s = values;
	*n = 1;
	return 0;
}

int
UxValuesOfXrtTblStringTable(s, n)
char ***s;
int  *n;
{
	static char *values[1];

	values[0] = CGETS_KL(VALOF_TBLSTRINGTABLE);
	*s = values;
	*n = 1;
	return 0;
}

int
UxValuesOfXrtTblValidatePolicy(ulist, n)
char ***ulist;
int  *n;
{
	*ulist = uXrtTblValidatePolicy;
	*n = XtNumber(uXrtTblValidatePolicy);
	return(*n);
}

int
UxValuesOfXrtTblWidgetSeries(s, n)
char ***s;
int  *n;
{
	static char *values[1];

	values[0] = CGETS_KL(VALOF_TBLWIDGETSERIES);
	*s = values;
	*n = 1;
	return 0;
}

int
UxValuesOfXrtTblXmStringGetMode(ulist, n)
char ***ulist;
int  *n;
{
	*ulist = uXrtTblXmStringGetMode;
	*n = XtNumber(uXrtTblXmStringGetMode);
	return(*n);
}

int
UxValuesOfXrtTblXmStringList(s, n)
char ***s;
int  *n;
{
	static char *values[1];

	values[0] = CGETS_KL(VALOF_TBLSTRINGLIST);
	*s = values;
	*n = 1;
	return 0;
}

int
UxValuesOfXrtTblXmStringSetMode(ulist, n)
char ***ulist;
int  *n;
{
	*ulist = uXrtTblXmStringSetMode;
	*n = XtNumber(uXrtTblXmStringSetMode);
	return(*n);
}


/*
 * Validate functions for both enumerated types and other Xtypes.
 * Use a general function for enumerated types.
 */

static int
ValidateXrtTblEnumType(rs, s, string_list, n)
swidget rs;
char	*s;
char	**string_list;
int		n;
{
	int i;

	if (s == NULL) {
		return ERROR;
	}
	for (i = 0; i < n; i++) {
		if (UxStrEqual(s, string_list[i])) {
			return NO_ERROR;
		}
	}
	return ERROR;
}

int
UxValidateXrtTblAlignment(rs, s)
swidget rs;
char *s;
{
	return(ValidateXrtTblEnumType(rs, s, uXrtTblAlignment,
								  XtNumber(uXrtTblAlignment)));
}

int
UxValidateXrtTblAttachment(rs, s)
swidget rs;
char *s;
{
	return(ValidateXrtTblEnumType(rs, s, uXrtTblAttachment,
								  XtNumber(uXrtTblAttachment)));
}

int
UxValidateXrtTblBorderSides(rs, s)
swidget rs;
char *s;
{
	return(ValidateXrtTblEnumType(rs, s, uXrtTblBorderSides,
								  XtNumber(uXrtTblBorderSides)));
}

int
UxValidateXrtTblBorderType(rs, s)
swidget rs;
char *s;
{
	return(ValidateXrtTblEnumType(rs, s, uXrtTblBorderType,
								  XtNumber(uXrtTblBorderType)));
}

int
UxValidateXrtTblCase(rs, s)
swidget rs;
char *s;
{
	return(ValidateXrtTblEnumType(rs, s, uXrtTblCase,
								  XtNumber(uXrtTblCase)));
}

int
UxValidateXrtTblCellValues(swgt, value)
swidget	swgt;
char	*value;
{
	XrtTblCellValues	*data;
	FILE				*fp;
	int					status = ERROR;

	if (!UxStrEqual(value,"")) {
		if ((fp = fopen(value, "r")) != NULL) {
			data = XrtTblReadAscii(UxGetWidget(swgt), fp, ",");
			if (data) {
				status = NO_ERROR;	
				XrtTblDestroyCellValues(data);
			}
			fclose(fp);
		}
	}
	else {
		status = NO_ERROR;
	}

	return (status);
}

int
UxValidateXrtTblColumnPlacement(rs, s)
swidget rs;
char *s;
{
	return(ValidateXrtTblEnumType(rs, s, uXrtTblColumnPlacement,
								  XtNumber(uXrtTblColumnPlacement)));
}

int
UxValidateXrtTblDataType(rs, s)
swidget rs;
char *s;
{
	return(ValidateXrtTblEnumType(rs, s, uXrtTblDataType,
								  XtNumber(uXrtTblDataType)));
}

int
UxValidateXrtTblDispScrollBar(rs, s)
swidget rs;
char *s;
{
	return(ValidateXrtTblEnumType(rs, s, uXrtTblDispScrollBar,
								  XtNumber(uXrtTblDispScrollBar)));
}

int
UxValidateXrtTblDoubleBuffer(rs, s)
swidget rs;
char *s;
{
	return(ValidateXrtTblEnumType(rs, s, uXrtTblDoubleBuffer,
								  XtNumber(uXrtTblDoubleBuffer)));
}

int
UxValidateXrtTblLabelBorderType(rs, s)
swidget rs;
char *s;
{
	return(ValidateXrtTblEnumType(rs, s, uXrtTblLabelBorderType,
								  XtNumber(uXrtTblLabelBorderType)));
}

int
UxValidateXrtTblLocation(rs, s)
swidget rs;
char *s;
{
	return(ValidateXrtTblEnumType(rs, s, uXrtTblLocation,
								  XtNumber(uXrtTblLocation)));
}

int
UxValidateXrtTblMode(rs, s)
swidget rs;
char *s;
{
	return(ValidateXrtTblEnumType(rs, s, uXrtTblMode,
								  XtNumber(uXrtTblMode)));
}

int
UxValidateXrtTblJumpScroll(rs, s)
swidget rs;
char *s;
{
	return(ValidateXrtTblEnumType(rs, s, uXrtTblJumpScroll,
								  XtNumber(uXrtTblJumpScroll)));
}

int
UxValidateXrtTblOverflow(rs, s)
swidget rs;
char *s;
{
	return(ValidateXrtTblEnumType(rs, s, uXrtTblOverflow,
								  XtNumber(uXrtTblOverflow)));
}

int
UxValidateXrtTblPixmapLayout(rs, s)
swidget rs;
char *s;
{
	return(ValidateXrtTblEnumType(rs, s, uXrtTblPixmapLayout,
								  XtNumber(uXrtTblPixmapLayout)));
}

int
UxValidateXrtTblRepaint(rs, s)
swidget rs;
char *s;
{
	return(ValidateXrtTblEnumType(rs, s, uXrtTblRepaint,
								  XtNumber(uXrtTblRepaint)));
}

int
UxValidateXrtTblResize(rs, s)
swidget rs;
char *s;
{
	return(ValidateXrtTblEnumType(rs, s, uXrtTblResize,
								  XtNumber(uXrtTblResize)));
}

int
UxValidateXrtTblRotation(rs, s)
swidget rs;
char *s;
{
	return(ValidateXrtTblEnumType(rs, s, uXrtTblRotation,
								  XtNumber(uXrtTblRotation)));
}

int
UxValidateXrtTblRowPlacement(rs, s)
swidget rs;
char *s;
{
	return(ValidateXrtTblEnumType(rs, s, uXrtTblRowPlacement,
								  XtNumber(uXrtTblRowPlacement)));
}

int
UxValidateXrtTblSBPosition(rs, s)
swidget rs;
char *s;
{
	return(ValidateXrtTblEnumType(rs, s, uXrtTblSBPosition,
								  XtNumber(uXrtTblSBPosition)));
}

int
UxValidateXrtTblSelectionPolicy(rs, s)
swidget rs;
char *s;
{
	return(ValidateXrtTblEnumType(rs, s, uXrtTblSelectionPolicy,
								  XtNumber(uXrtTblSelectionPolicy)));
}

int
UxValidateXrtTblValidatePolicy(rs, s)
swidget rs;
char *s;
{
	return(ValidateXrtTblEnumType(rs, s, uXrtTblValidatePolicy,
								  XtNumber(uXrtTblValidatePolicy)));
}

int
UxValidateXrtTblXmStringGetMode(rs, s)
swidget rs;
char *s;
{
	return(ValidateXrtTblEnumType(rs, s, uXrtTblXmStringGetMode,
								  XtNumber(uXrtTblXmStringGetMode)));
}

int
UxValidateXrtTblXmStringSetMode(rs, s)
swidget rs;
char *s;
{
	return(ValidateXrtTblEnumType(rs, s, uXrtTblXmStringSetMode,
								  XtNumber(uXrtTblXmStringSetMode)));
}

UxValuesOfXrtTblCurrencyPickList(s, n)
char ***s;
int  *n;
{
	static char *values[1];

	values[0]=CGETS_KL(VAOF_TBLCURRENCYPICKLIST);
	*s = values;
	*n = 1;
	return 0;
}


int
UxValuesOfXrtTblCurrencyPickListSeries(s, n)
char ***s;
int  *n;
{
	static char *values[1];

	values[0]=CGETS_KL(VAOF_TBLCURRENCYPICKLISTSERIES);
	*s = values;
	*n = 1;
	return 0;
}


int
UxValuesOfXrtTblDatePickList(s, n)
char ***s;
int  *n;
{
	static char *values[1];

	values[0]=CGETS_KL(VAOF_TBLDATEPICKLIST);
	*s = values;
	*n = 1;
	return 0;
}


int
UxValuesOfXrtTblDatePickListSeries(s, n)
char ***s;
int  *n;
{
	static char *values[1];

	values[0]=CGETS_KL(VAOF_TBLDATEPICKLISTSERIES);
	*s = values;
	*n = 1;
	return 0;
}


int
UxValuesOfXrtTblFloatPickList(s, n)
char ***s;
int  *n;
{
	static char *values[1];

	values[0]=CGETS_KL(VAOF_TBLFLOATPICKLIST);
	*s = values;
	*n = 1;
	return 0;
}


int
UxValuesOfXrtTblFloatPickListSeries(s, n)
char ***s;
int  *n;
{
	static char *values[1];

	values[0]=CGETS_KL(VAOF_TBLFLOATPICKLISTSERIES);
	*s = values;
	*n = 1;
	return 0;
}


int
UxValuesOfXrtTblIntPickList(s, n)
char ***s;
int  *n;
{
	static char *values[1];

	values[0]=CGETS_KL(VAOF_TBLINTPICKLIST);
	*s = values;
	*n = 1;
	return 0;
}


int
UxValuesOfXrtTblIntPickListSeries(s, n)
char ***s;
int  *n;
{
	static char *values[1];

	values[0]=CGETS_KL(VAOF_TBLINTPICKLISTSERIES);
	*s = values;
	*n = 1;
	return 0;
}


int
UxValuesOfXrtTblPreviewScrolling(ulist, n)
char ***ulist;
int	*n;
{
	*ulist = uXrtTblPreviewScrolling;
	*n = XtNumber(uXrtTblPreviewScrolling);
	return(*n);
}

int
UxValuesOfXrtTblStringPickList(s, n)
char ***s;
int  *n;
{
	static char *values[1];

	values[0]=CGETS_KL(VAOF_TBLSTRINGPICKLIST);
	*s = values;
	*n = 1;
	return 0;
}


int
UxValuesOfXrtTblStringPickListSeries(s, n)
char ***s;
int  *n;
{
	static char *values[1];

	values[0]=CGETS_KL(VAOF_TBLSTRINGPICKLISTSERIES);
	*s = values;
	*n = 1;
	return 0;
}


int
UxValidateXrtTblPreviewScrolling(rs, s)
swidget	rs;
char	*s;
{
	return(ValidateXrtTblEnumType(rs, s, uXrtTblPreviewScrolling,
								  XtNumber(uXrtTblPreviewScrolling)));
}


#endif   /* ! RUNTIME */

/* Conversion functions TO and FROM UIMX */

static int
String_Series(swgt, string, series, flag, name_series)
swidget				swgt;
char				**string;
XrtTblSeries		**series;
int					flag;
char				*name_series;
{
	int				status;
	XrmValue        from, to;
	Widget			table;

	status = ERROR;

	if (flag == TO_UIMX) {
		/*
		 *  Turn an XrtTblSeries structure into a string.
		 */
		

		from.size = sizeof(XrtTblSeries *);
		from.addr = (caddr_t) series;

		to.addr = NULL;

		if (XtConvertAndStore(UxTopLevel,
							  name_series, &from,
							  XtRString, &to))
		{
			*string = XrtEscapeQuotes(to.addr);
			if (to.addr) {
				XtFree(to.addr);
			}
			status = NO_ERROR;
		}
	}
	else {
		/*
		 *  Turn series string into a XrtTblSeries structure.
		 */

		
		from.size = strlen( *string ) + 1;
		from.addr = *string;

		to.size = sizeof(XrtTblSeries *);
		to.addr = (caddr_t) series;

		if (!(table = UxGetWidget(swgt))) {
			table = UxTopLevel;
		}
		if (XtConvertAndStore(table,
							  XtRString, &from,
							  name_series, &to))
		{
			status = NO_ERROR;
		}
	}

	return(status);
}

static int
String_AlignmentSeries(swgt, string, series, flag, xtype)
swidget				swgt;
char				**string;
XrtTblSeries		**series;
int					flag;
int					xtype;
{
	return(String_Series(swgt, string, series, flag, XmRxrtTblAlignmentSeries));
}

static int
String_BooleanSeries(swgt, string, series, flag, xtype)
swidget				swgt;
char				**string;
XrtTblSeries		**series;
int					flag;
int					xtype;
{
	return(String_Series(swgt, string, series, flag, XmRxrtTblBooleanSeries));
}

static int
String_BorderSidesSeries(swgt, string, series, flag, xtype)
swidget				swgt;
char				**string;
XrtTblSeries		**series;
int					flag;
int					xtype;
{
	return(String_Series(swgt, string, series, flag, XmRxrtTblBorderSidesSeries));
}

static int
String_BorderTypeSeries(swgt, string, series, flag, xtype)
swidget				swgt;
char				**string;
XrtTblSeries		**series;
int					flag;
int					xtype;
{
	return(String_Series(swgt, string, series, flag, XmRxrtTblBorderTypeSeries));
}

static int
String_CaseSeries(swgt, string, series, flag, xtype)
swidget				swgt;
char				**string;
XrtTblSeries		**series;
int					flag;
int					xtype;
{
	return(String_Series(swgt, string, series, flag, XmRxrtTblCaseSeries));
}

static int
String_CellSizeSeries(swgt, string, series, flag, xtype)
swidget				swgt;
char				**string;
XrtTblSeries		**series;
int					flag;
int					xtype;
{
	return(String_Series(swgt, string, series, flag, XmRxrtTblCellSizeSeries));
}

static int
File_CellValues(swgt, file, data, flag, xtype)
swidget				swgt;
char				**file;
XrtTblCellValues	**data;
int					flag;
int					xtype;
{
	int				status;
	XrmValue        from, to;
	XrtStringInfo	*info;

	status = ERROR;

	if (flag == TO_UIMX) {

		info = FindXrtStringInfo(File_CellValues, xtype, swgt);
		if (info) {
			*file = XtNewString(info->string);
		}
		else {
			*file = XtNewString("");
		}
		status = NO_ERROR;
	}
	else {

		if (**file) {
		
			from.size = strlen( *file ) + 1;
			from.addr = *file;

			to.size = sizeof(XrtTblCellValues *);
			to.addr = (caddr_t) data;

			if (XtConvertAndStore (UxTopLevel,
								   XtRString, &from,
								   XmRxrtTblCellValues, &to))
			{
				RegisterXrtStringInfo(File_CellValues, xtype, swgt, *file);
				status = NO_ERROR;
			}
		}
		else {
			*data = NULL;
			RegisterXrtStringInfo(File_CellValues,xtype,swgt,"");
			status = NO_ERROR;
		}
	}

	return(status);
}

static int
String_ColorSeries(swgt, string, series, flag, xtype)
swidget				swgt;
char				**string;
XrtTblSeries		**series;
int					flag;
int					xtype;
{
	return(String_Series(swgt, string, series, flag, XmRxrtTblColorSeries));
}

static int
String_Context(swgt, string, context, flag, xtype)
swidget			swgt;
char			**string;
XrtTblContext	**context;
int				flag;
int				xtype;
{
	int			i;
	int			status;
	XrmValue	from, to;

	status = ERROR;

	if (flag == TO_UIMX) {

		from.size = sizeof(XrtTblContext *);
		from.addr = (caddr_t) context;

		to.addr = NULL;

		if (XtConvertAndStore (UxTopLevel,
							   XmRxrtTblContext, &from,
							   XtRString, &to))
		{
			*string = XrtEscapeQuotes(to.addr);
			if (to.addr) {
				XtFree(to.addr);
			}
			status = NO_ERROR;
		}
	}
	else {
		
		from.size = strlen( *string ) + 1;
		from.addr = *string;

		to.size = sizeof(XrtTblContext *);
		to.addr = (caddr_t) context;

		if (XtConvertAndStore (UxTopLevel,
							   XtRString, &from,
							   XmRxrtTblContext, &to))
		{
			status = NO_ERROR;
		}
	}

	return(status);
}

static int
String_Cursor(swgt, string, cursor, flag, xtype)
swidget		swgt;
char		**string;
Cursor		*cursor;
int			flag;
int			xtype;
{
	int				status;
	XrmValue        from, to;
	XrtStringInfo	*info;

	status = ERROR;

	if (flag == TO_UIMX) {


		info = FindXrtStringInfo(String_Cursor, xtype, swgt);
		if (info) {
			*string = XtNewString(info->string);
		}
		else {
			*string = XtNewString("");
		}
		status = NO_ERROR;
	}
	else {
		
		from.size = strlen( *string ) + 1;
		from.addr = *string;

		to.size = sizeof(Cursor);
		to.addr = (caddr_t) cursor;

		if (XtConvertAndStore (UxTopLevel,
							   XtRString, &from,
							   XtRCursor, &to))
		{
			status = NO_ERROR;
			RegisterXrtStringInfo(String_Cursor, xtype, swgt, *string);
		}
	}
	
	return(status);
}

static int
String_DataTypeSeries(swgt, string, series, flag, xtype)
swidget				swgt;
char				**string;
XrtTblSeries		**series;
int					flag;
int					xtype;
{
	return(String_Series(swgt, string, series, flag, XmRxrtTblDataTypeSeries));
}

static int
String_FontList(swgt, string, fontlist, flag, xtype)
swidget			swgt;
char			**string;
XmFontList		*fontlist;
int				flag;
int				xtype;
{
	int				status;
	XrmValue        from, to;

	status = ERROR;

	if (flag == TO_UIMX) {
		
		from.size = sizeof(XmFontList);
		from.addr = (caddr_t) fontlist;

		to.addr = NULL;

		if (XtConvertAndStore(UxTopLevel,
							  XmRFontList, &from,
							  XmRString, &to))
		{
			*string = XrtEscapeQuotes(to.addr);
			if (to.addr) {
				XtFree(to.addr);
			}
			status = NO_ERROR;
		}
	}
	else {
		/*
		 *  Turn a XmFontList into a string
		 */

		
		from.size = strlen( *string ) + 1;
		from.addr = *string;

		to.size = sizeof(XmFontList);
		to.addr = (caddr_t) fontlist;

		if (XtConvertAndStore(UxTopLevel,
							  XmRString, &from,
							  XmRFontList, &to))
		{
			status = NO_ERROR;
		}
	}

done:
	return(status);
}

static int
String_FontListSeries(swgt, string, series, flag, xtype)
swidget				swgt;
char				**string;
XrtTblSeries		**series;
int					flag;
int					xtype;
{
	int				status;
	XrmValue        from, to;
	XrtStringInfo	*info;

	status = ERROR;

	if (flag == TO_UIMX) {


		info = FindXrtStringInfo(String_FontListSeries, xtype, swgt);
		if (info) {
			*string = XtNewString(info->string);
		}
		else {
			*string = XtNewString("");
		}
		status = NO_ERROR;
	}
	else {

		status = String_Series(swgt, string, series, flag,
							   XmRxrtTblFontListSeries);
		
		if (status == NO_ERROR) {
			RegisterXrtStringInfo(String_FontListSeries, xtype, swgt, *string);
		}
	}
	
	return(status);
}

static int
String_IntSeries(swgt, string, series, flag, xtype)
swidget				swgt;
char				**string;
XrtTblSeries		**series;
int					flag;
int					xtype;
{
	return(String_Series(swgt, string, series, flag, XmRxrtTblIntSeries));
}

static int
String_OverflowSeries(swgt, string, series, flag, xtype)
swidget				swgt;
char				**string;
XrtTblSeries		**series;
int					flag;
int					xtype;
{
	return(String_Series(swgt, string, series, flag, XmRxrtTblOverflowSeries));
}

static int
String_Pixmap(swgt, string, pixmap, flag, xtype)
swidget				swgt;
char				**string;
Pixmap				*pixmap;
int					flag;
int					xtype;
{
	int				status;
	XrmValue        from, to;
	XrtStringInfo	*info;

	status = ERROR;

	if (flag == TO_UIMX) {


		info = FindXrtStringInfo(String_Pixmap, xtype, swgt);
		if (info) {
			*string = XtNewString(info->string);
		}
		else {
			*string = XtNewString("");
		}
		status = NO_ERROR;
	}
	else {
		
		from.size = strlen( *string ) + 1;
		from.addr = *string;

		to.size = sizeof(Pixmap);
		to.addr = (caddr_t) pixmap;

		if (XtConvertAndStore(UxTopLevel,
							  XtRString, &from,
							  XmRPixmap, &to))
		{
			status = NO_ERROR;
			RegisterXrtStringInfo(String_Pixmap, xtype, swgt, *string);
		}
	}
	
	return(status);
}

static int
String_PixmapLayoutSeries(swgt, string, series, flag, xtype)
swidget				swgt;
char				**string;
XrtTblSeries		**series;
int					flag;
int					xtype;
{
	return(String_Series(swgt, string, series, flag,
						 XmRxrtTblPixmapLayoutSeries));
}

static int
String_PixmapSeries(swgt, string, series, flag, xtype)
swidget				swgt;
char				**string;
XrtTblSeries		**series;
int					flag;
int					xtype;
{
	int				status;
	XrmValue        from, to;
	XrtStringInfo	*info;

	status = ERROR;

	if (flag == TO_UIMX) {


		info = FindXrtStringInfo(String_PixmapSeries, xtype, swgt);
		if (info) {
			*string = XtNewString(info->string);
		}
		else {
			*string = XtNewString("");
		}
		status = NO_ERROR;
	}
	else {

		status = String_Series(swgt, string, series, flag,
							   XmRxrtTblPixmapSeries);
		
		if (status == NO_ERROR) {
			RegisterXrtStringInfo(String_PixmapSeries, xtype, swgt, *string);
		}
	}
	
	return(status);
}

static int
String_PSFontMapList(swgt, string, PSFontMap, flag, xtype)
swidget			swgt;
char			**string;
XrtTblPSFontMap	**PSFontMap;
int				flag;
int				xtype;
{
	int			i;
	int			status;
	XrmValue	from, to;

	status = ERROR;

	if (flag == TO_UIMX) {
		/*
		 *  Turn a PSFontMapList into a string.
		 */
		

		from.size = sizeof(XrtTblPSFontMap *);
		from.addr = (caddr_t) PSFontMap;

		to.addr = NULL;

		if (XtConvertAndStore (UxTopLevel,
							   XmRxrtTblPSFontMapList, &from,
							   XtRString, &to))
		{
			*string = XrtEscapeQuotes(to.addr);
			if (to.addr) {
				XtFree(to.addr);
			}
			status = NO_ERROR;
		}
	}
	else {
		/*
		 *  Turn string into a PSFontMapList.
		 */
		
		
		from.size = strlen( *string ) + 1;
		from.addr = *string;

		to.size = sizeof(XrtTblPSFontMap *);
		to.addr = (caddr_t) PSFontMap;

		if (XtConvertAndStore (UxTopLevel,
							   XtRString, &from,
							   XmRxrtTblPSFontMapList, &to))
		{
			status = NO_ERROR;
		}
	}

	return(status);
}

static int
String_Range(swgt, string, range, flag, xtype)
swidget			swgt;
char			**string;
XrtTblRange		**range;
int				flag;
int				xtype;
{
	int			i;
	int			status;
	XrmValue	from, to;

	status = ERROR;

	if (flag == TO_UIMX) {
		/*
		 *  Turn a range into a string.
		 */
		

		from.size = sizeof(XrtTblRange *);
		from.addr = (caddr_t) range;

		to.addr = NULL;

		if (XtConvertAndStore (UxTopLevel,
							   XmRxrtTblRange, &from,
							   XtRString, &to))
		{
			*string = XrtEscapeQuotes(to.addr);
			if (to.addr) {
				XtFree(to.addr);
			}
			status = NO_ERROR;
		}
	}
	else {
		/*
		 *  Turn string into a range.
		 */
		
		
		from.size = strlen( *string ) + 1;
		from.addr = *string;

		to.size = sizeof(XrtTblRange *);
		to.addr = (caddr_t) range;

		if (XtConvertAndStore (UxTopLevel,
							   XtRString, &from,
							   XmRxrtTblRange, &to))
		{
			status = NO_ERROR;
		}
	}

	return(status);
}

static int
String_RangeList(swgt, string, rangelist, flag, xtype)
swidget			swgt;
char			**string;
XrtTblRange		***rangelist;
int				flag;
int				xtype;
{
	int			i;
	int			status;
	XrmValue	from, to;

	status = ERROR;

	if (flag == TO_UIMX) {
		/*
		 *  Turn a list of ranges into a string.
		 */
		

		from.size = sizeof(XrtTblRange **);
		from.addr = (caddr_t) rangelist;

		to.addr = NULL;

		if (XtConvertAndStore (UxTopLevel,
							   XmRxrtTblRangeList, &from,
							   XtRString, &to))
		{
			*string = XrtEscapeQuotes(to.addr);
			if (to.addr) {
				XtFree(to.addr);
			}
			status = NO_ERROR;
		}
	}
	else {
		/*
		 *  Turn string into a list of ranges.
		 */
		
		
		from.size = strlen( *string ) + 1;
		from.addr = *string;

		to.size = sizeof(XrtTblRange **);
		to.addr = (caddr_t) rangelist;

		if (XtConvertAndStore (UxTopLevel,
							   XtRString, &from,
							   XmRxrtTblRangeList, &to))
		{
			status = NO_ERROR;
		}
	}

	return(status);
}

static int
String_StringSeries(swgt, string, series, flag, xtype)
swidget				swgt;
char				**string;
XrtTblSeries		**series;
int					flag;
int					xtype;
{
	return(String_Series(swgt, string, series, flag, XmRxrtTblStringSeries));
}


static int
String_StringTable(swgt, string, string_list, flag, xtype)
swidget				swgt;
char				**string;
char				***string_list;
int					flag;
int					xtype;
{
	int			status;
	XrmValue	from, to;

	status = ERROR;

	if (flag == TO_UIMX) {
		/*
		 *  Turn stringTable into a string.
		 */
		

		from.size = sizeof(char**);
		from.addr = (caddr_t) string_list;

		to.addr = NULL;

		if (XtConvertAndStore (UxTopLevel,
							   XmRStringTable, &from,
							   XmRString, &to))
		{
			*string = XrtEscapeQuotes(to.addr);
			if (to.addr) {
				XtFree(to.addr);
			}
			status = NO_ERROR;
		}
	}
	else {
		/*
		 *  Turn string into a stringTable.
		 */
		
		
		from.size = strlen( *string ) + 1;
		from.addr = *string;

		to.size = sizeof(char **);
		to.addr = (caddr_t) string_list;

		if (XtConvertAndStore (UxTopLevel,
							   XtRString, &from,
							   XmRStringTable, &to))
		{
			status = NO_ERROR;
		}
	}

	return(status);
}

static int
String_WidgetSeries(swgt, string, series, flag, xtype)
swidget				swgt;
char				**string;
XrtTblSeries		**series;
int					flag;
int					xtype;
{
	return(String_Series(swgt, string, series, flag, XmRxrtTblWidgetSeries));
}

static int
String_XmStringList(swgt, string, xmstrings, flag, xtype)
swidget				swgt;
char				**string;
XrtTblXmStringList	**xmstrings;
int					flag;
int					xtype;
{
	int			i;
	int			status;
	XrmValue	from, to;

	status = ERROR;

	if (flag == TO_UIMX) {
		/*
		 *  Turn a list of XmStrings into a string.
		 */
		

		from.size = sizeof(XrtTblXmStringList *);
		from.addr = (caddr_t) xmstrings;

		to.addr = NULL;

		if (XtConvertAndStore (UxTopLevel,
							   XmRxrtTblXmStringList, &from,
							   XtRString, &to))
		{
			*string = XrtEscapeQuotes(to.addr);
			if (to.addr) {
				XtFree(to.addr);
			}
			status = NO_ERROR;
		}
	}
	else {
		/*
		 *  Turn string into a list of XmStrings.
		 */
		
		
		from.size = strlen( *string ) + 1;
		from.addr = *string;

		to.size = sizeof(XrtTblXmStringList	*);
		to.addr = (caddr_t) xmstrings;

		if (XtConvertAndStore (UxTopLevel,
							   XtRString, &from,
							   XmRxrtTblXmStringList, &to))
		{
			status = NO_ERROR;
		}
	}

	return(status);
}


static int
String_CurrencyPickListSeries(swgt, string, series, flag, xtype)
swidget				swgt;
char				**string;
XrtTblSeries		**series;
int					flag;
int					xtype;
{
	return(String_Series(swgt, string, series, flag, XmRxrtTblCurrencyPickListSeries));
}

static int
String_DatePickListSeries(swgt, string, series, flag, xtype)
swidget				swgt;
char				**string;
XrtTblSeries		**series;
int					flag;
int					xtype;
{
	return(String_Series(swgt, string, series, flag, XmRxrtTblDatePickListSeries));
}

static int
String_FloatPickListSeries(swgt, string, series, flag, xtype)
swidget				swgt;
char				**string;
XrtTblSeries		**series;
int					flag;
int					xtype;
{
	return(String_Series(swgt, string, series, flag, XmRxrtTblFloatPickListSeries));
}

static int
String_StringPickListSeries(swgt, string, series, flag, xtype)
swidget				swgt;
char				**string;
XrtTblSeries		**series;
int					flag;
int					xtype;
{
	return(String_Series(swgt, string, series, flag, XmRxrtTblStringPickListSeries));
}

static int
String_IntPickListSeries(swgt, string, series, flag, xtype)
swidget				swgt;
char				**string;
XrtTblSeries		**series;
int					flag;
int					xtype;
{
	return(String_Series(swgt, string, series, flag, XmRxrtTblIntPickListSeries));
}


static int
String_CurrencyPickList(swgt, string, currency_list, flag, xtype)
swidget			swgt;
char			**string;
double			**currency_list;
int				flag;
int				xtype;
{
	int			i;
	int			status;
	XrmValue	from, to;

	status = ERROR;

	if (flag == TO_UIMX) {
		/*
		 *  Turn a CurrencyPickList into a string.
		 */
		
		from.size = sizeof(double *);
		from.addr = (caddr_t) currency_list;
		to.addr = NULL;
		if (XtConvertAndStore (UxTopLevel,
							   XmRxrtTblCurrencyPickList, &from,
							   XtRString, &to))
		{
			*string = XrtEscapeQuotes(to.addr);
			if (to.addr) {
				XtFree(to.addr);
			}
			status = NO_ERROR;
		}
	}
	else {
		/*
		 *  Turn string into a CurrencyPickList.
		 */
		
		from.size = strlen( *string ) + 1;
		from.addr = *string;
		to.size = sizeof(double *);
		to.addr = (caddr_t) currency_list;
		if (XtConvertAndStore (UxTopLevel,
							   XtRString, &from,
							   XmRxrtTblCurrencyPickList, &to))
		{
			status = NO_ERROR;
		}
	}

	return(status);
}

static int
String_DatePickList(swgt, string, date_list, flag, xtype)
swidget			swgt;
char			**string;
struct tm		***date_list;
int				flag;
int				xtype;
{
	int			i;
	int			status;
	XrmValue	from, to;

	status = ERROR;

	if (flag == TO_UIMX) {
		/*
		 *  Turn a DatePickList into a string.
		 */
		from.size = sizeof(struct tm **);
		from.addr = (caddr_t) date_list;
		to.addr = NULL;

		if (XtConvertAndStore (UxTopLevel,
							   XmRxrtTblDatePickList, &from,
							   XtRString, &to))
		{
			*string = XrtEscapeQuotes(to.addr);
			if (to.addr) {
				XtFree(to.addr);
			}
			status = NO_ERROR;
		}
	}
	else {
		/*
		 *  Turn string into a DatePickList.
		 */
		from.size = strlen( *string ) + 1;
		from.addr = *string;
		to.size = sizeof(struct tm **);
		to.addr = (caddr_t) date_list;
		if (XtConvertAndStore (UxTopLevel,
							   XtRString, &from,
							   XmRxrtTblDatePickList, &to))
		{
			status = NO_ERROR;
		}
	}
	return(status);
}

static int
String_FloatPickList(swgt, string, float_list, flag, xtype)
swidget			swgt;
char			**string;
double			**float_list;
int				flag;
int				xtype;
{
	int			i;
	int			status;
	XrmValue	from, to;

	status = ERROR;

	if (flag == TO_UIMX) {
		/*
		 *  Turn a FloatPickList into a string.
		 */
		
		from.size = sizeof(double *);
		from.addr = (caddr_t) float_list;

		to.addr = NULL;

		if (XtConvertAndStore (UxTopLevel,
							   XmRxrtTblFloatPickList, &from,
							   XtRString, &to))
		{
			*string = XrtEscapeQuotes(to.addr);
			if (to.addr) {
				XtFree(to.addr);
			}
			status = NO_ERROR;
		}
	}
	else {
		/*
		 *  Turn string into a FloatPickList.
		 */
		
		from.size = strlen( *string ) + 1;
		from.addr = *string;

		to.size = sizeof(double *);
		to.addr = (caddr_t) float_list;

		if (XtConvertAndStore (UxTopLevel,
							   XtRString, &from,
							   XmRxrtTblFloatPickList, &to))
		{
			status = NO_ERROR;
		}
	}
	return(status);
}

static int
String_IntPickList(swgt, string, int_list, flag, xtype)
swidget			swgt;
char			**string;
int				**int_list;
int				flag;
int				xtype;
{
	int			i;
	int			status;
	XrmValue	from, to;

	status = ERROR;

	if (flag == TO_UIMX) {
		/*
		 *  Turn a IntPickList into a string.
		 */
		from.size = sizeof(int *);
		from.addr = (caddr_t) int_list;

		to.addr = NULL;

		if (XtConvertAndStore (UxTopLevel,
							   XmRxrtTblIntPickList, &from,
							   XtRString, &to))
		{
			*string = XrtEscapeQuotes(to.addr);
			if (to.addr) {
				XtFree(to.addr);
			}
			status = NO_ERROR;
		}
	}
	else {
		/*
		 *  Turn string into a IntPickList.
		 */
		
		from.size = strlen( *string ) + 1;
		from.addr = *string;

		to.size = sizeof(int *);
		to.addr = (caddr_t) int_list;

		if (XtConvertAndStore (UxTopLevel,
							   XtRString, &from,
							   XmRxrtTblIntPickList, &to))
		{
			status = NO_ERROR;
		}
	}

	return(status);
}

static int
String_StringPickList(swgt, string, string_list, flag, xtype)
swidget			swgt;
char			**string;
String			**string_list;
int				flag;
int				xtype;
{
	int			i;
	int			status;
	XrmValue	from, to;

	status = ERROR;

	if (flag == TO_UIMX) {
		/*
		 *  Turn a StringPickList into a string.
		 */
		
		from.size = sizeof(String *);
		from.addr = (caddr_t) string_list;

		to.addr = NULL;

		if (XtConvertAndStore (UxTopLevel,
							   XmRxrtTblStringPickList, &from,
							   XtRString, &to))
		{
			*string = XrtEscapeQuotes(to.addr);
			if (to.addr) {
				XtFree(to.addr);
			}
			status = NO_ERROR;
		}
	}
	else {
		/*
		 *  Turn string into a StringPickList.
		 */
		
		from.size = strlen( *string ) + 1;
		from.addr = *string;

		to.size = sizeof(String *);
		to.addr = (caddr_t) string_list;

		if (XtConvertAndStore (UxTopLevel,
							   XtRString, &from,
							   XmRxrtTblStringPickList, &to))
		{
			status = NO_ERROR;
		}
	}

	return(status);
}


void
XrtTbl_enum()
{
	UxXT_XrtTblAlignment =
		UxAddEnumType(XmRxrtTblAlignment, 
  					  sizeof(unsigned char),
					  xXrtTblAlignment, 
					  uXrtTblAlignment, 
					  dXrtTblAlignment, 
					  XtNumber(uXrtTblAlignment), 
					  UxStringToCharEnum); 

	UxXT_XrtTblAttachment =
		UxAddEnumType(XmRxrtTblAttachment, 
					  sizeof(unsigned char),
					  xXrtTblAttachment, 
					  uXrtTblAttachment, 
					  dXrtTblAttachment, 
					  XtNumber(uXrtTblAttachment), 
					  UxStringToCharEnum); 

	UxXT_XrtTblBorderType =
		UxAddEnumType(XmRxrtTblBorderType, 
					  sizeof(unsigned char),
					  xXrtTblBorderType, 
					  uXrtTblBorderType, 
					  dXrtTblBorderType, 
					  XtNumber(uXrtTblBorderType), 
					  UxStringToCharEnum); 

	UxXT_XrtTblLabelBorderType =
		UxAddEnumType(XmRxrtLblBorderType, 
					  sizeof(unsigned char),
					  xXrtTblLabelBorderType, 
					  uXrtTblLabelBorderType, 
					  dXrtTblLabelBorderType, 
					  XtNumber(uXrtTblLabelBorderType), 
					  UxStringToCharEnum); 
	
	UxXT_XrtTblCase =
		UxAddEnumType(XmRxrtTblCase, 
					  sizeof(unsigned char),
					  xXrtTblCase, 
					  uXrtTblCase, 
					  dXrtTblCase, 
					  XtNumber(uXrtTblCase), 
					  UxStringToCharEnum); 

	UxXT_XrtTblColumnPlacement =
		UxAddEnumType(XmRxrtTblColumnPlacement, 
					  sizeof(unsigned char),
					  xXrtTblColumnPlacement, 
					  uXrtTblColumnPlacement, 
					  dXrtTblColumnPlacement, 
					  XtNumber(uXrtTblColumnPlacement), 
					  UxStringToCharEnum); 

	UxXT_XrtTblDataType =
		UxAddEnumType(XmRxrtTblDataType, 
					  sizeof(unsigned char),
					  xXrtTblDataType, 
					  uXrtTblDataType, 
					  dXrtTblDataType, 
					  XtNumber(uXrtTblDataType), 
					  UxStringToCharEnum); 

	UxXT_XrtTblDispScrollBar =
		UxAddEnumType(XmRxrtTblDispScrollBar, 
					  sizeof(unsigned char),
					  xXrtTblDispScrollBar, 
					  uXrtTblDispScrollBar, 
					  dXrtTblDispScrollBar, 
					  XtNumber(uXrtTblDispScrollBar), 
					  UxStringToCharEnum); 

	UxXT_XrtTblDoubleBuffer =
		UxAddEnumType(XmRxrtTblDoubleBuffer, 
					  sizeof(unsigned char),
					  xXrtTblDoubleBuffer, 
					  uXrtTblDoubleBuffer, 
					  dXrtTblDoubleBuffer, 
					  XtNumber(uXrtTblDoubleBuffer), 
					  UxStringToCharEnum);

	UxXT_XrtTblJumpScroll =
		UxAddEnumType(XmRxrtTblJumpScroll, 
					  sizeof(unsigned char),
					  xXrtTblJumpScroll, 
					  uXrtTblJumpScroll, 
					  dXrtTblJumpScroll, 
					  XtNumber(uXrtTblJumpScroll), 
					  UxStringToCharEnum); 

	UxXT_XrtTblBorderSides =
		UxAddEnumType(XmRxrtTblBorderSides, 
					  sizeof(unsigned char),
					  xXrtTblBorderSides, 
					  uXrtTblBorderSides, 
					  dXrtTblBorderSides, 
					  XtNumber(uXrtTblBorderSides), 
					  UxStringToCharEnum); 

	UxXT_XrtTblLocation =
		UxAddEnumType(XmRxrtTblLocation, 
					  sizeof(unsigned char),
					  xXrtTblLocation, 
					  uXrtTblLocation, 
					  dXrtTblLocation, 
					  XtNumber(uXrtTblLocation), 
					  UxStringToCharEnum); 

	UxXT_XrtTblMode =
		UxAddEnumType(XmRxrtTblMode, 
					  sizeof(unsigned char),
					  xXrtTblMode, 
					  uXrtTblMode, 
					  dXrtTblMode, 
					  XtNumber(uXrtTblMode), 
					  UxStringToCharEnum); 

	UxXT_XrtTblOverflow =
		UxAddEnumType(XmRxrtTblOverflow, 
					  sizeof(unsigned char),
					  xXrtTblOverflow, 
					  uXrtTblOverflow, 
					  dXrtTblOverflow, 
					  XtNumber(uXrtTblOverflow), 
					  UxStringToCharEnum); 

	UxXT_XrtTblPixmapLayout =
		UxAddEnumType(XmRxrtTblPixmapLayout, 
					  sizeof(unsigned char),
					  xXrtTblPixmapLayout, 
					  uXrtTblPixmapLayout, 
					  dXrtTblPixmapLayout, 
					  XtNumber(uXrtTblPixmapLayout), 
					  UxStringToCharEnum); 

	UxXT_XrtTblSBPosition =
		UxAddEnumType(XmRxrtTblScrollBarPosition, 
					  sizeof(unsigned char),
					  xXrtTblSBPosition, 
					  uXrtTblSBPosition, 
					  dXrtTblSBPosition, 
					  XtNumber(uXrtTblSBPosition), 
					  UxStringToCharEnum); 

	UxXT_XrtTblRepaint =
		UxAddEnumType(XmRxrtTblRepaint, 
					  sizeof(unsigned char),
					  xXrtTblRepaint, 
					  uXrtTblRepaint, 
					  dXrtTblRepaint, 
					  XtNumber(uXrtTblRepaint), 
					  UxStringToCharEnum); 

	UxXT_XrtTblResize =
		UxAddEnumType(XmRxrtTblResize, 
					  sizeof(unsigned char),
					  xXrtTblResize, 
					  uXrtTblResize, 
					  dXrtTblResize, 
					  XtNumber(uXrtTblResize), 
					  UxStringToCharEnum); 

	UxXT_XrtTblRotation =
		UxAddEnumType(XmRxrtLblRotation, 
					  sizeof(unsigned char),
					  xXrtTblRotation, 
					  uXrtTblRotation, 
					  dXrtTblRotation, 
					  XtNumber(uXrtTblRotation), 
					  UxStringToCharEnum);
	
	UxXT_XrtTblRowPlacement =
		UxAddEnumType(XmRxrtTblRowPlacement, 
					  sizeof(unsigned char),
					  xXrtTblRowPlacement, 
					  uXrtTblRowPlacement, 
					  dXrtTblRowPlacement, 
					  XtNumber(uXrtTblRowPlacement), 
					  UxStringToCharEnum);
	
	UxXT_XrtTblSelectionPolicy =
		UxAddEnumType(XmRxrtTblSelectionPolicy, 
					  sizeof(unsigned char),
					  xXrtTblSelectionPolicy, 
					  uXrtTblSelectionPolicy, 
					  dXrtTblSelectionPolicy, 
					  XtNumber(uXrtTblSelectionPolicy), 
					  UxStringToCharEnum); 


	UxXT_XrtTblValidatePolicy =
		UxAddEnumType(XmRxrtTblValidatePolicy, 
					  sizeof(unsigned char),
					  xXrtTblValidatePolicy, 
					  uXrtTblValidatePolicy, 
					  dXrtTblValidatePolicy, 
					  XtNumber(uXrtTblValidatePolicy), 
					  UxStringToCharEnum);
	
	UxXT_XrtTblXmStringGetMode =
		UxAddEnumType(XmRxrtTblXmStringGetMode, 
					  sizeof(unsigned char),
					  xXrtTblXmStringGetMode, 
					  uXrtTblXmStringGetMode, 
					  dXrtTblXmStringGetMode, 
					  XtNumber(uXrtTblXmStringGetMode), 
					  UxStringToCharEnum);
	
	UxXT_XrtTblXmStringSetMode =
		UxAddEnumType(XmRxrtTblXmStringSetMode, 
					  sizeof(unsigned char),
					  xXrtTblXmStringSetMode, 
					  uXrtTblXmStringSetMode, 
					  dXrtTblXmStringSetMode, 
					  XtNumber(uXrtTblXmStringSetMode), 
					  UxStringToCharEnum);
	
	UxXT_XrtTblPreviewScrolling = UxAddEnumType(XmRxrtTblPreviewScrolling, 
									sizeof(unsigned char),
									xXrtTblPreviewScrolling,
									uXrtTblPreviewScrolling,
									dXrtTblPreviewScrolling,
									XtNumber(xXrtTblPreviewScrolling),
									UxStringToCharEnum);

}

/* Add new XRT/table xtypes */

void
XrtTbl_xtypes()
{
	/*
	 * Initialize widget class inorder to initialize converters.  Also
	 * install reverse converters.
	 */
	
	XtInitializeWidgetClass(xtXrtLabelWidgetClass);
	XtInitializeWidgetClass(xtXrtTableWidgetClass);
	XrtTblSetReverseConverters();

	UxXT_XrtTblAlignmentSeries      = UxAddXtype(XmRxrtTblAlignmentSeries,
												 sizeof(XrtTblSeries *));
	UxXT_XrtTblBooleanSeries        = UxAddXtype(XmRxrtTblBooleanSeries,
												 sizeof(XrtTblSeries *));
	UxXT_XrtTblBorderSidesSeries    = UxAddXtype(XmRxrtTblBorderSidesSeries,
												 sizeof(XrtTblSeries *));
	UxXT_XrtTblBorderTypeSeries     = UxAddXtype(XmRxrtTblBorderTypeSeries,
												 sizeof(XrtTblSeries *));
	UxXT_XrtTblCaseSeries           = UxAddXtype(XmRxrtTblCaseSeries,
												 sizeof(XrtTblSeries *));
	UxXT_XrtTblCellSizeSeries       = UxAddXtype(XmRxrtTblCellSizeSeries,
												 sizeof(XrtTblSeries *));
	UxXT_XrtTblCellValues           = UxAddXtype(XmRxrtTblCellValues,
												 sizeof(XrtTblCellValues *));
	UxXT_XrtTblColorSeries          = UxAddXtype(XmRxrtTblColorSeries,
												 sizeof(XrtTblSeries *));
	UxXT_XrtTblContext              = UxAddXtype(XmRxrtTblContext,
												 sizeof(XrtTblContext *));
	UxXT_XrtTblCursorCorner         = UxAddXtype(XtRCursor, sizeof(Cursor));
	UxXT_XrtTblCursorHorizontal     = UxAddXtype(XtRCursor, sizeof(Cursor));
	UxXT_XrtTblCursorNonTrvrsbl     = UxAddXtype(XtRCursor, sizeof(Cursor));
	UxXT_XrtTblCursorTrvrsbl        = UxAddXtype(XtRCursor, sizeof(Cursor));
	UxXT_XrtTblCursorVertical       = UxAddXtype(XtRCursor, sizeof(Cursor));
	UxXT_XrtTblDataTypeSeries       = UxAddXtype(XmRxrtTblDataTypeSeries,
												 sizeof(XrtTblSeries *));
	UxXT_XrtTblFontList             = UxAddXtype(XmRFontList,
												 sizeof(XmFontList));
	UxXT_XrtTblFontListSeries       = UxAddXtype(XmRxrtTblFontListSeries,
												 sizeof(XrtTblSeries *));
	UxXT_XrtTblIntSeries            = UxAddXtype(XmRxrtTblIntSeries,
												 sizeof(XrtTblSeries *));
	UxXT_XrtTblOverflowSeries       = UxAddXtype(XmRxrtTblOverflowSeries,
												 sizeof(XrtTblSeries *));
	UxXT_XrtTblPixmap				= UxAddXtype(XmRPixmap, sizeof(Pixmap));
	UxXT_XrtTblPixmapLayoutSeries   = UxAddXtype(XmRxrtTblPixmapLayoutSeries,
												 sizeof(XrtTblSeries *));
	UxXT_XrtTblPixmapSeries         = UxAddXtype(XmRxrtTblPixmapSeries,
												 sizeof(XrtTblSeries *));
	UxXT_XrtTblPSFontMapList		= UxAddXtype(XmRxrtTblPSFontMapList,
												 sizeof(XrtTblPSFontMap *));
	UxXT_XrtTblRange                = UxAddXtype(XmRxrtTblRange,
												 sizeof(XrtTblRange *));
	UxXT_XrtTblRangeList            = UxAddXtype(XmRxrtTblRangeList,
												 sizeof(XrtTblRange **));
	UxXT_XrtTblStringSeries         = UxAddXtype(XmRxrtTblStringSeries,
												 sizeof(XrtTblSeries *));
	UxXT_XrtTblStringTable         = UxAddXtype(XmRStringTable,
												sizeof(String *));

	UxXT_XrtTblWidgetSeries         = UxAddXtype(XmRxrtTblWidgetSeries,
												 sizeof(XrtTblSeries *));
	UxXT_XrtTblXmStringList         = UxAddXtype(XmRxrtTblXmStringList,
												 sizeof(XrtTblXmStringList *));

	UxXT_XrtTblCurrencyPickList	=
		UxAddXtype(XmRxrtTblCurrencyPickList, sizeof(double *));
	UxXT_XrtTblCurrencyPickListSeries	=
		UxAddXtype(XmRxrtTblCurrencyPickListSeries, sizeof(XrtTblSeries *));
	UxXT_XrtTblDatePickList	= UxAddXtype(XmRxrtTblDatePickList,
										 sizeof(struct tm **));
	UxXT_XrtTblDatePickListSeries	=
		UxAddXtype(XmRxrtTblDatePickListSeries, sizeof(XrtTblSeries *));
	UxXT_XrtTblFloatPickList	= UxAddXtype(XmRxrtTblFloatPickList,
											 sizeof(double *));
	UxXT_XrtTblFloatPickListSeries	=
		UxAddXtype(XmRxrtTblFloatPickListSeries, sizeof(XrtTblSeries *));
	UxXT_XrtTblIntPickList	= UxAddXtype(XmRxrtTblIntPickList,
										 sizeof(int *));
	UxXT_XrtTblIntPickListSeries	=
		UxAddXtype(XmRxrtTblIntPickListSeries, sizeof(XrtTblSeries *));
	UxXT_XrtTblStringPickList	= UxAddXtype(XmRxrtTblStringPickList,
											 sizeof(String *));
	UxXT_XrtTblStringPickListSeries	=
		UxAddXtype(XmRxrtTblStringPickListSeries,
				   sizeof(XrtTblSeries *));

	/* Add new converters for Xtypes */

	UxAddConv(UxUT_string,UxXT_XrtTblAlignmentSeries,	String_AlignmentSeries);
	UxAddConv(UxUT_string,UxXT_XrtTblBooleanSeries,		String_BooleanSeries);
	UxAddConv(UxUT_string,UxXT_XrtTblBorderSidesSeries, String_BorderSidesSeries);
	UxAddConv(UxUT_string,UxXT_XrtTblBorderTypeSeries,	String_BorderTypeSeries);
	UxAddConv(UxUT_string,UxXT_XrtTblCaseSeries,		String_CaseSeries);
	UxAddConv(UxUT_string,UxXT_XrtTblCellSizeSeries,	String_CellSizeSeries);
	UxAddConv(UxUT_string,UxXT_XrtTblCellValues,		File_CellValues);
	UxAddConv(UxUT_string,UxXT_XrtTblColorSeries,		String_ColorSeries);
	UxAddConv(UxUT_string,UxXT_XrtTblContext,			String_Context);
	UxAddConv(UxUT_string,UxXT_XrtTblCursorCorner,		String_Cursor);
	UxAddConv(UxUT_string,UxXT_XrtTblCursorHorizontal,	String_Cursor);
	UxAddConv(UxUT_string,UxXT_XrtTblCursorNonTrvrsbl,	String_Cursor);
	UxAddConv(UxUT_string,UxXT_XrtTblCursorTrvrsbl,		String_Cursor);
	UxAddConv(UxUT_string,UxXT_XrtTblCursorVertical,	String_Cursor);
	UxAddConv(UxUT_string,UxXT_XrtTblDataTypeSeries,	String_DataTypeSeries);
	UxAddConv(UxUT_string,UxXT_XrtTblFontList,			String_FontList);
	UxAddConv(UxUT_string,UxXT_XrtTblFontListSeries,	String_FontListSeries);
	UxAddConv(UxUT_string,UxXT_XrtTblIntSeries,			String_IntSeries);
	UxAddConv(UxUT_string,UxXT_XrtTblOverflowSeries,	String_OverflowSeries);
	UxAddConv(UxUT_string,UxXT_XrtTblPixmap,			String_Pixmap);
	UxAddConv(UxUT_string,UxXT_XrtTblPixmapLayoutSeries,String_PixmapLayoutSeries);
	UxAddConv(UxUT_string,UxXT_XrtTblPixmapSeries,		String_PixmapSeries);
	UxAddConv(UxUT_string,UxXT_XrtTblPSFontMapList,		String_PSFontMapList);
	UxAddConv(UxUT_string,UxXT_XrtTblRange,				String_Range);
	UxAddConv(UxUT_string,UxXT_XrtTblRangeList,			String_RangeList);
	UxAddConv(UxUT_string,UxXT_XrtTblStringSeries,		String_StringSeries);
	UxAddConv(UxUT_string,UxXT_XrtTblStringTable,		String_StringTable);
	UxAddConv(UxUT_string,UxXT_XrtTblWidgetSeries,		String_WidgetSeries);
	UxAddConv(UxUT_string,UxXT_XrtTblXmStringList,		String_XmStringList);

  	UxAddConv(UxUT_string, UxXT_XrtTblCurrencyPickList, String_CurrencyPickList);
  	UxAddConv(UxUT_string, UxXT_XrtTblCurrencyPickListSeries, 
			  String_CurrencyPickListSeries);
  	UxAddConv(UxUT_string, UxXT_XrtTblDatePickList, String_DatePickList);
  	UxAddConv(UxUT_string, UxXT_XrtTblDatePickListSeries, 
			  String_DatePickListSeries);
  	UxAddConv(UxUT_string, UxXT_XrtTblFloatPickList, String_FloatPickList);
  	UxAddConv(UxUT_string, UxXT_XrtTblFloatPickListSeries, 
			  String_FloatPickListSeries);
  	UxAddConv(UxUT_string, UxXT_XrtTblIntPickList, String_IntPickList);
  	UxAddConv(UxUT_string, UxXT_XrtTblIntPickListSeries, 
			  String_IntPickListSeries);
  	UxAddConv(UxUT_string, UxXT_XrtTblStringPickList, String_StringPickList);
  	UxAddConv(UxUT_string, UxXT_XrtTblStringPickListSeries, 
			  String_StringPickListSeries);
}
