/* $AstecId: XrtGauge_restb.c,v 1.3 2003/02/14 02:23:31 kosaka Exp $ */
/* ALL RIGHTS RESERVED
 *
 * This file is provided for demonstration and educational uses only.
 * Permission to use, copy, modify and distribute this file for
 * any purpose and without fee is hereby granted, provided that the
 * above copyright notice and this permission notice appear in all
 * copies, and that the name of KL Group not be used in advertising
 * or publicity pertaining to this material without the specific,
 * prior written permission of an authorized representative of
 * KL Group.
 *
 * KL GROUP MAKES NO REPRESENTATIONS AND EXTENDS NO WARRANTIES, EX-
 * PRESS OR IMPLIED, WITH RESPECT TO THE SOFTWARE, INCLUDING, BUT
 * NOT LIMITED TO, THE IMPLIED WARRANTIES OF MERCHANTABILITY AND
 * FITNESS FOR ANY PARTICULAR PURPOSE, AND THE WARRANTY AGAINST IN-
 * FRINGEMENT OF PATENTS OR OTHER INTELLECTUAL PROPERTY RIGHTS.  THE
 * SOFTWARE IS PROVIDED "AS IS", AND IN NO EVENT SHALL KL GROUP OR
 * ANY OF ITS AFFILIATES BE LIABLE FOR ANY DAMAGES, INCLUDING ANY
 * LOST PROFITS OR OTHER INCIDENTAL OR CONSEQUENTIAL DAMAGES
 * RELATING TO THE USE OF THIS SOFTWARE.
 *
 *
 * XRT/gauge widget UIM/X integration file
 *
 *  SCCSID -- @(#)XrtGauge_restb.c	1.3    99/12/17 KL Group Inc.
 */

/*****************************************************************************
				XrtGauge_restb.c
*****************************************************************************/

#ifdef HASXRTGAUGE

#include <Xm/XrtGauge.h>
#include <UxLib.h>

#ifdef DESIGN_TIME

#include "veos.h"       		/* Visual Edge object system */
#include "valuesOf.h"   		/* ValuesOf & Validator functions */

#include "XrtGauge.cl.h"

#else

#include "stub_runtime.h"

#endif /* DESIGN_TIME */

#include "XrtGauge_xtype.h"
#include "Xrt_restable.h"

extern swidget UxGUIPopupColorView();
extern swidget UxGUIPopupPixView();

static int	XrtGaPutDouble();
static float	XrtGaGetDouble();


XrtGaugeResourceDesc	XrtGaCenter_res_table[] = {
{
	"background",
	"RD_background",
	XmNbackground,
	"XmNbackground",
	XRTGA_XM_PIXEL,
	{0, 0, 0},
	Offset(UxXrtGaCenterClass, XrtGaCenter.RD_background),
	XRTDIV_SPECIFIC,
	XRTPASS0,
	NULL,
	XrtGaCenter_background,
	FALSE,
	TRUE
},
{
	"xrtGaCircularScale",
	"RD_xrtGaCircularScale",
	XmNxrtGaCircularScale,
	"XmNxrtGaCircularScale",
	XRTGA_OBJECT,
	{0, 0, 0},
	Offset(UxXrtGaCenterClass, XrtGaCenter.RD_xrtGaCircularScale),
	XRTDIV_SPECIFIC,
	XRTPASS0,
	NULL,
	XrtGaCenter_CircularScale,
	FALSE,
	TRUE
},
{
	"xrtGaDebug",
	"RD_xrtGaDebug",
	XmNxrtGaDebug,
	"XmNxrtGaDebug",
	XRTGA_XM_BOOLEAN,
	{0, 0, 0},
	Offset(UxXrtGaCenterClass, XrtGaCenter.RD_xrtGaDebug),
	XRTDIV_SPECIFIC,
	XRTPASS0,
	NULL,
	XrtGaCenter_Debug,
	FALSE,
	TRUE
},
{
	"xrtGaImage",
	"RD_xrtGaImage",
	XmNxrtGaImage,
	"XmNxrtGaImage",
	XRTGA_IMAGE,
	{0, 0, 0},
	Offset(UxXrtGaCenterClass, XrtGaCenter.RD_xrtGaImage),
	XRTDIV_SPECIFIC,
	XRTPASS0,
	NULL,
	XrtGaCenter_Image,
	FALSE,
	TRUE
},
{
	"xrtGaIsShowing",
	"RD_xrtGaIsShowing",
	XmNxrtGaIsShowing,
	"XmNxrtGaIsShowing",
	XRTGA_XM_BOOLEAN,
	{0, 0, 0},
	Offset(UxXrtGaCenterClass, XrtGaCenter.RD_xrtGaIsShowing),
	XRTDIV_SPECIFIC,
	XRTPASS0,
	NULL,
	XrtGaCenter_IsShowing,
	FALSE,
	TRUE
},
{
	"xrtGaRadius",
	"RD_xrtGaRadius",
	XmNxrtGaRadius,
	"XmNxrtGaRadius",
	XRTGA_DOUBLE,
	{0, 0, 0},
	Offset(UxXrtGaCenterClass, XrtGaCenter.RD_xrtGaRadius),
	XRTDIV_SPECIFIC,
	XRTPASS0,
	NULL,
	XrtGaCenter_Radius,
	FALSE,
	TRUE
},
};

XrtGaugeResourceDesc	XrtGaCircularDial_res_table[] = {
{
	"xrtGaBorder",
	"RD_xrtGaBorder",
	XmNxrtGaBorder,
	"XmNxrtGaBorder",
	XRTGA_BORDER,
	{0, 0, 0},
	Offset(UxXrtGaCircularDialClass, XrtGaCircularDial.RD_xrtGaBorder),
	XRTDIV_SPECIFIC,
	XRTPASS0,
	NULL,
	XrtGaCDial_Border,
	FALSE,
	TRUE
},
{
	"xrtGaCircularScale",
	"RD_xrtGaCircularScale",
	XmNxrtGaCircularScale,
	"XmNxrtGaCircularScale",
	XRTGA_OBJECT,
	{0, 0, 0},
	Offset(UxXrtGaCircularDialClass, XrtGaCircularDial.RD_xrtGaCircularScale),
	XRTDIV_SPECIFIC,
	XRTPASS0,
	NULL,
	XrtGaCDial_CircularScale,
	FALSE,
	TRUE
},
{
	"xrtGaCounterList",
	"RD_xrtGaCounterList",
	XmNxrtGaCounterList,
	"XmNxrtGaCounterList",
	XRTGA_OBJECT_LIST,
	{0, 0, 0},
	Offset(UxXrtGaCircularDialClass, XrtGaCircularDial.RD_xrtGaCounterList),
	XRTDIV_SPECIFIC,
	XRTPASS0,
	NULL,
	XrtGaCDial_CounterList,
	TRUE,
	TRUE
},
{
	"xrtGaDebug",
	"RD_xrtGaDebug",
	XmNxrtGaDebug,
	"XmNxrtGaDebug",
	XRTGA_XM_BOOLEAN,
	{0, 0, 0},
	Offset(UxXrtGaCircularDialClass, XrtGaCircularDial.RD_xrtGaDebug),
	XRTDIV_SPECIFIC,
	XRTPASS0,
	NULL,
	XrtGaCDial_Debug,
	FALSE,
	TRUE
},
{
	"xrtGaDoubleBuffer",
	"RD_xrtGaDoubleBuffer",
	XmNxrtGaDoubleBuffer,
	"XmNxrtGaDoubleBuffer",
	XRTGA_XM_BOOLEAN,
	{0, 0, 0},
	Offset(UxXrtGaCircularDialClass, XrtGaCircularDial.RD_xrtGaDoubleBuffer),
	XRTDIV_SPECIFIC,
	XRTPASS0,
	NULL,
	XrtGaCDial_DoubleBuffer,
	FALSE,
	TRUE
},
{
	"xrtGaExposeCallback",
	"RD_xrtGaExposeCallback",
	XmNxrtGaExposeCallback,
	"XmNxrtGaExposeCallback",
	XRTGA_CALLBACK,
	{0, 0, 0},
	Offset(UxXrtGaCircularDialClass, XrtGaCircularDial.RD_xrtGaExposeCallback),
	XRTDIV_BEHAVIOR,
	XRTPASS0,
	NULL,
	XrtGaCDial_ExposeCallback,
	FALSE,
	TRUE
},
{
	"xrtGaFrame",
	"RD_xrtGaFrame",
	XmNxrtGaFrame,
	"XmNxrtGaFrame",
	XRTGA_OBJECT,
	{0, 0, 0},
	Offset(UxXrtGaCircularDialClass, XrtGaCircularDial.RD_xrtGaFrame),
	XRTDIV_SPECIFIC,
	XRTPASS0,
	NULL,
	XrtGaCDial_Frame,
	FALSE,
	TRUE
},
{
	"xrtGaHighlightColor",
	"RD_xrtGaHighlightColor",
	XmNxrtGaHighlightColor,
	"XmNxrtGaHighlightColor",
	XRTGA_XM_PIXEL,
	{0, 0, 0},
	Offset(UxXrtGaCircularDialClass, XrtGaCircularDial.RD_xrtGaHighlightColor),
	XRTDIV_SPECIFIC,
	XRTPASS0,
	NULL,
	XrtGaCDial_HighlightColor,
	FALSE,
	TRUE
},
{
	"xrtGaHighlightSelectedState",
	"RD_xrtGaHighlightSelectedState",
	XmNxrtGaHighlightSelectedState,
	"XmNxrtGaHighlightSelectedState",
	XRTGA_XM_BOOLEAN,
	{0, 0, 0},
	Offset(UxXrtGaCircularDialClass, XrtGaCircularDial.RD_xrtGaHighlightSelectedState),
	XRTDIV_SPECIFIC,
	XRTPASS0,
	NULL,
	XrtGaCDial_HighlightSelectedState,
	FALSE,
	TRUE
},
{
	"xrtGaImage",
	"RD_xrtGaImage",
	XmNxrtGaImage,
	"XmNxrtGaImage",
	XRTGA_IMAGE,
	{0, 0, 0},
	Offset(UxXrtGaCircularDialClass, XrtGaCircularDial.RD_xrtGaImage),
	XRTDIV_SPECIFIC,
	XRTPASS0,
	NULL,
	XrtGaCDial_Image,
	FALSE,
	TRUE
},
{
	"xrtGaImageLayout",
	"RD_xrtGaImageLayout",
	XmNxrtGaImageLayout,
	"XmNxrtGaImageLayout",
	XRTGA_IMAGE_LAYOUT,
	{0, 0, 0},
	Offset(UxXrtGaCircularDialClass, XrtGaCircularDial.RD_xrtGaImageLayout),
	XRTDIV_SPECIFIC,
	XRTPASS0,
	NULL,
	XrtGaCDial_ImageLayout,
	FALSE,
	TRUE
},
{
	"xrtGaInteractionCallback",
	"RD_xrtGaInteractionCallback",
	XmNxrtGaInteractionCallback,
	"XmNxrtGaInteractionCallback",
	XRTGA_CALLBACK,
	{0, 0, 0},
	Offset(UxXrtGaCircularDialClass, XrtGaCircularDial.RD_xrtGaInteractionCallback),
	XRTDIV_BEHAVIOR,
	XRTPASS0,
	NULL,
	XrtGaCDial_InteractionCallback,
	FALSE,
	TRUE
},
{
	"xrtGaLineInnerRadius",
	"RD_xrtGaLineInnerRadius",
	XmNxrtGaLineInnerRadius,
	"XmNxrtGaLineInnerRadius",
	XRTGA_DOUBLE,
	{0, 0, 0},
	Offset(UxXrtGaCircularDialClass, XrtGaCircularDial.RD_xrtGaLineInnerRadius),
	XRTDIV_SPECIFIC,
	XRTPASS0,
	NULL,
	XrtGaCDial_LineInnerRadius,
	FALSE,
	TRUE
},
{
	"xrtGaLineOuterRadius",
	"RD_xrtGaLineOuterRadius",
	XmNxrtGaLineOuterRadius,
	"XmNxrtGaLineOuterRadius",
	XRTGA_DOUBLE,
	{0, 0, 0},
	Offset(UxXrtGaCircularDialClass, XrtGaCircularDial.RD_xrtGaLineOuterRadius),
	XRTDIV_SPECIFIC,
	XRTPASS0,
	NULL,
	XrtGaCDial_LineOuterRadius,
	FALSE,
	TRUE
},
{
	"xrtGaMapCallback",
	"RD_xrtGaMapCallback",
	XmNxrtGaMapCallback,
	"XmNxrtGaMapCallback",
	XRTGA_CALLBACK,
	{0, 0, 0},
	Offset(UxXrtGaCircularDialClass, XrtGaCircularDial.RD_xrtGaMapCallback),
	XRTDIV_BEHAVIOR,
	XRTPASS0,
	NULL,
	XrtGaCDial_MapCallback,
	FALSE,
	TRUE
},
{
	"xrtGaMarker",
	"RD_xrtGaMarker",
	XmNxrtGaMarker,
	"XmNxrtGaMarker",
	XRTGA_MARKER_TYPE,
	{0, 0, 0},
	Offset(UxXrtGaCircularDialClass, XrtGaCircularDial.RD_xrtGaMarker),
	XRTDIV_SPECIFIC,
	XRTPASS0,
	NULL,
	XrtGaCDial_Marker,
	FALSE,
	TRUE
},
{
	"xrtGaOffsetDistance",
	"RD_xrtGaOffsetDistance",
	XmNxrtGaOffsetDistance,
	"XmNxrtGaOffsetDistance",
	XRTGA_DOUBLE,
	{0, 0, 0},
	Offset(UxXrtGaCircularDialClass, XrtGaCircularDial.RD_xrtGaOffsetDistance),
	XRTDIV_SPECIFIC,
	XRTPASS0,
	NULL,
	XrtGaCDial_OffsetDistance,
	FALSE,
	TRUE
},
{
	"xrtGaOffsetType",
	"RD_xrtGaOffsetType",
	XmNxrtGaOffsetType,
	"XmNxrtGaOffsetType",
	XRTGA_OFFSET_TYPE,
	{0, 0, 0},
	Offset(UxXrtGaCircularDialClass, XrtGaCircularDial.RD_xrtGaOffsetType),
	XRTDIV_SPECIFIC,
	XRTPASS0,
	NULL,
	XrtGaCDial_OffsetType,
	FALSE,
	TRUE
},
{
	"xrtGaRangeList",
	"RD_xrtGaRangeList",
	XmNxrtGaRangeList,
	"XmNxrtGaRangeList",
	XRTGA_OBJECT_LIST,
	{0, 0, 0},
	Offset(UxXrtGaCircularDialClass, XrtGaCircularDial.RD_xrtGaRangeList),
	XRTDIV_SPECIFIC,
	XRTPASS0,
	NULL,
	XrtGaCDial_RangeList,
	TRUE,
	TRUE
},
{
	"xrtGaRenderList",
	"RD_xrtGaRenderList",
	XmNxrtGaRenderList,
	"XmNxrtGaRenderList",
	XRTGA_OBJECT_LIST,
	{0, 0, 0},
	Offset(UxXrtGaCircularDialClass, XrtGaCircularDial.RD_xrtGaRenderList),
	XRTDIV_SPECIFIC,
	XRTPASS0,
	NULL,
	XrtGaCDial_RenderList,
	TRUE,
	TRUE
},
{
	"xrtGaRepaint",
	"RD_xrtGaRepaint",
	XmNxrtGaRepaint,
	"XmNxrtGaRepaint",
	XRTGA_XM_BOOLEAN,
	{0, 0, 0},
	Offset(UxXrtGaCircularDialClass, XrtGaCircularDial.RD_xrtGaRepaint),
	XRTDIV_SPECIFIC,
	XRTPASS0,
	NULL,
	XrtGaCDial_Repaint,
	FALSE,
	TRUE
},
{
	"xrtGaResizeCallback",
	"RD_xrtGaResizeCallback",
	XmNxrtGaResizeCallback,
	"XmNxrtGaResizeCallback",
	XRTGA_CALLBACK,
	{0, 0, 0},
	Offset(UxXrtGaCircularDialClass, XrtGaCircularDial.RD_xrtGaResizeCallback),
	XRTDIV_BEHAVIOR,
	XRTPASS0,
	NULL,
	XrtGaCDial_ResizeCallback,
	FALSE,
	TRUE
},
{
	"xrtGaStateList",
	"RD_xrtGaStateList",
	XmNxrtGaStateList,
	"XmNxrtGaStateList",
	XRTGA_OBJECT_LIST,
	{0, 0, 0},
	Offset(UxXrtGaCircularDialClass, XrtGaCircularDial.RD_xrtGaStateList),
	XRTDIV_SPECIFIC,
	XRTPASS0,
	NULL,
	XrtGaCDial_StateList,
	TRUE,
	TRUE
},
{
	"xrtGaSwitch",
	"RD_xrtGaSwitch",
	XmNxrtGaSwitch,
	"XmNxrtGaSwitch",
	XRTGA_SWITCH_TYPE,
	{0, 0, 0},
	Offset(UxXrtGaCircularDialClass, XrtGaCircularDial.RD_xrtGaSwitch),
	XRTDIV_SPECIFIC,
	XRTPASS0,
	NULL,
	XrtGaCDial_Switch,
	FALSE,
	TRUE
},
{
	"xrtGaTextList",
	"RD_xrtGaTextList",
	XmNxrtGaTextList,
	"XmNxrtGaTextList",
	XRTGA_OBJECT_LIST,
	{0, 0, 0},
	Offset(UxXrtGaCircularDialClass, XrtGaCircularDial.RD_xrtGaTextList),
	XRTDIV_SPECIFIC,
	XRTPASS0,
	NULL,
	XrtGaCDial_TextList,
	TRUE,
	TRUE
},
{
	"xrtGaTickList",
	"RD_xrtGaTickList",
	XmNxrtGaTickList,
	"XmNxrtGaTickList",
	XRTGA_OBJECT_LIST,
	{0, 0, 0},
	Offset(UxXrtGaCircularDialClass, XrtGaCircularDial.RD_xrtGaTickList),
	XRTDIV_SPECIFIC,
	XRTPASS0,
	NULL,
	XrtGaCDial_TickList,
	TRUE,
	TRUE
},
{
	"xrtGaUseRenderList",
	"RD_xrtGaUseRenderList",
	XmNxrtGaUseRenderList,
	"XmNxrtGaUseRenderList",
	XRTGA_XM_BOOLEAN,
	{0, 0, 0},
	Offset(UxXrtGaCircularDialClass, XrtGaCircularDial.RD_xrtGaUseRenderList),
	XRTDIV_SPECIFIC,
	XRTPASS0,
	NULL,
	XrtGaCDial_UseRenderList,
	FALSE,
	TRUE
},
};

XrtGaugeResourceDesc	XrtGaCircularGauge_res_table[] = {
{
	"xrtGaBorder",
	"RD_xrtGaBorder",
	XmNxrtGaBorder,
	"XmNxrtGaBorder",
	XRTGA_BORDER,
	{0, 0, 0},
	Offset(UxXrtGaCircularGaugeClass, XrtGaCircularGauge.RD_xrtGaBorder),
	XRTDIV_SPECIFIC,
	XRTPASS0,
	NULL,
	XrtGaCGauge_Border,
	FALSE,
	TRUE
},
{
	"xrtGaCenterList",
	"RD_xrtGaCenterList",
	XmNxrtGaCenterList,
	"XmNxrtGaCenterList",
	XRTGA_OBJECT_LIST,
	{0, 0, 0},
	Offset(UxXrtGaCircularGaugeClass, XrtGaCircularGauge.RD_xrtGaCenterList),
	XRTDIV_SPECIFIC,
	XRTPASS0,
	NULL,
	XrtGaCGauge_CenterList,
	TRUE,
	TRUE
},
{
	"xrtGaCircularScaleList",
	"RD_xrtGaCircularScaleList",
	XmNxrtGaCircularScaleList,
	"XmNxrtGaCircularScaleList",
	XRTGA_OBJECT_LIST,
	{0, 0, 0},
	Offset(UxXrtGaCircularGaugeClass, XrtGaCircularGauge.RD_xrtGaCircularScaleList),
	XRTDIV_SPECIFIC,
	XRTPASS0,
	NULL,
	XrtGaCGauge_CircularScaleList,
	TRUE,
	TRUE
},
{
	"xrtGaCounterList",
	"RD_xrtGaCounterList",
	XmNxrtGaCounterList,
	"XmNxrtGaCounterList",
	XRTGA_OBJECT_LIST,
	{0, 0, 0},
	Offset(UxXrtGaCircularGaugeClass, XrtGaCircularGauge.RD_xrtGaCounterList),
	XRTDIV_SPECIFIC,
	XRTPASS0,
	NULL,
	XrtGaCGauge_CounterList,
	TRUE,
	TRUE
},
{
	"xrtGaDebug",
	"RD_xrtGaDebug",
	XmNxrtGaDebug,
	"XmNxrtGaDebug",
	XRTGA_XM_BOOLEAN,
	{0, 0, 0},
	Offset(UxXrtGaCircularGaugeClass, XrtGaCircularGauge.RD_xrtGaDebug),
	XRTDIV_SPECIFIC,
	XRTPASS0,
	NULL,
	XrtGaCGauge_Debug,
	FALSE,
	TRUE
},
{
	"xrtGaDoubleBuffer",
	"RD_xrtGaDoubleBuffer",
	XmNxrtGaDoubleBuffer,
	"XmNxrtGaDoubleBuffer",
	XRTGA_XM_BOOLEAN,
	{0, 0, 0},
	Offset(UxXrtGaCircularGaugeClass, XrtGaCircularGauge.RD_xrtGaDoubleBuffer),
	XRTDIV_SPECIFIC,
	XRTPASS0,
	NULL,
	XrtGaCGauge_DoubleBuffer,
	FALSE,
	TRUE
},
{
	"xrtGaExposeCallback",
	"RD_xrtGaExposeCallback",
	XmNxrtGaExposeCallback,
	"XmNxrtGaExposeCallback",
	XRTGA_CALLBACK,
	{0, 0, 0},
	Offset(UxXrtGaCircularGaugeClass, XrtGaCircularGauge.RD_xrtGaExposeCallback),
	XRTDIV_BEHAVIOR,
	XRTPASS0,
	NULL,
	XrtGaCGauge_ExposeCallback,
	FALSE,
	TRUE
},
{
	"xrtGaFrame",
	"RD_xrtGaFrame",
	XmNxrtGaFrame,
	"XmNxrtGaFrame",
	XRTGA_OBJECT,
	{0, 0, 0},
	Offset(UxXrtGaCircularGaugeClass, XrtGaCircularGauge.RD_xrtGaFrame),
	XRTDIV_SPECIFIC,
	XRTPASS0,
	NULL,
	XrtGaCGauge_Frame,
	FALSE,
	TRUE
},
{
	"xrtGaImage",
	"RD_xrtGaImage",
	XmNxrtGaImage,
	"XmNxrtGaImage",
	XRTGA_IMAGE,
	{0, 0, 0},
	Offset(UxXrtGaCircularGaugeClass, XrtGaCircularGauge.RD_xrtGaImage),
	XRTDIV_SPECIFIC,
	XRTPASS0,
	NULL,
	XrtGaCGauge_Image,
	FALSE,
	TRUE
},
{
	"xrtGaImageLayout",
	"RD_xrtGaImageLayout",
	XmNxrtGaImageLayout,
	"XmNxrtGaImageLayout",
	XRTGA_IMAGE_LAYOUT,
	{0, 0, 0},
	Offset(UxXrtGaCircularGaugeClass, XrtGaCircularGauge.RD_xrtGaImageLayout),
	XRTDIV_SPECIFIC,
	XRTPASS0,
	NULL,
	XrtGaCGauge_ImageLayout,
	FALSE,
	TRUE
},
{
	"xrtGaInteractionCallback",
	"RD_xrtGaInteractionCallback",
	XmNxrtGaInteractionCallback,
	"XmNxrtGaInteractionCallback",
	XRTGA_CALLBACK,
	{0, 0, 0},
	Offset(UxXrtGaCircularGaugeClass, XrtGaCircularGauge.RD_xrtGaInteractionCallback),
	XRTDIV_BEHAVIOR,
	XRTPASS0,
	NULL,
	XrtGaCGauge_InteractionCallback,
	FALSE,
	TRUE
},
{
	"xrtGaMapCallback",
	"RD_xrtGaMapCallback",
	XmNxrtGaMapCallback,
	"XmNxrtGaMapCallback",
	XRTGA_CALLBACK,
	{0, 0, 0},
	Offset(UxXrtGaCircularGaugeClass, XrtGaCircularGauge.RD_xrtGaMapCallback),
	XRTDIV_BEHAVIOR,
	XRTPASS0,
	NULL,
	XrtGaCGauge_MapCallback,
	FALSE,
	TRUE
},
{
	"xrtGaNeedleList",
	"RD_xrtGaNeedleList",
	XmNxrtGaNeedleList,
	"XmNxrtGaNeedleList",
	XRTGA_OBJECT_LIST,
	{0, 0, 0},
	Offset(UxXrtGaCircularGaugeClass, XrtGaCircularGauge.RD_xrtGaNeedleList),
	XRTDIV_SPECIFIC,
	XRTPASS0,
	NULL,
	XrtGaCGauge_NeedleList,
	TRUE,
	TRUE
},
{
	"xrtGaRangeList",
	"RD_xrtGaRangeList",
	XmNxrtGaRangeList,
	"XmNxrtGaRangeList",
	XRTGA_OBJECT_LIST,
	{0, 0, 0},
	Offset(UxXrtGaCircularGaugeClass, XrtGaCircularGauge.RD_xrtGaRangeList),
	XRTDIV_SPECIFIC,
	XRTPASS0,
	NULL,
	XrtGaCGauge_RangeList,
	TRUE,
	TRUE
},
{
	"xrtGaRenderList",
	"RD_xrtGaRenderList",
	XmNxrtGaRenderList,
	"XmNxrtGaRenderList",
	XRTGA_OBJECT_LIST,
	{0, 0, 0},
	Offset(UxXrtGaCircularGaugeClass, XrtGaCircularGauge.RD_xrtGaRenderList),
	XRTDIV_SPECIFIC,
	XRTPASS0,
	NULL,
	XrtGaCGauge_RenderList,
	TRUE,
	TRUE
},
{
	"xrtGaRepaint",
	"RD_xrtGaRepaint",
	XmNxrtGaRepaint,
	"XmNxrtGaRepaint",
	XRTGA_XM_BOOLEAN,
	{0, 0, 0},
	Offset(UxXrtGaCircularGaugeClass, XrtGaCircularGauge.RD_xrtGaRepaint),
	XRTDIV_SPECIFIC,
	XRTPASS0,
	NULL,
	XrtGaCGauge_Repaint,
	FALSE,
	TRUE
},
{
	"xrtGaResizeCallback",
	"RD_xrtGaResizeCallback",
	XmNxrtGaResizeCallback,
	"XmNxrtGaResizeCallback",
	XRTGA_CALLBACK,
	{0, 0, 0},
	Offset(UxXrtGaCircularGaugeClass, XrtGaCircularGauge.RD_xrtGaResizeCallback),
	XRTDIV_BEHAVIOR,
	XRTPASS0,
	NULL,
	XrtGaCGauge_ResizeCallback,
	FALSE,
	TRUE
},
{
	"xrtGaTextList",
	"RD_xrtGaTextList",
	XmNxrtGaTextList,
	"XmNxrtGaTextList",
	XRTGA_OBJECT_LIST,
	{0, 0, 0},
	Offset(UxXrtGaCircularGaugeClass, XrtGaCircularGauge.RD_xrtGaTextList),
	XRTDIV_SPECIFIC,
	XRTPASS0,
	NULL,
	XrtGaCGauge_TextList,
	TRUE,
	TRUE
},
{
	"xrtGaTickList",
	"RD_xrtGaTickList",
	XmNxrtGaTickList,
	"XmNxrtGaTickList",
	XRTGA_OBJECT_LIST,
	{0, 0, 0},
	Offset(UxXrtGaCircularGaugeClass, XrtGaCircularGauge.RD_xrtGaTickList),
	XRTDIV_SPECIFIC,
	XRTPASS0,
	NULL,
	XrtGaCGauge_TickList,
	TRUE,
	TRUE
},
{
	"xrtGaUseRenderList",
	"RD_xrtGaUseRenderList",
	XmNxrtGaUseRenderList,
	"XmNxrtGaUseRenderList",
	XRTGA_XM_BOOLEAN,
	{0, 0, 0},
	Offset(UxXrtGaCircularGaugeClass, XrtGaCircularGauge.RD_xrtGaUseRenderList),
	XRTDIV_SPECIFIC,
	XRTPASS0,
	NULL,
	XrtGaCGauge_UseRenderList,
	FALSE,
	TRUE
},
};

XrtGaugeResourceDesc	XrtGaCircularScale_res_table[] = {
{
	"background",
	"RD_background",
	XmNbackground,
	"XmNbackground",
	XRTGA_XM_PIXEL,
	{0, 0, 0},
	Offset(UxXrtGaCircularScaleClass, XrtGaCircularScale.RD_background),
	XRTDIV_SPECIFIC,
	XRTPASS0,
	NULL,
	XrtGaCScale_background,
	FALSE,
	TRUE
},
{
	"xrtGaAllowTransform",
	"RD_xrtGaAllowTransform",
	XmNxrtGaAllowTransform,
	"XmNxrtGaAllowTransform",
	XRTGA_XM_BOOLEAN,
	{0, 0, 0},
	Offset(UxXrtGaCircularScaleClass, XrtGaCircularScale.RD_xrtGaAllowTransform),
	XRTDIV_SPECIFIC,
	XRTPASS0,
	NULL,
	XrtGaCScale_AllowTransform,
	FALSE,
	TRUE
},
{
	"xrtGaDebug",
	"RD_xrtGaDebug",
	XmNxrtGaDebug,
	"XmNxrtGaDebug",
	XRTGA_XM_BOOLEAN,
	{0, 0, 0},
	Offset(UxXrtGaCircularScaleClass, XrtGaCircularScale.RD_xrtGaDebug),
	XRTDIV_SPECIFIC,
	XRTPASS0,
	NULL,
	XrtGaCScale_Debug,
	FALSE,
	TRUE
},
{
	"xrtGaDirection",
	"RD_xrtGaDirection",
	XmNxrtGaDirection,
	"XmNxrtGaDirection",
	XRTGA_DIRECTION,
	{0, 0, 0},
	Offset(UxXrtGaCircularScaleClass, XrtGaCircularScale.RD_xrtGaDirection),
	XRTDIV_SPECIFIC,
	XRTPASS0,
	NULL,
	XrtGaCScale_Direction,
	FALSE,
	TRUE
},
{
	"xrtGaMax",
	"RD_xrtGaMax",
	XmNxrtGaMax,
	"XmNxrtGaMax",
	XRTGA_DOUBLE,
	{0, 0, 0},
	Offset(UxXrtGaCircularScaleClass, XrtGaCircularScale.RD_xrtGaMax),
	XRTDIV_SPECIFIC,
	XRTPASS0,
	NULL,
	XrtGaCScale_Max,
	FALSE,
	TRUE
},
{
	"xrtGaMin",
	"RD_xrtGaMin",
	XmNxrtGaMin,
	"XmNxrtGaMin",
	XRTGA_DOUBLE,
	{0, 0, 0},
	Offset(UxXrtGaCircularScaleClass, XrtGaCircularScale.RD_xrtGaMin),
	XRTDIV_SPECIFIC,
	XRTPASS0,
	NULL,
	XrtGaCScale_Min,
	FALSE,
	TRUE
},
{
	"xrtGaRadiusSize",
	"RD_xrtGaRadiusSize",
	XmNxrtGaRadiusSize,
	"XmNxrtGaRadiusSize",
	XRTGA_XM_INT,
	{0, 0, 0},
	Offset(UxXrtGaCircularScaleClass, XrtGaCircularScale.RD_xrtGaRadiusSize),
	XRTDIV_SPECIFIC,
	XRTPASS0,
	NULL,
	XrtGaCScale_RadiusSize,
	FALSE,
	TRUE
},
{
	"xrtGaStartAngle",
	"RD_xrtGaStartAngle",
	XmNxrtGaStartAngle,
	"XmNxrtGaStartAngle",
	XRTGA_DOUBLE,
	{0, 0, 0},
	Offset(UxXrtGaCircularScaleClass, XrtGaCircularScale.RD_xrtGaStartAngle),
	XRTDIV_SPECIFIC,
	XRTPASS0,
	NULL,
	XrtGaCScale_StartAngle,
	FALSE,
	TRUE
},
{
	"xrtGaStopAngle",
	"RD_xrtGaStopAngle",
	XmNxrtGaStopAngle,
	"XmNxrtGaStopAngle",
	XRTGA_DOUBLE,
	{0, 0, 0},
	Offset(UxXrtGaCircularScaleClass, XrtGaCircularScale.RD_xrtGaStopAngle),
	XRTDIV_SPECIFIC,
	XRTPASS0,
	NULL,
	XrtGaCScale_StopAngle,
	FALSE,
	TRUE
},
{
	"xrtGaTransformCallback",
	"RD_xrtGaTransformCallback",
	XmNxrtGaTransformCallback,
	"XmNxrtGaTransformCallback",
	XRTGA_CALLBACK,
	{0, 0, 0},
	Offset(UxXrtGaCircularScaleClass, XrtGaCircularScale.RD_xrtGaTransformCallback),
	XRTDIV_BEHAVIOR,
	XRTPASS0,
	NULL,
	XrtGaCScale_TransformCallback,
	FALSE,
	TRUE
},
{
	"xrtGaXOrigin",
	"RD_xrtGaXOrigin",
	XmNxrtGaXOrigin,
	"XmNxrtGaXOrigin",
	XRTGA_XM_INT,
	{0, 0, 0},
	Offset(UxXrtGaCircularScaleClass, XrtGaCircularScale.RD_xrtGaXOrigin),
	XRTDIV_SPECIFIC,
	XRTPASS0,
	NULL,
	XrtGaCScale_XOrigin,
	FALSE,
	TRUE
},
{
	"xrtGaYOrigin",
	"RD_xrtGaYOrigin",
	XmNxrtGaYOrigin,
	"XmNxrtGaYOrigin",
	XRTGA_XM_INT,
	{0, 0, 0},
	Offset(UxXrtGaCircularScaleClass, XrtGaCircularScale.RD_xrtGaYOrigin),
	XRTDIV_SPECIFIC,
	XRTPASS0,
	NULL,
	XrtGaCScale_YOrigin,
	FALSE,
	TRUE
},
};

XrtGaugeResourceDesc	XrtGaCounter_res_table[] = {
{
	"background",
	"RD_background",
	XmNbackground,
	"XmNbackground",
	XRTGA_XM_PIXEL,
	{0, 0, 0},
	Offset(UxXrtGaCounterClass, XrtGaCounter.RD_background),
	XRTDIV_SPECIFIC,
	XRTPASS0,
	NULL,
	XrtGaCounter_background,
	FALSE,
	TRUE
},
{
	"fontList",
	"RD_fontList",
	XmNfontList,
	"XmNfontList",
	XRTGA_XM_FONTLIST,
	{0, 0, 0},
	Offset(UxXrtGaCounterClass, XrtGaCounter.RD_fontList),
	XRTDIV_SPECIFIC,
	XRTPASS0,
	NULL,
	XrtGaCounter_fontList,
	FALSE,
	TRUE
},
{
	"height",
	"RD_height",
	XmNheight,
	"XmNheight",
	XRTGA_XM_INT,
	{0, 0, 0},
	Offset(UxXrtGaCounterClass, XrtGaCounter.RD_height),
	XRTDIV_SPECIFIC,
	XRTPASS0,
	NULL,
	XrtGaCounter_height,
	FALSE,
	TRUE
},
{
	"width",
	"RD_width",
	XmNwidth,
	"XmNwidth",
	XRTGA_XM_INT,
	{0, 0, 0},
	Offset(UxXrtGaCounterClass, XrtGaCounter.RD_width),
	XRTDIV_SPECIFIC,
	XRTPASS0,
	NULL,
	XrtGaCounter_width,
	FALSE,
	TRUE
},
{
	"x",
	"RD_x",
	XmNx,
	"XmNx",
	XRTGA_XM_INT,
	{0, 0, 0},
	Offset(UxXrtGaCounterClass, XrtGaCounter.RD_x),
	XRTDIV_SPECIFIC,
	XRTPASS0,
	NULL,
	XrtGaCounter_x,
	FALSE,
	TRUE
},
{
	"y",
	"RD_y",
	XmNy,
	"XmNy",
	XRTGA_XM_INT,
	{0, 0, 0},
	Offset(UxXrtGaCounterClass, XrtGaCounter.RD_y),
	XRTDIV_SPECIFIC,
	XRTPASS0,
	NULL,
	XrtGaCounter_y,
	FALSE,
	TRUE
},
{
	"xrtGaBorder",
	"RD_xrtGaBorder",
	XmNxrtGaBorder,
	"XmNxrtGaBorder",
	XRTGA_BORDER,
	{0, 0, 0},
	Offset(UxXrtGaCounterClass, XrtGaCounter.RD_xrtGaBorder),
	XRTDIV_SPECIFIC,
	XRTPASS0,
	NULL,
	XrtGaCounter_Border,
	FALSE,
	TRUE
},
{
	"xrtGaBorderWidth",
	"RD_xrtGaBorderWidth",
	XmNxrtGaBorderWidth,
	"XmNxrtGaBorderWidth",
	XRTGA_XM_INT,
	{0, 0, 0},
	Offset(UxXrtGaCounterClass, XrtGaCounter.RD_xrtGaBorderWidth),
	XRTDIV_SPECIFIC,
	XRTPASS0,
	NULL,
	XrtGaCounter_BorderWidth,
	FALSE,
	TRUE
},
{
	"xrtGaDebug",
	"RD_xrtGaDebug",
	XmNxrtGaDebug,
	"XmNxrtGaDebug",
	XRTGA_XM_BOOLEAN,
	{0, 0, 0},
	Offset(UxXrtGaCounterClass, XrtGaCounter.RD_xrtGaDebug),
	XRTDIV_SPECIFIC,
	XRTPASS0,
	NULL,
	XrtGaCounter_Debug,
	FALSE,
	TRUE
},
{
	"xrtGaDecimalPlaces",
	"RD_xrtGaDecimalPlaces",
	XmNxrtGaDecimalPlaces,
	"XmNxrtGaDecimalPlaces",
	XRTGA_XM_INT,
	{0, 0, 0},
	Offset(UxXrtGaCounterClass, XrtGaCounter.RD_xrtGaDecimalPlaces),
	XRTDIV_SPECIFIC,
	XRTPASS0,
	NULL,
	XrtGaCounter_DecimalPlaces,
	FALSE,
	TRUE
},
{
	"xrtGaDigitBackgroundColor",
	"RD_xrtGaDigitBackgroundColor",
	XmNxrtGaDigitBackgroundColor,
	"XmNxrtGaDigitBackgroundColor",
	XRTGA_XM_PIXEL,
	{0, 0, 0},
	Offset(UxXrtGaCounterClass, XrtGaCounter.RD_xrtGaDigitBackgroundColor),
	XRTDIV_SPECIFIC,
	XRTPASS0,
	NULL,
	XrtGaCounter_DigitBackgroundColor,
	FALSE,
	TRUE
},
{
	"xrtGaDigitForegroundColor",
	"RD_xrtGaDigitForegroundColor",
	XmNxrtGaDigitForegroundColor,
	"XmNxrtGaDigitForegroundColor",
	XRTGA_XM_PIXEL,
	{0, 0, 0},
	Offset(UxXrtGaCounterClass, XrtGaCounter.RD_xrtGaDigitForegroundColor),
	XRTDIV_SPECIFIC,
	XRTPASS0,
	NULL,
	XrtGaCounter_DigitForegroundColor,
	FALSE,
	TRUE
},
{
	"xrtGaImage",
	"RD_xrtGaImage",
	XmNxrtGaImage,
	"XmNxrtGaImage",
	XRTGA_IMAGE,
	{0, 0, 0},
	Offset(UxXrtGaCounterClass, XrtGaCounter.RD_xrtGaImage),
	XRTDIV_SPECIFIC,
	XRTPASS0,
	NULL,
	XrtGaCounter_Image,
	FALSE,
	TRUE
},
{
	"xrtGaImageLayout",
	"RD_xrtGaImageLayout",
	XmNxrtGaImageLayout,
	"XmNxrtGaImageLayout",
	XRTGA_IMAGE_LAYOUT,
	{0, 0, 0},
	Offset(UxXrtGaCounterClass, XrtGaCounter.RD_xrtGaImageLayout),
	XRTDIV_SPECIFIC,
	XRTPASS0,
	NULL,
	XrtGaCounter_ImageLayout,
	FALSE,
	TRUE
},
{
	"xrtGaIsShowing",
	"RD_xrtGaIsShowing",
	XmNxrtGaIsShowing,
	"XmNxrtGaIsShowing",
	XRTGA_XM_BOOLEAN,
	{0, 0, 0},
	Offset(UxXrtGaCounterClass, XrtGaCounter.RD_xrtGaIsShowing),
	XRTDIV_SPECIFIC,
	XRTPASS0,
	NULL,
	XrtGaCounter_IsShowing,
	FALSE,
	TRUE
},
{
	"xrtGaNumDigits",
	"RD_xrtGaNumDigits",
	XmNxrtGaNumDigits,
	"XmNxrtGaNumDigits",
	XRTGA_XM_INT,
	{0, 0, 0},
	Offset(UxXrtGaCounterClass, XrtGaCounter.RD_xrtGaNumDigits),
	XRTDIV_SPECIFIC,
	XRTPASS0,
	NULL,
	XrtGaCounter_NumDigits,
	FALSE,
	TRUE
},
{
	"xrtGaResetAlignment",
	"RD_xrtGaResetAlignment",
	XmNxrtGaResetAlignment,
	"XmNxrtGaResetAlignment",
	XRTGA_ALIGNMENT,
	{0, 0, 0},
	Offset(UxXrtGaCounterClass, XrtGaCounter.RD_xrtGaResetAlignment),
	XRTDIV_SPECIFIC,
	XRTPASS0,
	NULL,
	XrtGaCounter_ResetAlignment,
	FALSE,
	TRUE
},
{
	"xrtGaResetBackgroundColor",
	"RD_xrtGaResetBackgroundColor",
	XmNxrtGaResetBackgroundColor,
	"XmNxrtGaResetBackgroundColor",
	XRTGA_XM_PIXEL,
	{0, 0, 0},
	Offset(UxXrtGaCounterClass, XrtGaCounter.RD_xrtGaResetBackgroundColor),
	XRTDIV_SPECIFIC,
	XRTPASS0,
	NULL,
	XrtGaCounter_ResetBackgroundColor,
	FALSE,
	TRUE
},
{
	"xrtGaResetHeight",
	"RD_xrtGaResetHeight",
	XmNxrtGaResetHeight,
	"XmNxrtGaResetHeight",
	XRTGA_XM_INT,
	{0, 0, 0},
	Offset(UxXrtGaCounterClass, XrtGaCounter.RD_xrtGaResetHeight),
	XRTDIV_SPECIFIC,
	XRTPASS0,
	NULL,
	XrtGaCounter_ResetHeight,
	FALSE,
	TRUE
},
{
	"xrtGaResetImage",
	"RD_xrtGaResetImage",
	XmNxrtGaResetImage,
	"XmNxrtGaResetImage",
	XRTGA_IMAGE,
	{0, 0, 0},
	Offset(UxXrtGaCounterClass, XrtGaCounter.RD_xrtGaResetImage),
	XRTDIV_SPECIFIC,
	XRTPASS0,
	NULL,
	XrtGaCounter_ResetImage,
	FALSE,
	TRUE
},
{
	"xrtGaResetOffset",
	"RD_xrtGaResetOffset",
	XmNxrtGaResetOffset,
	"XmNxrtGaResetOffset",
	XRTGA_XM_INT,
	{0, 0, 0},
	Offset(UxXrtGaCounterClass, XrtGaCounter.RD_xrtGaResetOffset),
	XRTDIV_SPECIFIC,
	XRTPASS0,
	NULL,
	XrtGaCounter_ResetOffset,
	FALSE,
	TRUE
},
{
	"xrtGaResetShape",
	"RD_xrtGaResetShape",
	XmNxrtGaResetShape,
	"XmNxrtGaResetShape",
	XRTGA_SHAPE,
	{0, 0, 0},
	Offset(UxXrtGaCounterClass, XrtGaCounter.RD_xrtGaResetShape),
	XRTDIV_SPECIFIC,
	XRTPASS0,
	NULL,
	XrtGaCounter_ResetShape,
	FALSE,
	TRUE
},
{
	"xrtGaResetShow",
	"RD_xrtGaResetShow",
	XmNxrtGaResetShow,
	"XmNxrtGaResetShow",
	XRTGA_XM_BOOLEAN,
	{0, 0, 0},
	Offset(UxXrtGaCounterClass, XrtGaCounter.RD_xrtGaResetShow),
	XRTDIV_SPECIFIC,
	XRTPASS0,
	NULL,
	XrtGaCounter_ResetShow,
	FALSE,
	TRUE
},
{
	"xrtGaResetWidth",
	"RD_xrtGaResetWidth",
	XmNxrtGaResetWidth,
	"XmNxrtGaResetWidth",
	XRTGA_XM_INT,
	{0, 0, 0},
	Offset(UxXrtGaCounterClass, XrtGaCounter.RD_xrtGaResetWidth),
	XRTDIV_SPECIFIC,
	XRTPASS0,
	NULL,
	XrtGaCounter_ResetWidth,
	FALSE,
	TRUE
},
{
	"xrtGaSpacingHorizontal",
	"RD_xrtGaSpacingHorizontal",
	XmNxrtGaSpacingHorizontal,
	"XmNxrtGaSpacingHorizontal",
	XRTGA_XM_INT,
	{0, 0, 0},
	Offset(UxXrtGaCounterClass, XrtGaCounter.RD_xrtGaSpacingHorizontal),
	XRTDIV_SPECIFIC,
	XRTPASS0,
	NULL,
	XrtGaCounter_SpacingHorizontal,
	FALSE,
	TRUE
},
{
	"xrtGaSpacingVertical",
	"RD_xrtGaSpacingVertical",
	XmNxrtGaSpacingVertical,
	"XmNxrtGaSpacingVertical",
	XRTGA_XM_INT,
	{0, 0, 0},
	Offset(UxXrtGaCounterClass, XrtGaCounter.RD_xrtGaSpacingVertical),
	XRTDIV_SPECIFIC,
	XRTPASS0,
	NULL,
	XrtGaCounter_SpacingVertical,
	FALSE,
	TRUE
},
{
	"xrtGaTransitionRate",
	"RD_xrtGaTransitionRate",
	XmNxrtGaTransitionRate,
	"XmNxrtGaTransitionRate",
	XRTGA_XM_INT,
	{0, 0, 0},
	Offset(UxXrtGaCounterClass, XrtGaCounter.RD_xrtGaTransitionRate),
	XRTDIV_SPECIFIC,
	XRTPASS0,
	NULL,
	XrtGaCounter_TransitionRate,
	FALSE,
	TRUE
},
{
	"xrtGaTransitionSteps",
	"RD_xrtGaTransitionSteps",
	XmNxrtGaTransitionSteps,
	"XmNxrtGaTransitionSteps",
	XRTGA_XM_INT,
	{0, 0, 0},
	Offset(UxXrtGaCounterClass, XrtGaCounter.RD_xrtGaTransitionSteps),
	XRTDIV_SPECIFIC,
	XRTPASS0,
	NULL,
	XrtGaCounter_TransitionSteps,
	FALSE,
	TRUE
},
{
	"xrtGaUseTransition",
	"RD_xrtGaUseTransition",
	XmNxrtGaUseTransition,
	"XmNxrtGaUseTransition",
	XRTGA_XM_BOOLEAN,
	{0, 0, 0},
	Offset(UxXrtGaCounterClass, XrtGaCounter.RD_xrtGaUseTransition),
	XRTDIV_SPECIFIC,
	XRTPASS0,
	NULL,
	XrtGaCounter_UseTransition,
	FALSE,
	TRUE
},
{
	"xrtGaValue",
	"RD_xrtGaValue",
	XmNxrtGaValue,
	"XmNxrtGaValue",
	XRTGA_DOUBLE,
	{0, 0, 0},
	Offset(UxXrtGaCounterClass, XrtGaCounter.RD_xrtGaValue),
	XRTDIV_SPECIFIC,
	XRTPASS0,
	NULL,
	XrtGaCounter_Value,
	FALSE,
	TRUE
},
{
	"xrtGaValueChangedCallback",
	"RD_xrtGaValueChangedCallback",
	XmNxrtGaValueChangedCallback,
	"XmNxrtGaValueChangedCallback",
	XRTGA_CALLBACK,
	{0, 0, 0},
	Offset(UxXrtGaCounterClass, XrtGaCounter.RD_xrtGaValueChangedCallback),
	XRTDIV_BEHAVIOR,
	XRTPASS0,
	NULL,
	XrtGaCounter_ValueChangedCallback,
	FALSE,
	TRUE
},
};

XrtGaugeResourceDesc	XrtGaFrame_res_table[] = {
{
	"background",
	"RD_background",
	XmNbackground,
	"XmNbackground",
	XRTGA_XM_PIXEL,
	{0, 0, 0},
	Offset(UxXrtGaFrameClass, XrtGaFrame.RD_background),
	XRTDIV_SPECIFIC,
	XRTPASS0,
	NULL,
	XrtGaFrame_background,
	FALSE,
	TRUE
},
{
	"xrtGaBottomMargin",
	"RD_xrtGaBottomMargin",
	XmNxrtGaBottomMargin,
	"XmNxrtGaBottomMargin",
	XRTGA_XM_INT,
	{0, 0, 0},
	Offset(UxXrtGaFrameClass, XrtGaFrame.RD_xrtGaBottomMargin),
	XRTDIV_SPECIFIC,
	XRTPASS0,
	NULL,
	XrtGaFrame_BottomMargin,
	FALSE,
	TRUE
},
{
	"xrtGaDebug",
	"RD_xrtGaDebug",
	XmNxrtGaDebug,
	"XmNxrtGaDebug",
	XRTGA_XM_BOOLEAN,
	{0, 0, 0},
	Offset(UxXrtGaFrameClass, XrtGaFrame.RD_xrtGaDebug),
	XRTDIV_SPECIFIC,
	XRTPASS0,
	NULL,
	XrtGaFrame_Debug,
	FALSE,
	TRUE
},
{
	"xrtGaImage",
	"RD_xrtGaImage",
	XmNxrtGaImage,
	"XmNxrtGaImage",
	XRTGA_IMAGE,
	{0, 0, 0},
	Offset(UxXrtGaFrameClass, XrtGaFrame.RD_xrtGaImage),
	XRTDIV_SPECIFIC,
	XRTPASS0,
	NULL,
	XrtGaFrame_Image,
	FALSE,
	TRUE
},
{
	"xrtGaImageLayout",
	"RD_xrtGaImageLayout",
	XmNxrtGaImageLayout,
	"XmNxrtGaImageLayout",
	XRTGA_IMAGE_LAYOUT,
	{0, 0, 0},
	Offset(UxXrtGaFrameClass, XrtGaFrame.RD_xrtGaImageLayout),
	XRTDIV_SPECIFIC,
	XRTPASS0,
	NULL,
	XrtGaFrame_ImageLayout,
	FALSE,
	TRUE
},
{
	"xrtGaIsShowing",
	"RD_xrtGaIsShowing",
	XmNxrtGaIsShowing,
	"XmNxrtGaIsShowing",
	XRTGA_XM_BOOLEAN,
	{0, 0, 0},
	Offset(UxXrtGaFrameClass, XrtGaFrame.RD_xrtGaIsShowing),
	XRTDIV_SPECIFIC,
	XRTPASS0,
	NULL,
	XrtGaFrame_IsShowing,
	FALSE,
	TRUE
},
{
	"xrtGaLeftMargin",
	"RD_xrtGaLeftMargin",
	XmNxrtGaLeftMargin,
	"XmNxrtGaLeftMargin",
	XRTGA_XM_INT,
	{0, 0, 0},
	Offset(UxXrtGaFrameClass, XrtGaFrame.RD_xrtGaLeftMargin),
	XRTDIV_SPECIFIC,
	XRTPASS0,
	NULL,
	XrtGaFrame_LeftMargin,
	FALSE,
	TRUE
},
{
	"xrtGaRightMargin",
	"RD_xrtGaRightMargin",
	XmNxrtGaRightMargin,
	"XmNxrtGaRightMargin",
	XRTGA_XM_INT,
	{0, 0, 0},
	Offset(UxXrtGaFrameClass, XrtGaFrame.RD_xrtGaRightMargin),
	XRTDIV_SPECIFIC,
	XRTPASS0,
	NULL,
	XrtGaFrame_RightMargin,
	FALSE,
	TRUE
},
{
	"xrtGaShape",
	"RD_xrtGaShape",
	XmNxrtGaShape,
	"XmNxrtGaShape",
	XRTGA_SHAPE,
	{0, 0, 0},
	Offset(UxXrtGaFrameClass, XrtGaFrame.RD_xrtGaShape),
	XRTDIV_SPECIFIC,
	XRTPASS0,
	NULL,
	XrtGaFrame_Shape,
	FALSE,
	TRUE
},
{
	"xrtGaTopMargin",
	"RD_xrtGaTopMargin",
	XmNxrtGaTopMargin,
	"XmNxrtGaTopMargin",
	XRTGA_XM_INT,
	{0, 0, 0},
	Offset(UxXrtGaFrameClass, XrtGaFrame.RD_xrtGaTopMargin),
	XRTDIV_SPECIFIC,
	XRTPASS0,
	NULL,
	XrtGaFrame_TopMargin,
	FALSE,
	TRUE
},
};

XrtGaugeResourceDesc	XrtGaIcon_res_table[] = {
{
	"background",
	"RD_background",
	XmNbackground,
	"XmNbackground",
	XRTGA_XM_PIXEL,
	{0, 0, 0},
	Offset(UxXrtGaIconClass, XrtGaIcon.RD_background),
	XRTDIV_SPECIFIC,
	XRTPASS0,
	NULL,
	XrtGaIcon_background,
	FALSE,
	TRUE
},
{
	"xrtGaDebug",
	"RD_xrtGaDebug",
	XmNxrtGaDebug,
	"XmNxrtGaDebug",
	XRTGA_XM_BOOLEAN,
	{0, 0, 0},
	Offset(UxXrtGaIconClass, XrtGaIcon.RD_xrtGaDebug),
	XRTDIV_SPECIFIC,
	XRTPASS0,
	NULL,
	XrtGaIcon_Debug,
	FALSE,
	TRUE
},
{
	"xrtGaOffColor",
	"RD_xrtGaOffColor",
	XmNxrtGaOffColor,
	"XmNxrtGaOffColor",
	XRTGA_XM_PIXEL,
	{0, 0, 0},
	Offset(UxXrtGaIconClass, XrtGaIcon.RD_xrtGaOffColor),
	XRTDIV_SPECIFIC,
	XRTPASS0,
	NULL,
	XrtGaIcon_OffColor,
	FALSE,
	TRUE
},
{
	"xrtGaOnColor",
	"RD_xrtGaOnColor",
	XmNxrtGaOnColor,
	"XmNxrtGaOnColor",
	XRTGA_XM_PIXEL,
	{0, 0, 0},
	Offset(UxXrtGaIconClass, XrtGaIcon.RD_xrtGaOnColor),
	XRTDIV_SPECIFIC,
	XRTPASS0,
	NULL,
	XrtGaIcon_OnColor,
	FALSE,
	TRUE
},
{
	"xrtGaOffImage",
	"RD_xrtGaOffImage",
	XmNxrtGaOffImage,
	"XmNxrtGaOffImage",
	XRTGA_IMAGE,
	{0, 0, 0},
	Offset(UxXrtGaIconClass, XrtGaIcon.RD_xrtGaOffImage),
	XRTDIV_SPECIFIC,
	XRTPASS0,
	NULL,
	XrtGaIcon_OffImage,
	FALSE,
	TRUE
},
{
	"xrtGaOnImage",
	"RD_xrtGaOnImage",
	XmNxrtGaOnImage,
	"XmNxrtGaOnImage",
	XRTGA_IMAGE,
	{0, 0, 0},
	Offset(UxXrtGaIconClass, XrtGaIcon.RD_xrtGaOnImage),
	XRTDIV_SPECIFIC,
	XRTPASS0,
	NULL,
	XrtGaIcon_OnImage,
	FALSE,
	TRUE
},
{
	"xrtGaShape",
	"RD_xrtGaShape",
	XmNxrtGaShape,
	"XmNxrtGaShape",
	XRTGA_SHAPE,
	{0, 0, 0},
	Offset(UxXrtGaIconClass, XrtGaIcon.RD_xrtGaShape),
	XRTDIV_SPECIFIC,
	XRTPASS0,
	NULL,
	XrtGaIcon_Shape,
	FALSE,
	TRUE
},
};

XrtGaugeResourceDesc	XrtGaIndicator_res_table[] = {
{
	"background",
	"RD_background",
	XmNbackground,
	"XmNbackground",
	XRTGA_XM_PIXEL,
	{0, 0, 0},
	Offset(UxXrtGaIndicatorClass, XrtGaIndicator.RD_background),
	XRTDIV_SPECIFIC,
	XRTPASS0,
	NULL,
	XrtGaIndicator_background,
	FALSE,
	TRUE
},
{
	"width",
	"RD_width",
	XmNwidth,
	"XmNwidth",
	XRTGA_XM_INT,
	{0, 0, 0},
	Offset(UxXrtGaIndicatorClass, XrtGaIndicator.RD_width),
	XRTDIV_SPECIFIC,
	XRTPASS0,
	NULL,
	XrtGaIndicator_width,
	FALSE,
	TRUE
},
{
	"xrtGaDebug",
	"RD_xrtGaDebug",
	XmNxrtGaDebug,
	"XmNxrtGaDebug",
	XRTGA_XM_BOOLEAN,
	{0, 0, 0},
	Offset(UxXrtGaIndicatorClass, XrtGaIndicator.RD_xrtGaDebug),
	XRTDIV_SPECIFIC,
	XRTPASS0,
	NULL,
	XrtGaIndicator_Debug,
	FALSE,
	TRUE
},
{
	"xrtGaDrawFunc",
	"RD_xrtGaDrawFunc",
	XmNxrtGaDrawFunc,
	"XmNxrtGaDrawFunc",
	XRTGA_XM_FUNCTION,
	{0, 0, 0},
	Offset(UxXrtGaIndicatorClass, XrtGaIndicator.RD_xrtGaDrawFunc),
	XRTDIV_SPECIFIC,
	XRTPASS0,
	NULL,
	XrtGaIndicator_DrawFunc,
	FALSE,
	TRUE
},
{
	"xrtGaInnerExtent",
	"RD_xrtGaInnerExtent",
	XmNxrtGaInnerExtent,
	"XmNxrtGaInnerExtent",
	XRTGA_DOUBLE,
	{0, 0, 0},
	Offset(UxXrtGaIndicatorClass, XrtGaIndicator.RD_xrtGaInnerExtent),
	XRTDIV_SPECIFIC,
	XRTPASS0,
	NULL,
	XrtGaIndicator_InnerExtent,
	FALSE,
	TRUE
},
{
	"xrtGaImage",
	"RD_xrtGaImage",
	XmNxrtGaImage,
	"XmNxrtGaImage",
	XRTGA_IMAGE,
	{0, 0, 0},
	Offset(UxXrtGaIndicatorClass, XrtGaIndicator.RD_xrtGaImage),
	XRTDIV_SPECIFIC,
	XRTPASS0,
	NULL,
	XrtGaIndicator_Image,
	FALSE,
	TRUE
},
{
	"xrtGaImageRotate",
	"RD_xrtGaImageRotate",
	XmNxrtGaImageRotate,
	"XmNxrtGaImageRotate",
	XRTGA_XM_BOOLEAN,
	{0, 0, 0},
	Offset(UxXrtGaIndicatorClass, XrtGaIndicator.RD_xrtGaImageRotate),
	XRTDIV_SPECIFIC,
	XRTPASS0,
	NULL,
	XrtGaIndicator_ImageRotate,
	FALSE,
	TRUE
},
{
	"xrtGaLinearScale",
	"RD_xrtGaLinearScale",
	XmNxrtGaLinearScale,
	"XmNxrtGaLinearScale",
	XRTGA_OBJECT,
	{0, 0, 0},
	Offset(UxXrtGaIndicatorClass, XrtGaIndicator.RD_xrtGaLinearScale),
	XRTDIV_SPECIFIC,
	XRTPASS0,
	NULL,
	XrtGaIndicator_LinearScale,
	FALSE,
	TRUE
},
{
	"xrtGaInteractionType",
	"RD_xrtGaInteractionType",
	XmNxrtGaInteractionType,
	"XmNxrtGaInteractionType",
	XRTGA_INTERACTION_TYPE,
	{0, 0, 0},
	Offset(UxXrtGaIndicatorClass, XrtGaIndicator.RD_xrtGaInteractionType),
	XRTDIV_SPECIFIC,
	XRTPASS0,
	NULL,
	XrtGaIndicator_InteractionType,
	FALSE,
	TRUE
},
{
	"xrtGaIndicatorType",
	"RD_xrtGaIndicatorType",
	XmNxrtGaIndicatorType,
	"XmNxrtGaIndicatorType",
	XRTGA_INDICATOR_TYPE,
	{0, 0, 0},
	Offset(UxXrtGaIndicatorClass, XrtGaIndicator.RD_xrtGaIndicatorType),
	XRTDIV_SPECIFIC,
	XRTPASS0,
	NULL,
	XrtGaIndicator_IndicatorType,
	FALSE,
	TRUE
},
{
	"xrtGaIsShowing",
	"RD_xrtGaIsShowing",
	XmNxrtGaIsShowing,
	"XmNxrtGaIsShowing",
	XRTGA_XM_BOOLEAN,
	{0, 0, 0},
	Offset(UxXrtGaIndicatorClass, XrtGaIndicator.RD_xrtGaIsShowing),
	XRTDIV_SPECIFIC,
	XRTPASS0,
	NULL,
	XrtGaIndicator_IsShowing,
	FALSE,
	TRUE
},
{
	"xrtGaOuterExtent",
	"RD_xrtGaOuterExtent",
	XmNxrtGaOuterExtent,
	"XmNxrtGaOuterExtent",
	XRTGA_DOUBLE,
	{0, 0, 0},
	Offset(UxXrtGaIndicatorClass, XrtGaIndicator.RD_xrtGaOuterExtent),
	XRTDIV_SPECIFIC,
	XRTPASS0,
	NULL,
	XrtGaIndicator_OuterExtent,
	FALSE,
	TRUE
},
{
	"xrtGaValue",
	"RD_xrtGaValue",
	XmNxrtGaValue,
	"XmNxrtGaValue",
	XRTGA_DOUBLE,
	{0, 0, 0},
	Offset(UxXrtGaIndicatorClass, XrtGaIndicator.RD_xrtGaValue),
	XRTDIV_SPECIFIC,
	XRTPASS0,
	NULL,
	XrtGaIndicator_Value,
	FALSE,
	TRUE
},
{
	"xrtGaValueChangedCallback",
	"RD_xrtGaValueChangedCallback",
	XmNxrtGaValueChangedCallback,
	"XmNxrtGaValueChangedCallback",
	XRTGA_CALLBACK,
	{0, 0, 0},
	Offset(UxXrtGaIndicatorClass, XrtGaIndicator.RD_xrtGaValueChangedCallback),
	XRTDIV_BEHAVIOR,
	XRTPASS0,
	NULL,
	XrtGaIndicator_ValueChangedCallback,
	FALSE,
	TRUE
},
};

XrtGaugeResourceDesc	XrtGaItem_res_table[] = {
{
	"background",
	"RD_background",
	XmNbackground,
	"XmNbackground",
	XRTGA_XM_PIXEL,
	{0, 0, 0},
	Offset(UxXrtGaItemClass, XrtGaItem.RD_background),
	XRTDIV_SPECIFIC,
	XRTPASS0,
	NULL,
	XrtGaItem_background,
	FALSE,
	TRUE
},
{
	"xrtGaDebug",
	"RD_xrtGaDebug",
	XmNxrtGaDebug,
	"XmNxrtGaDebug",
	XRTGA_XM_BOOLEAN,
	{0, 0, 0},
	Offset(UxXrtGaItemClass, XrtGaItem.RD_xrtGaDebug),
	XRTDIV_SPECIFIC,
	XRTPASS0,
	NULL,
	XrtGaItem_Debug,
	FALSE,
	TRUE
},
{
	"xrtGaImage",
	"RD_xrtGaImage",
	XmNxrtGaImage,
	"XmNxrtGaImage",
	XRTGA_IMAGE,
	{0, 0, 0},
	Offset(UxXrtGaItemClass, XrtGaItem.RD_xrtGaImage),
	XRTDIV_SPECIFIC,
	XRTPASS0,
	NULL,
	XrtGaItem_Image,
	FALSE,
	TRUE
},
{
	"xrtGaIsShowing",
	"RD_xrtGaIsShowing",
	XmNxrtGaIsShowing,
	"XmNxrtGaIsShowing",
	XRTGA_XM_BOOLEAN,
	{0, 0, 0},
	Offset(UxXrtGaItemClass, XrtGaItem.RD_xrtGaIsShowing),
	XRTDIV_SPECIFIC,
	XRTPASS0,
	NULL,
	XrtGaItem_IsShowing,
	FALSE,
	TRUE
},
{
	"xrtGaLabelExtent",
	"RD_xrtGaLabelExtent",
	XmNxrtGaLabelExtent,
	"XmNxrtGaLabelExtent",
	XRTGA_DOUBLE,
	{0, 0, 0},
	Offset(UxXrtGaItemClass, XrtGaItem.RD_xrtGaLabelExtent),
	XRTDIV_SPECIFIC,
	XRTPASS0,
	NULL,
	XrtGaItem_LabelExtent,
	FALSE,
	TRUE
},
{
	"xrtGaValue",
	"RD_xrtGaValue",
	XmNxrtGaValue,
	"XmNxrtGaValue",
	XRTGA_DOUBLE,
	{0, 0, 0},
	Offset(UxXrtGaItemClass, XrtGaItem.RD_xrtGaValue),
	XRTDIV_SPECIFIC,
	XRTPASS0,
	NULL,
	XrtGaItem_Value,
	FALSE,
	TRUE
},
{
	"xrtGaValueChangedCallback",
	"RD_xrtGaValueChangedCallback",
	XmNxrtGaValueChangedCallback,
	"XmNxrtGaValueChangedCallback",
	XRTGA_CALLBACK,
	{0, 0, 0},
	Offset(UxXrtGaItemClass, XrtGaItem.RD_xrtGaValueChangedCallback),
	XRTDIV_BEHAVIOR,
	XRTPASS0,
	NULL,
	XrtGaItem_ValueChangedCallback,
	FALSE,
	TRUE
},
};

XrtGaugeResourceDesc	XrtGaLEDIcon_res_table[] = {
{
	"xrtGaBorder",
	"RD_xrtGaBorder",
	XmNxrtGaBorder,
	"XmNxrtGaBorder",
	XRTGA_BORDER,
	{0, 0, 0},
	Offset(UxXrtGaLEDIconClass, XrtGaLEDIcon.RD_xrtGaBorder),
	XRTDIV_SPECIFIC,
	XRTPASS0,
	NULL,
	XrtGaLEDIcon_Border,
	FALSE,
	TRUE
},
{
	"xrtGaDebug",
	"RD_xrtGaDebug",
	XmNxrtGaDebug,
	"XmNxrtGaDebug",
	XRTGA_XM_BOOLEAN,
	{0, 0, 0},
	Offset(UxXrtGaLEDIconClass, XrtGaLEDIcon.RD_xrtGaDebug),
	XRTDIV_SPECIFIC,
	XRTPASS0,
	NULL,
	XrtGaLEDIcon_Debug,
	FALSE,
	TRUE
},
{
	"xrtGaDecayRate",
	"RD_xrtGaDecayRate",
	XmNxrtGaDecayRate,
	"XmNxrtGaDecayRate",
	XRTGA_XM_INT,
	{0, 0, 0},
	Offset(UxXrtGaLEDIconClass, XrtGaLEDIcon.RD_xrtGaDecayRate),
	XRTDIV_SPECIFIC,
	XRTPASS0,
	NULL,
	XrtGaLEDIcon_DecayRate,
	FALSE,
	TRUE
},
{
	"xrtGaDisplayMode",
	"RD_xrtGaDisplayMode",
	XmNxrtGaDisplayMode,
	"XmNxrtGaDisplayMode",
	XRTGA_DISPLAY_MODE,
	{0, 0, 0},
	Offset(UxXrtGaLEDIconClass, XrtGaLEDIcon.RD_xrtGaDisplayMode),
	XRTDIV_SPECIFIC,
	XRTPASS0,
	NULL,
	XrtGaLEDIcon_DisplayMode,
	FALSE,
	TRUE
},
{
	"xrtGaDirection",
	"RD_xrtGaDirection",
	XmNxrtGaDirection,
	"XmNxrtGaDirection",
	XRTGA_DIRECTION,
	{0, 0, 0},
	Offset(UxXrtGaLEDIconClass, XrtGaLEDIcon.RD_xrtGaDirection),
	XRTDIV_SPECIFIC,
	XRTPASS0,
	NULL,
	XrtGaLEDIcon_Direction,
	FALSE,
	TRUE
},
{
	"xrtGaDoubleBuffer",
	"RD_xrtGaDoubleBuffer",
	XmNxrtGaDoubleBuffer,
	"XmNxrtGaDoubleBuffer",
	XRTGA_XM_BOOLEAN,
	{0, 0, 0},
	Offset(UxXrtGaLEDIconClass, XrtGaLEDIcon.RD_xrtGaDoubleBuffer),
	XRTDIV_SPECIFIC,
	XRTPASS0,
	NULL,
	XrtGaLEDIcon_DoubleBuffer,
	FALSE,
	TRUE
},
{
	"xrtGaExposeCallback",
	"RD_xrtGaExposeCallback",
	XmNxrtGaExposeCallback,
	"XmNxrtGaExposeCallback",
	XRTGA_CALLBACK,
	{0, 0, 0},
	Offset(UxXrtGaLEDIconClass, XrtGaLEDIcon.RD_xrtGaExposeCallback),
	XRTDIV_BEHAVIOR,
	XRTPASS0,
	NULL,
	XrtGaLEDIcon_ExposeCallback,
	FALSE,
	TRUE
},
{
	"xrtGaIconHeight",
	"RD_xrtGaIconHeight",
	XmNxrtGaIconHeight,
	"XmNxrtGaIconHeight",
	XRTGA_XM_INT,
	{0, 0, 0},
	Offset(UxXrtGaLEDIconClass, XrtGaLEDIcon.RD_xrtGaIconHeight),
	XRTDIV_SPECIFIC,
	XRTPASS0,
	NULL,
	XrtGaLEDIcon_IconHeight,
	FALSE,
	TRUE
},
{
	"xrtGaIconList",
	"RD_xrtGaIconList",
	XmNxrtGaIconList,
	"XmNxrtGaIconList",
	XRTGA_OBJECT_LIST,
	{0, 0, 0},
	Offset(UxXrtGaLEDIconClass, XrtGaLEDIcon.RD_xrtGaIconList),
	XRTDIV_SPECIFIC,
	XRTPASS0,
	NULL,
	XrtGaLEDIcon_IconList,
	TRUE,
	TRUE
},
{
	"xrtGaIconSpacing",
	"RD_xrtGaIconSpacing",
	XmNxrtGaIconSpacing,
	"XmNxrtGaIconSpacing",
	XRTGA_XM_INT,
	{0, 0, 0},
	Offset(UxXrtGaLEDIconClass, XrtGaLEDIcon.RD_xrtGaIconSpacing),
	XRTDIV_SPECIFIC,
	XRTPASS0,
	NULL,
	XrtGaLEDIcon_IconSpacing,
	FALSE,
	TRUE
},
{
	"xrtGaIconWidth",
	"RD_xrtGaIconWidth",
	XmNxrtGaIconWidth,
	"XmNxrtGaIconWidth",
	XRTGA_XM_INT,
	{0, 0, 0},
	Offset(UxXrtGaLEDIconClass, XrtGaLEDIcon.RD_xrtGaIconWidth),
	XRTDIV_SPECIFIC,
	XRTPASS0,
	NULL,
	XrtGaLEDIcon_IconWidth,
	FALSE,
	TRUE
},
{
	"xrtGaImage",
	"RD_xrtGaImage",
	XmNxrtGaImage,
	"XmNxrtGaImage",
	XRTGA_IMAGE,
	{0, 0, 0},
	Offset(UxXrtGaLEDIconClass, XrtGaLEDIcon.RD_xrtGaImage),
	XRTDIV_SPECIFIC,
	XRTPASS0,
	NULL,
	XrtGaLEDIcon_Image,
	FALSE,
	TRUE
},
{
	"xrtGaImageLayout",
	"RD_xrtGaImageLayout",
	XmNxrtGaImageLayout,
	"XmNxrtGaImageLayout",
	XRTGA_IMAGE_LAYOUT,
	{0, 0, 0},
	Offset(UxXrtGaLEDIconClass, XrtGaLEDIcon.RD_xrtGaImageLayout),
	XRTDIV_SPECIFIC,
	XRTPASS0,
	NULL,
	XrtGaLEDIcon_ImageLayout,
	FALSE,
	TRUE
},
{
	"xrtGaInteractionCallback",
	"RD_xrtGaInteractionCallback",
	XmNxrtGaInteractionCallback,
	"XmNxrtGaInteractionCallback",
	XRTGA_CALLBACK,
	{0, 0, 0},
	Offset(UxXrtGaLEDIconClass, XrtGaLEDIcon.RD_xrtGaInteractionCallback),
	XRTDIV_BEHAVIOR,
	XRTPASS0,
	NULL,
	XrtGaLEDIcon_InteractionCallback,
	FALSE,
	TRUE
},
{
	"xrtGaInteractionType",
	"RD_xrtGaInteractionType",
	XmNxrtGaInteractionType,
	"XmNxrtGaInteractionType",
	XRTGA_INTERACTION_TYPE,
	{0, 0, 0},
	Offset(UxXrtGaLEDIconClass, XrtGaLEDIcon.RD_xrtGaInteractionType),
	XRTDIV_SPECIFIC,
	XRTPASS0,
	NULL,
	XrtGaLEDIcon_InteractionType,
	FALSE,
	TRUE
},
{
	"xrtGaLEDStartValue",
	"RD_xrtGaLEDStartValue",
	XmNxrtGaLEDStartValue,
	"XmNxrtGaLEDStartValue",
	XRTGA_XM_INT,
	{0, 0, 0},
	Offset(UxXrtGaLEDIconClass, XrtGaLEDIcon.RD_xrtGaLEDStartValue),
	XRTDIV_SPECIFIC,
	XRTPASS0,
	NULL,
	XrtGaLEDIcon_LEDStartValue,
	FALSE,
	TRUE
},
{
	"xrtGaLEDValue",
	"RD_xrtGaLEDValue",
	XmNxrtGaLEDValue,
	"XmNxrtGaLEDValue",
	XRTGA_XM_INT,
	{0, 0, 0},
	Offset(UxXrtGaLEDIconClass, XrtGaLEDIcon.RD_xrtGaLEDValue),
	XRTDIV_SPECIFIC,
	XRTPASS0,
	NULL,
	XrtGaLEDIcon_LEDValue,
	FALSE,
	TRUE
},
{
	"xrtGaMaxIcon",
	"RD_xrtGaMaxIcon",
	XmNxrtGaMaxIcon,
	"XmNxrtGaMaxIcon",
	XRTGA_XM_BOOLEAN,
	{0, 0, 0},
	Offset(UxXrtGaLEDIconClass, XrtGaLEDIcon.RD_xrtGaMaxIcon),
	XRTDIV_SPECIFIC,
	XRTPASS0,
	NULL,
	XrtGaLEDIcon_MaxIcon,
	FALSE,
	TRUE
},
{
	"xrtGaOrientation",
	"RD_xrtGaOrientation",
	XmNxrtGaOrientation,
	"XmNxrtGaOrientation",
	XRTGA_XM_ORIENTATION,
	{0, 0, 0},
	Offset(UxXrtGaLEDIconClass, XrtGaLEDIcon.RD_xrtGaOrientation),
	XRTDIV_SPECIFIC,
	XRTPASS0,
	NULL,
	XrtGaLEDIcon_Orientation,
	FALSE,
	TRUE
},
{
	"xrtGaRepaint",
	"RD_xrtGaRepaint",
	XmNxrtGaRepaint,
	"XmNxrtGaRepaint",
	XRTGA_XM_BOOLEAN,
	{0, 0, 0},
	Offset(UxXrtGaLEDIconClass, XrtGaLEDIcon.RD_xrtGaRepaint),
	XRTDIV_SPECIFIC,
	XRTPASS0,
	NULL,
	XrtGaLEDIcon_Repaint,
	FALSE,
	TRUE
},
{
	"xrtGaResizeCallback",
	"RD_xrtGaResizeCallback",
	XmNxrtGaResizeCallback,
	"XmNxrtGaResizeCallback",
	XRTGA_CALLBACK,
	{0, 0, 0},
	Offset(UxXrtGaLEDIconClass, XrtGaLEDIcon.RD_xrtGaResizeCallback),
	XRTDIV_BEHAVIOR,
	XRTPASS0,
	NULL,
	XrtGaLEDIcon_ResizeCallback,
	FALSE,
	TRUE
},
{
	"xrtGaSizingPolicy",
	"RD_xrtGaSizingPolicy",
	XmNxrtGaSizingPolicy,
	"XmNxrtGaSizingPolicy",
	XRTGA_SIZING_POLICY,
	{0, 0, 0},
	Offset(UxXrtGaLEDIconClass, XrtGaLEDIcon.RD_xrtGaSizingPolicy),
	XRTDIV_SPECIFIC,
	XRTPASS0,
	NULL,
	XrtGaLEDIcon_SizingPolicy,
	FALSE,
	TRUE
},
{
	"xrtGaSpacingHorizontal",
	"RD_xrtGaSpacingHorizontal",
	XmNxrtGaSpacingHorizontal,
	"XmNxrtGaSpacingHorizontal",
	XRTGA_XM_INT,
	{0, 0, 0},
	Offset(UxXrtGaLEDIconClass, XrtGaLEDIcon.RD_xrtGaSpacingHorizontal),
	XRTDIV_SPECIFIC,
	XRTPASS0,
	NULL,
	XrtGaLEDIcon_SpacingHorizontal,
	FALSE,
	TRUE
},
{
	"xrtGaSpacingVertical",
	"RD_xrtGaSpacingVertical",
	XmNxrtGaSpacingVertical,
	"XmNxrtGaSpacingVertical",
	XRTGA_XM_INT,
	{0, 0, 0},
	Offset(UxXrtGaLEDIconClass, XrtGaLEDIcon.RD_xrtGaSpacingVertical),
	XRTDIV_SPECIFIC,
	XRTPASS0,
	NULL,
	XrtGaLEDIcon_SpacingVertical,
	FALSE,
	TRUE
},
{
	"xrtGaValueChangedCallback",
	"RD_xrtGaValueChangedCallback",
	XmNxrtGaValueChangedCallback,
	"XmNxrtGaValueChangedCallback",
	XRTGA_CALLBACK,
	{0, 0, 0},
	Offset(UxXrtGaLEDIconClass, XrtGaLEDIcon.RD_xrtGaValueChangedCallback),
	XRTDIV_BEHAVIOR,
	XRTPASS0,
	NULL,
	XrtGaLEDIcon_ValueChangedCallback,
	FALSE,
	TRUE
},
{
	"xrtGaXOrigin",
	"RD_xrtGaXOrigin",
	XmNxrtGaXOrigin,
	"XmNxrtGaXOrigin",
	XRTGA_XM_INT,
	{0, 0, 0},
	Offset(UxXrtGaLEDIconClass, XrtGaLEDIcon.RD_xrtGaXOrigin),
	XRTDIV_SPECIFIC,
	XRTPASS0,
	NULL,
	XrtGaLEDIcon_XOrigin,
	FALSE,
	TRUE
},
{
	"xrtGaYOrigin",
	"RD_xrtGaYOrigin",
	XmNxrtGaYOrigin,
	"XmNxrtGaYOrigin",
	XRTGA_XM_INT,
	{0, 0, 0},
	Offset(UxXrtGaLEDIconClass, XrtGaLEDIcon.RD_xrtGaYOrigin),
	XRTDIV_SPECIFIC,
	XRTPASS0,
	NULL,
	XrtGaLEDIcon_YOrigin,
	FALSE,
	TRUE
},
};

XrtGaugeResourceDesc	XrtGaLEDNumerical_res_table[] = {
{
	"xrtGaBorder",
	"RD_xrtGaBorder",
	XmNxrtGaBorder,
	"XmNxrtGaBorder",
	XRTGA_BORDER,
	{0, 0, 0},
	Offset(UxXrtGaLEDNumericalClass, XrtGaLEDNumerical.RD_xrtGaBorder),
	XRTDIV_SPECIFIC,
	XRTPASS0,
	NULL,
	XrtGaLEDNumerical_Border,
	FALSE,
	TRUE
},
{
	"xrtGaColorMixPercentage",
	"RD_xrtGaColorMixPercentage",
	XmNxrtGaColorMixPercentage,
	"XmNxrtGaColorMixPercentage",
	XRTGA_XM_INT,
	{0, 0, 0},
	Offset(UxXrtGaLEDNumericalClass, XrtGaLEDNumerical.RD_xrtGaColorMixPercentage),
	XRTDIV_SPECIFIC,
	XRTPASS0,
	NULL,
	XrtGaLEDNumerical_ColorMixPercentage,
	FALSE,
	TRUE
},
{
	"xrtGaDebug",
	"RD_xrtGaDebug",
	XmNxrtGaDebug,
	"XmNxrtGaDebug",
	XRTGA_XM_BOOLEAN,
	{0, 0, 0},
	Offset(UxXrtGaLEDNumericalClass, XrtGaLEDNumerical.RD_xrtGaDebug),
	XRTDIV_SPECIFIC,
	XRTPASS0,
	NULL,
	XrtGaLEDNumerical_Debug,
	FALSE,
	TRUE
},
{
	"xrtGaDecimalPlaces",
	"RD_xrtGaDecimalPlaces",
	XmNxrtGaDecimalPlaces,
	"XmNxrtGaDecimalPlaces",
	XRTGA_XM_INT,
	{0, 0, 0},
	Offset(UxXrtGaLEDNumericalClass, XrtGaLEDNumerical.RD_xrtGaDecimalPlaces),
	XRTDIV_SPECIFIC,
	XRTPASS0,
	NULL,
	XrtGaLEDNumerical_DecimalPlaces,
	FALSE,
	TRUE
},
{
	"xrtGaDecimalPosition",
	"RD_xrtGaDecimalPosition",
	XmNxrtGaDecimalPosition,
	"XmNxrtGaDecimalPosition",
	XRTGA_XM_INT,
	{0, 0, 0},
	Offset(UxXrtGaLEDNumericalClass, XrtGaLEDNumerical.RD_xrtGaDecimalPosition),
	XRTDIV_SPECIFIC,
	XRTPASS0,
	NULL,
	XrtGaLEDNumerical_DecimalPosition,
	FALSE,
	TRUE
},
{
	"xrtGaDecimalSize",
	"RD_xrtGaDecimalSize",
	XmNxrtGaDecimalSize,
	"XmNxrtGaDecimalSize",
	XRTGA_XM_INT,
	{0, 0, 0},
	Offset(UxXrtGaLEDNumericalClass, XrtGaLEDNumerical.RD_xrtGaDecimalSize),
	XRTDIV_SPECIFIC,
	XRTPASS0,
	NULL,
	XrtGaLEDNumerical_DecimalSize,
	FALSE,
	TRUE
},
{
	"xrtGaDoubleBuffer",
	"RD_xrtGaDoubleBuffer",
	XmNxrtGaDoubleBuffer,
	"XmNxrtGaDoubleBuffer",
	XRTGA_XM_BOOLEAN,
	{0, 0, 0},
	Offset(UxXrtGaLEDNumericalClass, XrtGaLEDNumerical.RD_xrtGaDoubleBuffer),
	XRTDIV_SPECIFIC,
	XRTPASS0,
	NULL,
	XrtGaLEDNumerical_DoubleBuffer,
	FALSE,
	TRUE
},
{
	"xrtGaExposeCallback",
	"RD_xrtGaExposeCallback",
	XmNxrtGaExposeCallback,
	"XmNxrtGaExposeCallback",
	XRTGA_CALLBACK,
	{0, 0, 0},
	Offset(UxXrtGaLEDNumericalClass, XrtGaLEDNumerical.RD_xrtGaExposeCallback),
	XRTDIV_BEHAVIOR,
	XRTPASS0,
	NULL,
	XrtGaLEDNumerical_ExposeCallback,
	FALSE,
	TRUE
},
{
	"xrtGaFixedDecimal",
	"RD_xrtGaFixedDecimal",
	XmNxrtGaFixedDecimal,
	"XmNxrtGaFixedDecimal",
	XRTGA_XM_BOOLEAN,
	{0, 0, 0},
	Offset(UxXrtGaLEDNumericalClass, XrtGaLEDNumerical.RD_xrtGaFixedDecimal),
	XRTDIV_SPECIFIC,
	XRTPASS0,
	NULL,
	XrtGaLEDNumerical_FixedDecimal,
	FALSE,
	TRUE
},
{
	"xrtGaLeadingOne",
	"RD_xrtGaLeadingOne",
	XmNxrtGaLeadingOne,
	"XmNxrtGaLeadingOne",
	XRTGA_XM_BOOLEAN,
	{0, 0, 0},
	Offset(UxXrtGaLEDNumericalClass, XrtGaLEDNumerical.RD_xrtGaLeadingOne),
	XRTDIV_SPECIFIC,
	XRTPASS0,
	NULL,
	XrtGaLEDNumerical_LeadingOne,
	FALSE,
	TRUE
},
{
	"xrtGaLeadingPlusMinus",
	"RD_xrtGaLeadingPlusMinus",
	XmNxrtGaLeadingPlusMinus,
	"XmNxrtGaLeadingPlusMinus",
	XRTGA_XM_BOOLEAN,
	{0, 0, 0},
	Offset(UxXrtGaLEDNumericalClass, XrtGaLEDNumerical.RD_xrtGaLeadingPlusMinus),
	XRTDIV_SPECIFIC,
	XRTPASS0,
	NULL,
	XrtGaLEDNumerical_LeadingPlusMinus,
	FALSE,
	TRUE
},
{
	"xrtGaLeadingZeros",
	"RD_xrtGaLeadingZeros",
	XmNxrtGaLeadingZeros,
	"XmNxrtGaLeadingZeros",
	XRTGA_XM_BOOLEAN,
	{0, 0, 0},
	Offset(UxXrtGaLEDNumericalClass, XrtGaLEDNumerical.RD_xrtGaLeadingZeros),
	XRTDIV_SPECIFIC,
	XRTPASS0,
	NULL,
	XrtGaLEDNumerical_LeadingZeros,
	FALSE,
	TRUE
},
{
	"xrtGaNumDigits",
	"RD_xrtGaNumDigits",
	XmNxrtGaNumDigits,
	"XmNxrtGaNumDigits",
	XRTGA_XM_INT,
	{0, 0, 0},
	Offset(UxXrtGaLEDNumericalClass, XrtGaLEDNumerical.RD_xrtGaNumDigits),
	XRTDIV_SPECIFIC,
	XRTPASS0,
	NULL,
	XrtGaLEDNumerical_NumDigits,
	FALSE,
	TRUE
},
{
	"xrtGaImage",
	"RD_xrtGaImage",
	XmNxrtGaImage,
	"XmNxrtGaImage",
	XRTGA_IMAGE,
	{0, 0, 0},
	Offset(UxXrtGaLEDNumericalClass, XrtGaLEDNumerical.RD_xrtGaImage),
	XRTDIV_SPECIFIC,
	XRTPASS0,
	NULL,
	XrtGaLEDNumerical_Image,
	FALSE,
	TRUE
},
{
	"xrtGaImageLayout",
	"RD_xrtGaImageLayout",
	XmNxrtGaImageLayout,
	"XmNxrtGaImageLayout",
	XRTGA_IMAGE_LAYOUT,
	{0, 0, 0},
	Offset(UxXrtGaLEDNumericalClass, XrtGaLEDNumerical.RD_xrtGaImageLayout),
	XRTDIV_SPECIFIC,
	XRTPASS0,
	NULL,
	XrtGaLEDNumerical_ImageLayout,
	FALSE,
	TRUE
},
{
	"xrtGaOnColor",
	"RD_xrtGaOnColor",
	XmNxrtGaOnColor,
	"XmNxrtGaOnColor",
	XRTGA_XM_PIXEL,
	{0, 0, 0},
	Offset(UxXrtGaLEDNumericalClass, XrtGaLEDNumerical.RD_xrtGaOnColor),
	XRTDIV_SPECIFIC,
	XRTPASS0,
	NULL,
	XrtGaLEDNumerical_OnColor,
	FALSE,
	TRUE
},
{
	"xrtGaOffColor",
	"RD_xrtGaOffColor",
	XmNxrtGaOffColor,
	"XmNxrtGaOffColor",
	XRTGA_XM_PIXEL,
	{0, 0, 0},
	Offset(UxXrtGaLEDNumericalClass, XrtGaLEDNumerical.RD_xrtGaOffColor),
	XRTDIV_SPECIFIC,
	XRTPASS0,
	NULL,
	XrtGaLEDNumerical_OffColor,
	FALSE,
	TRUE
},
{
	"xrtGaRepaint",
	"RD_xrtGaRepaint",
	XmNxrtGaRepaint,
	"XmNxrtGaRepaint",
	XRTGA_XM_BOOLEAN,
	{0, 0, 0},
	Offset(UxXrtGaLEDNumericalClass, XrtGaLEDNumerical.RD_xrtGaRepaint),
	XRTDIV_SPECIFIC,
	XRTPASS0,
	NULL,
	XrtGaLEDNumerical_Repaint,
	FALSE,
	TRUE
},
{
	"xrtGaResizeCallback",
	"RD_xrtGaResizeCallback",
	XmNxrtGaResizeCallback,
	"XmNxrtGaResizeCallback",
	XRTGA_CALLBACK,
	{0, 0, 0},
	Offset(UxXrtGaLEDNumericalClass, XrtGaLEDNumerical.RD_xrtGaResizeCallback),
	XRTDIV_BEHAVIOR,
	XRTPASS0,
	NULL,
	XrtGaLEDNumerical_ResizeCallback,
	FALSE,
	TRUE
},
{
	"xrtGaSegmentSpacing",
	"RD_xrtGaSegmentSpacing",
	XmNxrtGaSegmentSpacing,
	"XmNxrtGaSegmentSpacing",
	XRTGA_XM_INT,
	{0, 0, 0},
	Offset(UxXrtGaLEDNumericalClass, XrtGaLEDNumerical.RD_xrtGaSegmentSpacing),
	XRTDIV_SPECIFIC,
	XRTPASS0,
	NULL,
	XrtGaLEDNumerical_SegmentSpacing,
	FALSE,
	TRUE
},
{
	"xrtGaSegmentWidth",
	"RD_xrtGaSegmentWidth",
	XmNxrtGaSegmentWidth,
	"XmNxrtGaSegmentWidth",
	XRTGA_XM_INT,
	{0, 0, 0},
	Offset(UxXrtGaLEDNumericalClass, XrtGaLEDNumerical.RD_xrtGaSegmentWidth),
	XRTDIV_SPECIFIC,
	XRTPASS0,
	NULL,
	XrtGaLEDNumerical_SegmentWidth,
	FALSE,
	TRUE
},
{
	"xrtGaSlopeOffset",
	"RD_xrtGaSlopeOffset",
	XmNxrtGaSlopeOffset,
	"XmNxrtGaSlopeOffset",
	XRTGA_XM_INT,
	{0, 0, 0},
	Offset(UxXrtGaLEDNumericalClass, XrtGaLEDNumerical.RD_xrtGaSlopeOffset),
	XRTDIV_SPECIFIC,
	XRTPASS0,
	NULL,
	XrtGaLEDNumerical_SlopeOffset,
	FALSE,
	TRUE
},
{
	"xrtGaSpacingHorizontal",
	"RD_xrtGaSpacingHorizontal",
	XmNxrtGaSpacingHorizontal,
	"XmNxrtGaSpacingHorizontal",
	XRTGA_XM_INT,
	{0, 0, 0},
	Offset(UxXrtGaLEDNumericalClass, XrtGaLEDNumerical.RD_xrtGaSpacingHorizontal),
	XRTDIV_SPECIFIC,
	XRTPASS0,
	NULL,
	XrtGaLEDNumerical_SpacingHorizontal,
	FALSE,
	TRUE
},
{
	"xrtGaSpacingVertical",
	"RD_xrtGaSpacingVertical",
	XmNxrtGaSpacingVertical,
	"XmNxrtGaSpacingVertical",
	XRTGA_XM_INT,
	{0, 0, 0},
	Offset(UxXrtGaLEDNumericalClass, XrtGaLEDNumerical.RD_xrtGaSpacingVertical),
	XRTDIV_SPECIFIC,
	XRTPASS0,
	NULL,
	XrtGaLEDNumerical_SpacingVertical,
	FALSE,
	TRUE
},
{
	"xrtGaText",
	"RD_xrtGaText",
	XmNxrtGaText,
	"XmNxrtGaText",
	XRTGA_XM_STRING,
	{0, 0, 0},
	Offset(UxXrtGaLEDNumericalClass, XrtGaLEDNumerical.RD_xrtGaText),
	XRTDIV_SPECIFIC,
	XRTPASS0,
	NULL,
	XrtGaLEDNumerical_Text,
	FALSE,
	TRUE
},
{
	"xrtGaValue",
	"RD_xrtGaValue",
	XmNxrtGaValue,
	"XmNxrtGaValue",
	XRTGA_DOUBLE,
	{0, 0, 0},
	Offset(UxXrtGaLEDNumericalClass, XrtGaLEDNumerical.RD_xrtGaValue),
	XRTDIV_SPECIFIC,
	XRTPASS0,
	NULL,
	XrtGaLEDNumerical_Value,
	FALSE,
	TRUE
},
{
	"xrtGaValueChangedCallback",
	"RD_xrtGaValueChangedCallback",
	XmNxrtGaValueChangedCallback,
	"XmNxrtGaValueChangedCallback",
	XRTGA_CALLBACK,
	{0, 0, 0},
	Offset(UxXrtGaLEDNumericalClass, XrtGaLEDNumerical.RD_xrtGaValueChangedCallback),
	XRTDIV_BEHAVIOR,
	XRTPASS0,
	NULL,
	XrtGaLEDNumerical_ValueChangedCallback,
	FALSE,
	TRUE
},
{
	"xrtGaValueType",
	"RD_xrtGaValueType",
	XmNxrtGaValueType,
	"XmNxrtGaValueType",
	XRTGA_VALUE_TYPE,
	{0, 0, 0},
	Offset(UxXrtGaLEDNumericalClass, XrtGaLEDNumerical.RD_xrtGaValueType),
	XRTDIV_SPECIFIC,
	XRTPASS0,
	NULL,
	XrtGaLEDNumerical_ValueType,
	FALSE,
	TRUE
},
};

XrtGaugeResourceDesc	XrtGaLinearDial_res_table[] = {
{
	"xrtGaBorder",
	"RD_xrtGaBorder",
	XmNxrtGaBorder,
	"XmNxrtGaBorder",
	XRTGA_BORDER,
	{0, 0, 0},
	Offset(UxXrtGaLinearDialClass, XrtGaLinearDial.RD_xrtGaBorder),
	XRTDIV_SPECIFIC,
	XRTPASS0,
	NULL,
	XrtGaLDial_Border,
	FALSE,
	TRUE
},
{
	"xrtGaDebug",
	"RD_xrtGaDebug",
	XmNxrtGaDebug,
	"XmNxrtGaDebug",
	XRTGA_XM_BOOLEAN,
	{0, 0, 0},
	Offset(UxXrtGaLinearDialClass, XrtGaLinearDial.RD_xrtGaDebug),
	XRTDIV_SPECIFIC,
	XRTPASS0,
	NULL,
	XrtGaLDial_Debug,
	FALSE,
	TRUE
},
{
	"xrtGaDoubleBuffer",
	"RD_xrtGaDoubleBuffer",
	XmNxrtGaDoubleBuffer,
	"XmNxrtGaDoubleBuffer",
	XRTGA_XM_BOOLEAN,
	{0, 0, 0},
	Offset(UxXrtGaLinearDialClass, XrtGaLinearDial.RD_xrtGaDoubleBuffer),
	XRTDIV_SPECIFIC,
	XRTPASS0,
	NULL,
	XrtGaLDial_DoubleBuffer,
	FALSE,
	TRUE
},
{
	"xrtGaDrawFunc",
	"RD_xrtGaDrawFunc",
	XmNxrtGaDrawFunc,
	"XmNxrtGaDrawFunc",
	XRTGA_XM_FUNCTION,
	{0, 0, 0},
	Offset(UxXrtGaLinearDialClass, XrtGaLinearDial.RD_xrtGaDrawFunc),
	XRTDIV_SPECIFIC,
	XRTPASS0,
	NULL,
	XrtGaLDial_DrawFunc,
	FALSE,
	TRUE
},
{
	"xrtGaExposeCallback",
	"RD_xrtGaExposeCallback",
	XmNxrtGaExposeCallback,
	"XmNxrtGaExposeCallback",
	XRTGA_CALLBACK,
	{0, 0, 0},
	Offset(UxXrtGaLinearDialClass, XrtGaLinearDial.RD_xrtGaExposeCallback),
	XRTDIV_BEHAVIOR,
	XRTPASS0,
	NULL,
	XrtGaLDial_ExposeCallback,
	FALSE,
	TRUE
},
{
	"xrtGaFrame",
	"RD_xrtGaFrame",
	XmNxrtGaFrame,
	"XmNxrtGaFrame",
	XRTGA_OBJECT,
	{0, 0, 0},
	Offset(UxXrtGaLinearDialClass, XrtGaLinearDial.RD_xrtGaFrame),
	XRTDIV_SPECIFIC,
	XRTPASS0,
	NULL,
	XrtGaLDial_Frame,
	FALSE,
	TRUE
},
{
	"xrtGaImage",
	"RD_xrtGaImage",
	XmNxrtGaImage,
	"XmNxrtGaImage",
	XRTGA_IMAGE,
	{0, 0, 0},
	Offset(UxXrtGaLinearDialClass, XrtGaLinearDial.RD_xrtGaImage),
	XRTDIV_SPECIFIC,
	XRTPASS0,
	NULL,
	XrtGaLDial_Image,
	FALSE,
	TRUE
},
{
	"xrtGaImageLayout",
	"RD_xrtGaImageLayout",
	XmNxrtGaImageLayout,
	"XmNxrtGaImageLayout",
	XRTGA_IMAGE_LAYOUT,
	{0, 0, 0},
	Offset(UxXrtGaLinearDialClass, XrtGaLinearDial.RD_xrtGaImageLayout),
	XRTDIV_SPECIFIC,
	XRTPASS0,
	NULL,
	XrtGaLDial_ImageLayout,
	FALSE,
	TRUE
},
{
	"xrtGaIndicator",
	"RD_xrtGaIndicator",
	XmNxrtGaIndicator,
	"XmNxrtGaIndicator",
	XRTGA_INDICATOR_TYPE,
	{0, 0, 0},
	Offset(UxXrtGaLinearDialClass, XrtGaLinearDial.RD_xrtGaIndicator),
	XRTDIV_SPECIFIC,
	XRTPASS0,
	NULL,
	XrtGaLDial_Indicator,
	FALSE,
	TRUE
},
{
	"xrtGaInteractionCallback",
	"RD_xrtGaInteractionCallback",
	XmNxrtGaInteractionCallback,
	"XmNxrtGaInteractionCallback",
	XRTGA_CALLBACK,
	{0, 0, 0},
	Offset(UxXrtGaLinearDialClass, XrtGaLinearDial.RD_xrtGaInteractionCallback),
	XRTDIV_BEHAVIOR,
	XRTPASS0,
	NULL,
	XrtGaLDial_InteractionCallback,
	FALSE,
	TRUE
},
{
	"xrtGaLinearScale",
	"RD_xrtGaLinearScale",
	XmNxrtGaLinearScale,
	"XmNxrtGaLinearScale",
	XRTGA_OBJECT,
	{0, 0, 0},
	Offset(UxXrtGaLinearDialClass, XrtGaLinearDial.RD_xrtGaLinearScale),
	XRTDIV_SPECIFIC,
	XRTPASS0,
	NULL,
	XrtGaLDial_LinearScale,
	FALSE,
	TRUE
},
{
	"xrtGaMapCallback",
	"RD_xrtGaMapCallback",
	XmNxrtGaMapCallback,
	"XmNxrtGaMapCallback",
	XRTGA_CALLBACK,
	{0, 0, 0},
	Offset(UxXrtGaLinearDialClass, XrtGaLinearDial.RD_xrtGaMapCallback),
	XRTDIV_BEHAVIOR,
	XRTPASS0,
	NULL,
	XrtGaLDial_MapCallback,
	FALSE,
	TRUE
},
{
	"xrtGaOnColor",
	"RD_xrtGaOnColor",
	XmNxrtGaOnColor,
	"XmNxrtGaOnColor",
	XRTGA_XM_PIXEL,
	{0, 0, 0},
	Offset(UxXrtGaLinearDialClass, XrtGaLinearDial.RD_xrtGaOnColor),
	XRTDIV_SPECIFIC,
	XRTPASS0,
	NULL,
	XrtGaLDial_OnColor,
	FALSE,
	TRUE
},
{
	"xrtGaOnImage",
	"RD_xrtGaOnImage",
	XmNxrtGaOnImage,
	"XmNxrtGaOnImage",
	XRTGA_IMAGE,
	{0, 0, 0},
	Offset(UxXrtGaLinearDialClass, XrtGaLinearDial.RD_xrtGaOnImage),
	XRTDIV_SPECIFIC,
	XRTPASS0,
	NULL,
	XrtGaLDial_OnImage,
	FALSE,
	TRUE
},
{
	"xrtGaOffColor",
	"RD_xrtGaOffColor",
	XmNxrtGaOffColor,
	"XmNxrtGaOffColor",
	XRTGA_XM_PIXEL,
	{0, 0, 0},
	Offset(UxXrtGaLinearDialClass, XrtGaLinearDial.RD_xrtGaOffColor),
	XRTDIV_SPECIFIC,
	XRTPASS0,
	NULL,
	XrtGaLDial_OffColor,
	FALSE,
	TRUE
},
{
	"xrtGaOffImage",
	"RD_xrtGaOffImage",
	XmNxrtGaOffImage,
	"XmNxrtGaOffImage",
	XRTGA_IMAGE,
	{0, 0, 0},
	Offset(UxXrtGaLinearDialClass, XrtGaLinearDial.RD_xrtGaOffImage),
	XRTDIV_SPECIFIC,
	XRTPASS0,
	NULL,
	XrtGaLDial_OffImage,
	FALSE,
	TRUE
},
{
	"xrtGaShape",
	"RD_xrtGaShape",
	XmNxrtGaShape,
	"XmNxrtGaShape",
	XRTGA_SHAPE,
	{0, 0, 0},
	Offset(UxXrtGaLinearDialClass, XrtGaLinearDial.RD_xrtGaShape),
	XRTDIV_SPECIFIC,
	XRTPASS0,
	NULL,
	XrtGaLDial_Shape,
	FALSE,
	TRUE
},
{
	"xrtGaRenderList",
	"RD_xrtGaRenderList",
	XmNxrtGaRenderList,
	"XmNxrtGaRenderList",
	XRTGA_OBJECT_LIST,
	{0, 0, 0},
	Offset(UxXrtGaLinearDialClass, XrtGaLinearDial.RD_xrtGaRenderList),
	XRTDIV_SPECIFIC,
	XRTPASS0,
	NULL,
	XrtGaLDial_RenderList,
	TRUE,
	TRUE
},
{
	"xrtGaRepaint",
	"RD_xrtGaRepaint",
	XmNxrtGaRepaint,
	"XmNxrtGaRepaint",
	XRTGA_XM_BOOLEAN,
	{0, 0, 0},
	Offset(UxXrtGaLinearDialClass, XrtGaLinearDial.RD_xrtGaRepaint),
	XRTDIV_SPECIFIC,
	XRTPASS0,
	NULL,
	XrtGaLDial_Repaint,
	FALSE,
	TRUE
},
{
	"xrtGaResizeCallback",
	"RD_xrtGaResizeCallback",
	XmNxrtGaResizeCallback,
	"XmNxrtGaResizeCallback",
	XRTGA_CALLBACK,
	{0, 0, 0},
	Offset(UxXrtGaLinearDialClass, XrtGaLinearDial.RD_xrtGaResizeCallback),
	XRTDIV_BEHAVIOR,
	XRTPASS0,
	NULL,
	XrtGaLDial_ResizeCallback,
	FALSE,
	TRUE
},
{
	"xrtGaTextList",
	"RD_xrtGaTextList",
	XmNxrtGaTextList,
	"XmNxrtGaTextList",
	XRTGA_OBJECT_LIST,
	{0, 0, 0},
	Offset(UxXrtGaLinearDialClass, XrtGaLinearDial.RD_xrtGaTextList),
	XRTDIV_SPECIFIC,
	XRTPASS0,
	NULL,
	XrtGaLDial_TextList,
	TRUE,
	TRUE
},
{
	"xrtGaTickList",
	"RD_xrtGaTickList",
	XmNxrtGaTickList,
	"XmNxrtGaTickList",
	XRTGA_OBJECT_LIST,
	{0, 0, 0},
	Offset(UxXrtGaLinearDialClass, XrtGaLinearDial.RD_xrtGaTickList),
	XRTDIV_SPECIFIC,
	XRTPASS0,
	NULL,
	XrtGaLDial_TickList,
	TRUE,
	TRUE
},
{
	"xrtGaUseRenderList",
	"RD_xrtGaUseRenderList",
	XmNxrtGaUseRenderList,
	"XmNxrtGaUseRenderList",
	XRTGA_XM_BOOLEAN,
	{0, 0, 0},
	Offset(UxXrtGaLinearDialClass, XrtGaLinearDial.RD_xrtGaUseRenderList),
	XRTDIV_SPECIFIC,
	XRTPASS0,
	NULL,
	XrtGaLDial_UseRenderList,
	FALSE,
	TRUE
},
};

XrtGaugeResourceDesc	XrtGaLinearGauge_res_table[] = {
{
	"xrtGaBorder",
	"RD_xrtGaBorder",
	XmNxrtGaBorder,
	"XmNxrtGaBorder",
	XRTGA_BORDER,
	{0, 0, 0},
	Offset(UxXrtGaLinearGaugeClass, XrtGaLinearGauge.RD_xrtGaBorder),
	XRTDIV_SPECIFIC,
	XRTPASS0,
	NULL,
	XrtGaLGauge_Border,
	FALSE,
	TRUE
},
{
	"xrtGaDebug",
	"RD_xrtGaDebug",
	XmNxrtGaDebug,
	"XmNxrtGaDebug",
	XRTGA_XM_BOOLEAN,
	{0, 0, 0},
	Offset(UxXrtGaLinearGaugeClass, XrtGaLinearGauge.RD_xrtGaDebug),
	XRTDIV_SPECIFIC,
	XRTPASS0,
	NULL,
	XrtGaLGauge_Debug,
	FALSE,
	TRUE
},
{
	"xrtGaDoubleBuffer",
	"RD_xrtGaDoubleBuffer",
	XmNxrtGaDoubleBuffer,
	"XmNxrtGaDoubleBuffer",
	XRTGA_XM_BOOLEAN,
	{0, 0, 0},
	Offset(UxXrtGaLinearGaugeClass, XrtGaLinearGauge.RD_xrtGaDoubleBuffer),
	XRTDIV_SPECIFIC,
	XRTPASS0,
	NULL,
	XrtGaLGauge_DoubleBuffer,
	FALSE,
	TRUE
},
{
	"xrtGaExposeCallback",
	"RD_xrtGaExposeCallback",
	XmNxrtGaExposeCallback,
	"XmNxrtGaExposeCallback",
	XRTGA_CALLBACK,
	{0, 0, 0},
	Offset(UxXrtGaLinearGaugeClass, XrtGaLinearGauge.RD_xrtGaExposeCallback),
	XRTDIV_BEHAVIOR,
	XRTPASS0,
	NULL,
	XrtGaLGauge_ExposeCallback,
	FALSE,
	TRUE
},
{
	"xrtGaFrame",
	"RD_xrtGaFrame",
	XmNxrtGaFrame,
	"XmNxrtGaFrame",
	XRTGA_OBJECT,
	{0, 0, 0},
	Offset(UxXrtGaLinearGaugeClass, XrtGaLinearGauge.RD_xrtGaFrame),
	XRTDIV_SPECIFIC,
	XRTPASS0,
	NULL,
	XrtGaLGauge_Frame,
	FALSE,
	TRUE
},
{
	"xrtGaImage",
	"RD_xrtGaImage",
	XmNxrtGaImage,
	"XmNxrtGaImage",
	XRTGA_IMAGE,
	{0, 0, 0},
	Offset(UxXrtGaLinearGaugeClass, XrtGaLinearGauge.RD_xrtGaImage),
	XRTDIV_SPECIFIC,
	XRTPASS0,
	NULL,
	XrtGaLGauge_Image,
	FALSE,
	TRUE
},
{
	"xrtGaImageLayout",
	"RD_xrtGaImageLayout",
	XmNxrtGaImageLayout,
	"XmNxrtGaImageLayout",
	XRTGA_IMAGE_LAYOUT,
	{0, 0, 0},
	Offset(UxXrtGaLinearGaugeClass, XrtGaLinearGauge.RD_xrtGaImageLayout),
	XRTDIV_SPECIFIC,
	XRTPASS0,
	NULL,
	XrtGaLGauge_ImageLayout,
	FALSE,
	TRUE
},
{
	"xrtGaIndicatorList",
	"RD_xrtGaIndicatorList",
	XmNxrtGaIndicatorList,
	"XmNxrtGaIndicatorList",
	XRTGA_OBJECT_LIST,
	{0, 0, 0},
	Offset(UxXrtGaLinearGaugeClass, XrtGaLinearGauge.RD_xrtGaIndicatorList),
	XRTDIV_SPECIFIC,
	XRTPASS0,
	NULL,
	XrtGaLGauge_IndicatorList,
	TRUE,
	TRUE
},
{
	"xrtGaInteractionCallback",
	"RD_xrtGaInteractionCallback",
	XmNxrtGaInteractionCallback,
	"XmNxrtGaInteractionCallback",
	XRTGA_CALLBACK,
	{0, 0, 0},
	Offset(UxXrtGaLinearGaugeClass, XrtGaLinearGauge.RD_xrtGaInteractionCallback),
	XRTDIV_BEHAVIOR,
	XRTPASS0,
	NULL,
	XrtGaLGauge_InteractionCallback,
	FALSE,
	TRUE
},
{
	"xrtGaLinearScaleList",
	"RD_xrtGaLinearScaleList",
	XmNxrtGaLinearScaleList,
	"XmNxrtGaLinearScaleList",
	XRTGA_OBJECT_LIST,
	{0, 0, 0},
	Offset(UxXrtGaLinearGaugeClass, XrtGaLinearGauge.RD_xrtGaLinearScaleList),
	XRTDIV_SPECIFIC,
	XRTPASS0,
	NULL,
	XrtGaLGauge_LinearScaleList,
	TRUE,
	TRUE
},
{
	"xrtGaMapCallback",
	"RD_xrtGaMapCallback",
	XmNxrtGaMapCallback,
	"XmNxrtGaMapCallback",
	XRTGA_CALLBACK,
	{0, 0, 0},
	Offset(UxXrtGaLinearGaugeClass, XrtGaLinearGauge.RD_xrtGaMapCallback),
	XRTDIV_BEHAVIOR,
	XRTPASS0,
	NULL,
	XrtGaLGauge_MapCallback,
	FALSE,
	TRUE
},
{
	"xrtGaRangeList",
	"RD_xrtGaRangeList",
	XmNxrtGaRangeList,
	"XmNxrtGaRangeList",
	XRTGA_OBJECT_LIST,
	{0, 0, 0},
	Offset(UxXrtGaLinearGaugeClass, XrtGaLinearGauge.RD_xrtGaRangeList),
	XRTDIV_SPECIFIC,
	XRTPASS0,
	NULL,
	XrtGaLGauge_RangeList,
	TRUE,
	TRUE
},
{
	"xrtGaRenderList",
	"RD_xrtGaRenderList",
	XmNxrtGaRenderList,
	"XmNxrtGaRenderList",
	XRTGA_OBJECT_LIST,
	{0, 0, 0},
	Offset(UxXrtGaLinearGaugeClass, XrtGaLinearGauge.RD_xrtGaRenderList),
	XRTDIV_SPECIFIC,
	XRTPASS0,
	NULL,
	XrtGaLGauge_RenderList,
	TRUE,
	TRUE
},
{
	"xrtGaRepaint",
	"RD_xrtGaRepaint",
	XmNxrtGaRepaint,
	"XmNxrtGaRepaint",
	XRTGA_XM_BOOLEAN,
	{0, 0, 0},
	Offset(UxXrtGaLinearGaugeClass, XrtGaLinearGauge.RD_xrtGaRepaint),
	XRTDIV_SPECIFIC,
	XRTPASS0,
	NULL,
	XrtGaLGauge_Repaint,
	FALSE,
	TRUE
},
{
	"xrtGaResizeCallback",
	"RD_xrtGaResizeCallback",
	XmNxrtGaResizeCallback,
	"XmNxrtGaResizeCallback",
	XRTGA_CALLBACK,
	{0, 0, 0},
	Offset(UxXrtGaLinearGaugeClass, XrtGaLinearGauge.RD_xrtGaResizeCallback),
	XRTDIV_BEHAVIOR,
	XRTPASS0,
	NULL,
	XrtGaLGauge_ResizeCallback,
	FALSE,
	TRUE
},
{
	"xrtGaTextList",
	"RD_xrtGaTextList",
	XmNxrtGaTextList,
	"XmNxrtGaTextList",
	XRTGA_OBJECT_LIST,
	{0, 0, 0},
	Offset(UxXrtGaLinearGaugeClass, XrtGaLinearGauge.RD_xrtGaTextList),
	XRTDIV_SPECIFIC,
	XRTPASS0,
	NULL,
	XrtGaLGauge_TextList,
	TRUE,
	TRUE
},
{
	"xrtGaTickList",
	"RD_xrtGaTickList",
	XmNxrtGaTickList,
	"XmNxrtGaTickList",
	XRTGA_OBJECT_LIST,
	{0, 0, 0},
	Offset(UxXrtGaLinearGaugeClass, XrtGaLinearGauge.RD_xrtGaTickList),
	XRTDIV_SPECIFIC,
	XRTPASS0,
	NULL,
	XrtGaLGauge_TickList,
	TRUE,
	TRUE
},
{
	"xrtGaUseRenderList",
	"RD_xrtGaUseRenderList",
	XmNxrtGaUseRenderList,
	"XmNxrtGaUseRenderList",
	XRTGA_XM_BOOLEAN,
	{0, 0, 0},
	Offset(UxXrtGaLinearGaugeClass, XrtGaLinearGauge.RD_xrtGaUseRenderList),
	XRTDIV_SPECIFIC,
	XRTPASS0,
	NULL,
	XrtGaLGauge_UseRenderList,
	FALSE,
	TRUE
},
};

XrtGaugeResourceDesc	XrtGaLinearScale_res_table[] = {
{
	"background",
	"RD_background",
	XmNbackground,
	"XmNbackground",
	XRTGA_XM_PIXEL,
	{0, 0, 0},
	Offset(UxXrtGaLinearScaleClass, XrtGaLinearScale.RD_background),
	XRTDIV_SPECIFIC,
	XRTPASS0,
	NULL,
	XrtGaLScale_background,
	FALSE,
	TRUE
},
{
	"height",
	"RD_height",
	XmNheight,
	"XmNheight",
	XRTGA_XM_INT,
	{0, 0, 0},
	Offset(UxXrtGaLinearScaleClass, XrtGaLinearScale.RD_height),
	XRTDIV_SPECIFIC,
	XRTPASS0,
	NULL,
	XrtGaLScale_height,
	FALSE,
	TRUE
},
{
	"width",
	"RD_width",
	XmNwidth,
	"XmNwidth",
	XRTGA_XM_INT,
	{0, 0, 0},
	Offset(UxXrtGaLinearScaleClass, XrtGaLinearScale.RD_width),
	XRTDIV_SPECIFIC,
	XRTPASS0,
	NULL,
	XrtGaLScale_width,
	FALSE,
	TRUE
},
{
	"x",
	"RD_x",
	XmNx,
	"XmNx",
	XRTGA_XM_INT,
	{0, 0, 0},
	Offset(UxXrtGaLinearScaleClass, XrtGaLinearScale.RD_x),
	XRTDIV_SPECIFIC,
	XRTPASS0,
	NULL,
	XrtGaLScale_x,
	FALSE,
	TRUE
},
{
	"y",
	"RD_y",
	XmNy,
	"XmNy",
	XRTGA_XM_INT,
	{0, 0, 0},
	Offset(UxXrtGaLinearScaleClass, XrtGaLinearScale.RD_y),
	XRTDIV_SPECIFIC,
	XRTPASS0,
	NULL,
	XrtGaLScale_y,
	FALSE,
	TRUE
},
{
	"xrtGaAllowTransform",
	"RD_xrtGaAllowTransform",
	XmNxrtGaAllowTransform,
	"XmNxrtGaAllowTransform",
	XRTGA_XM_BOOLEAN,
	{0, 0, 0},
	Offset(UxXrtGaLinearScaleClass, XrtGaLinearScale.RD_xrtGaAllowTransform),
	XRTDIV_SPECIFIC,
	XRTPASS0,
	NULL,
	XrtGaLScale_AllowTransform,
	FALSE,
	TRUE
},
{
	"xrtGaDebug",
	"RD_xrtGaDebug",
	XmNxrtGaDebug,
	"XmNxrtGaDebug",
	XRTGA_XM_BOOLEAN,
	{0, 0, 0},
	Offset(UxXrtGaLinearScaleClass, XrtGaLinearScale.RD_xrtGaDebug),
	XRTDIV_SPECIFIC,
	XRTPASS0,
	NULL,
	XrtGaLScale_Debug,
	FALSE,
	TRUE
},
{
	"xrtGaDirection",
	"RD_xrtGaDirection",
	XmNxrtGaDirection,
	"XmNxrtGaDirection",
	XRTGA_DIRECTION,
	{0, 0, 0},
	Offset(UxXrtGaLinearScaleClass, XrtGaLinearScale.RD_xrtGaDirection),
	XRTDIV_SPECIFIC,
	XRTPASS0,
	NULL,
	XrtGaLScale_Direction,
	FALSE,
	TRUE
},
{
	"xrtGaMax",
	"RD_xrtGaMax",
	XmNxrtGaMax,
	"XmNxrtGaMax",
	XRTGA_DOUBLE,
	{0, 0, 0},
	Offset(UxXrtGaLinearScaleClass, XrtGaLinearScale.RD_xrtGaMax),
	XRTDIV_SPECIFIC,
	XRTPASS0,
	NULL,
	XrtGaLScale_Max,
	FALSE,
	TRUE
},
{
	"xrtGaMin",
	"RD_xrtGaMin",
	XmNxrtGaMin,
	"XmNxrtGaMin",
	XRTGA_DOUBLE,
	{0, 0, 0},
	Offset(UxXrtGaLinearScaleClass, XrtGaLinearScale.RD_xrtGaMin),
	XRTDIV_SPECIFIC,
	XRTPASS0,
	NULL,
	XrtGaLScale_Min,
	FALSE,
	TRUE
},
{
	"xrtGaOrientation",
	"RD_xrtGaOrientation",
	XmNxrtGaOrientation,
	"XmNxrtGaOrientation",
	XRTGA_XM_ORIENTATION,
	{0, 0, 0},
	Offset(UxXrtGaLinearScaleClass, XrtGaLinearScale.RD_xrtGaOrientation),
	XRTDIV_SPECIFIC,
	XRTPASS0,
	NULL,
	XrtGaLScale_Orientation,
	FALSE,
	TRUE
},
{
	"xrtGaTransformCallback",
	"RD_xrtGaTransformCallback",
	XmNxrtGaTransformCallback,
	"XmNxrtGaTransformCallback",
	XRTGA_CALLBACK,
	{0, 0, 0},
	Offset(UxXrtGaLinearScaleClass, XrtGaLinearScale.RD_xrtGaTransformCallback),
	XRTDIV_BEHAVIOR,
	XRTPASS0,
	NULL,
	XrtGaLScale_TransformCallback,
	FALSE,
	TRUE
},
};

XrtGaugeResourceDesc	XrtGaMarker_res_table[] = {
{
	"background",
	"RD_background",
	XmNbackground,
	"XmNbackground",
	XRTGA_XM_PIXEL,
	{0, 0, 0},
	Offset(UxXrtGaMarkerClass, XrtGaMarker.RD_background),
	XRTDIV_SPECIFIC,
	XRTPASS0,
	NULL,
	XrtGaMarker_background,
	FALSE,
	TRUE
},
{
	"width",
	"RD_width",
	XmNwidth,
	"XmNwidth",
	XRTGA_XM_INT,
	{0, 0, 0},
	Offset(UxXrtGaMarkerClass, XrtGaMarker.RD_width),
	XRTDIV_SPECIFIC,
	XRTPASS0,
	NULL,
	XrtGaMarker_width,
	FALSE,
	TRUE
},
{
	"xrtGaCircularScale",
	"RD_xrtGaCircularScale",
	XmNxrtGaCircularScale,
	"XmNxrtGaCircularScale",
	XRTGA_OBJECT,
	{0, 0, 0},
	Offset(UxXrtGaMarkerClass, XrtGaMarker.RD_xrtGaCircularScale),
	XRTDIV_SPECIFIC,
	XRTPASS0,
	NULL,
	XrtGaMarker_CircularScale,
	FALSE,
	TRUE
},
{
	"xrtGaDebug",
	"RD_xrtGaDebug",
	XmNxrtGaDebug,
	"XmNxrtGaDebug",
	XRTGA_XM_BOOLEAN,
	{0, 0, 0},
	Offset(UxXrtGaMarkerClass, XrtGaMarker.RD_xrtGaDebug),
	XRTDIV_SPECIFIC,
	XRTPASS0,
	NULL,
	XrtGaMarker_Debug,
	FALSE,
	TRUE
},
{
	"xrtGaDrawFunc",
	"RD_xrtGaDrawFunc",
	XmNxrtGaDrawFunc,
	"XmNxrtGaDrawFunc",
	XRTGA_XM_FUNCTION,
	{0, 0, 0},
	Offset(UxXrtGaMarkerClass, XrtGaMarker.RD_xrtGaDrawFunc),
	XRTDIV_SPECIFIC,
	XRTPASS0,
	NULL,
	XrtGaMarker_DrawFunc,
	FALSE,
	TRUE
},
{
	"xrtGaImage",
	"RD_xrtGaImage",
	XmNxrtGaImage,
	"XmNxrtGaImage",
	XRTGA_IMAGE,
	{0, 0, 0},
	Offset(UxXrtGaMarkerClass, XrtGaMarker.RD_xrtGaImage),
	XRTDIV_SPECIFIC,
	XRTPASS0,
	NULL,
	XrtGaMarker_Image,
	FALSE,
	TRUE
},
{
	"xrtGaImageRotate",
	"RD_xrtGaImageRotate",
	XmNxrtGaImageRotate,
	"XmNxrtGaImageRotate",
	XRTGA_XM_BOOLEAN,
	{0, 0, 0},
	Offset(UxXrtGaMarkerClass, XrtGaMarker.RD_xrtGaImageRotate),
	XRTDIV_SPECIFIC,
	XRTPASS0,
	NULL,
	XrtGaMarker_ImageRotate,
	FALSE,
	TRUE
},
{
	"xrtGaIsShowing",
	"RD_xrtGaIsShowing",
	XmNxrtGaIsShowing,
	"XmNxrtGaIsShowing",
	XRTGA_XM_BOOLEAN,
	{0, 0, 0},
	Offset(UxXrtGaMarkerClass, XrtGaMarker.RD_xrtGaIsShowing),
	XRTDIV_SPECIFIC,
	XRTPASS0,
	NULL,
	XrtGaMarker_IsShowing,
	FALSE,
	TRUE
},
{
	"xrtGaMarkerType",
	"RD_xrtGaMarkerType",
	XmNxrtGaMarkerType,
	"XmNxrtGaMarkerType",
	XRTGA_MARKER_TYPE,
	{0, 0, 0},
	Offset(UxXrtGaMarkerClass, XrtGaMarker.RD_xrtGaMarkerType),
	XRTDIV_SPECIFIC,
	XRTPASS0,
	NULL,
	XrtGaMarker_MarkerType,
	FALSE,
	TRUE
},
{
	"xrtGaInnerRadius",
	"RD_xrtGaInnerRadius",
	XmNxrtGaInnerRadius,
	"XmNxrtGaInnerRadius",
	XRTGA_DOUBLE,
	{0, 0, 0},
	Offset(UxXrtGaMarkerClass, XrtGaMarker.RD_xrtGaInnerRadius),
	XRTDIV_SPECIFIC,
	XRTPASS0,
	NULL,
	XrtGaMarker_InnerRadius,
	FALSE,
	TRUE
},
{
	"xrtGaOuterRadius",
	"RD_xrtGaOuterRadius",
	XmNxrtGaOuterRadius,
	"XmNxrtGaOuterRadius",
	XRTGA_DOUBLE,
	{0, 0, 0},
	Offset(UxXrtGaMarkerClass, XrtGaMarker.RD_xrtGaOuterRadius),
	XRTDIV_SPECIFIC,
	XRTPASS0,
	NULL,
	XrtGaMarker_OuterRadius,
	FALSE,
	TRUE
},
};

XrtGaugeResourceDesc	XrtGaNeedle_res_table[] = {
{
	"background",
	"RD_background",
	XmNbackground,
	"XmNbackground",
	XRTGA_XM_PIXEL,
	{0, 0, 0},
	Offset(UxXrtGaNeedleClass, XrtGaNeedle.RD_background),
	XRTDIV_SPECIFIC,
	XRTPASS0,
	NULL,
	XrtGaNeedle_background,
	FALSE,
	TRUE
},
{
	"width",
	"RD_width",
	XmNwidth,
	"XmNwidth",
	XRTGA_XM_INT,
	{0, 0, 0},
	Offset(UxXrtGaNeedleClass, XrtGaNeedle.RD_width),
	XRTDIV_SPECIFIC,
	XRTPASS0,
	NULL,
	XrtGaNeedle_width,
	FALSE,
	TRUE
},
{
	"xrtGaCircularScale",
	"RD_xrtGaCircularScale",
	XmNxrtGaCircularScale,
	"XmNxrtGaCircularScale",
	XRTGA_OBJECT,
	{0, 0, 0},
	Offset(UxXrtGaNeedleClass, XrtGaNeedle.RD_xrtGaCircularScale),
	XRTDIV_SPECIFIC,
	XRTPASS0,
	NULL,
	XrtGaNeedle_CircularScale,
	FALSE,
	TRUE
},
{
	"xrtGaDebug",
	"RD_xrtGaDebug",
	XmNxrtGaDebug,
	"XmNxrtGaDebug",
	XRTGA_XM_BOOLEAN,
	{0, 0, 0},
	Offset(UxXrtGaNeedleClass, XrtGaNeedle.RD_xrtGaDebug),
	XRTDIV_SPECIFIC,
	XRTPASS0,
	NULL,
	XrtGaNeedle_Debug,
	FALSE,
	TRUE
},
{
	"xrtGaDrawFunc",
	"RD_xrtGaDrawFunc",
	XmNxrtGaDrawFunc,
	"XmNxrtGaDrawFunc",
	XRTGA_XM_FUNCTION,
	{0, 0, 0},
	Offset(UxXrtGaNeedleClass, XrtGaNeedle.RD_xrtGaDrawFunc),
	XRTDIV_SPECIFIC,
	XRTPASS0,
	NULL,
	XrtGaNeedle_DrawFunc,
	FALSE,
	TRUE
},
{
	"xrtGaInteractionType",
	"RD_xrtGaInteractionType",
	XmNxrtGaInteractionType,
	"XmNxrtGaInteractionType",
	XRTGA_INTERACTION_TYPE,
	{0, 0, 0},
	Offset(UxXrtGaNeedleClass, XrtGaNeedle.RD_xrtGaInteractionType),
	XRTDIV_SPECIFIC,
	XRTPASS0,
	NULL,
	XrtGaNeedle_InteractionType,
	FALSE,
	TRUE
},
{
	"xrtGaIsShowing",
	"RD_xrtGaIsShowing",
	XmNxrtGaIsShowing,
	"XmNxrtGaIsShowing",
	XRTGA_XM_BOOLEAN,
	{0, 0, 0},
	Offset(UxXrtGaNeedleClass, XrtGaNeedle.RD_xrtGaIsShowing),
	XRTDIV_SPECIFIC,
	XRTPASS0,
	NULL,
	XrtGaNeedle_IsShowing,
	FALSE,
	TRUE
},
{
	"xrtGaLength",
	"RD_xrtGaLength",
	XmNxrtGaLength,
	"XmNxrtGaLength",
	XRTGA_DOUBLE,
	{0, 0, 0},
	Offset(UxXrtGaNeedleClass, XrtGaNeedle.RD_xrtGaLength),
	XRTDIV_SPECIFIC,
	XRTPASS0,
	NULL,
	XrtGaNeedle_Length,
	FALSE,
	TRUE
},
{
	"xrtGaNeedleType",
	"RD_xrtGaNeedleType",
	XmNxrtGaNeedleType,
	"XmNxrtGaNeedleType",
	XRTGA_NEEDLE_TYPE,
	{0, 0, 0},
	Offset(UxXrtGaNeedleClass, XrtGaNeedle.RD_xrtGaNeedleType),
	XRTDIV_SPECIFIC,
	XRTPASS0,
	NULL,
	XrtGaNeedle_NeedleType,
	FALSE,
	TRUE
},
{
	"xrtGaValue",
	"RD_xrtGaValue",
	XmNxrtGaValue,
	"XmNxrtGaValue",
	XRTGA_DOUBLE,
	{0, 0, 0},
	Offset(UxXrtGaNeedleClass, XrtGaNeedle.RD_xrtGaValue),
	XRTDIV_SPECIFIC,
	XRTPASS0,
	NULL,
	XrtGaNeedle_Value,
	FALSE,
	TRUE
},
{
	"xrtGaValueChangedCallback",
	"RD_xrtGaValueChangedCallback",
	XmNxrtGaValueChangedCallback,
	"XmNxrtGaValueChangedCallback",
	XRTGA_CALLBACK,
	{0, 0, 0},
	Offset(UxXrtGaNeedleClass, XrtGaNeedle.RD_xrtGaValueChangedCallback),
	XRTDIV_BEHAVIOR,
	XRTPASS0,
	NULL,
	XrtGaNeedle_ValueChangedCallback,
	FALSE,
	TRUE
},
};

XrtGaugeResourceDesc	XrtGaPercent_res_table[] = {
{
	"xrtGaBorder",
	"RD_xrtGaBorder",
	XmNxrtGaBorder,
	"XmNxrtGaBorder",
	XRTGA_BORDER,
	{0, 0, 0},
	Offset(UxXrtGaPercentClass, XrtGaPercent.RD_xrtGaBorder),
	XRTDIV_SPECIFIC,
	XRTPASS0,
	NULL,
	XrtGaPercent_Border,
	FALSE,
	TRUE
},
{
	"xrtGaCalcMode",
	"RD_xrtGaCalcMode",
	XmNxrtGaCalcMode,
	"XmNxrtGaCalcMode",
	XRTGA_CALC_MODE,
	{0, 0, 0},
	Offset(UxXrtGaPercentClass, XrtGaPercent.RD_xrtGaCalcMode),
	XRTDIV_SPECIFIC,
	XRTPASS0,
	NULL,
	XrtGaPercent_CalcMode,
	FALSE,
	TRUE
},
{
	"xrtGaDebug",
	"RD_xrtGaDebug",
	XmNxrtGaDebug,
	"XmNxrtGaDebug",
	XRTGA_XM_BOOLEAN,
	{0, 0, 0},
	Offset(UxXrtGaPercentClass, XrtGaPercent.RD_xrtGaDebug),
	XRTDIV_SPECIFIC,
	XRTPASS0,
	NULL,
	XrtGaPercent_Debug,
	FALSE,
	TRUE
},
{
	"xrtGaDoubleBuffer",
	"RD_xrtGaDoubleBuffer",
	XmNxrtGaDoubleBuffer,
	"XmNxrtGaDoubleBuffer",
	XRTGA_XM_BOOLEAN,
	{0, 0, 0},
	Offset(UxXrtGaPercentClass, XrtGaPercent.RD_xrtGaDoubleBuffer),
	XRTDIV_SPECIFIC,
	XRTPASS0,
	NULL,
	XrtGaPercent_DoubleBuffer,
	FALSE,
	TRUE
},
{
	"xrtGaExposeCallback",
	"RD_xrtGaExposeCallback",
	XmNxrtGaExposeCallback,
	"XmNxrtGaExposeCallback",
	XRTGA_CALLBACK,
	{0, 0, 0},
	Offset(UxXrtGaPercentClass, XrtGaPercent.RD_xrtGaExposeCallback),
	XRTDIV_BEHAVIOR,
	XRTPASS0,
	NULL,
	XrtGaPercent_ExposeCallback,
	FALSE,
	TRUE
},
{
	"xrtGaFrame",
	"RD_xrtGaFrame",
	XmNxrtGaFrame,
	"XmNxrtGaFrame",
	XRTGA_OBJECT,
	{0, 0, 0},
	Offset(UxXrtGaPercentClass, XrtGaPercent.RD_xrtGaFrame),
	XRTDIV_SPECIFIC,
	XRTPASS0,
	NULL,
	XrtGaPercent_Frame,
	FALSE,
	TRUE
},
{
	"xrtGaImage",
	"RD_xrtGaImage",
	XmNxrtGaImage,
	"XmNxrtGaImage",
	XRTGA_IMAGE,
	{0, 0, 0},
	Offset(UxXrtGaPercentClass, XrtGaPercent.RD_xrtGaImage),
	XRTDIV_SPECIFIC,
	XRTPASS0,
	NULL,
	XrtGaPercent_Image,
	FALSE,
	TRUE
},
{
	"xrtGaImageLayout",
	"RD_xrtGaImageLayout",
	XmNxrtGaImageLayout,
	"XmNxrtGaImageLayout",
	XRTGA_IMAGE_LAYOUT,
	{0, 0, 0},
	Offset(UxXrtGaPercentClass, XrtGaPercent.RD_xrtGaImageLayout),
	XRTDIV_SPECIFIC,
	XRTPASS0,
	NULL,
	XrtGaPercent_ImageLayout,
	FALSE,
	TRUE
},
{
	"xrtGaItemList",
	"RD_xrtGaItemList",
	XmNxrtGaItemList,
	"XmNxrtGaItemList",
	XRTGA_OBJECT_LIST,
	{0, 0, 0},
	Offset(UxXrtGaPercentClass, XrtGaPercent.RD_xrtGaItemList),
	XRTDIV_SPECIFIC,
	XRTPASS0,
	NULL,
	XrtGaPercent_ItemList,
	TRUE,
	TRUE
},
{
	"xrtGaMapCallback",
	"RD_xrtGaMapCallback",
	XmNxrtGaMapCallback,
	"XmNxrtGaMapCallback",
	XRTGA_CALLBACK,
	{0, 0, 0},
	Offset(UxXrtGaPercentClass, XrtGaPercent.RD_xrtGaMapCallback),
	XRTDIV_BEHAVIOR,
	XRTPASS0,
	NULL,
	XrtGaPercent_MapCallback,
	FALSE,
	TRUE
},
{
	"xrtGaRenderList",
	"RD_xrtGaRenderList",
	XmNxrtGaRenderList,
	"XmNxrtGaRenderList",
	XRTGA_OBJECT_LIST,
	{0, 0, 0},
	Offset(UxXrtGaPercentClass, XrtGaPercent.RD_xrtGaRenderList),
	XRTDIV_SPECIFIC,
	XRTPASS0,
	NULL,
	XrtGaPercent_RenderList,
	TRUE,
	TRUE
},
{
	"xrtGaRepaint",
	"RD_xrtGaRepaint",
	XmNxrtGaRepaint,
	"XmNxrtGaRepaint",
	XRTGA_XM_BOOLEAN,
	{0, 0, 0},
	Offset(UxXrtGaPercentClass, XrtGaPercent.RD_xrtGaRepaint),
	XRTDIV_SPECIFIC,
	XRTPASS0,
	NULL,
	XrtGaPercent_Repaint,
	FALSE,
	TRUE
},
{
	"xrtGaResizeCallback",
	"RD_xrtGaResizeCallback",
	XmNxrtGaResizeCallback,
	"XmNxrtGaResizeCallback",
	XRTGA_CALLBACK,
	{0, 0, 0},
	Offset(UxXrtGaPercentClass, XrtGaPercent.RD_xrtGaResizeCallback),
	XRTDIV_BEHAVIOR,
	XRTPASS0,
	NULL,
	XrtGaPercent_ResizeCallback,
	FALSE,
	TRUE
},
{
	"xrtGaScale",
	"RD_xrtGaScale",
	XmNxrtGaScale,
	"XmNxrtGaScale",
	XRTGA_OBJECT,
	{0, 0, 0},
	Offset(UxXrtGaPercentClass, XrtGaPercent.RD_xrtGaScale),
	XRTDIV_SPECIFIC,
	XRTPASS0,
	NULL,
	XrtGaPercent_Scale,
	FALSE,
	TRUE
},
{
	"xrtGaTextList",
	"RD_xrtGaTextList",
	XmNxrtGaTextList,
	"XmNxrtGaTextList",
	XRTGA_OBJECT_LIST,
	{0, 0, 0},
	Offset(UxXrtGaPercentClass, XrtGaPercent.RD_xrtGaTextList),
	XRTDIV_SPECIFIC,
	XRTPASS0,
	NULL,
	XrtGaPercent_TextList,
	TRUE,
	TRUE
},
{
	"xrtGaUseRenderList",
	"RD_xrtGaUseRenderList",
	XmNxrtGaUseRenderList,
	"XmNxrtGaUseRenderList",
	XRTGA_XM_BOOLEAN,
	{0, 0, 0},
	Offset(UxXrtGaPercentClass, XrtGaPercent.RD_xrtGaUseRenderList),
	XRTDIV_SPECIFIC,
	XRTPASS0,
	NULL,
	XrtGaPercent_UseRenderList,
	FALSE,
	TRUE
},
};

XrtGaugeResourceDesc	XrtGaRange_res_table[] = {
{
	"background",
	"RD_background",
	XmNbackground,
	"XmNbackground",
	XRTGA_XM_PIXEL,
	{0, 0, 0},
	Offset(UxXrtGaRangeClass, XrtGaRange.RD_background),
	XRTDIV_SPECIFIC,
	XRTPASS0,
	NULL,
	XrtGaRange_background,
	FALSE,
	TRUE
},
{
	"xrtGaDebug",
	"RD_xrtGaDebug",
	XmNxrtGaDebug,
	"XmNxrtGaDebug",
	XRTGA_XM_BOOLEAN,
	{0, 0, 0},
	Offset(UxXrtGaRangeClass, XrtGaRange.RD_xrtGaDebug),
	XRTDIV_SPECIFIC,
	XRTPASS0,
	NULL,
	XrtGaRange_Debug,
	FALSE,
	TRUE
},
{
	"xrtGaImage",
	"RD_xrtGaImage",
	XmNxrtGaImage,
	"XmNxrtGaImage",
	XRTGA_IMAGE,
	{0, 0, 0},
	Offset(UxXrtGaRangeClass, XrtGaRange.RD_xrtGaImage),
	XRTDIV_SPECIFIC,
	XRTPASS0,
	NULL,
	XrtGaRange_Image,
	FALSE,
	TRUE
},
{
	"xrtGaImageLayout",
	"RD_xrtGaImageLayout",
	XmNxrtGaImageLayout,
	"XmNxrtGaImageLayout",
	XRTGA_IMAGE_LAYOUT,
	{0, 0, 0},
	Offset(UxXrtGaRangeClass, XrtGaRange.RD_xrtGaImageLayout),
	XRTDIV_SPECIFIC,
	XRTPASS0,
	NULL,
	XrtGaRange_ImageLayout,
	FALSE,
	TRUE
},
{
	"xrtGaInnerExtent",
	"RD_xrtGaInnerExtent",
	XmNxrtGaInnerExtent,
	"XmNxrtGaInnerExtent",
	XRTGA_DOUBLE,
	{0, 0, 0},
	Offset(UxXrtGaRangeClass, XrtGaRange.RD_xrtGaInnerExtent),
	XRTDIV_SPECIFIC,
	XRTPASS0,
	NULL,
	XrtGaRange_InnerExtent,
	FALSE,
	TRUE
},
{
	"xrtGaIsShowing",
	"RD_xrtGaIsShowing",
	XmNxrtGaIsShowing,
	"XmNxrtGaIsShowing",
	XRTGA_XM_BOOLEAN,
	{0, 0, 0},
	Offset(UxXrtGaRangeClass, XrtGaRange.RD_xrtGaIsShowing),
	XRTDIV_SPECIFIC,
	XRTPASS0,
	NULL,
	XrtGaRange_IsShowing,
	FALSE,
	TRUE
},
{
	"xrtGaOffset",
	"RD_xrtGaOffset",
	XmNxrtGaOffset,
	"XmNxrtGaOffset",
	XRTGA_DOUBLE,
	{0, 0, 0},
	Offset(UxXrtGaRangeClass, XrtGaRange.RD_xrtGaOffset),
	XRTDIV_SPECIFIC,
	XRTPASS0,
	NULL,
	XrtGaRange_Offset,
	FALSE,
	TRUE
},
{
	"xrtGaOuterExtent",
	"RD_xrtGaOuterExtent",
	XmNxrtGaOuterExtent,
	"XmNxrtGaOuterExtent",
	XRTGA_DOUBLE,
	{0, 0, 0},
	Offset(UxXrtGaRangeClass, XrtGaRange.RD_xrtGaOuterExtent),
	XRTDIV_SPECIFIC,
	XRTPASS0,
	NULL,
	XrtGaRange_OuterExtent,
	FALSE,
	TRUE
},
{
	"xrtGaScale",
	"RD_xrtGaScale",
	XmNxrtGaScale,
	"XmNxrtGaScale",
	XRTGA_OBJECT,
	{0, 0, 0},
	Offset(UxXrtGaRangeClass, XrtGaRange.RD_xrtGaScale),
	XRTDIV_SPECIFIC,
	XRTPASS0,
	NULL,
	XrtGaRange_Scale,
	FALSE,
	TRUE
},
{
	"xrtGaShape",
	"RD_xrtGaShape",
	XmNxrtGaShape,
	"XmNxrtGaShape",
	XRTGA_SHAPE,
	{0, 0, 0},
	Offset(UxXrtGaRangeClass, XrtGaRange.RD_xrtGaShape),
	XRTDIV_SPECIFIC,
	XRTPASS0,
	NULL,
	XrtGaRange_Shape,
	FALSE,
	TRUE
},
{
	"xrtGaStartValue",
	"RD_xrtGaStartValue",
	XmNxrtGaStartValue,
	"XmNxrtGaStartValue",
	XRTGA_DOUBLE,
	{0, 0, 0},
	Offset(UxXrtGaRangeClass, XrtGaRange.RD_xrtGaStartValue),
	XRTDIV_SPECIFIC,
	XRTPASS0,
	NULL,
	XrtGaRange_StartValue,
	FALSE,
	TRUE
},
{
	"xrtGaStopValue",
	"RD_xrtGaStopValue",
	XmNxrtGaStopValue,
	"XmNxrtGaStopValue",
	XRTGA_DOUBLE,
	{0, 0, 0},
	Offset(UxXrtGaRangeClass, XrtGaRange.RD_xrtGaStopValue),
	XRTDIV_SPECIFIC,
	XRTPASS0,
	NULL,
	XrtGaRange_StopValue,
	FALSE,
	TRUE
},
};

XrtGaugeResourceDesc	XrtGaState_res_table[] = {
{
	"fontList",
	"RD_fontList",
	XmNfontList,
	"XmNfontList",
	XRTGA_XM_FONTLIST,
	{0, 0, 0},
	Offset(UxXrtGaStateClass, XrtGaState.RD_fontList),
	XRTDIV_SPECIFIC,
	XRTPASS0,
	NULL,
	XrtGaState_fontList,
	FALSE,
	TRUE
},
{
	"foreground",
	"RD_foreground",
	XmNforeground,
	"XmNforeground",
	XRTGA_XM_PIXEL,
	{0, 0, 0},
	Offset(UxXrtGaStateClass, XrtGaState.RD_foreground),
	XRTDIV_SPECIFIC,
	XRTPASS0,
	NULL,
	XrtGaState_foreground,
	FALSE,
	TRUE
},
{
	"xrtGaAlignment",
	"RD_xrtGaAlignment",
	XmNxrtGaAlignment,
	"XmNxrtGaAlignment",
	XRTGA_ALIGNMENT,
	{0, 0, 0},
	Offset(UxXrtGaStateClass, XrtGaState.RD_xrtGaAlignment),
	XRTDIV_SPECIFIC,
	XRTPASS0,
	NULL,
	XrtGaState_Alignment,
	FALSE,
	TRUE
},
{
	"xrtGaAlignmentUseDefault",
	"RD_xrtGaAlignmentUseDefault",
	XmNxrtGaAlignmentUseDefault,
	"XmNxrtGaAlignmentUseDefault",
	XRTGA_XM_BOOLEAN,
	{0, 0, 0},
	Offset(UxXrtGaStateClass, XrtGaState.RD_xrtGaAlignmentUseDefault),
	XRTDIV_SPECIFIC,
	XRTPASS0,
	NULL,
	XrtGaState_AlignmentUseDefault,
	FALSE,
	TRUE
},
{
	"xrtGaAngle",
	"RD_xrtGaAngle",
	XmNxrtGaAngle,
	"XmNxrtGaAngle",
	XRTGA_DOUBLE,
	{0, 0, 0},
	Offset(UxXrtGaStateClass, XrtGaState.RD_xrtGaAngle),
	XRTDIV_SPECIFIC,
	XRTPASS0,
	NULL,
	XrtGaState_Angle,
	FALSE,
	TRUE
},
{
	"xrtGaAngleUseDefault",
	"RD_xrtGaAngleUseDefault",
	XmNxrtGaAngleUseDefault,
	"XmNxrtGaAngleUseDefault",
	XRTGA_XM_BOOLEAN,
	{0, 0, 0},
	Offset(UxXrtGaStateClass, XrtGaState.RD_xrtGaAngleUseDefault),
	XRTDIV_SPECIFIC,
	XRTPASS0,
	NULL,
	XrtGaState_AngleUseDefault,
	FALSE,
	TRUE
},
{
	"xrtGaCircularScale",
	"RD_xrtGaCircularScale",
	XmNxrtGaCircularScale,
	"XmNxrtGaCircularScale",
	XRTGA_OBJECT,
	{0, 0, 0},
	Offset(UxXrtGaStateClass, XrtGaState.RD_xrtGaCircularScale),
	XRTDIV_SPECIFIC,
	XRTPASS0,
	NULL,
	XrtGaState_CircularScale,
	FALSE,
	TRUE
},
{
	"xrtGaDebug",
	"RD_xrtGaDebug",
	XmNxrtGaDebug,
	"XmNxrtGaDebug",
	XRTGA_XM_BOOLEAN,
	{0, 0, 0},
	Offset(UxXrtGaStateClass, XrtGaState.RD_xrtGaDebug),
	XRTDIV_SPECIFIC,
	XRTPASS0,
	NULL,
	XrtGaState_Debug,
	FALSE,
	TRUE
},
{
	"xrtGaIsShowing",
	"RD_xrtGaIsShowing",
	XmNxrtGaIsShowing,
	"XmNxrtGaIsShowing",
	XRTGA_XM_BOOLEAN,
	{0, 0, 0},
	Offset(UxXrtGaStateClass, XrtGaState.RD_xrtGaIsShowing),
	XRTDIV_SPECIFIC,
	XRTPASS0,
	NULL,
	XrtGaState_IsShowing,
	FALSE,
	TRUE
},
{
	"xrtGaLineDisplay",
	"RD_xrtGaLineDisplay",
	XmNxrtGaLineDisplay,
	"XmNxrtGaLineDisplay",
	XRTGA_XM_BOOLEAN,
	{0, 0, 0},
	Offset(UxXrtGaStateClass, XrtGaState.RD_xrtGaLineDisplay),
	XRTDIV_SPECIFIC,
	XRTPASS0,
	NULL,
	XrtGaState_LineDisplay,
	FALSE,
	TRUE
},
{
	"xrtGaLineInnerRadius",
	"RD_xrtGaLineInnerRadius",
	XmNxrtGaLineInnerRadius,
	"XmNxrtGaLineInnerRadius",
	XRTGA_DOUBLE,
	{0, 0, 0},
	Offset(UxXrtGaStateClass, XrtGaState.RD_xrtGaLineInnerRadius),
	XRTDIV_SPECIFIC,
	XRTPASS0,
	NULL,
	XrtGaState_LineInnerRadius,
	FALSE,
	TRUE
},
{
	"xrtGaLineInnerRadiusUseDefault",
	"RD_xrtGaLineInnerRadiusUseDefault",
	XmNxrtGaLineInnerRadiusUseDefault,
	"XmNxrtGaLineInnerRadiusUseDefault",
	XRTGA_XM_BOOLEAN,
	{0, 0, 0},
	Offset(UxXrtGaStateClass, XrtGaState.RD_xrtGaLineInnerRadiusUseDefault),
	XRTDIV_SPECIFIC,
	XRTPASS0,
	NULL,
	XrtGaState_LineInnerRadiusUseDefault,
	FALSE,
	TRUE
},
{
	"xrtGaLineOuterRadius",
	"RD_xrtGaLineOuterRadius",
	XmNxrtGaLineOuterRadius,
	"XmNxrtGaLineOuterRadius",
	XRTGA_DOUBLE,
	{0, 0, 0},
	Offset(UxXrtGaStateClass, XrtGaState.RD_xrtGaLineOuterRadius),
	XRTDIV_SPECIFIC,
	XRTPASS0,
	NULL,
	XrtGaState_LineOuterRadius,
	FALSE,
	TRUE
},
{
	"xrtGaLineOuterRadiusUseDefault",
	"RD_xrtGaLineOuterRadiusUseDefault",
	XmNxrtGaLineOuterRadiusUseDefault,
	"XmNxrtGaLineOuterRadiusUseDefault",
	XRTGA_XM_BOOLEAN,
	{0, 0, 0},
	Offset(UxXrtGaStateClass, XrtGaState.RD_xrtGaLineOuterRadiusUseDefault),
	XRTDIV_SPECIFIC,
	XRTPASS0,
	NULL,
	XrtGaState_LineOuterRadiusUseDefault,
	FALSE,
	TRUE
},
{
	"xrtGaLinePattern",
	"RD_xrtGaLinePattern",
	XmNxrtGaLinePattern,
	"XmNxrtGaLinePattern",
	XRTGA_LINE_PATTERN,
	{0, 0, 0},
	Offset(UxXrtGaStateClass, XrtGaState.RD_xrtGaLinePattern),
	XRTDIV_SPECIFIC,
	XRTPASS0,
	NULL,
	XrtGaState_LinePattern,
	FALSE,
	TRUE
},
{
	"xrtGaLineThickness",
	"RD_xrtGaLineThickness",
	XmNxrtGaLineThickness,
	"XmNxrtGaLineThickness",
	XRTGA_XM_INT,
	{0, 0, 0},
	Offset(UxXrtGaStateClass, XrtGaState.RD_xrtGaLineThickness),
	XRTDIV_SPECIFIC,
	XRTPASS0,
	NULL,
	XrtGaState_LineThickness,
	FALSE,
	TRUE
},
{
	"xrtGaOffsetUseDefault",
	"RD_xrtGaOffsetUseDefault",
	XmNxrtGaOffsetUseDefault,
	"XmNxrtGaOffsetUseDefault",
	XRTGA_XM_BOOLEAN,
	{0, 0, 0},
	Offset(UxXrtGaStateClass, XrtGaState.RD_xrtGaOffsetUseDefault),
	XRTDIV_SPECIFIC,
	XRTPASS0,
	NULL,
	XrtGaState_OffsetUseDefault,
	FALSE,
	TRUE
},
{
	"xrtGaOffsetX",
	"RD_xrtGaOffsetX",
	XmNxrtGaOffsetX,
	"XmNxrtGaOffsetX",
	XRTGA_XM_INT,
	{0, 0, 0},
	Offset(UxXrtGaStateClass, XrtGaState.RD_xrtGaOffsetX),
	XRTDIV_SPECIFIC,
	XRTPASS0,
	NULL,
	XrtGaState_OffsetX,
	FALSE,
	TRUE
},
{
	"xrtGaOffsetY",
	"RD_xrtGaOffsetY",
	XmNxrtGaOffsetY,
	"XmNxrtGaOffsetY",
	XRTGA_XM_INT,
	{0, 0, 0},
	Offset(UxXrtGaStateClass, XrtGaState.RD_xrtGaOffsetY),
	XRTDIV_SPECIFIC,
	XRTPASS0,
	NULL,
	XrtGaState_OffsetY,
	FALSE,
	TRUE
},
{
	"xrtGaText",
	"RD_xrtGaText",
	XmNxrtGaText,
	"XmNxrtGaText",
	XRTGA_XM_STRING,
	{0, 0, 0},
	Offset(UxXrtGaStateClass, XrtGaState.RD_xrtGaText),
	XRTDIV_SPECIFIC,
	XRTPASS0,
	NULL,
	XrtGaState_Text,
	FALSE,
	TRUE
},
};

XrtGaugeResourceDesc	XrtGaSwitch_res_table[] = {
{
	"background",
	"RD_background",
	XmNbackground,
	"XmNbackground",
	XRTGA_XM_PIXEL,
	{0, 0, 0},
	Offset(UxXrtGaSwitchClass, XrtGaSwitch.RD_background),
	XRTDIV_SPECIFIC,
	XRTPASS0,
	NULL,
	XrtGaSwitch_background,
	FALSE,
	TRUE
},
{
	"xrtGaCircularScale",
	"RD_xrtGaCircularScale",
	XmNxrtGaCircularScale,
	"XmNxrtGaCircularScale",
	XRTGA_OBJECT,
	{0, 0, 0},
	Offset(UxXrtGaSwitchClass, XrtGaSwitch.RD_xrtGaCircularScale),
	XRTDIV_SPECIFIC,
	XRTPASS0,
	NULL,
	XrtGaSwitch_CircularScale,
	FALSE,
	TRUE
},
{
	"xrtGaContinuous",
	"RD_xrtGaContinuous",
	XmNxrtGaContinuous,
	"XmNxrtGaContinuous",
	XRTGA_XM_BOOLEAN,
	{0, 0, 0},
	Offset(UxXrtGaSwitchClass, XrtGaSwitch.RD_xrtGaContinuous),
	XRTDIV_SPECIFIC,
	XRTPASS0,
	NULL,
	XrtGaSwitch_Continuous,
	FALSE,
	TRUE
},
{
	"xrtGaDebug",
	"RD_xrtGaDebug",
	XmNxrtGaDebug,
	"XmNxrtGaDebug",
	XRTGA_XM_BOOLEAN,
	{0, 0, 0},
	Offset(UxXrtGaSwitchClass, XrtGaSwitch.RD_xrtGaDebug),
	XRTDIV_SPECIFIC,
	XRTPASS0,
	NULL,
	XrtGaSwitch_Debug,
	FALSE,
	TRUE
},
{
	"xrtGaDrawFunc",
	"RD_xrtGaDrawFunc",
	XmNxrtGaDrawFunc,
	"XmNxrtGaDrawFunc",
	XRTGA_XM_FUNCTION,
	{0, 0, 0},
	Offset(UxXrtGaSwitchClass, XrtGaSwitch.RD_xrtGaDrawFunc),
	XRTDIV_SPECIFIC,
	XRTPASS0,
	NULL,
	XrtGaSwitch_DrawFunc,
	FALSE,
	TRUE
},
{
	"xrtGaImage",
	"RD_xrtGaImage",
	XmNxrtGaImage,
	"XmNxrtGaImage",
	XRTGA_IMAGE,
	{0, 0, 0},
	Offset(UxXrtGaSwitchClass, XrtGaSwitch.RD_xrtGaImage),
	XRTDIV_SPECIFIC,
	XRTPASS0,
	NULL,
	XrtGaSwitch_Image,
	FALSE,
	TRUE
},
{
	"xrtGaImageRotate",
	"RD_xrtGaImageRotate",
	XmNxrtGaImageRotate,
	"XmNxrtGaImageRotate",
	XRTGA_XM_BOOLEAN,
	{0, 0, 0},
	Offset(UxXrtGaSwitchClass, XrtGaSwitch.RD_xrtGaImageRotate),
	XRTDIV_SPECIFIC,
	XRTPASS0,
	NULL,
	XrtGaSwitch_ImageRotate,
	FALSE,
	TRUE
},
{
	"xrtGaIncrementValue",
	"RD_xrtGaIncrementValue",
	XmNxrtGaIncrementValue,
	"XmNxrtGaIncrementValue",
	XRTGA_DOUBLE,
	{0, 0, 0},
	Offset(UxXrtGaSwitchClass, XrtGaSwitch.RD_xrtGaIncrementValue),
	XRTDIV_SPECIFIC,
	XRTPASS0,
	NULL,
	XrtGaSwitch_IncrementValue,
	FALSE,
	TRUE
},
{
	"xrtGaInteractionType",
	"RD_xrtGaInteractionType",
	XmNxrtGaInteractionType,
	"XmNxrtGaInteractionType",
	XRTGA_INTERACTION_TYPE,
	{0, 0, 0},
	Offset(UxXrtGaSwitchClass, XrtGaSwitch.RD_xrtGaInteractionType),
	XRTDIV_SPECIFIC,
	XRTPASS0,
	NULL,
	XrtGaSwitch_InteractionType,
	FALSE,
	TRUE
},
{
	"xrtGaIsShowing",
	"RD_xrtGaIsShowing",
	XmNxrtGaIsShowing,
	"XmNxrtGaIsShowing",
	XRTGA_XM_BOOLEAN,
	{0, 0, 0},
	Offset(UxXrtGaSwitchClass, XrtGaSwitch.RD_xrtGaIsShowing),
	XRTDIV_SPECIFIC,
	XRTPASS0,
	NULL,
	XrtGaSwitch_IsShowing,
	FALSE,
	TRUE
},
{
	"xrtGaMultipleTurnEnabled",
	"RD_xrtGaMultipleTurnEnabled",
	XmNxrtGaMultipleTurnEnabled,
	"XmNxrtGaMultipleTurnEnabled",
	XRTGA_XM_BOOLEAN,
	{0, 0, 0},
	Offset(UxXrtGaSwitchClass, XrtGaSwitch.RD_xrtGaMultipleTurnEnabled),
	XRTDIV_SPECIFIC,
	XRTPASS0,
	NULL,
	XrtGaSwitch_MultipleTurnEnabled,
	FALSE,
	TRUE
},
{
	"xrtGaMultipleTurnValue",
	"RD_xrtGaMultipleTurnValue",
	XmNxrtGaMultipleTurnValue,
	"XmNxrtGaMultipleTurnValue",
	XRTGA_DOUBLE,
	{0, 0, 0},
	Offset(UxXrtGaSwitchClass, XrtGaSwitch.RD_xrtGaMultipleTurnValue),
	XRTDIV_SPECIFIC,
	XRTPASS0,
	NULL,
	XrtGaSwitch_MultipleTurnValue,
	FALSE,
	TRUE
},
{
	"xrtGaRadius",
	"RD_xrtGaRadius",
	XmNxrtGaRadius,
	"XmNxrtGaRadius",
	XRTGA_DOUBLE,
	{0, 0, 0},
	Offset(UxXrtGaSwitchClass, XrtGaSwitch.RD_xrtGaRadius),
	XRTDIV_SPECIFIC,
	XRTPASS0,
	NULL,
	XrtGaSwitch_Radius,
	FALSE,
	TRUE
},
{
	"xrtGaValue",
	"RD_xrtGaValue",
	XmNxrtGaValue,
	"XmNxrtGaValue",
	XRTGA_DOUBLE,
	{0, 0, 0},
	Offset(UxXrtGaSwitchClass, XrtGaSwitch.RD_xrtGaValue),
	XRTDIV_SPECIFIC,
	XRTPASS0,
	NULL,
	XrtGaSwitch_Value,
	FALSE,
	TRUE
},
{
	"xrtGaValueChangedCallback",
	"RD_xrtGaValueChangedCallback",
	XmNxrtGaValueChangedCallback,
	"XmNxrtGaValueChangedCallback",
	XRTGA_CALLBACK,
	{0, 0, 0},
	Offset(UxXrtGaSwitchClass, XrtGaSwitch.RD_xrtGaValueChangedCallback),
	XRTDIV_BEHAVIOR,
	XRTPASS0,
	NULL,
	XrtGaSwitch_ValueChangedCallback,
	FALSE,
	TRUE
},
{
	"xrtGaSwitchType",
	"RD_xrtGaSwitchType",
	XmNxrtGaSwitchType,
	"XmNxrtGaSwitchType",
	XRTGA_SWITCH_TYPE,
	{0, 0, 0},
	Offset(UxXrtGaSwitchClass, XrtGaSwitch.RD_xrtGaSwitchType),
	XRTDIV_SPECIFIC,
	XRTPASS0,
	NULL,
	XrtGaSwitch_SwitchType,
	FALSE,
	TRUE
},
};

XrtGaugeResourceDesc	XrtGaText_res_table[] = {
{
	"background",
	"RD_background",
	XmNbackground,
	"XmNbackground",
	XRTGA_XM_PIXEL,
	{0, 0, 0},
	Offset(UxXrtGaTextClass, XrtGaText.RD_background),
	XRTDIV_SPECIFIC,
	XRTPASS0,
	NULL,
	XrtGaText_background,
	FALSE,
	TRUE
},
{
	"fontList",
	"RD_fontList",
	XmNfontList,
	"XmNfontList",
	XRTGA_XM_FONTLIST,
	{0, 0, 0},
	Offset(UxXrtGaTextClass, XrtGaText.RD_fontList),
	XRTDIV_SPECIFIC,
	XRTPASS0,
	NULL,
	XrtGaText_fontList,
	FALSE,
	TRUE
},
{
	"foreground",
	"RD_foreground",
	XmNforeground,
	"XmNforeground",
	XRTGA_XM_PIXEL,
	{0, 0, 0},
	Offset(UxXrtGaTextClass, XrtGaText.RD_foreground),
	XRTDIV_SPECIFIC,
	XRTPASS0,
	NULL,
	XrtGaText_foreground,
	FALSE,
	TRUE
},
{
	"height",
	"RD_height",
	XmNheight,
	"XmNheight",
	XRTGA_XM_INT,
	{0, 0, 0},
	Offset(UxXrtGaTextClass, XrtGaText.RD_height),
	XRTDIV_SPECIFIC,
	XRTPASS0,
	NULL,
	XrtGaText_height,
	FALSE,
	TRUE
},
{
	"width",
	"RD_width",
	XmNwidth,
	"XmNwidth",
	XRTGA_XM_INT,
	{0, 0, 0},
	Offset(UxXrtGaTextClass, XrtGaText.RD_width),
	XRTDIV_SPECIFIC,
	XRTPASS0,
	NULL,
	XrtGaText_width,
	FALSE,
	TRUE
},
{
	"x",
	"RD_x",
	XmNx,
	"XmNx",
	XRTGA_XM_INT,
	{0, 0, 0},
	Offset(UxXrtGaTextClass, XrtGaText.RD_x),
	XRTDIV_SPECIFIC,
	XRTPASS0,
	NULL,
	XrtGaText_x,
	FALSE,
	TRUE
},
{
	"y",
	"RD_y",
	XmNy,
	"XmNy",
	XRTGA_XM_INT,
	{0, 0, 0},
	Offset(UxXrtGaTextClass, XrtGaText.RD_y),
	XRTDIV_SPECIFIC,
	XRTPASS0,
	NULL,
	XrtGaText_y,
	FALSE,
	TRUE
},
{
	"xrtGaAlignment",
	"RD_xrtGaAlignment",
	XmNxrtGaAlignment,
	"XmNxrtGaAlignment",
	XRTGA_ALIGNMENT,
	{0, 0, 0},
	Offset(UxXrtGaTextClass, XrtGaText.RD_xrtGaAlignment),
	XRTDIV_SPECIFIC,
	XRTPASS0,
	NULL,
	XrtGaText_Alignment,
	FALSE,
	TRUE
},
{
	"xrtGaAllowWidgetPositioning",
	"RD_xrtGaAllowWidgetPositioning",
	XmNxrtGaAllowWidgetPositioning,
	"XmNxrtGaAllowWidgetPositioning",
	XRTGA_XM_BOOLEAN,
	{0, 0, 0},
	Offset(UxXrtGaTextClass, XrtGaText.RD_xrtGaAllowWidgetPositioning),
	XRTDIV_SPECIFIC,
	XRTPASS0,
	NULL,
	XrtGaText_AllowWidgetPositioning,
	FALSE,
	TRUE
},
{
	"xrtGaBorder",
	"RD_xrtGaBorder",
	XmNxrtGaBorder,
	"XmNxrtGaBorder",
	XRTGA_BORDER,
	{0, 0, 0},
	Offset(UxXrtGaTextClass, XrtGaText.RD_xrtGaBorder),
	XRTDIV_SPECIFIC,
	XRTPASS0,
	NULL,
	XrtGaText_Border,
	FALSE,
	TRUE
},
{
	"xrtGaBorderWidth",
	"RD_xrtGaBorderWidth",
	XmNxrtGaBorderWidth,
	"XmNxrtGaBorderWidth",
	XRTGA_XM_INT,
	{0, 0, 0},
	Offset(UxXrtGaTextClass, XrtGaText.RD_xrtGaBorderWidth),
	XRTDIV_SPECIFIC,
	XRTPASS0,
	NULL,
	XrtGaText_BorderWidth,
	FALSE,
	TRUE
},
{
	"xrtGaDebug",
	"RD_xrtGaDebug",
	XmNxrtGaDebug,
	"XmNxrtGaDebug",
	XRTGA_XM_BOOLEAN,
	{0, 0, 0},
	Offset(UxXrtGaTextClass, XrtGaText.RD_xrtGaDebug),
	XRTDIV_SPECIFIC,
	XRTPASS0,
	NULL,
	XrtGaText_Debug,
	FALSE,
	TRUE
},
{
	"xrtGaImage",
	"RD_xrtGaImage",
	XmNxrtGaImage,
	"XmNxrtGaImage",
	XRTGA_IMAGE,
	{0, 0, 0},
	Offset(UxXrtGaTextClass, XrtGaText.RD_xrtGaImage),
	XRTDIV_SPECIFIC,
	XRTPASS0,
	NULL,
	XrtGaText_Image,
	FALSE,
	TRUE
},
{
	"xrtGaImageLayout",
	"RD_xrtGaImageLayout",
	XmNxrtGaImageLayout,
	"XmNxrtGaImageLayout",
	XRTGA_IMAGE_LAYOUT,
	{0, 0, 0},
	Offset(UxXrtGaTextClass, XrtGaText.RD_xrtGaImageLayout),
	XRTDIV_SPECIFIC,
	XRTPASS0,
	NULL,
	XrtGaText_ImageLayout,
	FALSE,
	TRUE
},
{
	"xrtGaImageMinimumSize",
	"RD_xrtGaImageMinimumSize",
	XmNxrtGaImageMinimumSize,
	"XmNxrtGaImageMinimumSize",
	XRTGA_XM_BOOLEAN,
	{0, 0, 0},
	Offset(UxXrtGaTextClass, XrtGaText.RD_xrtGaImageMinimumSize),
	XRTDIV_SPECIFIC,
	XRTPASS0,
	NULL,
	XrtGaText_ImageMinimumSize,
	FALSE,
	TRUE
},
{
	"xrtGaIsShowing",
	"RD_xrtGaIsShowing",
	XmNxrtGaIsShowing,
	"XmNxrtGaIsShowing",
	XRTGA_XM_BOOLEAN,
	{0, 0, 0},
	Offset(UxXrtGaTextClass, XrtGaText.RD_xrtGaIsShowing),
	XRTDIV_SPECIFIC,
	XRTPASS0,
	NULL,
	XrtGaText_IsShowing,
	FALSE,
	TRUE
},
{
	"xrtGaString",
	"RD_xrtGaString",
	XmNxrtGaString,
	"XmNxrtGaString",
	XRTGA_XM_STRING,
	{0, 0, 0},
	Offset(UxXrtGaTextClass, XrtGaText.RD_xrtGaString),
	XRTDIV_SPECIFIC,
	XRTPASS0,
	NULL,
	XrtGaText_String,
	FALSE,
	TRUE
},
{
	"xrtGaXmString",
	"RD_xrtGaXmString",
	XmNxrtGaXmString,
	"XmNxrtGaXmString",
	XRTGA_XM_XMSTRING,
	{0, 0, 0},
	Offset(UxXrtGaTextClass, XrtGaText.RD_xrtGaXmString),
	XRTDIV_SPECIFIC,
	XRTPASS0,
	NULL,
	XrtGaText_XmString,
	FALSE,
	TRUE
},
{
	"xrtGaStringMode",
	"RD_xrtGaStringMode",
	XmNxrtGaStringMode,
	"XmNxrtGaStringMode",
	XRTGA_STRING_MODE,
	{0, 0, 0},
	Offset(UxXrtGaTextClass, XrtGaText.RD_xrtGaStringMode),
	XRTDIV_SPECIFIC,
	XRTPASS0,
	NULL,
	XrtGaText_StringMode,
	FALSE,
	TRUE
},
{
	"xrtGaValueObject",
	"RD_xrtGaValueObject",
	XmNxrtGaValueObject,
	"XmNxrtGaValueObject",
	XRTGA_OBJECT,
	{0, 0, 0},
	Offset(UxXrtGaTextClass, XrtGaText.RD_xrtGaValueObject),
	XRTDIV_SPECIFIC,
	XRTPASS0,
	NULL,
	XrtGaText_ValueObject,
	FALSE,
	TRUE
},
};

XrtGaugeResourceDesc	XrtGaTick_res_table[] = {
{
	"background",
	"RD_background",
	XmNbackground,
	"XmNbackground",
	XRTGA_XM_PIXEL,
	{0, 0, 0},
	Offset(UxXrtGaTickClass, XrtGaTick.RD_background),
	XRTDIV_SPECIFIC,
	XRTPASS0,
	NULL,
	XrtGaTick_background,
	FALSE,
	TRUE
},
{
	"fontList",
	"RD_fontList",
	XmNfontList,
	"XmNfontList",
	XRTGA_XM_FONTLIST,
	{0, 0, 0},
	Offset(UxXrtGaTickClass, XrtGaTick.RD_fontList),
	XRTDIV_SPECIFIC,
	XRTPASS0,
	NULL,
	XrtGaTick_fontList,
	FALSE,
	TRUE
},
{
	"width",
	"RD_width",
	XmNwidth,
	"XmNwidth",
	XRTGA_XM_INT,
	{0, 0, 0},
	Offset(UxXrtGaTickClass, XrtGaTick.RD_width),
	XRTDIV_SPECIFIC,
	XRTPASS0,
	NULL,
	XrtGaTick_width, 
	FALSE,
	TRUE
},
{
	"xrtGaAutomatic",
	"RD_xrtGaAutomatic",
	XmNxrtGaAutomatic,
	"XmNxrtGaAutomatic",
	XRTGA_XM_BOOLEAN,
	{0, 0, 0},
	Offset(UxXrtGaTickClass, XrtGaTick.RD_xrtGaAutomatic),
	XRTDIV_SPECIFIC,
	XRTPASS0,
	NULL,
	XrtGaTick_Automatic,
	FALSE,
	TRUE
},
{
	"xrtGaDebug",
	"RD_xrtGaDebug",
	XmNxrtGaDebug,
	"XmNxrtGaDebug",
	XRTGA_XM_BOOLEAN,
	{0, 0, 0},
	Offset(UxXrtGaTickClass, XrtGaTick.RD_xrtGaDebug),
	XRTDIV_SPECIFIC,
	XRTPASS0,
	NULL,
	XrtGaTick_Debug,
	FALSE,
	TRUE
},
{
	"xrtGaDrawLabels",
	"RD_xrtGaDrawLabels",
	XmNxrtGaDrawLabels,
	"XmNxrtGaDrawLabels",
	XRTGA_XM_BOOLEAN,
	{0, 0, 0},
	Offset(UxXrtGaTickClass, XrtGaTick.RD_xrtGaDrawLabels),
	XRTDIV_SPECIFIC,
	XRTPASS0,
	NULL,
	XrtGaTick_DrawLabels,
	FALSE,
	TRUE
},
{
	"xrtGaIncrementValue",
	"RD_xrtGaIncrementValue",
	XmNxrtGaIncrementValue,
	"XmNxrtGaIncrementValue",
	XRTGA_DOUBLE,
	{0, 0, 0},
	Offset(UxXrtGaTickClass, XrtGaTick.RD_xrtGaIncrementValue),
	XRTDIV_SPECIFIC,
	XRTPASS0,
	NULL,
	XrtGaTick_IncrementValue,
	FALSE,
	TRUE
},
{
	"xrtGaInnerExtent",
	"RD_xrtGaInnerExtent",
	XmNxrtGaInnerExtent,
	"XmNxrtGaInnerExtent",
	XRTGA_DOUBLE,
	{0, 0, 0},
	Offset(UxXrtGaTickClass, XrtGaTick.RD_xrtGaInnerExtent),
	XRTDIV_SPECIFIC,
	XRTPASS0,
	NULL,
	XrtGaTick_InnerExtent,
	FALSE,
	TRUE
},
{
	"xrtGaIsShowing",
	"RD_xrtGaIsShowing",
	XmNxrtGaIsShowing,
	"XmNxrtGaIsShowing",
	XRTGA_XM_BOOLEAN,
	{0, 0, 0},
	Offset(UxXrtGaTickClass, XrtGaTick.RD_xrtGaIsShowing),
	XRTDIV_SPECIFIC,
	XRTPASS0,
	NULL,
	XrtGaTick_IsShowing,
	FALSE,
	TRUE
},
{
	"xrtGaLabelExtent",
	"RD_xrtGaLabelExtent",
	XmNxrtGaLabelExtent,
	"XmNxrtGaLabelExtent",
	XRTGA_DOUBLE,
	{0, 0, 0},
	Offset(UxXrtGaTickClass, XrtGaTick.RD_xrtGaLabelExtent),
	XRTDIV_SPECIFIC,
	XRTPASS0,
	NULL,
	XrtGaTick_LabelExtent,
	FALSE,
	TRUE
},
{
	"xrtGaLabelFunc",
	"RD_xrtGaLabelFunc",
	XmNxrtGaLabelFunc,
	"XmNxrtGaLabelFunc",
	XRTGA_XM_FUNCTION,
	{0, 0, 0},
	Offset(UxXrtGaTickClass, XrtGaTick.RD_xrtGaLabelFunc),
	XRTDIV_SPECIFIC,
	XRTPASS0,
	NULL,
	XrtGaTick_LabelFunc,
	FALSE,
	TRUE
},
{
	"xrtGaOffset",
	"RD_xrtGaOffset",
	XmNxrtGaOffset,
	"XmNxrtGaOffset",
	XRTGA_DOUBLE,
	{0, 0, 0},
	Offset(UxXrtGaTickClass, XrtGaTick.RD_xrtGaOffset),
	XRTDIV_SPECIFIC,
	XRTPASS0,
	NULL,
	XrtGaTick_Offset,
	FALSE,
	TRUE
},
{
	"xrtGaOuterExtent",
	"RD_xrtGaOuterExtent",
	XmNxrtGaOuterExtent,
	"XmNxrtGaOuterExtent",
	XRTGA_DOUBLE,
	{0, 0, 0},
	Offset(UxXrtGaTickClass, XrtGaTick.RD_xrtGaOuterExtent),
	XRTDIV_SPECIFIC,
	XRTPASS0,
	NULL,
	XrtGaTick_OuterExtent,
	FALSE,
	TRUE
},
{
	"xrtGaPrecision",
	"RD_xrtGaPrecision",
	XmNxrtGaPrecision,
	"XmNxrtGaPrecision",
	XRTGA_XM_INT,
	{0, 0, 0},
	Offset(UxXrtGaTickClass, XrtGaTick.RD_xrtGaPrecision),
	XRTDIV_SPECIFIC,
	XRTPASS0,
	NULL,
	XrtGaTick_Precision,
	FALSE,
	TRUE
},
{
	"xrtGaPrecisionUseDefault",
	"RD_xrtGaPrecisionUseDefault",
	XmNxrtGaPrecisionUseDefault,
	"XmNxrtGaPrecisionUseDefault",
	XRTGA_XM_BOOLEAN,
	{0, 0, 0},
	Offset(UxXrtGaTickClass, XrtGaTick.RD_xrtGaPrecisionUseDefault),
	XRTDIV_SPECIFIC,
	XRTPASS0,
	NULL,
	XrtGaTick_PrecisionUseDefault,
	FALSE,
	TRUE
},
{
	"xrtGaScale",
	"RD_xrtGaScale",
	XmNxrtGaScale,
	"XmNxrtGaScale",
	XRTGA_OBJECT,
	{0, 0, 0},
	Offset(UxXrtGaTickClass, XrtGaTick.RD_xrtGaScale),
	XRTDIV_SPECIFIC,
	XRTPASS0,
	NULL,
	XrtGaTick_Scale,
	FALSE,
	TRUE
},
{
	"xrtGaStartValue",
	"RD_xrtGaStartValue",
	XmNxrtGaStartValue,
	"XmNxrtGaStartValue",
	XRTGA_DOUBLE,
	{0, 0, 0},
	Offset(UxXrtGaTickClass, XrtGaTick.RD_xrtGaStartValue),
	XRTDIV_SPECIFIC,
	XRTPASS0,
	NULL,
	XrtGaTick_StartValue,
	FALSE,
	TRUE
},
{
	"xrtGaStopValue",
	"RD_xrtGaStopValue",
	XmNxrtGaStopValue,
	"XmNxrtGaStopValue",
	XRTGA_DOUBLE,
	{0, 0, 0},
	Offset(UxXrtGaTickClass, XrtGaTick.RD_xrtGaStopValue),
	XRTDIV_SPECIFIC,
	XRTPASS0,
	NULL,
	XrtGaTick_StopValue,
	FALSE,
	TRUE
},
{
	"xrtGaTickType",
	"RD_xrtGaTickType",
	XmNxrtGaTickType,
	"XmNxrtGaTickType",
	XRTGA_TICK_TYPE,
	{0, 0, 0},
	Offset(UxXrtGaTickClass, XrtGaTick.RD_xrtGaTickType),
	XRTDIV_SPECIFIC,
	XRTPASS0,
	NULL,
	XrtGaTick_TickType,
	FALSE,
	TRUE
		}
};	

int numXrtGaCircularDial_res =
(sizeof(XrtGaCircularDial_res_table) / sizeof(XrtGaCircularDial_res_table[0]));
int numXrtGaCircularGauge_res =
(sizeof(XrtGaCircularGauge_res_table) / sizeof(XrtGaCircularGauge_res_table[0]));
int numXrtGaCounter_res =
(sizeof(XrtGaCounter_res_table) / sizeof(XrtGaCounter_res_table[0]));
int numXrtGaLEDIcon_res =
(sizeof(XrtGaLEDIcon_res_table) / sizeof(XrtGaLEDIcon_res_table[0]));
int numXrtGaLEDNumerical_res =
(sizeof(XrtGaLEDNumerical_res_table) / sizeof(XrtGaLEDNumerical_res_table[0]));
int numXrtGaLinearDial_res =
(sizeof(XrtGaLinearDial_res_table) / sizeof(XrtGaLinearDial_res_table[0]));
int numXrtGaLinearGauge_res =
(sizeof(XrtGaLinearGauge_res_table) / sizeof(XrtGaLinearGauge_res_table[0]));
int numXrtGaPercent_res =
(sizeof(XrtGaPercent_res_table) / sizeof(XrtGaPercent_res_table[0]));
int numXrtGaCenter_res =
(sizeof(XrtGaCenter_res_table) / sizeof(XrtGaCenter_res_table[0]));
int numXrtGaCircularScale_res =
(sizeof(XrtGaCircularScale_res_table) / sizeof(XrtGaCircularScale_res_table[0]));
int numXrtGaFrame_res =
(sizeof(XrtGaFrame_res_table) / sizeof(XrtGaFrame_res_table[0]));
int numXrtGaIcon_res =
(sizeof(XrtGaIcon_res_table) / sizeof(XrtGaIcon_res_table[0]));
int numXrtGaIndicator_res =
(sizeof(XrtGaIndicator_res_table) / sizeof(XrtGaIndicator_res_table[0]));
int numXrtGaItem_res =
(sizeof(XrtGaItem_res_table) / sizeof(XrtGaItem_res_table[0]));
int numXrtGaLinearScale_res =
(sizeof(XrtGaLinearScale_res_table) / sizeof(XrtGaLinearScale_res_table[0]));
int numXrtGaMarker_res =
(sizeof(XrtGaMarker_res_table) / sizeof(XrtGaMarker_res_table[0]));
int numXrtGaNeedle_res =
(sizeof(XrtGaNeedle_res_table) / sizeof(XrtGaNeedle_res_table[0]));
int numXrtGaRange_res =
(sizeof(XrtGaRange_res_table) / sizeof(XrtGaRange_res_table[0]));
int numXrtGaState_res =
(sizeof(XrtGaState_res_table) / sizeof(XrtGaState_res_table[0]));
int numXrtGaSwitch_res =
(sizeof(XrtGaSwitch_res_table) / sizeof(XrtGaSwitch_res_table[0]));
int numXrtGaText_res =
(sizeof(XrtGaText_res_table) / sizeof(XrtGaText_res_table[0]));
int numXrtGaTick_res =
(sizeof(XrtGaTick_res_table) / sizeof(XrtGaTick_res_table[0]));

XrtResourceType **xrtgauge_res_types = NULL;
int				numgauge_res_types;

#endif /* HASXRTGAUGE */

void
XrtGauge_init_resource_types()
{
#ifdef HASXRTGAUGE
	
	XrtResourceType	*type;
	int				n;
	static Boolean	AlreadyDone = FALSE;
	
	xrt_debug_enter("XrtGauge_init_resource_types");

	if (AlreadyDone) {
		return;
	}

	n = 0;
	xrtgauge_res_types = (XrtResourceType **)
		calloc(n+2, sizeof(XrtResourceType *));
	type = (XrtResourceType *) calloc (1, sizeof(XrtResourceType));
	type->datatype.type_gauge = XRTGA_XM_BOOLEAN;
	type->utype = UxUT_string;
	type->xtype = UxXT_Boolean;
	type->convert_flag = 1;
	type->converter = NULL;
	type->values_of = UxValuesOfBoolean;
	type->validate = UxValidateBoolean;
	type->edit_func = NULL;
	type->get_func = NULL;
	type->put_func = NULL;
	xrtgauge_res_types[n++] = type;

	xrtgauge_res_types = (XrtResourceType **)
		realloc(xrtgauge_res_types, (n+2) * sizeof(XrtResourceType *));
	type = (XrtResourceType *) calloc (1, sizeof(XrtResourceType));
	type->datatype.type_gauge = XRTGA_XM_FONTLIST;
	type->utype = UxUT_string;
	type->xtype = UxXT_XmFontList;
	type->convert_flag = 1;
	type->converter = NULL;
	type->values_of = UxValuesOfXmFontList;
	type->validate = UxValidateXmFontList;
	type->edit_func = NULL;
	type->get_func = NULL;
	type->put_func = NULL;
	xrtgauge_res_types[n++] = type;

	xrtgauge_res_types = (XrtResourceType **)
		realloc(xrtgauge_res_types, (n+2) * sizeof(XrtResourceType *));
	type = (XrtResourceType *) calloc (1, sizeof(XrtResourceType));
	type->datatype.type_gauge = XRTGA_XM_FUNCTION;
	type->utype = UxUT_voidFunction;
	type->xtype = UxXT_String;
	type->convert_flag = 0;
	type->converter = NULL;
	type->values_of = UxValuesOfVoidFunction;
	type->validate = UxValidateVoidFunction;
	type->edit_func = NULL;
	type->get_func = NULL;
	type->put_func = NULL;
	xrtgauge_res_types[n++] = type;

	xrtgauge_res_types = (XrtResourceType **)
		realloc(xrtgauge_res_types, (n+2) * sizeof(XrtResourceType *));
	type = (XrtResourceType *) calloc (1, sizeof(XrtResourceType));
	type->datatype.type_gauge = XRTGA_XM_INT;
	type->utype = UxUT_int;
	type->xtype = UxXT_int;
	type->convert_flag = 0;
	type->converter = NULL;
	type->values_of = UxValuesOfInt;
	type->validate = UxValidateInt;
	type->edit_func = NULL;
	type->get_func = NULL;
	type->put_func = NULL;
	xrtgauge_res_types[n++] = type;

	xrtgauge_res_types = (XrtResourceType **)
		realloc(xrtgauge_res_types, (n+2) * sizeof(XrtResourceType *));
	type = (XrtResourceType *) calloc (1, sizeof(XrtResourceType));
	type->datatype.type_gauge = XRTGA_XM_ORIENTATION;
	type->utype = UxUT_string;
	type->xtype = UxXT_Orientation;
	type->convert_flag = 1;
	type->converter = NULL;
	type->values_of = UxValuesOfOrientation;
	type->validate = UxValidateOrientation;
	type->edit_func = NULL;
	type->get_func = NULL;
	type->put_func = NULL;
	xrtgauge_res_types[n++] = type;

	xrtgauge_res_types = (XrtResourceType **)
		realloc(xrtgauge_res_types, (n+2) * sizeof(XrtResourceType *));
	type = (XrtResourceType *) calloc (1, sizeof(XrtResourceType));
	type->datatype.type_gauge = XRTGA_XM_PIXEL;
	type->utype = UxUT_string;
	type->xtype = UxXT_Pixel;
	type->convert_flag = 1;
	type->converter = NULL;
	type->values_of = UxValuesOfPixel;
	type->validate = UxValidatePixel;
	type->edit_func = UxGUIPopupColorView;
	type->get_func = NULL;
	type->put_func = NULL;
	xrtgauge_res_types[n++] = type;

	xrtgauge_res_types = (XrtResourceType **)
		realloc(xrtgauge_res_types, (n+2) * sizeof(XrtResourceType *));
	type = (XrtResourceType *) calloc (1, sizeof(XrtResourceType));
	type->datatype.type_gauge = XRTGA_XM_STRING;
	type->utype = UxUT_string;
	type->xtype = UxXT_String;
	type->convert_flag = 0;
	type->converter = NULL;
	type->values_of = UxValuesOfString;
	type->validate = UxValidateString;
	type->edit_func = NULL;
	type->get_func = NULL;
	type->put_func = NULL;
	xrtgauge_res_types[n++] = type;

	xrtgauge_res_types = (XrtResourceType **)
		realloc(xrtgauge_res_types, (n+2) * sizeof(XrtResourceType *));
	type = (XrtResourceType *) calloc (1, sizeof(XrtResourceType));
	type->datatype.type_gauge = XRTGA_XM_XMSTRING;
	type->utype = UxUT_string;
	type->xtype = UxXT_XmString;
	type->convert_flag = 1;
	type->converter = NULL;
	type->values_of = UxValuesOfXmString;
	type->validate = UxValidateXmString;
	type->edit_func = NULL;
	type->get_func = NULL;
	type->put_func = NULL;
	xrtgauge_res_types[n++] = type;

	xrtgauge_res_types = (XrtResourceType **)
		realloc(xrtgauge_res_types, (n+2) * sizeof(XrtResourceType *));
	type = (XrtResourceType *) calloc (1, sizeof(XrtResourceType));
	type->datatype.type_gauge = XRTGA_ALIGNMENT;
	type->utype = UxUT_string;
	type->xtype = UxXT_XrtGaAlignment;
	type->convert_flag = 1;
	type->converter = NULL;
	type->values_of = UxValuesOfXrtGaAlignment;
	type->validate = UxValidateXrtGaAlignment;
	type->edit_func = NULL;
	type->get_func = NULL;
	type->put_func = NULL;
	xrtgauge_res_types[n++] = type;

	xrtgauge_res_types = (XrtResourceType **)
		realloc(xrtgauge_res_types, (n+2) * sizeof(XrtResourceType *));
	type = (XrtResourceType *) calloc (1, sizeof(XrtResourceType));
	type->datatype.type_gauge = XRTGA_BORDER;
	type->utype = UxUT_string;
	type->xtype = UxXT_XrtGaBorder;
	type->convert_flag = 1;
	type->converter = NULL;
	type->values_of = UxValuesOfXrtGaBorder;
	type->validate = UxValidateXrtGaBorder;
	type->edit_func = NULL;
	type->get_func = NULL;
	type->put_func = NULL;
	xrtgauge_res_types[n++] = type;

	xrtgauge_res_types = (XrtResourceType **)
		realloc(xrtgauge_res_types, (n+2) * sizeof(XrtResourceType *));
	type = (XrtResourceType *) calloc (1, sizeof(XrtResourceType));
	type->datatype.type_gauge = XRTGA_CALC_MODE;
	type->utype = UxUT_string;
	type->xtype = UxXT_XrtGaCalcMode;
	type->convert_flag = 1;
	type->converter = NULL;
	type->values_of = UxValuesOfXrtGaCalcMode;
	type->validate = UxValidateXrtGaCalcMode;
	type->edit_func = NULL;
	type->get_func = NULL;
	type->put_func = NULL;
	xrtgauge_res_types[n++] = type;

	xrtgauge_res_types = (XrtResourceType **)
		realloc(xrtgauge_res_types, (n+2) * sizeof(XrtResourceType *));
	type = (XrtResourceType *) calloc (1, sizeof(XrtResourceType));
	type->datatype.type_gauge = XRTGA_CALLBACK;
	type->utype = (short) 0;
	type->xtype = 0;
	type->convert_flag = 0;
	type->converter = NULL;
	type->values_of = NULL;
	type->validate = NULL;
	type->edit_func = NULL;
	type->get_func = NULL;
	type->put_func = NULL;
	xrtgauge_res_types[n++] = type;

	xrtgauge_res_types = (XrtResourceType **)
		realloc(xrtgauge_res_types, (n+2) * sizeof(XrtResourceType *));
	type = (XrtResourceType *) calloc (1, sizeof(XrtResourceType));
	type->datatype.type_gauge = XRTGA_DIRECTION;
	type->utype = UxUT_string;
	type->xtype = UxXT_XrtGaDirection;
	type->convert_flag = 1;
	type->converter = NULL;
	type->values_of = UxValuesOfXrtGaDirection;
	type->validate = UxValidateXrtGaDirection;
	type->edit_func = NULL;
	type->get_func = NULL;
	type->put_func = NULL;
	xrtgauge_res_types[n++] = type;

	xrtgauge_res_types = (XrtResourceType **)
		realloc(xrtgauge_res_types, (n+2) * sizeof(XrtResourceType *));
	type = (XrtResourceType *) calloc (1, sizeof(XrtResourceType));
	type->datatype.type_gauge = XRTGA_DISPLAY_MODE;
	type->utype = UxUT_string;
	type->xtype = UxXT_XrtGaDisplayMode;
	type->convert_flag = 1;
	type->converter = NULL;
	type->values_of = UxValuesOfXrtGaDisplayMode;
	type->validate = UxValidateXrtGaDisplayMode;
	type->edit_func = NULL;
	type->get_func = NULL;
	type->put_func = NULL;
	xrtgauge_res_types[n++] = type;

	xrtgauge_res_types = (XrtResourceType **)
		realloc(xrtgauge_res_types, (n+2) * sizeof(XrtResourceType *));
	type = (XrtResourceType *) calloc (1, sizeof(XrtResourceType));
	type->datatype.type_gauge = XRTGA_DOUBLE;
	type->utype = UxUT_float;
	type->xtype = UxXT_XrtGaDouble;
	type->convert_flag = 0;
	type->converter = "UxConvertXrtGaDouble";
	type->values_of = UxValuesOfXrtGaDouble;
	type->validate = UxValidateInt;
	type->edit_func = NULL;
	type->get_func = XrtGaGetDouble;
	type->put_func = XrtGaPutDouble;
	xrtgauge_res_types[n++] = type;

	xrtgauge_res_types = (XrtResourceType **)
		realloc(xrtgauge_res_types, (n+2) * sizeof(XrtResourceType *));
	type = (XrtResourceType *) calloc (1, sizeof(XrtResourceType));
	type->datatype.type_gauge = XRTGA_IMAGE;
	type->utype = UxUT_string;
	type->xtype = UxXT_XrtGaImage;
	type->convert_flag = 1;
	type->converter = NULL;
	type->values_of = UxValuesOfXrtGaImage;
	type->validate = UxValidateString;
	type->edit_func = UxGUIPopupPixView;
	type->get_func = NULL;
	type->put_func = NULL;
	xrtgauge_res_types[n++] = type;

	xrtgauge_res_types = (XrtResourceType **)
		realloc(xrtgauge_res_types, (n+2) * sizeof(XrtResourceType *));
	type = (XrtResourceType *) calloc (1, sizeof(XrtResourceType));
	type->datatype.type_gauge = XRTGA_IMAGE_LAYOUT;
	type->utype = UxUT_string;
	type->xtype = UxXT_XrtGaImageLayout;
	type->convert_flag = 1;
	type->converter = NULL;
	type->values_of = UxValuesOfXrtGaImageLayout;
	type->validate = UxValidateXrtGaImageLayout;
	type->edit_func = NULL;
	type->get_func = NULL;
	type->put_func = NULL;
	xrtgauge_res_types[n++] = type;

	xrtgauge_res_types = (XrtResourceType **)
		realloc(xrtgauge_res_types, (n+2) * sizeof(XrtResourceType *));
	type = (XrtResourceType *) calloc (1, sizeof(XrtResourceType));
	type->datatype.type_gauge = XRTGA_INDICATOR_TYPE;
	type->utype = UxUT_string;
	type->xtype = UxXT_XrtGaIndicatorType;
	type->convert_flag = 1;
	type->converter = NULL;
	type->values_of = UxValuesOfXrtGaIndicatorType;
	type->validate = UxValidateXrtGaIndicatorType;
	type->edit_func = NULL;
	type->get_func = NULL;
	type->put_func = NULL;
	xrtgauge_res_types[n++] = type;

	xrtgauge_res_types = (XrtResourceType **)
		realloc(xrtgauge_res_types, (n+2) * sizeof(XrtResourceType *));
	type = (XrtResourceType *) calloc (1, sizeof(XrtResourceType));
	type->datatype.type_gauge = XRTGA_INTERACTION_TYPE;
	type->utype = UxUT_string;
	type->xtype = UxXT_XrtGaInteractionType;
	type->convert_flag = 1;
	type->converter = NULL;
	type->values_of = UxValuesOfXrtGaInteractionType;
	type->validate = UxValidateXrtGaInteractionType;
	type->edit_func = NULL;
	type->get_func = NULL;
	type->put_func = NULL;
	xrtgauge_res_types[n++] = type;

	xrtgauge_res_types = (XrtResourceType **)
		realloc(xrtgauge_res_types, (n+2) * sizeof(XrtResourceType *));
	type = (XrtResourceType *) calloc (1, sizeof(XrtResourceType));
	type->datatype.type_gauge = XRTGA_LINE_PATTERN;
	type->utype = UxUT_string;
	type->xtype = UxXT_XrtGaLinePattern;
	type->convert_flag = 1;
	type->converter = NULL;
	type->values_of = UxValuesOfXrtGaLinePattern;
	type->validate = UxValidateXrtGaLinePattern;
	type->edit_func = NULL;
	type->get_func = NULL;
	type->put_func = NULL;
	xrtgauge_res_types[n++] = type;

	xrtgauge_res_types = (XrtResourceType **)
		realloc(xrtgauge_res_types, (n+2) * sizeof(XrtResourceType *));
	type = (XrtResourceType *) calloc (1, sizeof(XrtResourceType));
	type->datatype.type_gauge = XRTGA_MARKER_TYPE;
	type->utype = UxUT_string;
	type->xtype = UxXT_XrtGaMarkerType;
	type->convert_flag = 1;
	type->converter = NULL;
	type->values_of = UxValuesOfXrtGaMarkerType;
	type->validate = UxValidateXrtGaMarkerType;
	type->edit_func = NULL;
	type->get_func = NULL;
	type->put_func = NULL;
	xrtgauge_res_types[n++] = type;

	xrtgauge_res_types = (XrtResourceType **)
		realloc(xrtgauge_res_types, (n+2) * sizeof(XrtResourceType *));
	type = (XrtResourceType *) calloc (1, sizeof(XrtResourceType));
	type->datatype.type_gauge = XRTGA_NEEDLE_TYPE;
	type->utype = UxUT_string;
	type->xtype = UxXT_XrtGaNeedleType;
	type->convert_flag = 1;
	type->converter = NULL;
	type->values_of = UxValuesOfXrtGaNeedleType;
	type->validate = UxValidateXrtGaNeedleType;
	type->edit_func = NULL;
	type->get_func = NULL;
	type->put_func = NULL;
	xrtgauge_res_types[n++] = type;

	xrtgauge_res_types = (XrtResourceType **)
		realloc(xrtgauge_res_types, (n+2) * sizeof(XrtResourceType *));
	type = (XrtResourceType *) calloc (1, sizeof(XrtResourceType));
	type->datatype.type_gauge = XRTGA_OBJECT;
	type->utype = UxUT_string;
	type->xtype = UxXT_XrtGaObject;
	type->convert_flag = 1;
	type->converter = NULL;
	type->values_of = UxValuesOfString;
	type->validate = UxValidateString;
	type->edit_func = NULL;
	type->get_func = NULL;
	type->put_func = NULL;
	xrtgauge_res_types[n++] = type;

	xrtgauge_res_types = (XrtResourceType **)
		realloc(xrtgauge_res_types, (n+2) * sizeof(XrtResourceType *));
	type = (XrtResourceType *) calloc (1, sizeof(XrtResourceType));
	type->datatype.type_gauge = XRTGA_OBJECT_LIST;
	type->utype = UxUT_string;
	type->xtype = UxXT_XrtGaObjectList;
	type->convert_flag = 1;
	type->converter = NULL;
	type->values_of = UxValuesOfString;
	type->validate = UxValidateString;
	type->edit_func = NULL;
	type->get_func = NULL;
	type->put_func = NULL;
	xrtgauge_res_types[n++] = type;

	xrtgauge_res_types = (XrtResourceType **)
		realloc(xrtgauge_res_types, (n+2) * sizeof(XrtResourceType *));
	type = (XrtResourceType *) calloc (1, sizeof(XrtResourceType));
	type->datatype.type_gauge = XRTGA_OFFSET_TYPE;
	type->utype = UxUT_string;
	type->xtype = UxXT_XrtGaOffsetType;
	type->convert_flag = 1;
	type->converter = NULL;
	type->values_of = UxValuesOfXrtGaOffsetType;
	type->validate = UxValidateXrtGaOffsetType;
	type->edit_func = NULL;
	type->get_func = NULL;
	type->put_func = NULL;
	xrtgauge_res_types[n++] = type;

	xrtgauge_res_types = (XrtResourceType **)
		realloc(xrtgauge_res_types, (n+2) * sizeof(XrtResourceType *));
	type = (XrtResourceType *) calloc (1, sizeof(XrtResourceType));
	type->datatype.type_gauge = XRTGA_SHAPE;
	type->utype = UxUT_string;
	type->xtype = UxXT_XrtGaShape;
	type->convert_flag = 1;
	type->converter = NULL;
	type->values_of = UxValuesOfXrtGaShape;
	type->validate = UxValidateXrtGaShape;
	type->edit_func = NULL;
	type->get_func = NULL;
	type->put_func = NULL;
	xrtgauge_res_types[n++] = type;

	xrtgauge_res_types = (XrtResourceType **)
		realloc(xrtgauge_res_types, (n+2) * sizeof(XrtResourceType *));
	type = (XrtResourceType *) calloc (1, sizeof(XrtResourceType));
	type->datatype.type_gauge = XRTGA_SIZING_POLICY;
	type->utype = UxUT_string;
	type->xtype = UxXT_XrtGaSizingPolicy;
	type->convert_flag = 1;
	type->converter = NULL;
	type->values_of = UxValuesOfXrtGaSizingPolicy;
	type->validate = UxValidateXrtGaSizingPolicy;
	type->edit_func = NULL;
	type->get_func = NULL;
	type->put_func = NULL;
	xrtgauge_res_types[n++] = type;

	xrtgauge_res_types = (XrtResourceType **)
		realloc(xrtgauge_res_types, (n+2) * sizeof(XrtResourceType *));
	type = (XrtResourceType *) calloc (1, sizeof(XrtResourceType));
	type->datatype.type_gauge = XRTGA_STRING_MODE;
	type->utype = UxUT_string;
	type->xtype = UxXT_XrtGaStringMode;
	type->convert_flag = 1;
	type->converter = NULL;
	type->values_of = UxValuesOfXrtGaStringMode;
	type->validate = UxValidateXrtGaStringMode;
	type->edit_func = NULL;
	type->get_func = NULL;
	type->put_func = NULL;
	xrtgauge_res_types[n++] = type;

	xrtgauge_res_types = (XrtResourceType **)
		realloc(xrtgauge_res_types, (n+2) * sizeof(XrtResourceType *));
	type = (XrtResourceType *) calloc (1, sizeof(XrtResourceType));
	type->datatype.type_gauge = XRTGA_SWITCH_TYPE;
	type->utype = UxUT_string;
	type->xtype = UxXT_XrtGaSwitchType;
	type->convert_flag = 1;
	type->converter = NULL;
	type->values_of = UxValuesOfXrtGaSwitchType;
	type->validate = UxValidateXrtGaSwitchType;
	type->edit_func = NULL;
	type->get_func = NULL;
	type->put_func = NULL;
	xrtgauge_res_types[n++] = type;

	xrtgauge_res_types = (XrtResourceType **)
		realloc(xrtgauge_res_types, (n+2) * sizeof(XrtResourceType *));
	type = (XrtResourceType *) calloc (1, sizeof(XrtResourceType));
	type->datatype.type_gauge = XRTGA_TICK_TYPE;
	type->utype = UxUT_string;
	type->xtype = UxXT_XrtGaTickType;
	type->convert_flag = 1;
	type->converter = NULL;
	type->values_of = UxValuesOfXrtGaTickType;
	type->validate = UxValidateXrtGaTickType;
	type->edit_func = NULL;
	type->get_func = NULL;
	type->put_func = NULL;
	xrtgauge_res_types[n++] = type;

	xrtgauge_res_types = (XrtResourceType **)
		realloc(xrtgauge_res_types, (n+2) * sizeof(XrtResourceType *));
	type = (XrtResourceType *) calloc (1, sizeof(XrtResourceType));
	type->datatype.type_gauge = XRTGA_VALUE_TYPE;
	type->utype = UxUT_string;
	type->xtype = UxXT_XrtGaValueType;
	type->convert_flag = 1;
	type->converter = NULL;
	type->values_of = UxValuesOfXrtGaValueType;
	type->validate = UxValidateXrtGaValueType;
	type->edit_func = NULL;
	type->get_func = NULL;
	type->put_func = NULL;
	xrtgauge_res_types[n++] = type;


	xrtgauge_res_types[n] = NULL;
	numgauge_res_types = n;
	AlreadyDone = TRUE;

	xrt_debug_print_int("numgauge_res_types", numgauge_res_types);
	xrt_debug_leave("XrtGauge_init_resource_types");

#endif /* HASXRTGAUGE*/
}

static void
XrtGauge_initialize_resources(table, nres, nres_string)
XrtGaugeResourceDesc	*table;
int					nres;
char				*nres_string;
{
#ifdef HASXRTGAUGE
	int		itype, n;
	char	buffer[128];
	
	xrt_debug_enter("XrtGauge_initialize_resources");

	sprintf(buffer, "%s", nres_string);
	xrt_debug_print_int(buffer, nres);
	
	for (n = 0; n < nres; n++) {
		itype = (int) table[n].res_type;
		table[n].type = xrtgauge_res_types[itype];
		if (table[n].resnum != n) {
			sprintf(buffer,
					"Gauge resource number (%d) & table number (%d) unequal!",
					table[n].resnum, n);
			xrt_debug_print_string("Resource Error!!!", buffer);
		}
	}

	xrt_debug_leave("XrtGauge_initialize_resources");
#endif /* HASXRTGAUGE */
}

void
XrtGauge_init_resource_table()
{
#ifdef HASXRTGAUGE
	static Boolean	AlreadyDone = FALSE;

 	if (AlreadyDone) {
		return;
	}

	xrt_debug_enter("XrtGauge_init_resource_table");
	
	XrtGauge_init_resource_types();

	XrtGauge_initialize_resources(XrtGaCircularDial_res_table,
								  numXrtGaCircularDial_res, "numXrtGaCircularDial_res");
	XrtGauge_initialize_resources(XrtGaCircularGauge_res_table,
								  numXrtGaCircularGauge_res, "numXrtGaCircularGauge_res");
	XrtGauge_initialize_resources(XrtGaCounter_res_table,
								  numXrtGaCounter_res, "numXrtGaCounter_res");
	XrtGauge_initialize_resources(XrtGaLEDIcon_res_table,
								  numXrtGaLEDIcon_res, "numXrtGaLEDIcon_res");
	XrtGauge_initialize_resources(XrtGaLEDNumerical_res_table,
								  numXrtGaLEDNumerical_res, "numXrtGaLEDNumerical_res");
	XrtGauge_initialize_resources(XrtGaLinearDial_res_table,
								  numXrtGaLinearDial_res, "numXrtGaLinearDial_res");
	XrtGauge_initialize_resources(XrtGaLinearGauge_res_table,
								  numXrtGaLinearGauge_res, "numXrtGaLinearGauge_res");
	XrtGauge_initialize_resources(XrtGaPercent_res_table,
								  numXrtGaPercent_res, "numXrtGaPercent_res");
	XrtGauge_initialize_resources(XrtGaCenter_res_table,
								  numXrtGaCenter_res, "numXrtGaCenter_res");
	XrtGauge_initialize_resources(XrtGaCircularScale_res_table,
								  numXrtGaCircularScale_res, "numXrtGaCircularScale_res");
	XrtGauge_initialize_resources(XrtGaFrame_res_table,
								  numXrtGaFrame_res, "numXrtGaFrame_res");
	XrtGauge_initialize_resources(XrtGaIcon_res_table,
								  numXrtGaIcon_res, "numXrtGaIcon_res");
	XrtGauge_initialize_resources(XrtGaIndicator_res_table,
								  numXrtGaIndicator_res, "numXrtGaIndicator_res");
	XrtGauge_initialize_resources(XrtGaItem_res_table,
								  numXrtGaItem_res, "numXrtGaItem_res");
	XrtGauge_initialize_resources(XrtGaLinearScale_res_table,
								  numXrtGaLinearScale_res, "numXrtGaLinearScale_res");
	XrtGauge_initialize_resources(XrtGaMarker_res_table,
								  numXrtGaMarker_res, "numXrtGaMarker_res");
	XrtGauge_initialize_resources(XrtGaNeedle_res_table,
								  numXrtGaNeedle_res, "numXrtGaNeedle_res");
	XrtGauge_initialize_resources(XrtGaRange_res_table,
								  numXrtGaRange_res, "numXrtGaRange_res");
	XrtGauge_initialize_resources(XrtGaState_res_table,
								  numXrtGaState_res, "numXrtGaState_res");
	XrtGauge_initialize_resources(XrtGaSwitch_res_table,
								  numXrtGaSwitch_res, "numXrtGaSwitch_res");
	XrtGauge_initialize_resources(XrtGaText_res_table,
								  numXrtGaText_res, "numXrtGaText_res");
	XrtGauge_initialize_resources(XrtGaTick_res_table,
								  numXrtGaTick_res, "numXrtGaTick_res");

	AlreadyDone = TRUE;

	xrt_debug_leave("XrtGauge_init_resource_table");
#endif /* HASXRTGAUGE */
}

#ifdef DESIGN_TIME

static float
XrtGaGetDouble(sw, res)
swidget         sw;
Resource_t      *res;
{
	Widget		w;
	double		value = 0.0;
	char		*ptr;
	XtArgVal	argval;

	ptr = UxGetXtName(res);
	if (UxIsSwidget(sw))
		if ((w = UxGetWidget(sw)) != NULL)
			XtVaGetValues (w, ptr, &value, NULL);
		else
			if(UxFindValue(sw, res, &argval))
				value = XrtGaArgValToDouble(argval);

#ifdef osf1
#include <limits.h>
	if (value > FLT_MAX) {
		value = FLT_MAX;
	}
	if (value < -FLT_MAX) {
		value = -FLT_MAX;
	}
#endif /* osf1 */
	return (float)value;
}

static int
XrtGaPutDouble(sw, res, intvalue)
swidget		sw;
Resource_t	*res;
int		intvalue;
{
	Widget		w;
	char		*ptr;
	int		status = ERROR;
	XtArgVal	argval;
	FloatInt_t	localcast;
	float		value;

	localcast.i = intvalue;
	value = localcast.f;

	ptr = UxGetXtName(res);

	if (UxIsSwidget(sw)) {
		argval = XrtGaDoubleToArgVal((double)value);
		UxSaveValue (sw, res, argval, FALSE);

		/*
		 *  If the delay flag is NOT set, update widget now
		 *  so that the change happens immediately in the
		 *  property editor.
		 */
		if(!UxGetDelay(sw) && (w = (Widget) UxGetWidget(sw)) != NULL) {
			XtVaSetValues(w, ptr, argval, NULL);
		}

		status = NO_ERROR;
	}
	else {
		status = ERROR;
	}
	
	return(status);
}

#else


static float	XrtGaGetDouble() {}
static int	XrtGaPutDouble() {}

#endif /* DESIGN_TIME */
